
#ifndef _BASICRT_HXX
#define _BASICRT_HXX

#include <tools/string.hxx>
class SbiRuntime;
class SbErrorStackEntry;

class BasicRuntime
{
	SbiRuntime* pRun;
public:
	BasicRuntime( SbiRuntime* p ) : pRun ( p ){;}
	const String GetModuleName( SbxNameType nType );
	const String GetMethodName( SbxNameType nType );
	xub_StrLen GetLine();
	xub_StrLen GetCol1();
	xub_StrLen GetCol2();
	BOOL IsValid() { return pRun != NULL; }
	BasicRuntime GetNextRuntime();
};

class BasicErrorStackEntry
{
	SbErrorStackEntry *pEntry;
public:
	BasicErrorStackEntry( SbErrorStackEntry *p ) : pEntry ( p ){;}
	const String GetModuleName( SbxNameType nType );
	const String GetMethodName( SbxNameType nType );
	xub_StrLen GetLine();
	xub_StrLen GetCol1();
	xub_StrLen GetCol2();
};

class BasicRuntimeAccess
{
public:
	static BasicRuntime GetRuntime();
	static BOOL HasRuntime();
	static USHORT GetStackEntryCount();
	static BasicErrorStackEntry GetStackEntry( USHORT nIndex );
	static BOOL HasStack();
	static void DeleteStack();

	static BOOL IsRunInit();
};

#endif

