

#ifndef _SB_HILIGHT_HXX
#define _SB_HILIGHT_HXX

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif
#ifndef _SV_GEN_HXX 
#include <tools/gen.hxx>
#endif

#include <svtools/svarray.hxx>

class SimpleTokenizer_Impl;

enum TokenTypes
{
	TT_UNKNOWN,
	TT_IDENTIFIER,
	TT_WHITESPACE,
	TT_NUMBER,
	TT_STRING,
	TT_EOL,
	TT_COMMENT,
	TT_ERROR,
	TT_OPERATOR,
	TT_KEYWORD
};

struct HighlightPortion { UINT16 nBegin; UINT16 nEnd; TokenTypes tokenType; };

SV_DECL_VARARR(HighlightPortions, HighlightPortion, 0, 16)

enum HighlighterLanguage
{
	HIGHLIGHT_BASIC
};

class SyntaxHighlighter
{
	HighlighterLanguage eLanguage;
	SimpleTokenizer_Impl* m_pSimpleTokenizer;
	char* m_pKeyWords;
	UINT16 m_nKeyWordCount;

public:
	SyntaxHighlighter( void );
	~SyntaxHighlighter( void );

	void initialize( HighlighterLanguage eLanguage_ );

	const Range notifyChange( UINT32 nLine, INT32 nLineCountDifference,
					const String* pChangedLines, UINT32 nArrayLength);

	void getHighlightPortions( UINT32 nLine, const String& rLine,
								HighlightPortions& pPortions );

};

#endif

