

#ifndef _MYBASIC_HXX
#define _MYBASIC_HXX

#ifndef _SB_SBSTAR_HXX 
#include <basic/sbstar.hxx>
#endif

class BasicApp;
class AppBasEd;
class ErrorEntry;

class BasicError {
	AppBasEd* pWin;
	USHORT  nLine, nCol1, nCol2;
	String aText;
public:
	BasicError( AppBasEd*, USHORT, const String&, USHORT, USHORT, USHORT );
	void Show();
};

DECLARE_LIST( ErrorList, BasicError* );

#define SBXID_MYBASIC	0x594D		
#define	SBXCR_TEST		0x54534554	

class MyBasic : public StarBASIC
{
	SbError nError;
	virtual BOOL ErrorHdl();
	virtual USHORT BreakHdl();

protected:
	Link GenLogHdl();
	Link GenWinInfoHdl();
	Link GenModuleWinExistsHdl();

	void StartListening( SfxBroadcaster &rBroadcaster );

	String GenRealString( const String &aResString );

public:
	SBX_DECL_PERSIST_NODATA(SBXCR_TEST,SBXID_MYBASIC,1);
	TYPEINFO();
	ErrorList aErrors;
	MyBasic();
	virtual ~MyBasic();
	virtual BOOL Compile( SbModule* );
	void Reset();
	SbError GetErrors() { return nError; }

	SbxObject *pTestObject;			

	virtual void LoadIniFile();
	virtual SbTextType GetSymbolType( const String &Symbol, BOOL bWasTTControl );	
	virtual const String GetSpechialErrorText();
	virtual void ReportRuntimeError( AppBasEd *pEditWin );

	static void SetCompileModule( SbModule *pMod );
	static SbModule *GetCompileModule();
};

SV_DECL_IMPL_REF(MyBasic)

#endif
