

#ifndef _SB_SBMETH_HXX
#define _SB_SBMETH_HXX

#ifndef _ERRCODE_HXX 
#include <tools/errcode.hxx>
#endif
#ifndef __SBX_SBXMETHOD_HXX 
#include <svtools/sbxmeth.hxx>
#endif
#include <basic/sbdef.hxx>

class SbModule;

class SbMethod : public SbxMethod
{
	friend class SbiFactory;
	friend class SbModule;
	friend class SbiCodeGen;
	friend class SbJScriptMethod;
	SbModule* pMod;
	USHORT    nDebugFlags;
	USHORT	  nLine1, nLine2;
	USHORT	  nStart;
	BOOL	  bInvalid;
	SbMethod( const String&, SbxDataType, SbModule* );
	virtual BOOL LoadData( SvStream&, USHORT );
	virtual BOOL StoreData( SvStream& ) const;
	virtual ~SbMethod();
public:
	SBX_DECL_PERSIST_NODATA(SBXCR_SBX,SBXID_BASICMETHOD,2);
	TYPEINFO();
	virtual SbxInfo* GetInfo();
	SbxArray* GetLocals();
	SbxArray* GetStatics();
	SbModule* GetModule() 				 { return pMod; 	   }
	USHORT	  GetId() const				 { return nStart;	   }
	USHORT    GetDebugFlags()			 { return nDebugFlags; }
	void 	  SetDebugFlags( USHORT n )  { nDebugFlags = n;    }
	void 	  GetLineRange( USHORT&, USHORT& );

	virtual ErrCode Call( SbxValue* pRet = NULL );
};

#ifndef __SB_SBMETHODREF_HXX
#define __SB_SBMETHODREF_HXX
SV_DECL_IMPL_REF(SbMethod)
#endif

#endif
