

#ifndef _COPYPRJ_HXX
#define _COPYPRJ_HXX

#include <tools/fsys.hxx>
#include <tools/string.hxx>
#include <tools/stream.hxx>
#include <tools/sstring.hxx>

class GenericInformationList;
class GenericInformation;
class OutpathList;

#define PC_DATA_VALID					0x0000
#define PC_PROJECT_NOT_VALID 			0x0001
#define PC_VERSION_NOT_VALID 			0x0002
#define PC_DESTINATIONPATH_NOT_EXIST    0x0004
#define PC_SOURCEPATH_NOT_EXIST			0x0008
#define PC_DSTVERSION_NOT_VALID 		0x000F

#define PC_COPYACTION_OK				0x0000
#define PC_COPYACTION_FAILED			0x0001
#define PC_COPYACTION_NOMEMORY			0x0002

class ProjectCop
{
private:
	ByteString 	sProject;					
	ByteString 	sVersion;					
	ByteString  sDstVersion;				
	ByteString 	sDestination;				
	ByteString	sSource;					

	GenericInformationList *pList;
	GenericInformation *pStand;

	GenericInformation *pDstVer;

	GenericInformationList *pEnvList;
	OutpathList *pDstEnvs;

	BOOL	bCopyPrj;					
	BOOL	bDontDelete;
	BOOL	bAddVerName;
	BOOL	bAddOutPath;
	BOOL	bOnlyOutPath;
	BOOL	bUpdate;
	BOOL	bFlatVersion;

	BOOL	CopyDirectory( DirEntry &rDir, BOOL bCopyAllDirs = FALSE );
	BOOL	CVSPatch( ByteString &rSrc, ByteString &rDest );

protected:
	virtual void PrintStatus( const char* cStatus ) = 0;

public:

	ProjectCop( ByteString &rPrj, ByteString &rVer, ByteString &rDest,
			BOOL bAddPath = TRUE, BOOL bOutPath = TRUE, BOOL bFlat = FALSE,
			BOOL bOnlyOutpath = FALSE, BOOL bUpdate = FALSE );

	ProjectCop( ByteString &rSrcVer, ByteString &rDstVer,
	OutpathList *pEnvs = NULL,
	GenericInformationList *pIList = NULL,
	BOOL bAddPath = TRUE, BOOL bOutPath = TRUE, BOOL bFlat=FALSE );

	~ProjectCop();

	USHORT	IsValid(); 					
	USHORT	Copy();						

	USHORT	Copy( ByteString &rPrj );		
};

#endif
