
#ifndef _REVISION_HXX
#define _REVISION_HXX

#include <tools/list.hxx>
#include <tools/string.hxx>

DECLARE_LIST( IntList, int * );

class Revision
{
	ULONG			nMajorNumber;
	ULONG			nMinorNumber;
	IntList*		pIntList;
	BOOL			bBranched;
public:
		Revision( ULONG nMajor, ULONG nMinor );
		Revision( ByteString aRev );
		Revision();
		Revision( const Revision& rRev );

	Revision&		operator = ( ByteString aRev );
	Revision&		operator = ( const char* pChar );
		operator ByteString();				
	friend BOOL 	operator ==( const Revision& rRev1, const Revision& rRev2 );
	friend BOOL 	operator <( const Revision& rRev1, const Revision& rRev2 );
	friend BOOL 	operator >( const Revision& rRev1, const Revision& rRev2 );

	ULONG			operator++();
	ULONG			operator++(int);
	ULONG			operator--();
	ULONG			operator--(int);
};

#endif
