

#ifndef _CONNECTIVITY_SDBCX_COLUMN_HXX_
#include "connectivity/sdbcx/VColumn.hxx"
#endif

namespace connectivity
{
	namespace parse
	{
		class OParseColumn;

		typedef sdbcx::OColumn OParseColumn_BASE;
		typedef ::comphelper::OIdPropertyArrayUsageHelper<OParseColumn> OParseColumn_PROP;

		class OParseColumn :	public OParseColumn_BASE,
					public OParseColumn_PROP
		{
			::rtl::OUString	m_aRealName;
			::rtl::OUString m_aTableName;
			sal_Bool		m_bFunction;
			sal_Bool		m_bDbasePrecisionChanged;
		protected:
			virtual ::cppu::IPropertyArrayHelper* createArrayHelper( sal_Int32 _nId) const;
			virtual ::cppu::IPropertyArrayHelper & SAL_CALL getInfoHelper();
		public:
	        OParseColumn(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet>& _xColumn,sal_Bool _bCase);
			OParseColumn(const ::rtl::OUString& _Name,
		const ::rtl::OUString& _TypeName,
		const ::rtl::OUString& _DefaultValue,
		sal_Int32		_IsNullable,
		sal_Int32		_Precision,
		sal_Int32		_Scale,
		sal_Int32		_Type,
		sal_Bool		_IsAutoIncrement,
		sal_Bool		_IsCurrency,
		sal_Bool		_bCase);
	~OParseColumn();
	virtual void construct();
	void setRealName(const ::rtl::OUString& _rName)  { m_aRealName  = _rName; }
			void setTableName(const ::rtl::OUString& _rName) { m_aTableName = _rName; }
			void setFunction(sal_Bool _bFunction)			 { m_bFunction	= _bFunction; }
			void setDbasePrecisionChanged(sal_Bool _bDbasePrecisionChanged)	{ m_bDbasePrecisionChanged = _bDbasePrecisionChanged; }
	::rtl::OUString getRealName() const { return  m_aRealName; }
			::rtl::OUString getTableName() const { return  m_aTableName; }
			sal_Bool		getFunction() const { return  m_bFunction; }
			sal_Bool		getDbasePrecisionChanged()	const { return  m_bDbasePrecisionChanged; }
		};
	}
}

