

#ifndef _CONNECTIVITY_SDBCX_DESCRIPTOR_HXX_
#define _CONNECTIVITY_SDBCX_DESCRIPTOR_HXX_

#ifndef _COMPHELPER_PROPERTYCONTAINER_HXX_
#include <comphelper/propertycontainer.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _COM_SUN_STAR_LANG_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif
#ifndef _COMPHELPER_STLTYPES_HXX_
#include <comphelper/stl_types.hxx>
#endif

namespace connectivity
{
	namespace sdbcx
	{

		typedef ::comphelper::OPropertyContainer ODescriptor_PBASE;
		class ODescriptor
		:public ODescriptor_PBASE
		,public ::com::sun::star::lang::XUnoTunnel
		{
		protected:
			::rtl::OUString			m_Name;
	void changePropertyAttributte(::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property>& _rProps) const
			{
	::com::sun::star::beans::Property* pBegin	= _rProps.getArray();
	::com::sun::star::beans::Property* pEnd		= pBegin + _rProps.getLength();
	for(;pBegin != pEnd;++pBegin)
	{
		pBegin->Attributes = isNew() ? 0 : ::com::sun::star::beans::PropertyAttribute::READONLY;
	}
			}
		private:
			comphelper::UStringMixEqual	m_aCase;
			sal_Bool					m_bNew;

		public:
			ODescriptor(::cppu::OBroadcastHelper& _rBHelper,sal_Bool _bCase, sal_Bool _bNew = sal_False);
	virtual ~ODescriptor();
	sal_Bool isNew()  const			{ return m_bNew;	}
			sal_Bool getNew() const			{ return m_bNew;	}
			virtual	void	 setNew(sal_Bool _bNew);
	sal_Bool isCaseSensitive() const { return m_aCase.isCaseSensitive(); }
	virtual void construct();
	virtual ::com::sun::star::uno::Any SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
			virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL getTypes(  ) throw(::com::sun::star::uno::RuntimeException);
	inline sal_Bool operator == ( const ::rtl::OUString & _rRH )
			{
	return m_aCase(m_Name,_rRH);
			}
	         virtual sal_Int64 SAL_CALL getSomething( const ::com::sun::star::uno::Sequence< sal_Int8 >& aIdentifier ) throw(::com::sun::star::uno::RuntimeException);
	        static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();
		};
	}

}
#endif 

