
#ifndef _MAILBRW_HXX
#define _MAILBRW_HXX

#include <goodies/mailsrv.hxx>

#ifndef _TIMER_HXX 
#include <vcl/timer.hxx>
#endif
#ifndef _SVX_BRWBOX_HXX 
#include <svtools/brwbox.hxx>
#endif

class MailReadOnlyDialog;

class MailBrowser : public BrowseBox
{
friend class MailBrowseDialog;

private:
	Link                aSelectHdlLink;
	Link                aDoubleClickHdlLink;

	AutoTimer			aTimer;
	MailServer*         pServer;    
	Mail*               pMail;      

#if 0 // _SOLAR__PRIVATE
	void				Init();

	DECL_LINK( TimeoutHdl, AutoTimer * );
#endif

protected:

	virtual long        GetRowCount() const;
	virtual BOOL        SeekRow( long nRow );
	virtual void        PaintField( OutputDevice& rDev, const Rectangle& rRect,
				USHORT nColumnId ) const;

	virtual void        Select();
	virtual void        DoubleClick();

public:
	MailBrowser( Window *pParent, const ResId& rResId );
	MailBrowser( Window *pParent, WinBits nBits = 0 );
	~MailBrowser();

	BOOL                Connect( MailServer& rServer );

	void                SetSelectHdl( const Link& rNewLink )
					{ aSelectHdlLink = rNewLink; }
	const Link&         GetSelectHdl() const { return aSelectHdlLink; }
	void                SetDoubleClickHdl( const Link& rNewLink )
					{ aDoubleClickHdlLink = rNewLink; }
	const Link&         GetDoubleClickHdl() const { return aDoubleClickHdlLink; }

	void				SetConfig( const String& rCfgStr );
	String				GetConfig() const;

	MailServer*         GetServer() const { return pServer; }
	IncomingMail*		GetCurMail( BOOL bAttach = TRUE ) const;
};

#ifdef _SALE_SOLAR

class MailBrowseDialog : public FloatingWindow
{
private:
	PushButton		 	aOpenButton;
	PushButton		 	aDeleteButton;
	PushButton		 	aCloseButton;

	MailBrowser			aMailBrowser;

	BOOL				bInbox;

#if 0 // _SOLAR__PRIVATE
	DECL_LINK( OpenHdl, Button * );
	DECL_LINK( DeleteHdl, Button * );
	DECL_LINK( CloseHdl, Button * );
	DECL_LINK( OpenAttachFileHdl, MailReadOnlyDialog * );
	DECL_LINK( SelectHdl, MailBrowser * );
	DECL_LINK( DoubleClickHdl, MailBrowser * );
#endif

protected:
	virtual	void		Open( Window* pParent, const String& rFile );
	virtual BOOL		Close();

public:
	MailBrowseDialog( Window* pParent, MailServer& rServ, BOOL bFlag = TRUE );

	void				SetConfig( const String& rCfgStr );
	String				GetConfig() const;

	virtual void		Resize();
	virtual void		Resizing( Size& rSize );
};

#endif 

#endif

