
#ifndef _MAILFMGR_HXX
#define _MAILFMGR_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

class Mail;

enum MailFolder
{
	MAILFOLDER_INBOX,
	MAILFOLDER_OUTBOX,
	MAILFOLDER_SENT,
	MAILFOLDER_TRASH
};

class MailFolderManager
{
public:
		MailFolderManager();
	virtual			~MailFolderManager();

	virtual ULONG	GetMailCount( MailFolder eFolder ) const;
	virtual Mail*	GetMail( ULONG nIndex,
				 MailFolder eFolder, BOOL bAttach ) const;
	virtual	BOOL	AddMail( const Mail& rMail, MailFolder eFolder );
	virtual	BOOL	RemoveMail( const Mail& rMail, MailFolder eFolder );
	virtual BOOL	MoveMail( const Mail& rMail,
				  MailFolder eSrc, MailFolder eDest );
	virtual	BOOL	SetReadFlag( const Mail& rMail,
					 MailFolder eFolder, FASTBOOL bRead );
};

#endif

