

#ifndef _INET_CLIENT_HXX
#define _INET_CLIENT_HXX "$Revision: 1.1.1.1 $"

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _VOS_REF_HXX_
#include <vos/ref.hxx>
#endif
#ifndef _VOS_OBJECT_HXX_
#include <vos/object.hxx>
#endif

#ifndef _INET_MACROS_HXX
#include <inet/macros.hxx>
#endif

class INetCoreDNSHostEntry;

#ifdef _USE_NAMESPACE
namespace inet {
#endif

class INetSocket;
class INetClientManager_Impl;

class INetClientConnection_Impl :
	public NAMESPACE_VOS(OReference),
	public NAMESPACE_VOS(OObject)
{
	VOS_DECLARE_CLASSINFO (VOS_NAMESPACE (INetClientConnection_Impl, inet));

public:
	INetClientConnection_Impl (void);
	virtual ~INetClientConnection_Impl (void);

	virtual sal_Bool handleResolverEvent (
		sal_Int32             nEvent,
		INetCoreDNSHostEntry *pHostEntry) = 0;

	virtual sal_Bool handleSocketEvent (
		const NAMESPACE_VOS(ORef)<INetSocket> &rxSocket,
		sal_Int32                              nEvent) = 0;

protected:

	static sal_Bool onResolverEvent (
		sal_Int32             nEvent,
		INetCoreDNSHostEntry *pHostEntry,
		void                 *pData);

	static sal_Bool onSocketEvent (
		const NAMESPACE_VOS(ORef)<INetSocket> &rxSocket,
		sal_Int32                              nEvent,
		void                                  *pData);

private:

	NAMESPACE_VOS(ORef)<INetClientManager_Impl> m_xManager;

	INetClientConnection_Impl (const INetClientConnection_Impl&);
	INetClientConnection_Impl& operator= (const INetClientConnection_Impl&);
};

#ifdef _USE_NAMESPACE
}
#endif

extern "C" void SAL_CALL INetClientCleanup_Impl (void);

#endif 

