

#ifndef _LINGUISTIC_HYPHDTA_HXX_
#define _LINGUISTIC_HYPHDTA_HXX_

#ifndef _COM_SUN_STAR_LINGUISTIC2_XHYPHENATEDWORD_HPP_
#include <com/sun/star/linguistic2/XHyphenatedWord.hpp>
#endif
#ifndef _COM_SUN_STAR_LINGUISTIC2_XPOSSIBLEHYPHENS_HPP_
#include <com/sun/star/linguistic2/XPossibleHyphens.hpp>
#endif

#include <tools/solar.h>

#include <uno/lbnames.h>			
#include <cppuhelper/implbase1.hxx>	

namespace linguistic
{

class HyphenatedWord :
	public cppu::WeakImplHelper1
	<
		::com::sun::star::linguistic2::XHyphenatedWord
	>
{
	::rtl::OUString		aWord;
	::rtl::OUString		aHyphenatedWord;
	INT16				nHyphPos;
	INT16				nHyphenationPos;
	INT16				nLanguage;
	BOOL				bIsAltSpelling;

	HyphenatedWord(const HyphenatedWord &);
	HyphenatedWord & operator = (const HyphenatedWord &);

public:
	HyphenatedWord(const ::rtl::OUString &rWord, INT16 nLang, INT16 nHyphenationPos,
	   const ::rtl::OUString &rHyphenatedWord, INT16 nHyphenPos );
	virtual ~HyphenatedWord();
	 virtual ::rtl::OUString SAL_CALL
		getWord()
			throw(::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::lang::Locale SAL_CALL
		getLocale()
			throw(::com::sun::star::uno::RuntimeException);
	virtual sal_Int16 SAL_CALL
		getHyphenationPos()
			throw(::com::sun::star::uno::RuntimeException);
	virtual ::rtl::OUString SAL_CALL
		getHyphenatedWord()
			throw(::com::sun::star::uno::RuntimeException);
	virtual sal_Int16 SAL_CALL
		getHyphenPos()
			throw(::com::sun::star::uno::RuntimeException);
	virtual sal_Bool SAL_CALL
		isAlternativeSpelling()
			throw(::com::sun::star::uno::RuntimeException);
};

class PossibleHyphens :
	public cppu::WeakImplHelper1
	<
		::com::sun::star::linguistic2::XPossibleHyphens
	>
{
	::rtl::OUString				aWord;
	::rtl::OUString				aWordWithHyphens;
	::com::sun::star::uno::Sequence< INT16 >	aOrigHyphenPos;
	INT16						nLanguage;

	PossibleHyphens(const PossibleHyphens &);
	PossibleHyphens & operator = (const PossibleHyphens &);

public:
	PossibleHyphens(const ::rtl::OUString &rWord, INT16 nLang,
			const ::rtl::OUString &rHyphWord,
			const ::com::sun::star::uno::Sequence< INT16 > &rPositions);
	virtual ~PossibleHyphens();
	 virtual ::rtl::OUString SAL_CALL
		getWord()
			throw(::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::lang::Locale SAL_CALL
		getLocale()
			throw(::com::sun::star::uno::RuntimeException);
	virtual ::rtl::OUString SAL_CALL
		getPossibleHyphens()
			throw(::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::uno::Sequence< sal_Int16 > SAL_CALL
		getHyphenationPositions()
			throw(::com::sun::star::uno::RuntimeException);
};

} 

#endif

