

#ifndef _LINGUISTIC_SPELLDTA_HXX_
#define _LINGUISTIC_SPELLDTA_HXX_

#ifndef _COM_SUN_STAR_LINGUISTIC2_XSPELLALTERNATIVES_HPP_
#include <com/sun/star/linguistic2/XSpellAlternatives.hpp>
#endif

#include <tools/solar.h>

#include <uno/lbnames.h>			
#include <cppuhelper/implbase1.hxx>	

namespace linguistic
{

::com::sun::star::uno::Reference< 
	::com::sun::star::linguistic2::XSpellAlternatives > 
		MergeProposals(
			::com::sun::star::uno::Reference< 
	::com::sun::star::linguistic2::XSpellAlternatives > &rxAlt1,
			::com::sun::star::uno::Reference< 
	::com::sun::star::linguistic2::XSpellAlternatives > &rxAlt2 );

class SpellAlternatives :
	public cppu::WeakImplHelper1
	<
		::com::sun::star::linguistic2::XSpellAlternatives
	>
{
	::com::sun::star::uno::Sequence< ::rtl::OUString >	aAlt;	
	::rtl::OUString			aWord;
	INT16					nType;			
	INT16					nLanguage;

	SpellAlternatives(const SpellAlternatives &);
	SpellAlternatives & operator = (const SpellAlternatives &);

public:
	SpellAlternatives();
	SpellAlternatives(const ::rtl::OUString &rWord, INT16 nLang, INT16 nFailureType,
		  const ::rtl::OUString &rRplcWord );
	virtual ~SpellAlternatives();
	 virtual ::rtl::OUString SAL_CALL
		getWord()
			throw(::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::lang::Locale SAL_CALL
		getLocale()
			throw(::com::sun::star::uno::RuntimeException);
	virtual sal_Int16 SAL_CALL
		getFailureType()
			throw(::com::sun::star::uno::RuntimeException);
	virtual sal_Int16 SAL_CALL
		getAlternativesCount()
			throw(::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL
		getAlternatives()
			throw(::com::sun::star::uno::RuntimeException);

	void	SetWordLanguage(const ::rtl::OUString &rWord, INT16 nLang);
	void	SetFailureType(INT16 nTypeP);
	void	SetAlternatives(
	const ::com::sun::star::uno::Sequence< ::rtl::OUString > &rAlt );
};

}	

#endif

