/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Sun
 * Microsystems, Inc.  Portions created by Sun are
 * Copyright (C) 2001 Sun Microsystems, Inc. All
 * Rights Reserved.
 *
 * Created by: Paul Sandoz   <paul.sandoz@sun.com> 
 *
 * Contributor(s): 
 */

#ifndef nsBooleanExpression_h__
#define nsBooleanExpression_h__

#include "nsIBooleanExpression.h"
#include "nsCOMPtr.h"
#include "nsString.h"

class nsBooleanConditionString : public nsIBooleanConditionString
{
public:
    NS_DECL_ISUPPORTS
    NS_DECL_NSIBOOLEANCONDITIONSTRING

    nsBooleanConditionString();
    virtual ~nsBooleanConditionString();

    static NS_METHOD Create(nsISupports *aOuter, REFNSIID aIID, void **aResult);

protected:
    nsBooleanConditionType mCondition;
    nsCString mName;
    nsString mValue;
};

class nsBooleanExpression: public nsIBooleanExpression
{
public:
    NS_DECL_ISUPPORTS
    NS_DECL_NSIBOOLEANEXPRESSION

    nsBooleanExpression();
    virtual ~nsBooleanExpression();

    static NS_METHOD Create(nsISupports *aOuter, REFNSIID aIID, void **aResult);
protected:
    nsBooleanOperationType mOperation;
    nsCOMPtr<nsISupportsArray> mExpressions;
};

nsresult
NS_NewIBooleanConditionString(nsIBooleanConditionString** aInstancePtrResult);

nsresult
NS_NewIBooleanExpression(nsIBooleanExpression** aInstancePtrResult);

#endif
