/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIDispatchListener.idl
 */

#ifndef __gen_nsIDispatchListener_h__
#define __gen_nsIDispatchListener_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIEvent_h__
#include "nsIEvent.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIDispatchListener */
#define NS_IDISPATCHLISTENER_IID_STR "2efb5007-4508-11d3-aeda-00a024ffc08c"

#define NS_IDISPATCHLISTENER_IID \
  {0x2efb5007, 0x4508, 0x11d3, \
    { 0xae, 0xda, 0x00, 0xa0, 0x24, 0xff, 0xc0, 0x8c }}

/**
 * The nsIDispatchListener defines the callback listener interface that
 * can be passed to the Run routine on and event loop.  This allows 
 * application override or additions to the default dispatching event mechanism.    
 */
class NS_NO_VTABLE nsIDispatchListener : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IDISPATCHLISTENER_IID)

  /* void PreDispatch (in nsIEvent evt); */
  NS_IMETHOD PreDispatch(nsIEvent *evt) = 0;

  /* void PostDispatch (in nsIEvent evt, in boolean fDispatchHandled); */
  NS_IMETHOD PostDispatch(nsIEvent *evt, PRBool fDispatchHandled) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIDISPATCHLISTENER \
  NS_IMETHOD PreDispatch(nsIEvent *evt); \
  NS_IMETHOD PostDispatch(nsIEvent *evt, PRBool fDispatchHandled); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIDISPATCHLISTENER(_to) \
  NS_IMETHOD PreDispatch(nsIEvent *evt) { return _to ## PreDispatch(evt); } \
  NS_IMETHOD PostDispatch(nsIEvent *evt, PRBool fDispatchHandled) { return _to ## PostDispatch(evt, fDispatchHandled); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIDISPATCHLISTENER(_to) \
  NS_IMETHOD PreDispatch(nsIEvent *evt) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> PreDispatch(evt); } \
  NS_IMETHOD PostDispatch(nsIEvent *evt, PRBool fDispatchHandled) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> PostDispatch(evt, fDispatchHandled); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsDispatchListener : public nsIDispatchListener
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIDISPATCHLISTENER

  nsDispatchListener();
  virtual ~nsDispatchListener();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsDispatchListener, nsIDispatchListener)

nsDispatchListener::nsDispatchListener()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsDispatchListener::~nsDispatchListener()
{
  /* destructor code */
}

/* void PreDispatch (in nsIEvent evt); */
NS_IMETHODIMP nsDispatchListener::PreDispatch(nsIEvent *evt)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void PostDispatch (in nsIEvent evt, in boolean fDispatchHandled); */
NS_IMETHODIMP nsDispatchListener::PostDispatch(nsIEvent *evt, PRBool fDispatchHandled)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIDispatchListener_h__ */
