/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIEventLoop.idl
 */

#ifndef __gen_nsIEventLoop_h__
#define __gen_nsIEventLoop_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIEventFilter_h__
#include "nsIEventFilter.h"
#endif

#ifndef __gen_nsIEvent_h__
#include "nsIEvent.h"
#endif

#ifndef __gen_nsIDispatchListener_h__
#include "nsIDispatchListener.h"
#endif

#ifndef __gen_nsITranslateListener_h__
#include "nsITranslateListener.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
typedef PRInt32 nsEventLoopType;


/* starting interface:    nsEventLoopTypes */
#define NS_EVENTLOOPTYPES_IID_STR "2efb5002-4508-11d3-aeda-00a024ffc08c"

#define NS_EVENTLOOPTYPES_IID \
  {0x2efb5002, 0x4508, 0x11d3, \
    { 0xae, 0xda, 0x00, 0xa0, 0x24, 0xff, 0xc0, 0x8c }}

class NS_NO_VTABLE nsEventLoopTypes {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_EVENTLOOPTYPES_IID)

  enum { MainAppLoop = 1 };

  enum { ThreadLoop = 2 };

  enum { AppBreathLoop = 3 };

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSEVENTLOOPTYPES \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSEVENTLOOPTYPES(_to) \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSEVENTLOOPTYPES(_to) \

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public nsEventLoopTypes
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSEVENTLOOPTYPES

  _MYCLASS_();
  virtual ~_MYCLASS_();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, nsEventLoopTypes)

_MYCLASS_::_MYCLASS_()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIEventLoop */
#define NS_IEVENTLOOP_IID_STR "2efb5001-4508-11d3-aeda-00a024ffc08c"

#define NS_IEVENTLOOP_IID \
  {0x2efb5001, 0x4508, 0x11d3, \
    { 0xae, 0xda, 0x00, 0xa0, 0x24, 0xff, 0xc0, 0x8c }}

/**
 * The nsIEventLoop provides the facilities to interfact with a native 
 * application event queue.    
 */
class NS_NO_VTABLE nsIEventLoop : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IEVENTLOOP_IID)

  /********  High Level App Usage *******/
  /* void Run (in nsIEventFilter filter, in nsITranslateListener translateListener, in nsIDispatchListener dispatchListener, out long retCode); */
  NS_IMETHOD Run(nsIEventFilter *filter, nsITranslateListener *translateListener, nsIDispatchListener *dispatchListener, PRInt32 *retCode) = 0;

  /* void Exit (in long exitCode); */
  NS_IMETHOD Exit(PRInt32 exitCode) = 0;

  /* void CloneEvent (in nsIEvent event, out nsIEvent newEvent); */
  NS_IMETHOD CloneEvent(nsIEvent *event, nsIEvent **newEvent) = 0;

  /* void CreateNewEvent (out nsIEvent newEvent); */
  NS_IMETHOD CreateNewEvent(nsIEvent **newEvent) = 0;

  /* void CreateNewEventFilter (out nsIEventFilter newFilter); */
  NS_IMETHOD CreateNewEventFilter(nsIEventFilter **newFilter) = 0;

  /*******  Low Level Loop Management *****/
  /* void GetNextEvent (in nsIEventFilter filter, in nsIEvent evt); */
  NS_IMETHOD GetNextEvent(nsIEventFilter *filter, nsIEvent *evt) = 0;

  /* void PeekNextEvent (in nsIEventFilter filter, in nsIEvent evt, in boolean fRemoveEvent); */
  NS_IMETHOD PeekNextEvent(nsIEventFilter *filter, nsIEvent *evt, PRBool fRemoveEvent) = 0;

  /* void TranslateEvent (in nsIEvent evt); */
  NS_IMETHOD TranslateEvent(nsIEvent *evt) = 0;

  /* void DispatchEvent (in nsIEvent evt); */
  NS_IMETHOD DispatchEvent(nsIEvent *evt) = 0;

  /*******  Loop Manipulation ******/
  /* void SendLoopEvent (in nsIEvent evt, out long result); */
  NS_IMETHOD SendLoopEvent(nsIEvent *evt, PRInt32 *result) = 0;

  /* void PostLoopEvent (in nsIEvent evt); */
  NS_IMETHOD PostLoopEvent(nsIEvent *evt) = 0;

  /*******  Event Loop Information ******/
  /* readonly attribute nsEventLoopType EventLoopType; */
  NS_IMETHOD GetEventLoopType(nsEventLoopType *aEventLoopType) = 0;

  /* readonly attribute wstring EventLoopName; */
  NS_IMETHOD GetEventLoopName(PRUnichar * *aEventLoopName) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIEVENTLOOP \
  NS_IMETHOD Run(nsIEventFilter *filter, nsITranslateListener *translateListener, nsIDispatchListener *dispatchListener, PRInt32 *retCode); \
  NS_IMETHOD Exit(PRInt32 exitCode); \
  NS_IMETHOD CloneEvent(nsIEvent *event, nsIEvent **newEvent); \
  NS_IMETHOD CreateNewEvent(nsIEvent **newEvent); \
  NS_IMETHOD CreateNewEventFilter(nsIEventFilter **newFilter); \
  NS_IMETHOD GetNextEvent(nsIEventFilter *filter, nsIEvent *evt); \
  NS_IMETHOD PeekNextEvent(nsIEventFilter *filter, nsIEvent *evt, PRBool fRemoveEvent); \
  NS_IMETHOD TranslateEvent(nsIEvent *evt); \
  NS_IMETHOD DispatchEvent(nsIEvent *evt); \
  NS_IMETHOD SendLoopEvent(nsIEvent *evt, PRInt32 *result); \
  NS_IMETHOD PostLoopEvent(nsIEvent *evt); \
  NS_IMETHOD GetEventLoopType(nsEventLoopType *aEventLoopType); \
  NS_IMETHOD GetEventLoopName(PRUnichar * *aEventLoopName); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIEVENTLOOP(_to) \
  NS_IMETHOD Run(nsIEventFilter *filter, nsITranslateListener *translateListener, nsIDispatchListener *dispatchListener, PRInt32 *retCode) { return _to ## Run(filter, translateListener, dispatchListener, retCode); } \
  NS_IMETHOD Exit(PRInt32 exitCode) { return _to ## Exit(exitCode); } \
  NS_IMETHOD CloneEvent(nsIEvent *event, nsIEvent **newEvent) { return _to ## CloneEvent(event, newEvent); } \
  NS_IMETHOD CreateNewEvent(nsIEvent **newEvent) { return _to ## CreateNewEvent(newEvent); } \
  NS_IMETHOD CreateNewEventFilter(nsIEventFilter **newFilter) { return _to ## CreateNewEventFilter(newFilter); } \
  NS_IMETHOD GetNextEvent(nsIEventFilter *filter, nsIEvent *evt) { return _to ## GetNextEvent(filter, evt); } \
  NS_IMETHOD PeekNextEvent(nsIEventFilter *filter, nsIEvent *evt, PRBool fRemoveEvent) { return _to ## PeekNextEvent(filter, evt, fRemoveEvent); } \
  NS_IMETHOD TranslateEvent(nsIEvent *evt) { return _to ## TranslateEvent(evt); } \
  NS_IMETHOD DispatchEvent(nsIEvent *evt) { return _to ## DispatchEvent(evt); } \
  NS_IMETHOD SendLoopEvent(nsIEvent *evt, PRInt32 *result) { return _to ## SendLoopEvent(evt, result); } \
  NS_IMETHOD PostLoopEvent(nsIEvent *evt) { return _to ## PostLoopEvent(evt); } \
  NS_IMETHOD GetEventLoopType(nsEventLoopType *aEventLoopType) { return _to ## GetEventLoopType(aEventLoopType); } \
  NS_IMETHOD GetEventLoopName(PRUnichar * *aEventLoopName) { return _to ## GetEventLoopName(aEventLoopName); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIEVENTLOOP(_to) \
  NS_IMETHOD Run(nsIEventFilter *filter, nsITranslateListener *translateListener, nsIDispatchListener *dispatchListener, PRInt32 *retCode) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> Run(filter, translateListener, dispatchListener, retCode); } \
  NS_IMETHOD Exit(PRInt32 exitCode) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> Exit(exitCode); } \
  NS_IMETHOD CloneEvent(nsIEvent *event, nsIEvent **newEvent) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> CloneEvent(event, newEvent); } \
  NS_IMETHOD CreateNewEvent(nsIEvent **newEvent) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> CreateNewEvent(newEvent); } \
  NS_IMETHOD CreateNewEventFilter(nsIEventFilter **newFilter) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> CreateNewEventFilter(newFilter); } \
  NS_IMETHOD GetNextEvent(nsIEventFilter *filter, nsIEvent *evt) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> GetNextEvent(filter, evt); } \
  NS_IMETHOD PeekNextEvent(nsIEventFilter *filter, nsIEvent *evt, PRBool fRemoveEvent) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> PeekNextEvent(filter, evt, fRemoveEvent); } \
  NS_IMETHOD TranslateEvent(nsIEvent *evt) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> TranslateEvent(evt); } \
  NS_IMETHOD DispatchEvent(nsIEvent *evt) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> DispatchEvent(evt); } \
  NS_IMETHOD SendLoopEvent(nsIEvent *evt, PRInt32 *result) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> SendLoopEvent(evt, result); } \
  NS_IMETHOD PostLoopEvent(nsIEvent *evt) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> PostLoopEvent(evt); } \
  NS_IMETHOD GetEventLoopType(nsEventLoopType *aEventLoopType) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->GetEventLoopType(aEventLoopType); } \
  NS_IMETHOD GetEventLoopName(PRUnichar * *aEventLoopName) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->GetEventLoopName(aEventLoopName); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsEventLoop : public nsIEventLoop
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIEVENTLOOP

  nsEventLoop();
  virtual ~nsEventLoop();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsEventLoop, nsIEventLoop)

nsEventLoop::nsEventLoop()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsEventLoop::~nsEventLoop()
{
  /* destructor code */
}

/* void Run (in nsIEventFilter filter, in nsITranslateListener translateListener, in nsIDispatchListener dispatchListener, out long retCode); */
NS_IMETHODIMP nsEventLoop::Run(nsIEventFilter *filter, nsITranslateListener *translateListener, nsIDispatchListener *dispatchListener, PRInt32 *retCode)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void Exit (in long exitCode); */
NS_IMETHODIMP nsEventLoop::Exit(PRInt32 exitCode)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void CloneEvent (in nsIEvent event, out nsIEvent newEvent); */
NS_IMETHODIMP nsEventLoop::CloneEvent(nsIEvent *event, nsIEvent **newEvent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void CreateNewEvent (out nsIEvent newEvent); */
NS_IMETHODIMP nsEventLoop::CreateNewEvent(nsIEvent **newEvent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void CreateNewEventFilter (out nsIEventFilter newFilter); */
NS_IMETHODIMP nsEventLoop::CreateNewEventFilter(nsIEventFilter **newFilter)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void GetNextEvent (in nsIEventFilter filter, in nsIEvent evt); */
NS_IMETHODIMP nsEventLoop::GetNextEvent(nsIEventFilter *filter, nsIEvent *evt)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void PeekNextEvent (in nsIEventFilter filter, in nsIEvent evt, in boolean fRemoveEvent); */
NS_IMETHODIMP nsEventLoop::PeekNextEvent(nsIEventFilter *filter, nsIEvent *evt, PRBool fRemoveEvent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void TranslateEvent (in nsIEvent evt); */
NS_IMETHODIMP nsEventLoop::TranslateEvent(nsIEvent *evt)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void DispatchEvent (in nsIEvent evt); */
NS_IMETHODIMP nsEventLoop::DispatchEvent(nsIEvent *evt)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void SendLoopEvent (in nsIEvent evt, out long result); */
NS_IMETHODIMP nsEventLoop::SendLoopEvent(nsIEvent *evt, PRInt32 *result)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void PostLoopEvent (in nsIEvent evt); */
NS_IMETHODIMP nsEventLoop::PostLoopEvent(nsIEvent *evt)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsEventLoopType EventLoopType; */
NS_IMETHODIMP nsEventLoop::GetEventLoopType(nsEventLoopType *aEventLoopType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring EventLoopName; */
NS_IMETHODIMP nsEventLoop::GetEventLoopName(PRUnichar * *aEventLoopName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIEventLoop_h__ */
