

#ifndef _SD_ANMINFO_HXX
#define _SD_ANMINFO_HXX

#ifndef _COM_SUN_STAR_PRESENTATION_ANIMATIONEFFECT_HPP_
#include <com/sun/star/presentation/AnimationEffect.hpp>
#endif
#ifndef _COM_SUN_STAR_PRESENTATION_ANIMATIONSPEED_HPP_
#include <com/sun/star/presentation/AnimationSpeed.hpp>
#endif
#ifndef _COM_SUN_STAR_PRESENTATION_CLICKACTION_HPP_
#include <com/sun/star/presentation/ClickAction.hpp>
#endif

#ifndef _SD_ANMDEF_HXX
#include <sd/anmdef.hxx>
#endif
#ifndef _SVDOBJ_HXX 
#include <svx/svdobj.hxx>
#endif
#ifndef _SV_COLOR_HXX 
#include <vcl/color.hxx>
#endif

class Polygon;
class Point;
class SvStream;
class SdrObjSurrogate;
class SdrObject;
class SdrPathObj;
class SdDrawDocument;

class SdAnimationInfo : public SdrObjUserData, public SfxListener
{
private:

	SdDrawDocument*			pDoc;

public:

	Polygon*				pPolygon; 		
	Point					aStart;			
	Point					aEnd; 			
	::com::sun::star::presentation::AnimationEffect			eEffect;		
	::com::sun::star::presentation::AnimationEffect			eTextEffect;	
	::com::sun::star::presentation::AnimationSpeed			eSpeed;			
	BOOL					bActive;		
	BOOL					bDimPrevious;	
	BOOL					bIsMovie; 		
	BOOL					bDimHide; 		
	Color					aBlueScreen;	
	Color					aDimColor;		
	String					aSoundFile;		
	BOOL					bSoundOn; 		
	BOOL					bPlayFull;		
	SdrObjSurrogate*		pPathSuro;		
	SdrPathObj* 			pPathObj; 		
	::com::sun::star::presentation::ClickAction 			eClickAction; 	
	::com::sun::star::presentation::AnimationEffect			eSecondEffect;	
	::com::sun::star::presentation::AnimationSpeed			eSecondSpeed; 	
	String					aSecondSoundFile; 
	BOOL					bSecondSoundOn;	
	BOOL					bSecondPlayFull;
	String					aBookmark;		
	USHORT					nVerb;			
	BOOL					bInvisibleInPresentation;
	BOOL					bIsShown; 		
	BOOL					bShow;			

	BOOL					bDimmed;		

	ULONG					nPresOrder;
					SdAnimationInfo(SdDrawDocument* pTheDoc);
				SdAnimationInfo(const SdAnimationInfo& rAnmInfo);
	virtual					~SdAnimationInfo();

	virtual SdrObjUserData*	Clone(SdrObject* pObj) const;

	virtual void			WriteData(SvStream& rOut);
	virtual void			ReadData(SvStream& rIn);
	void			SetPath(SdrPathObj* pPath = NULL);
	virtual void			SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType, const SfxHint& rHint, const TypeId& rHintType);
	virtual void			AfterRead();
};

#endif 

