

#ifndef _SD_CUSSHOW_HXX
#define _SD_CUSSHOW_HXX

#ifndef _LIST_HXX 
#include <tools/list.hxx>
#endif

#ifndef _STREAM_HXX 
#include <tools/stream.hxx>
#endif

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif

#ifndef _CPPUHELPER_WEAKREF_HXX_
#include <cppuhelper/weakref.hxx>
#endif

class SdDrawDocument;

class SdCustomShow : public List
{
private:
	String          aName;
	SdDrawDocument* pDoc;

	::com::sun::star::uno::WeakReference< ::com::sun::star::uno::XInterface > mxUnoCustomShow;

public:
	SdCustomShow(SdDrawDocument* pDrawDoc);
	SdCustomShow(SdDrawDocument* pDrawDoc, ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > xShow );

	SdCustomShow( const SdCustomShow& rShow );
	virtual ~SdCustomShow();

	void   SetName(const String& rName) { aName = rName; }
	String GetName() const              { return aName; }

	SdDrawDocument* GetDoc() const { return pDoc; }

	friend SvStream& operator << (SvStream& rOut, const SdCustomShow& rCustomShow);
	friend SvStream& operator >> (SvStream& rIn, SdCustomShow& rCustomShow);

	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > getUnoCustomShow();
};

#endif      

