

#ifndef _SDDLL_HXX
#define _SDDLL_HXX

#ifndef _SFXMODULE_HXX 
#include <sfx2/module.hxx>
#endif
#ifndef _SFXDEFS_HXX 
#include <sfx2/sfxdefs.hxx>
#endif

class SvFactory;
class SotFactory;
class SfxMedium;
class SfxFilter;

class SdDLL
{
protected:
	static void     RegisterFactorys();
	static void     RegisterInterfaces();
	static void     RegisterControllers();

public:
			SdDLL();
		~SdDLL();

	static void 	LibInit();	
	static void 	LibExit();	

	static void     Init();     
	static void     Exit();     

	static ULONG    DetectFilter(SfxMedium& rMedium, const SfxFilter** pFilter,
					 SfxFilterFlags nMust, SfxFilterFlags nDont);
};

class SdModuleDummy : public SfxModule
{
public:
	TYPEINFO();

#ifndef SO3
	SvFactory* pSdDrawDocShellFactory;
	SvFactory* pSdGraphicDocShellFactory;
	   SdModuleDummy(ResMgr* pResMgr, BOOL bDummy,
				 SvFactory* pDrawObjFact, SvFactory* pGraphicObjFact)
#else
	SotFactory* pSdDrawDocShellFactory;
	SotFactory* pSdGraphicDocShellFactory;
	   SdModuleDummy(ResMgr* pResMgr, BOOL bDummy,
				 SotFactory* pDrawObjFact, SotFactory* pGraphicObjFact)
#endif
	  : SfxModule(pResMgr, bDummy,
				   (SfxObjectFactory*) (pDrawObjFact ? pDrawObjFact    : pGraphicObjFact),
			   (SfxObjectFactory*) (pDrawObjFact ? pGraphicObjFact : pDrawObjFact),
			   0L),
	 pSdDrawDocShellFactory( pDrawObjFact ),
	 pSdGraphicDocShellFactory( pGraphicObjFact )
	  {}

	virtual SfxModule*  Load();

	static SvGlobalName GetID(USHORT nFileFormat);
	static USHORT       HasID(const SvGlobalName& rName);
};

#ifndef _SD_DLL                      
#define SD_MOD() ( *(SdModuleDummy**) GetAppData(SHL_DRAW) )
#endif

#endif                               

