
#ifndef _SIFSYS_HXX
#define _SIFSYS_HXX

#ifndef _FSYS_HXX
#include <tools/fsys.hxx>
#endif

class SiDirEntry : public DirEntry
{
public:
		SiDirEntry( DirEntryFlag aDirFlag = FSYS_FLAG_CURRENT );
		SiDirEntry( const DirEntry& rEntry );
		SiDirEntry( const ByteString& rInitName, FSysPathStyle eParser = FSYS_STYLE_HOST );
		SiDirEntry( const String& rInitName, FSysPathStyle eParser = FSYS_STYLE_HOST );

		ByteString		GetName( FSysPathStyle eFormatter = FSYS_STYLE_HOST ) const;
		String			GetNameUni( FSysPathStyle eFormatter = FSYS_STYLE_HOST ) const;

		ByteString		GetFull( FSysPathStyle eFormatter = FSYS_STYLE_HOST,
					 BOOL bWithDelimiter = FALSE,
					 USHORT nMaxChars = STRING_MAXLEN ) const;

		String	 		GetFullUni( FSysPathStyle eFormatter = FSYS_STYLE_HOST,
					 BOOL bWithDelimiter = FALSE,
					 USHORT nMaxChars = STRING_MAXLEN ) const;
};

#endif
