

#include <setup2/os.hxx>

#ifndef SETUP_ZIPFILE_HXX
#define SETUP_ZIPFILE_HXX

class SiFile;

class SiZipFile
{
	SiFile *m_pFile;
	Link    m_aProgressLink;
	ULONG   m_lBytesWritten;

	USHORT 	m_nFiles;
	ULONG 	m_nSize;

	static SiZipFile *m_pThis;

	static void UnzipCallback(long lBytesWritten);
	static void EnumFilesCallBack(char *pFile, ULONG nSize, void *pObject);
	 void OnEnumFile(char *pFile, ULONG nSize);

public:
	SiZipFile();
	~SiZipFile();

	void	DetectFilesAndSize(const ByteString& rFilename);
	USHORT	GetFiles() const { return m_nFiles; }
	ULONG	GetSize() const { return m_nSize; }

	BOOL 	AddSubfileListTo(ByteString const& aZipFile, SiFile*,
				 const char* pPattern = OS::GetAllFilesWildCard());

	int  	Unzip(ByteString const& aZipFile, ByteString const& anExtractName,
				BOOL bDoDontOverwriteUnzip = FALSE );

	ULONG	GetCRC32(ByteString const& aZipFile);
	int		CRCCheck(ByteString const& aZipFile);

	ULONG	GetBytesWritten() const { return m_lBytesWritten; }
	void 	SetProgressHdl(Link const& aLink) { m_aProgressLink = aLink; }
};

#endif 
