
#ifndef _SFX_CLIENTSH_HXX
#define _SFX_CLIENTSH_HXX

#ifndef _IPCLIENT_HXX 
#include <so3/ipclient.hxx>
#endif
struct SfxInPlaceClient_Impl;
class SfxViewShell;
class INetURLObject;

class SfxInPlaceClient : public SvInPlaceClient
{
	SfxInPlaceClient_Impl*	pImp;
	SfxViewShell*			pViewSh;

public:
			SfxInPlaceClient( SfxViewShell* pViewShell,
							  Window* pDraw );
			SfxInPlaceClient( SfxViewShell* pViewShell,
							  SvInPlaceClient* pParent );
	virtual 			~SfxInPlaceClient();

	virtual void    	Opened( BOOL bOpen );
	virtual void        Embedded( BOOL bEmbedding );
	virtual void		Connected( BOOL bConnect );
	virtual void    	InPlaceActivate( BOOL bActivate );
	virtual void		UIActivate( BOOL );
	virtual void    	RequestObjAreaPixel( const Rectangle & rObjRect );
	virtual void 		MakeViewData();
	virtual void		FreeViewData();
	virtual void		MakeVisible();
	virtual ErrCode		GetContURL( INetURLObject & );

	SfxViewShell*		GetViewShell() const { return pViewSh; }

#if 0 // _SOLAR__PRIVATE
	DECL_LINK			(TimerHdl_Impl, Timer*);
#endif
};

SO2_DECL_IMPL_REF(SfxInPlaceClient)

#endif

