
#ifndef _SFXDOCTDLG_HXX
#define _SFXDOCTDLG_HXX

#include <sfx2/doctempl.hxx>

#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

class SfxModalDefParentHelper;

class SfxDocumentTemplateDlg : public ModalDialog
{
private:

	FixedLine		aEditFL;
	Edit 			aNameEd;
	FixedLine 		aTemplateFL;
	FixedText		aRegionFt;
	ListBox			aRegionLb;
	FixedText		aTemplateFt;
	ListBox			aTemplateLb;

	OKButton		aOkBt;
	CancelButton	aCancelBt;
	HelpButton		aHelpBt;
	PushButton		aEditBt;
	PushButton		aOrganizeBt;

	SfxDocumentTemplates *pTemplates;

	SfxModalDefParentHelper* pHelper;

	void Init();

	DECL_LINK( OrganizeHdl, Button * );
	DECL_LINK( OkHdl, Control * );
	DECL_LINK( RegionSelect, ListBox * );
	DECL_LINK( TemplateSelect, ListBox * );
	DECL_LINK( NameModify, Edit * );
	DECL_LINK( EditHdl, Button * );

public:
	SfxDocumentTemplateDlg(Window * pParent, SfxDocumentTemplates* pTempl );
	~SfxDocumentTemplateDlg();

	String GetTemplateName() const
	{ return aNameEd.GetText().EraseLeadingChars(); }
	String GetTemplatePath();
	void NewTemplate(const String &rPath);
	USHORT GetRegion() const { return aRegionLb.GetSelectEntryPos(); }
};

#endif

