
#ifndef _SFXDOCTEMPL_HXX
#define _SFXDOCTEMPL_HXX

#ifndef _REF_HXX 
#include <tools/ref.hxx>
#endif
#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif

class SfxObjectShell;

#ifndef SFX_DECL_OBJECTSHELL_DEFINED
#define SFX_DECL_OBJECTSHELL_DEFINED
SV_DECL_REF(SfxObjectShell)
SV_DECL_LOCK(SfxObjectShell)
#endif

class SfxDocTemplate_Impl;

#ifndef SFX_DECL_DOCTEMPLATES_DEFINED
#define SFX_DECL_DOCTEMPLATES_DEFINED
SV_DECL_REF(SfxDocTemplate_Impl)
#endif

class SfxDocumentTemplates
{
private:
	SfxDocTemplate_ImplRef	pImp;

	BOOL				CopyOrMove( USHORT nTargetRegion, USHORT nTargetIdx,
						USHORT nSourceRegion, USHORT nSourceIdx, BOOL bMove );
public:
			SfxDocumentTemplates();
			SfxDocumentTemplates(const SfxDocumentTemplates &);
			~SfxDocumentTemplates();

	BOOL				IsConstructed() { return pImp != NULL; }
	void				Construct();

	static BOOL			SaveDir(  ) ;
	const SfxDocumentTemplates &operator=(const SfxDocumentTemplates &);

	BOOL				Rescan();		

	BOOL                IsRegionLoaded( USHORT nIdx ) const;
	USHORT				GetRegionCount() const;
	const String&		GetRegionName(USHORT nIdx) const;					
	String 				GetFullRegionName(USHORT nIdx) const;
	USHORT				GetRegionNo( const String &rRegionName ) const;

	USHORT				GetCount(USHORT nRegion) const;
	USHORT				GetCount( const String &rName) const;
	const String&		GetName(USHORT nRegion, USHORT nIdx) const;			
	String				GetFileName(USHORT nRegion, USHORT nIdx) const;
	String				GetPath(USHORT nRegion, USHORT nIdx) const;

	String				GetDefaultTemplatePath(const String &rLongName);

	String				GetTemplatePath(USHORT nRegion, const String &rLongName) const;

	void			NewTemplate(USHORT nRegion,
					const String &rLongName,
					const String &rFileName);

	BOOL			Copy(USHORT nTargetRegion,
			 USHORT nTargetIdx,
			 USHORT nSourceRegion,
			 USHORT nSourceIdx);
	BOOL			Move(USHORT nTargetRegion,
			 USHORT nTargetIdx,
			 USHORT nSourceRegion,
			 USHORT nSourceIdx);
	BOOL			Delete(USHORT nRegion, USHORT nIdx);
	BOOL			InsertDir(const String &rText, USHORT nRegion);
	BOOL			SetName(const String &rName, USHORT nRegion, USHORT nIdx);

	BOOL			CopyTo(USHORT nRegion, USHORT nIdx, const String &rName) const;
	BOOL			CopyFrom(USHORT nRegion, USHORT nIdx, String &rName);

	SfxObjectShellRef CreateObjectShell(USHORT nRegion, USHORT nIdx);
	BOOL 			DeleteObjectShell(USHORT, USHORT);

	BOOL 			GetFull( const String& rRegion, const String& rName, String& rPath );
	BOOL 			GetLogicNames( const String& rPath, String& rRegion, String& rName ) const;
};

#endif 

