
#ifndef _SFX_EXPTYPES_HXX
#define _SFX_EXPTYPES_HXX

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif

class FileStat;
#ifdef ENABLE_INIMANAGER
class SfxIniManager;
#endif
class FixedText;
class BigInt;
class DateTime;
class DirEntry;
class Window;

String CreateKBText( ULONG nSize );

#if SUPD < 535
String CreateSizeText( ULONG nSize, BOOL bExtraBytes = TRUE );
String CreateSizeText( ULONG nSize, BOOL bExtraBytes, BOOL bSmartExtraBytes );
#else
String CreateSizeText( ULONG nSize, BOOL bExtraBytes = TRUE, BOOL bSmartExtraBytes = FALSE );
#endif

#if SUPD < 535
String ExtendedCreateSizeText( const BigInt& rInt );
String ExtendedCreateSizeText( const BigInt& rInt, BOOL bExtraBytes, BOOL bSmartExtraBytes );
#else
String ExtendedCreateSizeText( const BigInt& rInt, BOOL bExtraBytes = TRUE, BOOL bSmartExtraBytes = FALSE );
#endif

String CreateExactSizeText( ULONG nSize );
String CreateExactSizeText( const BigInt& nSize );

String ConvertWithTilde( const String& rTxt );

void CreateDateTimeText( const DateTime& rDT, String& rText );

String Create_CreateDate_Text( const FileStat& rFileStat );

String Create_ChangeDate_Text( const FileStat& rFileStat );
#ifdef ENABLE_INIMANAGER

String GetAddressToken( USHORT nToken, SfxIniManager* pMgr = NULL );

#define ADRPOS_COMPANY		((USHORT) 0)
#define ADRPOS_STREET		((USHORT) 1)
#define ADRPOS_COUNTRY		((USHORT) 2)
#define ADRPOS_PLZ			((USHORT) 3)
#define ADRPOS_CITY			((USHORT) 4)
#define ADRPOS_TITLE		((USHORT) 5)
#define ADRPOS_POSITION		((USHORT) 6)
#define ADRPOS_TEL_PRIVATE	((USHORT) 7)
#define ADRPOS_TEL_COMPANY	((USHORT) 8)
#define ADRPOS_FAX			((USHORT) 9)
#define ADRPOS_EMAIL		((USHORT)10)
#define ADRPOS_STATE		((USHORT)11)
#endif

void InsertPathInFixedText( FixedText& rFT, const DirEntry& rEntry );

BOOL Trim_And_Test_Text( Window& rWnd );

#endif

