

#ifndef _FRAMEOBJ_HXX
#define _FRAMEOBJ_HXX

#ifndef _IPOBJ_HXX 
#include <so3/ipobj.hxx>
#endif
#include <sfx2/app.hxx>

struct SfxFrameObject_Impl;
class SfxFrameDescriptor;

struct SfxFrameObjectFactoryPtr
{

	SotFactory *pSfxFrameObjectFactory;
	SfxFrameObjectFactoryPtr();
};

class SfxFrameObject : public SvInPlaceObject

{
	SfxFrameObject_Impl*	pImpl;

#if 0 // _SOLAR__PRIVATE
	void					DataChanged_Impl( BOOL bOnlyEmbedSource );
	DECL_LINK(				NewObjectHdl_Impl, Timer* );
#endif

protected:
	BOOL					ConstructFrame();
#if SUPD<=628
	virtual void    		FillClass( SvGlobalName * pClassName,
				   ULONG * pFormat,
				   String * pAppName,
				   String * pFullTypeName,
				   String * pShortTypeName ) const;
 #else
	virtual void            FillClass( SvGlobalName * pClassName,
				   ULONG * pFormat,
				   String * pAppName,
				   String * pFullTypeName,
				   String * pShortTypeName,
	                           long nFileFormat = SOFFICE_FILEFORMAT_CURRENT ) const;
#endif

	virtual void    		Open( BOOL bOpen );
	virtual void    		InPlaceActivate( BOOL );
	virtual ErrCode    		Verb( long, SvEmbeddedClient * pCallerClient,
					Window * pWin, const Rectangle * pWorkRectPixel );

	virtual void    		SetVisArea( const Rectangle & rVisArea );
	virtual Rectangle 		GetVisArea( USHORT nAspect ) const;
	virtual void    		Draw( OutputDevice *,
					const JobSetup & rSetup,
					USHORT nAspect = ASPECT_CONTENT );

	virtual BOOL    		InitNew( SvStorage * );
	virtual BOOL    		Load( SvStorage * );
	virtual BOOL    		Save();
	virtual BOOL    		SaveAs( SvStorage * );
	virtual void   			HandsOff();
	virtual BOOL    		SaveCompleted( SvStorage * );
					~SfxFrameObject();
public:

	static SfxFrameObjectFactoryPtr*
				GetFactoryPtr();
					SO2_DECL_BASIC_CLASS_DLL(SfxFrameObject, GetFactoryPtr())
					SfxFrameObject();

	virtual ULONG			GetMiscStatus() const;
	virtual BOOL			IsLink() const;
	void					SetFrameDescriptor( const SfxFrameDescriptor*);
	const SfxFrameDescriptor*
				GetFrameDescriptor() const;
	SfxFrame*				GetFrame() const;

#if 0 // _SOLAR__PRIVATE
	void					ReleaseFrame_Impl();
#endif
};

inline SfxFrameObjectFactoryPtr::SfxFrameObjectFactoryPtr()
	: pSfxFrameObjectFactory(0) 	
{

}

SO2_DECL_IMPL_REF(SfxFrameObject)

class SfxInsertFloatingFrameDialog
{
	Window*				pParentWindow;
public:
			SfxInsertFloatingFrameDialog( Window *pParent );
	SvInPlaceObjectRef	Execute( SvStorage* pStor );
};

#endif
