
#ifndef _SFXGENLINK_HXX
#define _SFXGENLINK_HXX

#ifndef _LINK_HXX 
#include <tools/link.hxx>
#endif
typedef long (*CFuncPtr)(void*);

class GenLink
{
	Link        aLink;
	CFuncPtr    pFunc;

public:
	GenLink(): pFunc(0) {}
	GenLink( CFuncPtr pCFunc ): pFunc(pCFunc) {}
	GenLink( const Link& rLink ): aLink(rLink), pFunc(0) {}
	GenLink( const GenLink& rOrig ):
		pFunc(rOrig.pFunc), aLink(rOrig.aLink) {}

	GenLink& operator = ( const GenLink& rOrig )
		{ pFunc = rOrig.pFunc; aLink = rOrig.aLink; return *this; }

	BOOL operator!() const { return !aLink && !pFunc; }
	BOOL IsSet() const { return aLink.IsSet() || pFunc; }

	long Call( void* pCaller )
		 { return pFunc ? (*pFunc)(pCaller) : aLink.Call(pCaller); }
};

#endif
