
#ifndef _SFX_IPFRM_HXX
#define _SFX_IPFRM_HXX

#include <sfx2/viewfrm.hxx>
#include <sfx2/objface.hxx>
#include <sfx2/objsh.hxx>

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

class SfxItemSet;
class SfxItemPool;
class SfxViewShell;
class SfxInPlaceFrame;
class SfxInPlaceEnv_Impl;
class SvInPlaceClipWindow;
class SvInPlaceWindow;
class SfxConfigManager;
class SfxBorderWindow;
struct SfxInPlaceFrame_Impl;

class SfxInPlaceFrame: public SfxViewFrame
{
friend SfxBorderWindow; 

	SfxInPlaceFrame_Impl*	pImp; 
	SfxInPlaceEnv_Impl*     pEnv;
	SfxViewShell*			pViewShell;

protected:

	virtual void            Activate( BOOL bUI );
	virtual void            Deactivate( BOOL bUI );
	virtual BOOL            Close();

	virtual void            SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
						const SfxHint& rHint, const TypeId& rHintType );
	virtual void            ShowStatusText( const String& rText );
	virtual void            HideStatusText();
	virtual                 ~SfxInPlaceFrame();

public:
				TYPEINFO();
				SFX_DECL_INTERFACE(SFX_INTERFACE_SFXIPFRM);
					SfxInPlaceFrame( SfxObjectShell &rObjSh, SfxFrame*p=0 );

	virtual void            SetZoomFactor( const Fraction &rZoomX,
							   const Fraction &rZoomY );

	void                    Exec(SfxRequest &);
	void                    GetState(SfxItemSet &);

	virtual void            Optimize();

	void                    SetChildWindow(const ResId& rResId);

	virtual BOOL			SetBorderPixelImpl( const SfxViewShell *pSh,
									const SvBorder &rBorder );
	virtual const SvBorder& GetBorderPixelImpl( const SfxViewShell *pSh ) const;
	virtual void			InvalidateBorderImpl( const SfxViewShell *pSh );

#ifndef _SFXDOC_HXX
	SfxInPlaceObject*		GetIPObject_Impl()
					{ return GetObjectShell()->GetInPlaceObject(); }
	SfxInPlaceEnv_Impl* 	GetEnv_Impl() const
					 { 	return pEnv; }
#endif
};

#endif

