
#ifndef _MACROPG_HXX
#define _MACROPG_HXX

#include <sfx2/basedlgs.hxx>
#include <sfx2/tabdlg.hxx>

#ifndef _SFXMACITEM_HXX 
#include <svtools/macitem.hxx>
#endif
#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif
class _SfxMacroTabPage;
class SvStringsDtor;
class SvTabListBox;
class Edit;
class MultiLineEdit;
class String;

#if SUPD>399
typedef SvStringsDtor* (*FNGetRangeHdl)( _SfxMacroTabPage*,
							const String& rLanguage );

typedef SvStringsDtor* (*FNGetMacrosOfRangeHdl)( _SfxMacroTabPage*,
									const String& rLanguage,
									const String& rRange );
#else
typedef SvStringsDtor* (*FNGetRangeHdl)( _SfxMacroTabPage*,
							ScriptType eType );

typedef SvStringsDtor* (*FNGetMacrosOfRangeHdl)( _SfxMacroTabPage*,
									ScriptType eType,
									const String& rRange );
#endif

class SfxConfigGroupListBox_Impl;
class SfxConfigFunctionListBox_Impl;

class _SfxMacroTabPage : public SfxTabPage
{
	SvxMacroTableDtor aTbl;
#if 0 // _SOLAR__PRIVATE
	DECL_STATIC_LINK( _SfxMacroTabPage, SelectEvent_Impl, SvTabListBox * );
	DECL_STATIC_LINK( _SfxMacroTabPage, SelectGroup_Impl, ListBox * );
	DECL_STATIC_LINK( _SfxMacroTabPage, SelectMacro_Impl, ListBox * );

	DECL_STATIC_LINK( _SfxMacroTabPage, DoubleClickHdl_Impl, Control* );
	DECL_STATIC_LINK( _SfxMacroTabPage, AssignDeleteHdl_Impl, PushButton * );

	DECL_STATIC_LINK( _SfxMacroTabPage, ChangeScriptHdl_Impl, RadioButton * );
	DECL_STATIC_LINK( _SfxMacroTabPage, GetFocus_Impl, Edit* );
#endif
protected:
	PushButton*		pAssignPB;
	PushButton*		pDeletePB;
	ListBox*		pScriptTypeLB;
	SvTabListBox*	pEventLB;
	SfxConfigGroupListBox_Impl* pGroupLB;
	SfxConfigFunctionListBox_Impl* pMacroLB;
	 FixedLine*      pEventGB;
	FixedLine*      pMacroGB;
	String*			pMacroStr;
#if SUPD<582
	String*			pJavaStr;
	MultiLineEdit*	pJavaED;
#endif
	FNGetRangeHdl	fnGetRange;
	FNGetMacrosOfRangeHdl fnGetMacroOfRange;

	BOOL			bReadOnly;

	_SfxMacroTabPage( Window* pParent, const ResId& rId,
			const SfxItemSet& rItemSet );

	void InitAndSetHandler();
	void FillEvents();
	void FillMacroList();
	void EnableButtons( const String& rLanguage );

public:

	virtual ~_SfxMacroTabPage();

	void AddEvent( const String & rEventName, USHORT nEventId );

	const SvxMacroTableDtor& GetMacroTbl() const 	  { return aTbl; }
	void SetMacroTbl( const SvxMacroTableDtor& rTbl ) { aTbl = rTbl; }
	void ClearMacroTbl()							  { aTbl.DelDtor(); }

	virtual void ScriptChanged( const String& rLanguage );

	void SetGetRangeLink( FNGetRangeHdl pFn ) 	{ fnGetRange = pFn; }
	FNGetRangeHdl GetGetRangeLink() const 		{ return fnGetRange; }
	void SetGetMacrosOfRangeLink( FNGetMacrosOfRangeHdl pFn )	{ fnGetMacroOfRange = pFn; }
	FNGetMacrosOfRangeHdl GetGetMacrosOfRangeLink() const 		{ return fnGetMacroOfRange; }

	virtual	BOOL FillItemSet( SfxItemSet& rSet );
	virtual	void Reset( const SfxItemSet& rSet );

	void SetReadOnly( BOOL bSet )
			{ bReadOnly = bSet; }
	BOOL IsReadOnly() const
			{ return bReadOnly; }
	void SelectEvent( const String& rEventName, USHORT nEventId );
};

class SfxMacroTabPage : public _SfxMacroTabPage
{
public:
	SfxMacroTabPage( Window* pParent, const ResId& rId,
		const SfxItemSet& rSet );

	static SfxTabPage* Create( Window* pParent, const SfxItemSet& rAttrSet );
};

class SfxSmallMacroTabPage : public _SfxMacroTabPage
{
public:
	SfxSmallMacroTabPage( Window* pParent, const ResId& rId,
		const SfxItemSet& rSet );

	static SfxTabPage* Create( Window* pParent, const SfxItemSet& rAttrSet );
};

class SfxMacroAssignDlg : public SfxSingleTabDialog
{
public:
	SfxMacroAssignDlg( Window* pParent, SfxItemSet& rSet );
	virtual	~SfxMacroAssignDlg();
};

#endif
