
#ifndef _SFX_MINFITEM_HXX
#define _SFX_MINFITEM_HXX

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
class BasicManager;

class SfxMacroInfoItem: public SfxPoolItem
{
	const BasicManager* 	pBasicManager;
	String					aLibName;
	String					aModuleName;
	String					aMethodName;
	String					aCommentText;

public:
	TYPEINFO();
	SfxMacroInfoItem( USHORT nWhich,
		const BasicManager* pMgr,
		const String &rLibName,
		const String &rModuleName,
		const String &rMethodName,
		const String &rComment);

	SfxMacroInfoItem( const SfxMacroInfoItem& );

	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual int 			operator==( const SfxPoolItem& ) const;
	String					GetComment() const
					{ return aCommentText; }
	void					SetComment( const String& r )
					{ aCommentText = r; }
	String					GetMethod() const
					{ return aMethodName; }
	void					SetMethod( const String& r )
					{ aMethodName = r; }
	String					GetModule() const
					{ return aModuleName; }
	void					SetModule( const String& r )
					{ aModuleName = r; }
	String					GetLib() const
					{ return aLibName; }
	void					SetLib( const String& r )
					{ aLibName = r; }
	const BasicManager* 	GetBasicManager() const
				{ return pBasicManager; }
	String					GetQualifiedName() const;
};

#endif
