
#ifndef _SFXMINSTACK_HXX
#define _SFXMINSTACK_HXX

#ifndef _SFXVARARR_HXX
#include <sfx2/minarray.hxx>
#endif

#define DECL_OBJSTACK( ARR, T, nI, nG ) \
DECL_OBJARRAY( ARR##arr_, T, nI, nG ); \
class ARR: private ARR##arr_ \
{ \
public: \
	ARR( BYTE nInitSize = nI, BYTE nGrowSize = nG ): \
		ARR##arr_( nInitSize, nGrowSize ) \
	{} \
\
	ARR( const ARR& rOrig ): \
		ARR##arr_( rOrig ) \
	{} \
\
	USHORT		Count() const { return ARR##arr_::Count(); } \
	void		Push( const T& rElem ) { Append( rElem ); } \
	const T& Top( USHORT nLevel = 0 ) const \
	            { return (*this)[Count()-nLevel-1]; } \
	const T& Bottom() const { return (*this)[0]; } \
	T		 Pop(); \
	void		Clear() { ARR##arr_::Clear(); } \
	BOOL		Contains( const T& rItem ) const \
	{ return ARR##arr_::Contains( rItem ); } \
}

#define IMPL_OBJSTACK( ARR, T ) \
IMPL_OBJARRAY( ARR##arr_, T ); \
\
T ARR::Pop() \
{	T aRet = (*this)[Count()-1]; \
	Remove( Count()-1, 1 ); \
	return aRet; \
}

#define DECL_PTRSTACK( ARR, T, nI, nG ) \
DECL_PTRARRAY( ARR##arr_, T, nI, nG ); \
class ARR: private ARR##arr_ \
{ \
public: \
	ARR( BYTE nInitSize = nI, BYTE nGrowSize = nG ): \
		ARR##arr_( nInitSize, nGrowSize ) \
	{} \
\
	ARR( const ARR& rOrig ): \
		ARR##arr_( rOrig ) \
	{} \
\
	USHORT		Count() const { return ARR##arr_::Count(); } \
	void		Push( T rElem ) { Append( rElem ); } \
	BOOL        Replace( T rOldElem, T rNewElem ) \
	            { return ARR##arr_::Replace( rOldElem, rNewElem ); } \
	T			Top( USHORT nLevel = 0 ) const \
	            { return (*this)[Count()-nLevel-1]; } \
	T			Bottom() const { return (*this)[0]; } \
	T			Pop() \
	{	T aRet = (*this)[Count()-1]; \
	                Remove( Count()-1, 1 ); \
	                return aRet; \
	            } \
	T*		 operator*() \
	            { return &(*this)[Count()-1]; } \
	void		Clear() { ARR##arr_::Clear(); } \
	BOOL		Contains( const T pItem ) const \
	{ return ARR##arr_::Contains( pItem ); } \
}

#endif

