
#ifndef _SFXMSGPOOL_HXX
#define _SFXMSGPOOL_HXX

#pragma hdrstop

#include <sfx2/msg.hxx>

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif
#ifndef _SVARRAY_HXX
#include <svtools/svarray.hxx>
#endif

class  SfxInterface;
class  SfxSlot;
class  SfxInterfaceArr_Impl;
class  SfxSlotGroupArr_Impl;
class  SfxSlotTypeArr_Impl;
class  IdPool;
class  SbxObject;
struct SfxSIDRegistration_Impl;
class  SvStream;
class SfxSlotArr_Impl;

class SfxSlotPool
{
	IdPool* 					_pIdPool;
	SfxSlotGroupArr_Impl*		_pGroups;
	SfxSlotTypeArr_Impl*		_pTypes;
	SfxSlotPool*				_pParentPool;
	ResMgr*						_pResMgr;
	SfxInterfaceArr_Impl*		_pInterfaces;
	USHORT						_nCurGroup;
	USHORT						_nCurInterface;
	USHORT						_nCurMsg;
	SfxSlotArr_Impl*			_pUnoSlots;

private:
	const SfxSlot*		SeekSlot( USHORT nObject );

public:
			SfxSlotPool( SfxSlotPool* pParent=0, ResMgr* pMgr=0);
			~SfxSlotPool();

	void				RegisterInterface( SfxInterface& rFace );
	void				ReleaseInterface( SfxInterface& rFace );
	SfxInterface*       FirstInterface();
	SfxInterface*       NextInterface();

	IdPool& 			GetIdPool();
	void				StoreId( SvStream& rStream, USHORT nId );
	void				LoadId( SvStream& rStream, USHORT &rId );
	USHORT				RegisterSID( const String &rGroup, const String &rName );
	void  				ReleaseSID( const String &rGroup, const String &rName );

	USHORT				GetGroupCount();
	String				SeekGroup( USHORT nNo );
	const SfxSlot*		FirstSlot();
	const SfxSlot*		NextSlot();
	const SfxSlot*		GetSlot( USHORT nId );
	const SfxSlot*		GetUnoSlot( USHORT nId );
	const SfxSlot*		GetUnoSlot( const String& rUnoName );
	String				GetSlotName_Impl(USHORT nId,
							 String *pHelpText = 0) const;
	String				GetSlotName_Impl(const SfxSlot &rSlot,
							 String *pHelpText = 0) const
			{
				return GetSlotName_Impl(rSlot.GetSlotId(), pHelpText);
			}
	String 				GetSlotHelpText_Impl(USHORT nId) const;
	String 				GetSlotHelpText_Impl(const SfxSlot &rSlot) const
			{
				return GetSlotHelpText_Impl(rSlot.GetSlotId());
			}

	TypeId				GetSlotType( USHORT nSlotId ) const;
	SbxObject*			GetSbxObject(USHORT nId) const;

#ifdef STARBASIC
	USHORT				RegisterMacro( sbToken aToken );
	void				ReleaseMacro( sbToken aToken );
#endif
};

inline const SfxSlot* SfxSlotPool::FirstSlot()
{
	return SeekSlot(0);
}

#define SFX_SLOTPOOL() SFX_APP()->GetSlotPool()

#endif

