

#ifndef _SFX_PRINTOPT_HXX
#define _SFX_PRINTOPT_HXX

#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX 
#include <vcl/button.hxx>
#endif
#ifndef _SV_LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_PRINT_HXX
#include <vcl/print.hxx>
#endif

#include <sfx2/tabdlg.hxx>

class SvtBasePrintOptions;

class SfxCommonPrintOptionsTabPage : public SfxTabPage
{
private:
	 FixedLine           aReduceGB;
	 FixedText           aOutputTypeFT;
	RadioButton         aPrinterOutputRB;
	RadioButton         aPrintFileOutputRB;
	 FixedLine           aOutputGB;
	 CheckBox            aReduceTransparencyCB;
	RadioButton         aReduceTransparencyAutoRB;
	RadioButton         aReduceTransparencyNoneRB;
	 CheckBox            aReduceGradientsCB;
	RadioButton         aReduceGradientsStripesRB;
	RadioButton         aReduceGradientsColorRB;
	NumericField        aReduceGradientsStepCountNF;
	 CheckBox            aReduceBitmapsCB;
	RadioButton         aReduceBitmapsOptimalRB;
	RadioButton         aReduceBitmapsNormalRB;
	RadioButton         aReduceBitmapsResolutionRB;
	CheckBox            aReduceBitmapsTransparencyCB;
	ListBox             aReduceBitmapsResolutionLB;
	 CheckBox            aConvertToGreyscalesCB;
	 FixedLine           aWarnGB;
	 CheckBox			aPaperSizeCB;
	CheckBox			aPaperOrientationCB;
	CheckBox			aTransparencyCB;

private:
	 PrinterOptions      maPrinterOptions;
	PrinterOptions      maPrintFileOptions;
	                     DECL_LINK( ToggleOutputPrinterRBHdl, RadioButton* pButton );
	                    DECL_LINK( ToggleOutputPrintFileRBHdl, RadioButton* pButton );
	                     DECL_LINK( ClickReduceTransparencyCBHdl, CheckBox* pBox );
	                    DECL_LINK( ClickReduceGradientsCBHdl, CheckBox* pBox );
	                    DECL_LINK( ClickReduceBitmapsCBHdl, CheckBox* pBox );
	                     DECL_LINK( ToggleReduceGradientsStripesRBHdl, RadioButton* pButton );
	                    DECL_LINK( ToggleReduceBitmapsResolutionRBHdl, RadioButton* pButton );
	 void                ImplUpdateControls( const PrinterOptions* pCurrentOptions );
	void                ImplSaveControls( PrinterOptions* pCurrentOptions );

protected:
	 virtual int         DeactivatePage( SfxItemSet* pSet = NULL );

public:
	                     SfxCommonPrintOptionsTabPage( Window* pParent, const SfxItemSet& rSet );
	                 ~SfxCommonPrintOptionsTabPage();

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
};

class TransparencyPrintWarningBox : public ModalDialog
{
private:

	FixedImage		aWarnFI;
	FixedText		aWarnFT;
	OKButton		aYesBtn;
	PushButton	    aNoBtn;
	CancelButton    aCancelBtn;
	CheckBox		aNoWarnCB;
	                 DECL_LINK( ClickNoBtn, PushButton* );

public:
			TransparencyPrintWarningBox( Window* pParent );
		~TransparencyPrintWarningBox();

	BOOL			IsNoWarningChecked() const { return aNoWarnCB.IsChecked(); }
};

#endif 

