
#ifndef _SFX_PRNMON_HXX
#define _SFX_PRNMON_HXX

#ifndef _BUTTON_HXX 
#include <vcl/button.hxx>
#endif
#ifndef _DIALOG_HXX 
#include <vcl/dialog.hxx>
#endif
#include <sfx2/printer.hxx>
#include <sfx2/progress.hxx>

class SfxViewShell;
class SfxProgress;
struct SfxPrintProgress_Impl;

#define PAGE_MAX    9999        

class SfxPrintProgress: public SfxProgress
{
	SfxPrintProgress_Impl*  pImp;

private:
#if 0 // _SOLAR__PRIVATE
	DECL_LINK( PrintErrorNotify, void * );
	DECL_LINK( EndPrintNotify, void * );
#endif
public:
				SfxPrintProgress( SfxViewShell* pViewSh,
								  FASTBOOL bShow = TRUE );
	virtual                 ~SfxPrintProgress();

	virtual void            SetText( const String &rText );
			BOOL            SetStateText( ULONG nVal, const String &rVal, ULONG nNewRange = 0 );
	virtual BOOL            SetState( ULONG nVal, ULONG nNewRange = 0 );

	void                    RestoreOnEndPrint( SfxPrinter *pOldPrinter );
	void                    RestoreOnEndPrint( SfxPrinter *pOldPrinter,
								   BOOL bOldEnablePrintFile );
	void                    DeleteOnEndPrint();
};

class SfxPrintOptionsDialog: public ModalDialog
{
	OKButton                aOkBtn;
	CancelButton            aCancelBtn;
	HelpButton*             pHelpBtn; 
	SfxViewShell*           pViewSh;
	SfxItemSet*             pOptions;
	SfxTabPage*             pPage;

public:
				SfxPrintOptionsDialog( Window *pParent,
									   SfxViewShell *pViewShell,
									   const SfxItemSet *rOptions );
	virtual                 ~SfxPrintOptionsDialog();

	BOOL                    Construct();
	virtual short           Execute();

	SfxTabPage*             GetTabPage() const { return pPage; }
	const SfxItemSet&       GetOptions() const { return *pOptions; }
};

#endif
