
#ifndef _SFX_PROGRESS_HXX
#define _SFX_PROGRESS_HXX

#include <tools/solar.h>

#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif

class String;
class SfxObjectShell;
class SfxStatusBarManager;
class INetHint;
class SvDispatch;
struct SfxProgress_Impl;
struct PlugInLoadStatus;
struct SvProgressArg;

class SfxProgress
{
	SfxProgress_Impl*		pImp;
	ULONG					nVal;
	BOOL					bSuspended;

public:
#if SUPD>=349
				SfxProgress( SfxObjectShell* pObjSh,
							 const String& rText,
							 ULONG nRange, BOOL bAllDocs = FALSE,
							 BOOL bWait = TRUE );
#else
				SfxProgress( SfxObjectShell* pObjSh,
							 const String& rText,
							 ULONG nRange, BOOL bAllDocs = FALSE );
#endif
	virtual 				~SfxProgress();

	virtual void			SetText( const String& rText );
	BOOL					SetStateText( ULONG nVal, const String &rVal, ULONG nNewRange = 0 );
	virtual BOOL			SetState( ULONG nVal, ULONG nNewRange = 0 );
	ULONG					GetState() const { return nVal; }

	void					Resume();
	void					Suspend();
	BOOL					IsSuspended() const { return bSuspended; }

	void					Lock();
	void					UnLock();
	void					Reschedule();

	void					Stop();

	void					SetWaitMode( BOOL bWait );
	BOOL					GetWaitMode() const;

	static SfxProgress* 	GetActiveProgress( SfxObjectShell *pDocSh = 0 );
	static void				EnterLock();
	static void				LeaveLock();

#if 0 // _SOLAR__PRIVATE
	DECL_STATIC_LINK( SfxProgress, SetStateHdl, PlugInLoadStatus* );
	DECL_STATIC_LINK( SfxProgress, DefaultBindingProgress, SvProgressArg* );
	FASTBOOL				StatusBarManagerGone_Impl(SfxStatusBarManager*pStb);
	const String&           GetStateText_Impl() const;
#endif
};

#endif

