

#ifndef _SFXHTML_HXX
#define _SFXHTML_HXX

#ifndef _PARHTML_HXX
#include <svtools/parhtml.hxx>
#endif
#ifndef _SFXMACITEM_HXX 
#include <svtools/macitem.hxx>
#endif

class ImageMap;
class SfxDocumentInfo;
class SfxMedium;
class SfxObjectShell;
class SvKeyValueIterator;

class SfxHTMLParser : public HTMLParser
{
	DECL_STATIC_LINK( SfxHTMLParser, FileDownloadDone, void* );

	String					aScriptType;

	SfxMedium*				pMedium;
	SfxMedium *pDLMedium;	

	USHORT nMetaTags;		
	ScriptType eScriptType;

	void GetScriptType_Impl( SvKeyValueIterator* );

protected:

	SfxHTMLParser( SvStream& rStream, BOOL bNewDoc=TRUE, SfxMedium *pMedium=0 );

	~SfxHTMLParser();

public:

	static BOOL ParseMapOptions(ImageMap * pImageMap,
					const HTMLOptions * pOptions );
	BOOL ParseMapOptions(ImageMap * pImageMap)
	{ return ParseMapOptions(pImageMap, GetOptions()); }
	static BOOL ParseAreaOptions(ImageMap * pImageMap,
					 const HTMLOptions * pOptions,
					 USHORT nEventMouseOver = 0,
					 USHORT nEventMouseOut = 0 );
	inline BOOL ParseAreaOptions(ImageMap * pImageMap,
					 USHORT nEventMouseOver = 0,
					 USHORT nEventMouseOut = 0);

	static BOOL ParseMetaOptions( SfxDocumentInfo*, SvKeyValueIterator*,
					  const HTMLOptions*, USHORT& rMetaCnt,
					  rtl_TextEncoding& rEnc );

	static double GetTableDataOptionsValNum( ULONG& nNumForm,
			LanguageType& eNumLang, const String& aValStr,
			const String& aNumStr, SvNumberFormatter& rFormatter );
	 static rtl_TextEncoding GetEncodingByHttpHeader( SvKeyValueIterator *pHTTPHeader );
protected:

	BOOL ParseMetaOptions( SfxDocumentInfo*, SvKeyValueIterator* );

	void StartFileDownload( const String& rURL, int nToken,
				SfxObjectShell *pSh=0 );

	BOOL GetFileDownloadMIME( String& rMime );

	BOOL FinishFileDownload( String& rStr );

	BOOL ShouldFinishFileDownload() const { return pDLMedium != 0; }

	SfxMedium *GetMedium() { return pMedium; }
	const SfxMedium *GetMedium() const { return pMedium; }

	ScriptType GetScriptType( SvKeyValueIterator* ) const;
	const String& GetScriptTypeString( SvKeyValueIterator* ) const;

	static rtl_TextEncoding GetEncodingByMIME( const String& rMime );

	BOOL SetEncodingByHTTPHeader( SvKeyValueIterator *pHTTPHeader );

};

inline BOOL SfxHTMLParser::ParseAreaOptions(ImageMap * pImageMap,
								USHORT nEventMouseOver,
								USHORT nEventMouseOut)
{
	return ParseAreaOptions( pImageMap, GetOptions(),
				 nEventMouseOver, nEventMouseOut );
}

#endif
