
#ifndef _SFXSTBITEM_HXX
#define _SFXSTBITEM_HXX

#ifndef _SFXCTRLITEM_HXX
#include <sfx2/ctrlitem.hxx>
#endif

class SvStream;
class SvStream;
class SfxModule;

class StatusBar;
class SfxStatusBarControl;
class SfxBindings;

typedef SfxStatusBarControl* (*SfxStatusBarControlCtor)( USHORT nId, StatusBar &rStb, SfxBindings & );

struct SfxStbCtrlFactory
{
	SfxStatusBarControlCtor pCtor;
	TypeId					nTypeId;
	USHORT					nSlotId;

	SfxStbCtrlFactory( SfxStatusBarControlCtor pTheCtor,
			TypeId nTheTypeId, USHORT nTheSlotId ):
		pCtor(pTheCtor),
		nTypeId(nTheTypeId),
		nSlotId(nTheSlotId)
	{}
};

class  CommandEvent;
class  MouseEvent;
class UserDrawEvent;

class SfxStatusBarControl: public SfxControllerItem
{
friend class SfxStatusBar_Impl;

	StatusBar*		pBar;

protected:
	virtual void	StateChanged( USHORT nSID, SfxItemState eState,
					  const SfxPoolItem* pState );
	virtual void	Click();
	virtual void	DoubleClick();
	virtual void	Command( const CommandEvent& rCEvt );
	virtual BOOL	MouseButtonDown( const MouseEvent & );
	virtual BOOL	MouseMove( const MouseEvent & );
	virtual BOOL	MouseButtonUp( const MouseEvent & );
	virtual void	Paint( const UserDrawEvent &rUDEvt );

public:
		SfxStatusBarControl( USHORT nId, StatusBar& rBar, SfxBindings & );
	virtual 		~SfxStatusBarControl();

	StatusBar&		GetStatusBar() const { return *pBar; }
	void			CaptureMouse();
	void			ReleaseMouse();

	static SfxStatusBarControl* CreateControl( USHORT nId, StatusBar *pBar, SfxBindings&, SfxModule* );
};

#define SFX_DECL_STATUSBAR_CONTROL() \
		static SfxStatusBarControl* CreateImpl( USHORT nId, StatusBar &rStb, SfxBindings &rBindings ); \
		static void RegisterControl(USHORT nSlotId = 0, SfxModule *pMod=NULL)

#define SFX_IMPL_STATUSBAR_CONTROL(Class, nItemClass) \
		SfxStatusBarControl* __EXPORT Class::CreateImpl( USHORT nId, StatusBar &rStb, SfxBindings &rBindings ) \
	  { return new Class(nId, rStb, rBindings); } \
		void Class::RegisterControl(USHORT nSlotId, SfxModule *pMod) \
	  { SFX_APP()->RegisterStatusBarControl( pMod, new SfxStbCtrlFactory( \
		Class::CreateImpl, TYPE(nItemClass), nSlotId ) ); }

#endif

