
#ifndef _SFXSTBMGR_HXX
#define _SFXSTBMGR_HXX

#ifndef _STATUS_HXX 
#include <vcl/status.hxx>
#endif
#ifndef _SFXLSTNER_HXX 
#include <svtools/lstner.hxx>
#endif

#include <framework/statusbarconfiguration.hxx>

#include <sfx2/app.hxx>
#include <sfx2/cfgitem.hxx>

class SfxStatusItemArr_Impl;
class SfxStatusItemInfArr_Impl;
class SfxStatusBarControl;
class SfxBindings;

class SfxStatusBarManager: public SfxConfigItem, public SfxListener
{
friend class SfxStatusBar_Impl;

	StatusBar*					pBar;
	SfxStatusItemArr_Impl*		pBoundItems;
	SfxBindings*				pBindings;
	ULONG						nMaxProgress;
	SfxStatusItemInfArr_Impl*	pItems;
	SfxShell*					pShell;

private:
#if 0 // _SOLAR__PRIVATE
	BOOL                        Store( SvStream& rStream );
	int                         Load( SvStream& rStream );
	void						Construct();
	SfxStatusBarControl*		FindControl_Impl( USHORT nId ) const;
	void						Clear_Impl();
#endif

public:
		SfxStatusBarManager( Window* pParent, SfxBindings&,
			SfxShell*, SfxConfigManager*, USHORT nId=SFX_ITEMTYPE_STATBAR,
			StatusBar*p=NULL );
	                SfxStatusBarManager( Window* pParent, const SfxStatusBarManager& rOther, SfxConfigManager* );
		~SfxStatusBarManager();

	static BOOL     Import( SvStream& rInStream, SvStream& rOutStream );
	static BOOL     Export( SvStream& rInStream, SvStream& rOutStream );
	 virtual BOOL    Store( SotStorage& rStream );
	virtual int     Load( SotStorage& rStream );
	virtual	void	UseDefault();
	virtual String  GetStreamName() const;
	StatusBar*		GetStatusBar() const
		{ return pBar; }

	BOOL			AddItem( USHORT nItemId, long nWidth,
				USHORT nOffset = STATUSBAR_OFFSET,
				USHORT nPos = STATUSBAR_APPEND );

	void			RemoveItem( USHORT nItemId);
	void			SetItemWidth (USHORT nId, long nWidth);
	USHORT			GetItemPos(USHORT nId)
			{ return pBar->GetItemPos(nId); }

	void			Clear();
	void			Show();
	void			Hide();
	void			DestroyingBindings(SfxBindings*);

	BOOL			IsVisible() const
			{ return pBar->IsVisible(); }
	long			GetWidth( const String& rStr ) const
			{ return pBar->GetTextWidth(rStr); }

	void			StartProgressMode(const String &rText, ULONG nMax);

	void			SetProgressState(ULONG nVal);
	void			EndProgressMode();
	void            SetProgressMaxValue(ULONG nVal){nMaxProgress=nVal;}
	BOOL			IsProgressMode() const { return pBar->IsProgressMode(); }

	void			ShowHelpText(const String &rText );

	void			ShowItems()
			{ pBar->ShowItems(); }

	virtual void 	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
			 const SfxHint& rHint, const TypeId& rHintType );
#if 0 // _SOLAR__PRIVATE
	SfxBindings*	GetBindings_Impl()
		{ return pBindings; }
#endif
};

#endif
