
#ifndef _SFX_TEMPLDLG_HXX
#define _SFX_TEMPLDLG_HXX

#include <rsc/rscsfx.hxx>

#include <sfx2/dockwin.hxx>
#include <sfx2/childwin.hxx>
#include <sfx2/basedlgs.hxx>

class SfxTemplateDialog_Impl;
class SfxTemplateCatalog_Impl;

class ISfxTemplateCommon
{
public:
	virtual SfxStyleFamily GetActualFamily() const = 0;
	virtual String GetSelectedEntry() const = 0;
};

class SfxTemplateDialog : public SfxDockingWindow
{
private:
	SfxTemplateDialog_Impl *pImpl;

	virtual void Resize();
	virtual SfxChildAlignment
			CheckAlignment(SfxChildAlignment,SfxChildAlignment);

public:
#if SUPD <= 351
	SfxStyleFamily GetActualFamily() const;
#endif
	virtual void Update();
	ISfxTemplateCommon* GetISfxTemplateCommon();
	SfxTemplateDialog(SfxBindings*, SfxChildWindow*, Window*);
	~SfxTemplateDialog();

private:
friend class SfxTemplateDialogWrapper;
friend class SfxTemplateDialog_Impl;
};

class SfxTemplateCatalog : public SfxModalDialog
{
private:
	SfxTemplateCatalog_Impl *pImpl;

public:
	SfxTemplateCatalog(Window * pParent, SfxBindings *pBindings);
	~SfxTemplateCatalog();
	friend class SfxTemplateCatalog_Impl;
};

class SfxTemplateDialogWrapper : public SfxChildWindow
{
public:
	SfxTemplateDialogWrapper
		(Window*,USHORT,SfxBindings*,SfxChildWinInfo*);
	SFX_DECL_CHILDWINDOW(SfxTemplateDialogWrapper);
};

#endif

