
#ifndef _VIEWFAC_HXX
#define _VIEWFAC_HXX

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif
#ifndef _RESID_HXX 
#include <vcl/resid.hxx>
#endif

class SfxViewFrame;
class SfxViewShell;
class Window;

typedef SfxViewShell* (*SfxViewCtor)(SfxViewFrame*, SfxViewShell*);
typedef void (*SfxViewInit)();

class SfxViewFactory
{
public:
	SfxViewFactory( SfxViewCtor fnC, SfxViewInit fnI,
		USHORT nOrdinal, const ResId& aDescrResId );
	~SfxViewFactory();

	SfxViewShell *CreateInstance(SfxViewFrame *pViewFrame, SfxViewShell *pOldSh);
	void		  InitFactory();

	String		  GetDescription() const
	  { return String( aDescription ); }
	USHORT		  GetOrdinal() const { return nOrd; }

private:
	SfxViewCtor fnCreate;
	SfxViewInit fnInit;
	USHORT      nOrd;
	ResId		aDescription;
};

#endif

