

#ifndef _APPLET_HXX
#define _APPLET_HXX

#ifdef MAC

class SdApplet_MRJ;
#endif

#include <so3/ipobj.hxx>
#include <svtools/ownlist.hxx>

struct SvAppletData_Impl;
class INetURLObject;
class SjApplet;
class RmAppletObject;
class SvAppletObject : public SvInPlaceObject

{
friend class SvAppletEnvironment;
	SvAppletData_Impl *	pImpl;

	void			DataChanged_Impl( BOOL bOnlyEmbedSource );
protected:
	BOOL			StartApplet();
	virtual void    FillClass( SvGlobalName * pClassName,
				   ULONG * pFormat,
				   String * pAppName,
				   String * pFullTypeName,
				   String * pShortTypeName,
	                           long nFileFormat = SOFFICE_FILEFORMAT_CURRENT ) const;

	virtual void    Open( BOOL bOpen );
	virtual void    InPlaceActivate( BOOL );
	virtual ErrCode Verb( long, SvEmbeddedClient * pCallerClient,
			Window * pWin, const Rectangle * pWorkRectPixel );

	virtual void    SetVisArea( const Rectangle & rVisArea );
	virtual void    Draw( OutputDevice *,
			  const JobSetup & rSetup,
			  USHORT nAspect = ASPECT_CONTENT );

	virtual BOOL    InitNew( SvStorage * );
	virtual BOOL    Load( SvStorage * );
	virtual BOOL    Save();
	virtual BOOL    SaveAs( SvStorage * );
	virtual void    HandsOff();
	virtual BOOL    SaveCompleted( SvStorage * );
			~SvAppletObject();
public:
		SO2_DECL_BASIC_CLASS_DLL(SvAppletObject,SOAPP)
		SvAppletObject();

	virtual ULONG	GetMiscStatus() const;
	virtual BOOL	IsLink() const;

#ifdef MRJ_JAVA
	SdApplet_MRJ *	GetApplet() const;
#elif defined( REMOTE_VERSION )
	RmAppletObject *GetApplet() const;
#else
	SjApplet *		GetApplet() const;
#endif

	void			SetCommandList( const SvCommandList & rList );
	const SvCommandList & GetCommandList() const;
	void			SetClass( const String & rClass );
	const String &	GetClass()const;
	void			SetName( const XubString & rClass );
	const XubString &GetName() const;
	void			SetDocBase( const INetURLObject & );
	void			SetCodeBase( const INetURLObject & );
	void			SetCodeBase( const XubString & );
	const XubString & GetCodeBase() const;
	void			SetMayScript( BOOL bMayScript );
	BOOL			IsMayScript() const;
};

SO2_DECL_IMPL_REF(SvAppletObject)

#endif 
