

#ifndef _IPOBJ_HXX
#define _IPOBJ_HXX

#include <so3/embobj.hxx>
#include <so3/ipobj.hxx>

class  ImpInPlaceObject;
class  ImpInPlaceSite;
class  ImpOleInPlaceActiveObject;
class  SvInPlaceObject;
class  SvContainerEnvironment;
class  SvInPlaceMenuBar;
class  SvInPlaceClipWindow;
class  SvInPlaceWindow;
struct IOleInPlaceObject;
struct IOleInPlaceActiveObject;
class  SvInPlaceObjectList;
class  MenuBar;
class  Window;
class  KeyEvent;
class  Palette;
class SvInPlaceEnvironment;

class SvInPlaceObject : public SvEmbeddedObject
{
friend ImpInPlaceObject;
friend ImpInPlaceSite;
friend SvInPlaceClient;
friend ImpOleInPlaceActiveObject;
friend SvEditObjectProtocol;
friend ImplSvEditObjectProtocol;
friend SvInPlaceEnvironment;

	IOleInPlaceObject *         pObjI;
	IOleInPlaceActiveObject *   pActiveObj;
	SvInPlaceEnvironment *      pIPEnv;
	BOOL						bIsUndoable:1,
					bDeleteIPEnv:1;

	BOOL 						DoMergePalette();
protected:
		~SvInPlaceObject();

	virtual void    TopWinActivate( BOOL bActivate );
	virtual void    DocWinActivate( BOOL bActivate );

	void			SetIPEnv( SvInPlaceEnvironment * pFrm );

	virtual ErrCode Verb( long nVerbPos, SvEmbeddedClient * pCallerClient,
			Window * pWin, const Rectangle * pWorkAreaPixel );
	virtual void    Open( BOOL bOpen );
	virtual void    InPlaceActivate( BOOL bActivate );
	virtual void    UIActivate( BOOL bActivate );

	void			SetUndoable( BOOL bUndoable )
		{ bIsUndoable = bUndoable; }

	virtual	BOOL 	MergePalette( const Palette & rContainerPal );
public:
		SvInPlaceObject();
		SO2_DECL_STANDARD_CLASS_DLL(SvInPlaceObject,SOAPP)
	IOleInPlaceObject *         GetInPlaceObject() const;
	IOleInPlaceActiveObject *   GetInPlaceActiveObject() const;
	BOOL                        SetInPlaceActiveObject( IOleInPlaceActiveObject * );

	SvInPlaceEnvironment* GetIPEnv() const { return pIPEnv; }
	SvInPlaceClient * GetIPClient() const
		{ return aProt.GetIPClient(); }
	static	SvInPlaceObjectList & GetIPActiveObjectList();

	ErrCode         DoInPlaceActivate( BOOL bActivate );
	ErrCode         DoUIActivate( BOOL bActivate );

	virtual void    SetVisArea( const Rectangle & rVisArea );
	BOOL			IsUndoable() const { return bIsUndoable; }
	virtual BOOL 	ReactivateAndUndo();
};

DECLARE_LIST(SvInPlaceObjectList,SvInPlaceObject*)
#ifndef SO2_DECL_SVINPLACEOBJECT_DEFINED
#define SO2_DECL_SVINPLACEOBJECT_DEFINED
SO2_DECL_REF(SvInPlaceObject)
#endif
SO2_IMPL_REF(SvInPlaceObject)

class SvDeathObject : public SvInPlaceObject

{
protected:
	virtual ErrCode Verb( long, SvEmbeddedClient * pCallerClient,
			Window * pWin, const Rectangle * pWorkRectPixel );
	virtual void    Draw( OutputDevice *,
			  const JobSetup & rSetup,
			  USHORT nAspect = ASPECT_CONTENT );
public:
		SvDeathObject( const Rectangle & rVisArea );
};

#endif 
