
#ifndef _LINKSRC_HXX
#define _LINKSRC_HXX

#ifndef _TOOLS_REF_HXX
#include <tools/ref.hxx>
#endif
#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

#ifndef _SAL_CONFIG_H
#include <sal/config.h>
#define _SAL_CONFIG_H
#endif

namespace com { namespace sun { namespace star { namespace uno
{
	class Any;

}}}}
class Window;
class String;

#ifndef ADVISEMODE_NODATA

#define ADVISEMODE_NODATA       0x01

#define ADVISEMODE_ONLYONCE     0x04

#endif

namespace so3
{

class SvBaseLink;
struct SvLinkSource_Impl;

class SvLinkSource : public SvRefBase
{
	SvLinkSource_Impl *	pImpl; 
public:
			TYPEINFO();
				SvLinkSource();
	virtual				~SvLinkSource();

	BOOL				HasDataLinks( const SvBaseLink* = 0 ) const;

	void				Closed();

	ULONG 				GetUpdateTimeout() const;
	void				SetUpdateTimeout( ULONG nTime );

	void				DataChanged( const String & rMimeType,
						const ::com::sun::star::uno::Any & rVal );
	void				SendDataChanged();
	void				NotifyDataChanged();

	virtual BOOL		Connect( SvBaseLink * );
	virtual BOOL		GetData( ::com::sun::star::uno::Any & rData ,
					const String & rMimeType,
					BOOL bSynchron = FALSE );

	virtual BOOL		IsPending() const;

	virtual BOOL		IsDataComplete() const;

	virtual String		Edit( Window *, SvBaseLink * );

	void				AddDataAdvise( SvBaseLink *, const String & rMimeType,
							USHORT nAdviceMode );
	void				RemoveAllDataAdvise( SvBaseLink * );

	void				AddConnectAdvise( SvBaseLink * );
	void				RemoveConnectAdvise( SvBaseLink * );
};

SV_DECL_IMPL_REF(SvLinkSource);

}

#endif
