

#ifndef _OUTPLACE_HXX
#define _OUTPLACE_HXX

#include <so3/ipobj.hxx>

struct SvOutPlace_Impl;
class SvOutPlaceObject : public SvInPlaceObject

{
	SvOutPlace_Impl *	pImpl;

	void			DataChanged_Impl( BOOL bOnlyEmbedSource );
	void			LoadSO_Cont();
protected:
	virtual void    FillClass( SvGlobalName * pClassName,
				   ULONG * pFormat,
				   String * pAppName,
				   String * pFullTypeName,
				   String * pShortTypeName,
	                           long nFileFormat = SOFFICE_FILEFORMAT_CURRENT ) const;

	virtual void    Open( BOOL bOpen );
	virtual void    Embed( BOOL bEmbedded );
	virtual ErrCode Verb( long, SvEmbeddedClient * pCallerClient,
			Window * pWin, const Rectangle * pWorkRectPixel );

	virtual void    Draw( OutputDevice *,
			  const JobSetup & rSetup,
			  USHORT nAspect = ASPECT_CONTENT );

	virtual BOOL    InitNew( SvStorage * );
	virtual BOOL    Load( SvStorage * );
	virtual BOOL    Save();
	virtual BOOL    SaveAs( SvStorage * );
	virtual void    HandsOff();
	virtual BOOL    SaveCompleted( SvStorage * );
			~SvOutPlaceObject();
public:
		SO2_DECL_BASIC_CLASS(SvOutPlaceObject)
			SvOutPlaceObject();
	static SvInPlaceObjectRef	InsertObject( Window *, SvStorage * pIStorage,
								BOOL & bOut, String & rTypeName, String & rFileName );
	static SvInPlaceObjectRef	CreateFromClipboard( SvStorage * );
	static SvGlobalName			GetCLSID( const String & rFileName );
	static SvInPlaceObjectRef	CreateFromFile( SvStorage * pStor, const String & rFileName );

	void			ClearCache();
	SotStorage *	GetWorkingStorage();
	virtual void    SetVisArea( const Rectangle & rVisArea );
	Rectangle		GetVisArea( USHORT dwAspect ) const;
	void			ViewChanged( USHORT nAspects );
	virtual const SvVerbList & GetVerbList() const;

	virtual UINT32			GetViewAspect() const;
};

SO2_DECL_IMPL_REF(SvOutPlaceObject)

#endif 
