

#ifndef _PASTEDLG_HXX
#define _PASTEDLG_HXX

#ifndef _TABLE_HXX 
#include <tools/table.hxx>
#endif
#ifndef _SOT_FORMATS_HXX
#include <sot/formats.hxx>
#endif
#ifndef _GLOBNAME_HXX 
#include <tools/globname.hxx>
#endif

class Window;
struct TransferableObjectDescriptor;

class SvPasteObjectDialog
{
	Table       	aSupplementTable;
	SvGlobalName	aObjClassName;
	String			aObjName;
	USHORT      	nAspect;
	BOOL        	bLink;

	void        	SetDefault();
public:
	SvPasteObjectDialog();
	~SvPasteObjectDialog();

	void        Insert( SotFormatStringId nFormat, const String & rFormatName );

	void		SetObjName( const SvGlobalName & rClass, const String & rObjName )
	{
		aObjClassName = rClass;
		aObjName = rObjName;
	}

	ULONG       Execute( Window* pParent, const
			::com::sun::star::uno::Reference<
				::com::sun::star::datatransfer::XTransferable >
					& rxTransferable );
	ULONG 		Execute( Window* pParent,
			const DataFlavorExVector& rFormats,
			const TransferableObjectDescriptor& rDesc );

	USHORT      GetAspect() const { return nAspect; }
	BOOL        ShouldLink() const { return bLink; }
};

#endif 
