

#ifndef _PROTOCOL_HXX
#define _PROTOCOL_HXX

#ifndef _ERRCODE_HXX 
#include <tools/errcode.hxx>
#endif
#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _TOOLS_STRING_HXX
#include <tools/string.hxx>
#endif

class  SvEmbeddedObject;
class  SvInPlaceObject;
class  SvEmbeddedClient;
class  SvInPlaceClient;
class  SoDll;
class  ImplSvEditObjectProtocol;
class  String;

class SvEditObjectProtocol
{
friend SoDll;
	ImplSvEditObjectProtocol * pImp;
	static void         Imp_DeleteDefault();
	BOOL                Release();
public:
	SvEditObjectProtocol();
	SvEditObjectProtocol( SvEmbeddedObject *, SvEmbeddedClient * );
	SvEditObjectProtocol( const SvEditObjectProtocol & );
	SvEditObjectProtocol & operator = ( const SvEditObjectProtocol & );
	~SvEditObjectProtocol();

	SvEmbeddedObject * GetObj() const;
	SvInPlaceObject *  GetIPObj() const;
	SvEmbeddedClient * GetClient() const;
	SvInPlaceClient *  GetIPClient() const;

	BOOL IsConnect() const;
	BOOL IsOpen() const;
	BOOL IsEmbed() const;
	BOOL IsPlugIn() const;
	BOOL IsInPlaceActive() const;
	BOOL IsUIActive() const;
	BOOL IsTopWinActive() const;
	BOOL IsDocWinActive() const;
	BOOL IsInClosed() const;

	ErrCode EmbedProtocol();
	ErrCode	PlugInProtocol();
	ErrCode	IPProtocol();
	ErrCode UIProtocol();

	BOOL CanEmbedProtocol() const;
	BOOL CanPlugInProtocol() const;
	BOOL CanInPlaceProtocol() const;
	BOOL CanUIProtocol() const;

	BOOL Reset();
	BOOL Reset2Connect();
	BOOL Reset2Open();
	BOOL Reset2Embed();
	BOOL Reset2PlugIn();
	BOOL Reset2InPlaceActive();
	BOOL Reset2UIActive();

	void Connected( BOOL bOpen );
	void Opened( BOOL bOpen );
	void Embedded( BOOL bEmbed );
	void PlugIn( BOOL bPlugIn );
	void InPlaceActivate( BOOL bActivate );
	void UIActivate( BOOL bActivate );
	void TopWinActivate( BOOL bActivate );
	void DocWinActivate( BOOL bActivate );
	void SetInClosed( BOOL bInClosed );
	void DocNameChanged( const String & rName );
};

#endif 
