

#ifndef _SO2DLL_HXX
#define _SO2DLL_HXX

#ifndef _PSTM_HXX 
#include <tools/pstm.hxx>
#endif
#ifndef _LINK_HXX 
#include <tools/link.hxx>
#endif
#ifndef _GLOBNAME_HXX 
#include <tools/globname.hxx>
#endif

class ImpFactory;
class SotFactory;
class SvObjectList;
class SotFactoryList;
class SvAdviseSinkIndex;
class SvInPlaceClient;
class SvInPlaceClientList;
class SvInPlaceObjectList;
class WorkWindow;
class MDIWindow;
class ImpSO2Clipboard;
class ResMgr;
class SvSoIPCServer;
class SvIPCServerInfo;
class ImplSvEditObjectProtocol;
class Impl_DeathTimer;
class Timer;
class SvContainerEnvironmentList;
class SvInPlaceEnvironment;
class SvVerbList;
struct SvBindingData;

class PlugInManager; 

#if ((SUPD >= 535) && defined(_USE_NAMESPACE))
namespace inet {
	class INetWrapper;
}
#else
class INetWrapper;
#endif

struct ConvertTo_Impl

{
	SvGlobalName    aName;          
	SvGlobalName    aSvName;        
	long            aFormat;        

	ConvertTo_Impl() {};
	ConvertTo_Impl( const SvGlobalName & a1, long a2 )
		: aName( a1 )
		, aSvName( a1 )
		, aFormat( a2 )
	{}
	ConvertTo_Impl( const SvGlobalName & a1,
		const SvGlobalName & rSvClass,
		long a2 )
		: aName( a1 )
		, aSvName( rSvClass )
		, aFormat( a2 )
	{}
};
#define SO3_OFFICE_VERSIONS	5

class SoDll
{
friend ImpFactory;
friend class SvFactory;
friend Impl_DeathTimer;
	UINT32          nAliveCount;
	Link            aAliveHdl;
	BOOL            bInit;
	BOOL            bSelfInit;
	SvObjectList *  pReleaseList; 
public:

	SotFactory *     pSvObjectFactory;
	SotFactory *     pSvStorageStreamFactory;
	SotFactory *     pSvStorageFactory;
	SotFactory *     pSvEmbeddedObjectFactory;
	SotFactory *     pSvEmbeddedClientFactory;
	SotFactory *     pSvInPlaceObjectFactory;
	SotFactory *     pSvPlugInObjectFactory;
	SotFactory *     pSvAppletObjectFactory;
	SotFactory *     pSvInPlaceClientFactory;
	SotFactory *     pSvPersistFactory;
	SotFactory *     pSvPseudoObjectFactory;
	SotFactory *     pSvSimplePersistFactory;
	SotFactory *     pSvObjectContainerFactory;
	SotFactory *     pSvFactory_ImplFactory;
	SotFactory *	 pDfltPlugInFactory;
	SotFactory *	 pDfltAppletFactory;
	SotFactory *	 pSoBindingFactory;

	SvContainerEnvironmentList *pContEnvList;

	SvInPlaceClientList *		pIPActiveClientList;
	SvInPlaceObjectList *		pIPActiveObjectList;
	SvInPlaceEnvironment * 		pUIShowIPEnv;
	ImplSvEditObjectProtocol *	pIEOPDflt;

	ResMgr *        			pResMgr;
	SvClassManager  			aInfoClassMgr;
	SvGlobalName    			aSvInterface;

	SvVerbList *				pPlugInVerbList;
	ULONG						nPlugInDocFormat;

#if ((SUPD >= 535) && defined(_USE_NAMESPACE))
	inet::INetWrapper *			pINetWrapper;
#else
	INetWrapper *				pINetWrapper;
#endif

	SvVerbList *				pAppletVerbList;
	ULONG						nAppletDocFormat;

	Timer *						pDeathTimer;
	void * 						pDead;
	SvBindingData*              pBindingData;
	ConvertTo_Impl 				(*pConvTable)[SO3_OFFICE_VERSIONS];
	USHORT						nConvTableEntries;
					SoDll();
				~SoDll();
	ResMgr *    			GetResMgr();
	SvIPCServerInfo * 		GetIPCServerInfo();
};

#endif 

