

#ifndef _SOT_SOTREF_HXX
#define _SOT_SOTREF_HXX

#ifndef _TOOLS_REF_HXX
#include <tools/ref.hxx>
#endif

enum SvCastEnum { SV_AGGREGATION_CAST };
#ifndef SVT_DECL_SOTOBJECT_DEFINED
#define SVT_DECL_SOTOBJECT_DEFINED
class SotObject;
class SotObjectRef
{
	PRV_SV_DECL_REF(SotObject)
	inline SotObjectRef( SotObject * pObjP, SvCastEnum );
};
#endif

#define SO2_DECL_REF(ClassName)                                           \
class ClassName;                                                          \
class ClassName##Ref                                                      \
{                                                                         \
	PRV_SV_DECL_REF(ClassName)                                            \
	inline          ClassName##Ref( const SotObjectRef & );               \
	inline          ClassName##Ref( SotObject * pObjP );                  \
	inline          ClassName##Ref( SotObject * pObjP, SvCastEnum );      \
};

#define SO2_IMPL_REF(ClassName)                                           \
SV_IMPL_REF(ClassName)                                                    \
inline ClassName##Ref::ClassName##Ref( const SotObjectRef & r )           \
{                                                                         \
	pObj = (ClassName *)ClassName::ClassFactory()->CastAndAddRef( &r );	  \
}                                                                         \
inline ClassName##Ref::ClassName##Ref( SotObject * pObjP )                \
{                                                                         \
	pObj = (ClassName *)ClassName::ClassFactory()->CastAndAddRef( pObjP );\
}                                                                         \
inline ClassName##Ref::ClassName##Ref( SotObject * pObjP, SvCastEnum )    \
{                                                                         \
	pObj = (ClassName *)ClassName::ClassFactory()->AggCastAndAddRef( pObjP );\
}

#define SO2_DECL_IMPL_REF(ClassName)                                      \
	SO2_DECL_REF(ClassName)                                               \
	SO2_IMPL_REF(ClassName)

#endif 
