

#ifndef _STGAVL_HXX
#define _STGAVL_HXX

#ifndef _TOOLS_SOLAR_H
#include <tools/solar.h>
#endif

class StgAvlNode
{
	friend class StgAvlIterator;
private:
	short Locate( StgAvlNode*, StgAvlNode**, StgAvlNode**, StgAvlNode** );
	short Adjust( StgAvlNode**, StgAvlNode* );
	StgAvlNode* RotLL();
	StgAvlNode* RotLR();
	StgAvlNode* RotRR();
	StgAvlNode* RotRL();
	void   Enum( short& );
	static StgAvlNode* Rem( StgAvlNode**, StgAvlNode*, BOOL );
protected:
	short nId;						  	
	short nBalance;						
	StgAvlNode* pLeft, *pRight; 		
	StgAvlNode();
public:
	virtual ~StgAvlNode();
	StgAvlNode* Find( StgAvlNode* );
	static BOOL Insert( StgAvlNode**, StgAvlNode* );
	static BOOL Remove( StgAvlNode**, StgAvlNode*, BOOL bDel = TRUE );
	static BOOL Move( StgAvlNode**, StgAvlNode**, StgAvlNode* );
	virtual short Compare( const StgAvlNode* ) const = 0;
};

class StgAvlIterator {
	StgAvlNode* pRoot;					
	short 	    nCount;					
	short		nCur;					
	StgAvlNode* Find( short );
public:
	StgAvlIterator( StgAvlNode* );
	StgAvlNode* First();
	StgAvlNode* Last();
	StgAvlNode* Next();
	StgAvlNode* Prev();
};

#endif
