
#ifndef INCLUDED_SVTOOLS_ACCELCFG_HXX
#define INCLUDED_SVTOOLS_ACCELCFG_HXX

#ifndef _COM_SUN_STAR_AWT_KEYEVENT_HPP_
#include <com/sun/star/awt/KeyEvent.hpp>
#endif

#include <rtl/ustring.hxx>
#include <tools/stream.hxx>

struct SvtAcceleratorConfigItem
{
	sal_uInt16      nCode;
	sal_uInt16      nModifier;
	::rtl::OUString aCommand;
};

#include <list>
typedef ::std::list < SvtAcceleratorConfigItem > SvtAcceleratorItemList;

class SvStream;
class KeyEvent;
class String;
class SvtAcceleratorConfig_Impl;

class SvtAcceleratorConfiguration
{
	SvtAcceleratorConfig_Impl*    pImp;

private:

public:
	                 SvtAcceleratorConfiguration();
	 static SvtAcceleratorConfiguration* CreateFromStream( SvStream& rStream );
	static String	GetStreamName();
	static SvStream* GetDefaultStream( StreamMode );
	                 ~SvtAcceleratorConfiguration();
	 bool            Commit( SvStream& rStream );
	 ::rtl::OUString GetCommand( const ::com::sun::star::awt::KeyEvent& rKeyEvent );
	 const SvtAcceleratorItemList& GetItems();
	 void            SetCommand( const SvtAcceleratorConfigItem& rItem );
	 void            SetItems( const SvtAcceleratorItemList& rItems, bool bClear );
};

#endif
