
#ifndef _SFXBRDCST_HXX
#define _SFXBRDCST_HXX

#ifndef _RTTI_HXX 
#include <tools/rtti.hxx>
#endif
#include <svtools/svarray.hxx>

class SfxListener;
class SfxHint;

#ifndef _SFX_BRDCST_CXX
typedef SvPtrarr SfxListenerArr_Impl;
#endif

#if SUPD<=310
#define SFX_FORWARD( rBC, rBCT, rHint, rHintT ) \
		Forward( rBC, rBCT, rHint, rHintT )
#else
#define SFX_FORWARD( rBC, rBCT, rHint, rHintT ) \
		Forward( rBC, rHint )
#endif

class SfxBroadcaster
{
friend class SfxListener;

	SfxListenerArr_Impl 	aListeners;

private:
#if SUPD>=501
	BOOL
#else
	void
#endif
				AddListener( SfxListener& rListener );
	void					RemoveListener( SfxListener& rListener );
	const SfxBroadcaster&	operator=(const SfxBroadcaster &); 

protected:
	void					SFX_FORWARD(SfxBroadcaster& rBC, const TypeId& rBCType,
							const SfxHint& rHint, const TypeId& rHintType);
	virtual void			ListenersGone();

public:
				TYPEINFO();
					SfxBroadcaster();
				SfxBroadcaster( const SfxBroadcaster &rBC );
	virtual 				~SfxBroadcaster();

	void					Broadcast( const SfxHint &rHint );
	void					BroadcastDelayed( const SfxHint& rHint );
	void					BroadcastInIdle( const SfxHint& rHint );

	BOOL					HasListeners() const;
	USHORT					GetListenerCount() const { return aListeners.Count(); }
	SfxListener*			GetListener( USHORT nNo ) const
				{ return (SfxListener*) aListeners[nNo]; }
};

#endif

