

#ifndef INCLUDED_SVTOOLS_CACHEOPTIONS_HXX
#define INCLUDED_SVTOOLS_CACHEOPTIONS_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif
#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif
#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

class SvtCacheOptions_Impl;

class SvtCacheOptions
{

	public:
	      SvtCacheOptions();
	    ~SvtCacheOptions();

		sal_Int32	GetWriterOLE_Objects() const;
		sal_Int32	GetDrawingEngineOLE_Objects() const;
		sal_Int32	GetGraphicManagerTotalCacheSize() const; 
		sal_Int32	GetGraphicManagerObjectCacheSize() const;
		sal_Int32	GetGraphicManagerObjectReleaseTime() const;

		void		SetWriterOLE_Objects( sal_Int32 nObjects );
		void		SetDrawingEngineOLE_Objects( sal_Int32 nObjects );
		void		SetGraphicManagerTotalCacheSize( sal_Int32 nTotalCacheSize );
		void		SetGraphicManagerObjectCacheSize( sal_Int32 nObjectCacheSize );
		void        SetGraphicManagerObjectReleaseTime( sal_Int32 nReleaseTimeSeconds );

		static ::osl::Mutex& GetOwnStaticMutex();

	private:
	 	static SvtCacheOptions_Impl*	m_pDataContainer	;	
		static sal_Int32				m_nRefCount			;	

};		

#endif 
