

#ifdef C_START
#undef C_START1
#undef C_START
#undef C_END
#undef C_INIT
#undef C_DONE
#undef C
#undef C1
#undef C2
#undef V_INIT
#undef V_PTR
#undef V_DECL_PTR
#undef V_IMPL_PTR
#undef V_DECL0
#undef V_BASE_DECL0
#undef V_IMPL0
#undef V_IMPL0V
#undef V_BASE_IMPL0
#undef V_BASE_IMPL0V
#undef V_DECL1
#undef V_BASE_DECL1
#undef V_IMPL1
#undef V_IMPL1V
#undef V_BASE_IMPL1
#undef V_BASE_IMPL1V
#undef V_DECL2
#undef V_BASE_DECL2
#undef V_IMPL2
#undef V_IMPL2V
#undef V_BASE_IMPL2
#undef V_BASE_IMPL2V
#endif

#ifndef _COMPAT_HXX_SPE
#define _COMPAT_HXX_SPE

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _SOLAR_HRC
#include <svtools/solar.hrc>
#endif

#define SFX_POINTER_SIZE  4096
#define SFX_MOD_SIZE      4096

struct VirtualPtr
{
	void (*pMethod)();
	void *pThis;
};

struct SfxPointerEntry
{
	const void *pObject;
	void *pPointer;
	SfxPointerEntry(){pObject=0;}
};

class SfxPointerServer
{

  public:

	SfxPointerServer();
	~SfxPointerServer();

	BOOL HasPointer( const void *);
	void * GetPointer(const void *);
	void ReleasePointer(const void *);
	void **CreatePointer(const void *);

	static	SfxPointerServer* GetServer();
	static	void ReleaseServer();

  private:

	SfxPointerEntry aPointers[SFX_POINTER_SIZE];

	const SfxPointerEntry *pLast;
	const void *pCache;
	void *pCachePtr;

	long MakeHash(const void * pObj);
	USHORT nObjectCount;
};

inline long SfxPointerServer::MakeHash(const void *pObj)
{
	return ((((unsigned long)pObj) >> 16) + ((unsigned long) pObj) )
		% SFX_MOD_SIZE;
}

#endif

#if SUPD >= 311
#if C_VERSION > 1000
#error S_VERSION oder SOLAR_VERSION implizit durch compat verwendet
#endif
#endif

#if (((SOLAR_VERSION > C_VERSION && C_VERSION < 4000 && C_VERSION > 1000) ||	\
	 (S_VERSION >= C_VERSION && C_VERSION > 4000) ||							\
	 (SUPD >= C_VERSION && C_VERSION < 1000 )) || defined(ICC))

#define V_INIT(aClass, aMethod)

#define V_PTR(aMethod, aPtr)

#define V_DECL_PTR(aMethod) void Dummy##aMethod()

#define V_IMPL_PTR(aClass, aMethod, aPtr)

#define V_DECL0(aRetType, aMethod) \
	 virtual aRetType aMethod()

#define V_BASE_DECL0(aRetType, aMethod) \
	 virtual aRetType aMethod()

#define V_IMPL0V(aClass, aMethod) \
	 void __EXPORT aClass::aMethod()

#define V_IMPL0(aRetType, aClass, aMethod) \
	 aRetType __EXPORT aClass::aMethod()

#define V_BASE_IMPL0V(aClass, aMethod) \
	 void __EXPORT aClass::aMethod()

#define V_BASE_IMPL0(aRetType, aClass, aMethod) \
	 aRetType __EXPORT aClass::aMethod()

#define V_DECL1(aRetType, aMethod, aArgType1) \
	 virtual aRetType aMethod(aArgType1)

#define V_BASE_DECL1(aRetType, aMethod, aArgType1) \
	 virtual aRetType aMethod(aArgType1)

#define V_IMPL1V(aClass, aMethod, aArgType1, aArgName1) \
	 void __EXPORT aClass::aMethod(aArgType1 aArgName1)

#define V_IMPL1(aRetType, aClass, aMethod, aArgType1, aArgName1) \
	 aRetType __EXPORT aClass::aMethod(aArgType1 aArgName1)

#define V_BASE_IMPL1V(aClass, aMethod, aArgType1, aArgName1) \
	 void __EXPORT aClass::aMethod(aArgType1 aArgName1)

#define V_BASE_IMPL1(aRetType, aClass, aMethod, aArgType1, aArgName1) \
	 aRetType __EXPORT aClass::aMethod(aArgType1 aArgName1)

#define V_DECL2(aRetType, aMethod, aArgType1, aArgType2) \
	 virtual aRetType aMethod(aArgType1, aArgType2)

#define V_BASE_DECL2(aRetType, aMethod, aArgType1, aArgType2) \
	 virtual aRetType aMethod(aArgType1, aArgType2)

#define V_IMPL2V(aClass, aMethod, aArgType1, aArgName1, aArgType2, aArgName2) \
	 void __EXPORT aClass::aMethod(aArgType1 aArgName1, aArgType2 aArgName2)

#define V_IMPL2(aRetType, aClass, aMethod, aArgType1, aArgName1, aArgType2, aArgName2) \
	 aRetType __EXPORT aClass::aMethod(aArgType1 aArgName1, aArgType2 aArgName2)

#define V_BASE_IMPL2V(aClass, aMethod, aArgType1, aArgName1, aArgType2, aArgName2) \
	 void __EXPORT aClass::aMethod(aArgType1 aArgName1, aArgType2 aArgName2)

#define V_BASE_IMPL2(aRetType, aClass, aMethod, aArgType1, aArgName1, aArgType2, aArgName2) \
	 aRetType __EXPORT aClass::aMethod(aArgType1 aArgName1, aArgType2 aArgName2)

#define C_START

#define C_START1(x)

#define C_END

#define C_INIT

#define C_DONE

#define C(Member) (Member)

#define C1(Class, Member) (Class::Member)

#define C2(Object, Class, Member) ((Object)->Member)

#else

#define V_INIT(aClass, aMethod) \
	 VirtualGetThisPtr##aMethod()->pMethod= \
	  (void (*)())&aClass::VirtualStub##aMethod; \
	 VirtualGetThisPtr##aMethod()->pThis=this

#define V_PTR(aMethod, aPtr) \
	 VirtualPtr *VirtualGetThisPtr##aMethod() \
	 { return &aPtr; }

#define V_DECL_PTR(aMethod) \
	 VirtualPtr *VirtualGetThisPtr##aMethod()

#define V_IMPL_PTR(aClass, aMethod, aPtr) \
	 VirtualPtr* aClass::VirtualGetThisPtr##aMethod() \
	 { return &aPtr; }

#define V_DECL0(aRetType, aMethod) \
	 static aRetType VirtualStub##aMethod(void *pThis); \
	 aRetType VirtualMethod##aMethod()

#define V_BASE_DECL0(aRetType, aMethod) \
	 aRetType aMethod(); \
	 V_DECL1(aRetType, aMethod)

#define V_IMPL0V(aClass, aMethod) \
	 void __EXPORT aClass::VirtualStub##aMethod( \
	     void *pThis) \
	 { ((aClass*)pThis) \
	 ->VirtualMethod##aMethod(); } \
	 void aClass::VirtualMethod##aMethod()

#define V_IMPL0(aRetType, aClass, aMethod) \
	 aRetType __EXPORT aClass::VirtualStub##aMethod( \
	     void *pThis) \
	 { return ((aClass*)pThis) \
	 ->VirtualMethod##aMethod(); } \
	 aRetType aClass::VirtualMethod##aMethod()

#define V_BASE_IMPL0V(aClass, aMethod) \
	 void aClass::aMethod() \
	 { (* ( void (*)(void*) ) \
		VirtualGetThisPtr##aMethod()->pMethod ) \
	 ( VirtualGetThisPtr##aMethod()->pThis ); } \
	 V_IMPL0V(aClass, aMethod)

#define V_BASE_IMPL0(aRetType, aClass, aMethod) \
	 aRetType aClass::aMethod() \
	 { return (* ( aRetType (*)(void*) ) \
		VirtualGetThisPtr##aMethod()->pMethod ) \
	 ( VirtualGetThisPtr##aMethod()->pThis ); } \
	 V_IMPL0(aRetType, aClass, aMethod)

#define V_DECL1(aRetType, aMethod, aArgType1) \
	 static aRetType VirtualStub##aMethod(void *pThis, aArgType1); \
	 aRetType VirtualMethod##aMethod(aArgType1)

#define V_BASE_DECL1(aRetType, aMethod, aArgType1) \
	 aRetType aMethod(aArgType1); \
	 V_DECL1(aRetType, aMethod, aArgType1)

#define V_IMPL1V(aClass, aMethod, aArgType1, aArgName1) \
	 void __EXPORT aClass::VirtualStub##aMethod( \
	     void *pThis, aArgType1 aArgName1) \
	 { ((aClass*)pThis) \
	 ->VirtualMethod##aMethod(aArgName1); } \
	 void aClass::VirtualMethod##aMethod(aArgType1 aArgName1)

#define V_IMPL1(aRetType, aClass, aMethod, aArgType1, aArgName1) \
	 aRetType __EXPORT aClass::VirtualStub##aMethod( \
	     void *pThis, aArgType1 aArgName1) \
	 { return ((aClass*)pThis) \
	 ->VirtualMethod##aMethod(aArgName1); } \
	 aRetType aClass::VirtualMethod##aMethod(aArgType1 aArgName1)

#define V_BASE_IMPL1V(aClass, aMethod, aArgType1, aArgName1) \
	 void aClass::aMethod(aArgType1 aArgName1) \
	 { (* ( void (*)(void*, aArgType1) ) \
		VirtualGetThisPtr##aMethod()->pMethod ) \
	 ( VirtualGetThisPtr##aMethod()->pThis, aArgName1 ); } \
	 V_IMPL1V(aClass, aMethod, aArgType1, aArgName1)

#define V_BASE_IMPL1(aRetType, aClass, aMethod, aArgType1, aArgName1) \
	 aRetType aClass::aMethod(aArgType1 aArgName1) \
	 { return (* ( aRetType(*)(void*, aArgType1) ) \
		VirtualGetThisPtr##aMethod()->pMethod ) \
	 ( VirtualGetThisPtr##aMethod()->pThis, aArgName1 ); } \
	 V_IMPL1(aRetType, aClass, aMethod, aArgType1, aArgName1)

#define V_DECL2(aRetType, aMethod, aArgType1, aArgType2) \
	 static aRetType VirtualStub##aMethod(void *pThis, aArgType1, aArgType2); \
	 aRetType VirtualMethod##aMethod(aArgType1, aArgType2)

#define V_BASE_DECL2(aRetType, aMethod, aArgType1, aArgType2) \
	 aRetType aMethod(aArgType1, aArgType2); \
	 V_DECL2(aRetType, aMethod, aArgType1, aArgType2)

#define V_IMPL2V(aClass, aMethod, aArgType1, aArgName1, aArgType2, aArgName2) \
	 void __EXPORT aClass::VirtualStub##aMethod( \
	     void *pThis, aArgType1 aArgName1, aArgType2 aArgName2) \
	 { ((aClass*)pThis) \
	 ->VirtualMethod##aMethod(aArgName1, aArgName2); } \
	 void aClass::VirtualMethod##aMethod(aArgType1 aArgName1, aArgType2 aArgName2)

#define V_IMPL2(aRetType, aClass, aMethod, aArgType1, aArgName1, aArgType2, aArgName2) \
	 aRetType __EXPORT aClass::VirtualStub##aMethod( \
	     void *pThis, aArgType1 aArgName1, aArgType2 aArgName2) \
	 { return ((aClass*)pThis) \
	 ->VirtualMethod##aMethod(aArgName1, aArgName2); } \
	 aRetType aClass::VirtualMethod##aMethod(aArgType1 aArgName1, aArgType2 aArgName2)

#define V_BASE_IMPL2V(aClass, aMethod, aArgType1, aArgName1, aArgType2, aArgName2) \
	 void aClass::aMethod(aArgType1 aArgName1, aArgType2 aArgName2) \
	 { (* ( void (*)(void*, aArgType1, aArgType2) ) \
		VirtualGetThisPtr##aMethod()->pMethod ) \
	 ( VirtualGetThisPtr##aMethod()->pThis, aArgName1, aArgName2 ); } \
	 V_IMPL1V(aClass, aMethod, aArgType1, aArgName1, aArgType2, aArgName2)

#define V_BASE_IMPL2(aRetType, aClass, aMethod, aArgType1, aArgName1, aArgType2, aArgName2) \
	 aRetType aClass::aMethod(aArgType1 aArgName1, aArgType2, aArgName2) \
	 { return (* ( aRetType (*)(void*, aArgType1, aArgType2) ) \
		VirtualGetThisPtr##aMethod()->pMethod ) \
	 ( VirtualGetThisPtr##aMethod()->pThis, aArgName1, aArgName2 ); } \
	 V_IMPL1(aRetType, aClass, aMethod, aArgType1, aArgName1, aArgType2, aArgName2)

#define C_START \
	 const void * CompatibleGetThis() const {return this;} \
	 struct CompatibleImpl {

#define C_START1(x) \
	 const void * CompatibleGetThis() const {return &x;} \
	 struct CompatibleImpl {

#define C_END };

#define C_INIT \
  (*(CompatibleImpl **)SfxPointerServer::GetServer()->CreatePointer(CompatibleGetThis()))= \
	  new CompatibleImpl

#define C_DONE \
  delete ((CompatibleImpl *)SfxPointerServer::GetServer()->GetPointer(CompatibleGetThis())); \
  SfxPointerServer::GetServer()->ReleasePointer(CompatibleGetThis())

#ifdef C_SAFEUSE

#define C(Member) \
( \
  (SfxPointerServer::GetServer()->HasPointer(CompatibleGetThis()) ? NULL : (C_INIT)),\
  ((CompatibleImpl *)SfxPointerServer::GetServer()->GetPointer(CompatibleGetThis()))->Member \
)

#define C1(Class, Member) \
( \
  (SfxPointerServer::GetServer()->HasPointer(Class::CompatibleGetThis()) ? NULL : (C_INIT)),\
  ((Class::CompatibleImpl *) \
   SfxPointerServer::GetServer()->GetPointer(Class::CompatibleGetThis()))->Member \
)

#define C2(Object, Class, Member) \
( \
  (SfxPointerServer::GetServer()->HasPointer(((Class*)Object)->CompatibleGetThis()) \
	  ? NULL : (C_INIT)),\
  ((Class::CompatibleImpl *) \
   SfxPointerServer::GetServer()->GetPointer(((Class*)Object)->CompatibleGetThis()))->Member \
)

#else

#define C(Member) \
  (((CompatibleImpl *)SfxPointerServer::GetServer()->GetPointer(CompatibleGetThis()))->Member)

#define C1(Class, Member) \
  (((Class::CompatibleImpl *) \
   SfxPointerServer::GetServer()->GetPointer(Class::CompatibleGetThis()))->Member)

#define C2(Object, Class, Member) \
  (((Class::CompatibleImpl *) \
   SfxPointerServer::GetServer()->GetPointer(((Class*)Object)->CompatibleGetThis()))->Member)

#endif

#endif

#undef C_VERSION
#ifdef C_SAFEUSE
#undef C_SAVEUSE

#endif

