

#ifndef _CSTITEM_HXX
#define _CSTITEM_HXX

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

#include <svtools/poolitem.hxx>

class SvStream;

enum CrawlStatus
{
	CSTAT_NEVER_UPD			= 0,	    
	CSTAT_IN_UPD			= 1,		
	CSTAT_UPD_NEWER			= 2,		
	CSTAT_UPD_NOT_NEWER		= 3,		
	CSTAT_UPD_CANCEL		= 4,		
	CSTAT_ERR_GENERAL		= 5,		
	CSTAT_ERR_NOTEXISTS		= 6,		
	CSTAT_ERR_NOTREACHED	= 7,		
	CSTAT_UPD_IMMEDIATELY	= 8,		
	CSTAT_ERR_OFFLINE		= 9			
};

DBG_NAMEEX(SfxCrawlStatusItem);

class SfxCrawlStatusItem : public SfxPoolItem
{
private:
			CrawlStatus		eStatus;
public:
			TYPEINFO();
	SfxCrawlStatusItem( const SfxCrawlStatusItem& rCpy );
			SfxCrawlStatusItem( USHORT nWhich );
			SfxCrawlStatusItem( USHORT nWhich, CrawlStatus eStat );
			~SfxCrawlStatusItem() { DBG_DTOR(SfxCrawlStatusItem, 0); }

	virtual	int				operator==( const SfxPoolItem& )			const;
	virtual int				Compare( const SfxPoolItem &rWith )			const;
	virtual SfxPoolItem*	Create( SvStream&, USHORT nItemVersion )	const;
	virtual SvStream&		Store( SvStream&, USHORT nItemVersion )		const;
	virtual SfxPoolItem*	Clone( SfxItemPool* pPool = 0 )				const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						XubString &rText,
	                                const IntlWrapper * pIntlWrapper = 0 )
		const;

	CrawlStatus				GetStatus() const { return eStatus; }
	void					SetStatus(CrawlStatus eNew) { eStatus = eNew; }

	virtual	BOOL PutValue  ( const com::sun::star::uno::Any& rVal,
			     BYTE nMemberId = 0 );
	virtual	BOOL QueryValue( com::sun::star::uno::Any& rVal,
				 BYTE nMemberId = 0 ) const;
};

#endif

