
#ifndef _SVTOOLS_CTYPEITM_HXX
#define _SVTOOLS_CTYPEITM_HXX

#ifndef _INETTYPE_HXX
#include <svtools/inettype.hxx>
#endif
#ifndef _SVTOOLS_CUSTRITM_HXX
#include <svtools/custritm.hxx>
#endif

class CntContentTypeItem : public CntUnencodedStringItem
{
private:
	INetContentType _eType;
	XubString		_aPresentation;

public:
	TYPEINFO();

	CntContentTypeItem();
	CntContentTypeItem(	USHORT nWhich, const XubString& rType );
	CntContentTypeItem(	USHORT nWhich, const INetContentType eType );
	CntContentTypeItem( const CntContentTypeItem& rOrig );

	virtual SfxPoolItem* Create( SvStream& rStream,
					 USHORT nItemVersion ) const;
	virtual SvStream & Store(SvStream & rStream, USHORT) const;

	virtual int          operator==( const SfxPoolItem& rOrig ) const;

	virtual USHORT GetVersion(USHORT) const;

	virtual SfxPoolItem* Clone( SfxItemPool *pPool = NULL ) const;

	void SetValue( const XubString& rNewVal );
	void SetPresentation( const XubString& rNewVal );
	 virtual int Compare( const SfxPoolItem &rWith, const IntlWrapper& rIntlWrapper ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
									 SfxMapUnit eCoreMetric,
									 SfxMapUnit ePresMetric,
									 XubString &rText,
	                                             const IntlWrapper* pIntlWrapper = 0 ) const;

	virtual	BOOL QueryValue( com::sun::star::uno::Any& rVal,
				 BYTE nMemberId = 0 ) const;
	virtual	BOOL PutValue  ( const com::sun::star::uno::Any& rVal,
			     BYTE nMemberId = 0);

	const INetContentType GetEnumValue() const;

	void  			  	  SetValue( const INetContentType eType );
};

#endif 

