

#ifndef _SVT_FILEDLG_HXX
#define _SVT_FILEDLG_HXX

#ifndef _DIALOG_HXX
#include <vcl/dialog.hxx>
#endif

class Edit;
class ImpSvFileDlg;

class PathDialog : public ModalDialog
{
private:
	friend class FileDialog;	

	ImpSvFileDlg*		pImpFileDlg;	
	Link				aOKHdlLink; 	

protected:
	UniString			aDfltExt;		

public:
			PathDialog( Window* pParent, WinBits nWinStyle = 0, BOOL bCreateDir = TRUE );
			~PathDialog();

	virtual long		OK();

	void				SetPath( const UniString& rNewPath );
	void				SetPath( const Edit& rEdit );
	UniString				GetPath() const;

	void				SetOKHdl( const Link& rLink ) { aOKHdlLink = rLink; }
	const Link& 		GetOKHdl() const { return aOKHdlLink; }

	virtual short		Execute();
};

class FileDialog : public PathDialog
{
private:
	Link				aFileHdlLink;	
	Link				aFilterHdlLink; 

public:
			FileDialog( Window* pParent, WinBits nWinStyle );
			~FileDialog();

	virtual void		FileSelect();
	virtual void		FilterSelect();

	void				SetDefaultExt( const UniString& rExt ) { aDfltExt = rExt; }
	const UniString&		GetDefaultExt() const { return aDfltExt; }
	void				AddFilter( const UniString& rFilter, const UniString& rType );
	void				AddFilter( const UniString& rFilter, const UniString& rType,
					   const UniString& rSysType );
	void				RemoveFilter( const UniString& rFilter );
	void				RemoveAllFilter();
	void				SetCurFilter( const UniString& rFilter );
	UniString				GetCurFilter() const;
	USHORT				GetFilterCount() const;
	UniString				GetFilterName( USHORT nPos ) const;
	UniString				GetFilterType( USHORT nPos ) const;

	void				SetFileSelectHdl( const Link& rLink ) { aFileHdlLink = rLink; }
	const Link& 		GetFileSelectHdl() const { return aFileHdlLink; }
	void				SetFilterSelectHdl( const Link& rLink ) { aFilterHdlLink = rLink; }
	const Link& 		GetFilterSelectHdl() const { return aFilterHdlLink; }

	void				SetOkButtonText( const UniString& rText );
	void				SetCancelButtonText( const UniString& rText );
};

#endif	
