
#ifndef _SFXFLAGITEM_HXX
#define _SFXFLAGITEM_HXX

#include <tools/solar.h>
#include <tools/rtti.hxx>
#include <svtools/poolitem.hxx>

class SfxArguments;
class SvStream;

DBG_NAMEEX(SfxFlagItem);

extern USHORT nSfxFlagVal[16];

class SfxFlagItem: public SfxPoolItem
{
	USHORT					 nVal;

public:
				 TYPEINFO();
					 SfxFlagItem( USHORT nWhich = 0, USHORT nValue = 0 );
				 SfxFlagItem( USHORT nWhich, SvStream & );
				 SfxFlagItem( const SfxFlagItem& );
					 ~SfxFlagItem() {
					DBG_DTOR(SfxFlagItem, 0); }

	virtual BYTE			 GetFlagCount() const;
	virtual XubString		 GetFlagText( BYTE nFlag ) const;

	virtual int 			 operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*     Create(SvStream &, USHORT nVersion) const;
	virtual SvStream&		 Store(SvStream &, USHORT nItemVersion) const;

	virtual SfxPoolItem*	 Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						XubString &rText,
	                                const IntlWrapper * = 0 ) const;
			USHORT           GetValue() const { return nVal; }
			void			 SetValue( USHORT nNewVal ) {
					 DBG_ASSERT( GetRef() == 0, "SetValue() with pooled item" );
					 nVal = nNewVal;
				 }
			int 			 GetFlag( BYTE nFlag ) const {
					 return ( (nVal & nSfxFlagVal[nFlag]) != 0 ); }
			void			 SetFlag( BYTE nFlag, int bVal );
};

#endif
