
#ifndef INCLUDED_SVTOOLS_FONTOPTIONS_HXX
#define INCLUDED_SVTOOLS_FONTOPTIONS_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

class SvtFontOptions_Impl;

class SvtFontOptions
{

	public:
	      SvtFontOptions();
	    ~SvtFontOptions();

		sal_Bool	IsReplacementTableEnabled	(					) const	;
		void		EnableReplacementTable		( sal_Bool bState	)		;

		sal_Bool	IsFontHistoryEnabled		(					) const	;
		void		EnableFontHistory			( sal_Bool bState	)		;

		sal_Bool	IsFontWYSIWYGEnabled		(					) const	;
		void		EnableFontWYSIWYG			( sal_Bool bState	)		;

		static ::osl::Mutex& impl_GetOwnStaticMutex();

	private:
	 	static SvtFontOptions_Impl*			m_pDataContainer	;	
		static sal_Int32					m_nRefCount			;	

};		

#endif	
