
#ifndef INCLUDED_SVTOOLS_HISTORYOPTIONS_HXX
#define INCLUDED_SVTOOLS_HISTORYOPTIONS_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

#define	HISTORY_PROPERTYNAME_URL			::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("URL"		))
#define	HISTORY_PROPERTYNAME_FILTER			::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("Filter"	))
#define	HISTORY_PROPERTYNAME_TITLE			::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("Title"		))
#define	HISTORY_PROPERTYNAME_PASSWORD		::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("Password"	))

enum EHistoryType
{
	ePICKLIST	=	0,
	eHISTORY	=	1
};

class SvtHistoryOptions_Impl;

class SvtHistoryOptions
{

	public:
	      SvtHistoryOptions();
	    ~SvtHistoryOptions();

		sal_uInt32	GetSize( EHistoryType eHistory						) const	;
		void		SetSize( EHistoryType eHistory, sal_uInt32 nSize	)		;

		void Clear( EHistoryType eHistory );

		::com::sun::star::uno::Sequence< ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue > > GetList( EHistoryType eHistory ) const ;

		void AppendItem(			EHistoryType		eHistory	,
				const	::rtl::OUString&	sURL		,
				const	::rtl::OUString&	sFilter		,
				const	::rtl::OUString&	sTitle		,
				const	::rtl::OUString&	sPassword	);

		static ::osl::Mutex& GetOwnStaticMutex();

	private:
	 	static SvtHistoryOptions_Impl*	m_pDataContainer	;	
		static sal_Int32				m_nRefCount			;	

};		

#endif	
