
#ifndef _GOODIES_IMAPCIRC_HXX
#define _GOODIES_IMAPCIRC_HXX

#ifndef _GEN_HXX 
#include <tools/gen.hxx>
#endif

#include <svtools/imapobj.hxx>

class Fraction;

class IMapCircleObject : public IMapObject
{
	Point				aCenter;
	ULONG				nRadius;

	void				ImpConstruct( const Point& rCenter, ULONG nRad, BOOL bPixel );

protected:

	virtual void		WriteIMapObject( SvStream& rOStm ) const;
	virtual void		ReadIMapObject(  SvStream& rIStm );

public:
				IMapCircleObject() {};
			IMapCircleObject( const Point& rCenter, ULONG nRad,
							  const String& rURL,
							  const String& rDescription,
							  BOOL bActive = TRUE,
							  BOOL bPixelCoords = TRUE );
			IMapCircleObject( const Point& rCenter, ULONG nRad,
							  const String& rURL,
							  const String& rDescription,
							  const String& rTarget,
							  BOOL bActive = TRUE,
							  BOOL bPixelCoords = TRUE );
			IMapCircleObject( const Point& rCenter, ULONG nRad,
							  const String& rURL,
							  const String& rDescription,
							  const String& rTarget,
							  const String& rName,
							  BOOL bActive = TRUE,
							  BOOL bPixelCoords = TRUE );
	virtual				~IMapCircleObject() {};

	virtual UINT16		GetType() const;
	virtual BOOL		IsHit( const Point& rPoint ) const;

	Point				GetCenter( BOOL bPixelCoords = TRUE ) const;
	ULONG				GetRadius( BOOL bPixelCoords = TRUE ) const;

	virtual Rectangle	GetBoundRect() const;

	void				Scale( const Fraction& rFractX, const Fraction& rFracY );

	BOOL				IsEqual( const IMapCircleObject& rEqObj );

	void				WriteCERN( SvStream& rOStm ) const;
	void				WriteNCSA( SvStream& rOStm ) const;
};

#endif
