

#ifndef _GOODIES_IMAPPOLY_HXX
#define _GOODIES_IMAPPOLY_HXX

#include <svtools/imapobj.hxx>

#ifndef _POLY_HXX 
#include <vcl/poly.hxx>
#endif

class Fraction;

class IMapPolygonObject : public IMapObject
{
	Polygon				aPoly;
	Rectangle			aEllipse;
	BOOL				bEllipse;

	void				ImpConstruct( const Polygon& rPoly, BOOL bPixel );

protected:

	virtual void		WriteIMapObject( SvStream& rOStm ) const;
	virtual void		ReadIMapObject(  SvStream& rIStm );

	BOOL				ReadPreProLine( SvStream& rIStm, String& rStr );

public:
			IMapPolygonObject() {};
			IMapPolygonObject( const Polygon& rPoly,
							   const String& rURL,
							   const String& rDescription,
							   BOOL bActive = TRUE,
							   BOOL bPixelCoords = TRUE );
			IMapPolygonObject( const Polygon& rPoly,
							   const String& rURL,
							   const String& rDescription,
							   const String& rTarget,
							   BOOL bActive = TRUE,
							   BOOL bPixelCoords = TRUE );
			IMapPolygonObject( const Polygon& rPoly,
							   const String& rURL,
							   const String& rDescription,
							   const String& rTarget,
							   const String& rName,
							   BOOL bActive = TRUE,
							   BOOL bPixelCoords = TRUE );
	virtual				~IMapPolygonObject() {};

	virtual UINT16		GetType() const;
	virtual BOOL		IsHit( const Point& rPoint ) const;

	Polygon				GetPolygon( BOOL bPixelCoords = TRUE ) const;

	virtual Rectangle	GetBoundRect() const { 	return aPoly.GetBoundRect(); }

	BOOL				HasExtraEllipse() const { return bEllipse; }
	const Rectangle&	GetExtraEllipse() const { return aEllipse; }
	void				SetExtraEllipse( const Rectangle& rEllipse );

	void				Scale( const Fraction& rFractX, const Fraction& rFracY );

	BOOL				IsEqual( const IMapPolygonObject& rEqObj );

	void				WriteCERN( SvStream& rOStm ) const;
	void				WriteNCSA( SvStream& rOStm ) const;
};

#endif
