
#ifndef _GOODIES_IMAPRECT_HXX
#define _GOODIES_IMAPRECT_HXX

#ifndef _GEN_HXX 
#include <tools/gen.hxx>
#endif

#include <svtools/imapobj.hxx>

class Fraction;

class IMapRectangleObject : public IMapObject
{
	Rectangle			aRect;

	void				ImpConstruct( const Rectangle& rRect, BOOL bPixel );

protected:

	virtual void		WriteIMapObject( SvStream& rOStm ) const;
	virtual void		ReadIMapObject(  SvStream& rIStm );

public:
				IMapRectangleObject() {};
			IMapRectangleObject( const Rectangle& rRect,
								 const String& rURL,
								 const String& rDescription,
								 BOOL bActive = TRUE,
								 BOOL bPixelCoords = TRUE );
			IMapRectangleObject( const Rectangle& rRect,
								 const String& rURL,
								 const String& rDescription,
								 const String& rTarget,
								 BOOL bActive = TRUE,
								 BOOL bPixelCoords = TRUE );
			IMapRectangleObject( const Rectangle& rRect,
								 const String& rURL,
								 const String& rDescription,
								 const String& rTarget,
								 const String& rName,
								 BOOL bActive = TRUE,
								 BOOL bPixelCoords = TRUE );
	virtual				~IMapRectangleObject() {};

	virtual UINT16		GetType() const;
	virtual BOOL		IsHit( const Point& rPoint ) const;

	Rectangle			GetRectangle( BOOL bPixelCoords = TRUE ) const;

	virtual Rectangle	GetBoundRect() const { return aRect; }

	void				Scale( const Fraction& rFractX, const Fraction& rFracY );

	BOOL				IsEqual( const IMapRectangleObject& rEqObj );

	void				WriteCERN( SvStream& rOStm ) const;
	void				WriteNCSA( SvStream& rOStm ) const;
};

#endif
