

#ifndef _SVTOOLS_INETTBC_HXX
#define _SVTOOLS_INETTBC_HXX

#include <tools/string.hxx>
#include <tools/urlobj.hxx>

#ifndef _COMBOBOX_HXX 
#include <vcl/combobox.hxx>
#endif

class SvtURLBox : public ComboBox
{
friend class SvtMatchContext_Impl;
friend class SvtURLBox_Impl;
	Link							aOpenHdl;
	String							aBaseURL;
	SvtMatchContext_Impl*			pCtx;
	SvtURLBox_Impl*					pImp;
	INetProtocol					eSmartProtocol;
	BOOL            				bAutoCompleteMode   : 1;
	BOOL							bOnlyDirectories    : 1;
	BOOL							bModified           : 1;
	BOOL                            bTryAutoComplete    : 1;
	BOOL							bCtrlClick          : 1;
	BOOL							bHistoryDisabled    : 1;

	BOOL            				ProcessKey( const KeyCode& rCode );
	void            				TryAutoComplete( BOOL bForward, BOOL bForce );
	void                            UpdatePicklistForSmartProtocol_Impl();
	DECL_LINK(                      AutoCompleteHdl_Impl, void* );

protected:
	virtual long					Notify( NotifyEvent& rNEvt );
	virtual void					Select();
	virtual void					Modify();
	virtual long					PreNotify( NotifyEvent& rNEvt );

public:
	                                SvtURLBox( Window* pParent, INetProtocol eSmart = INET_PROT_NOT_VALID );
	                                SvtURLBox( Window* pParent, const ResId& _rResId, INetProtocol eSmart = INET_PROT_NOT_VALID );
	                                ~SvtURLBox();

	void							SetBaseURL( const String& rURL );
	const String&					GetBaseURL() const { return aBaseURL; }
	void							SetOpenHdl( const Link& rLink ) { aOpenHdl = rLink; }
	const Link& 					GetOpenHdl() const { return aOpenHdl; }
	void							SetOnlyDirectories( BOOL bDir = TRUE );
	INetProtocol					GetSmartProtocol() const { return eSmartProtocol; }
	void                            SetSmartProtocol( INetProtocol eProt );
	BOOL                            IsCtrlOpen()
	                                { return bCtrlClick; }
	String                          GetURL();
	void							DisableHistory();
	 static String                   ParseSmart( String aText, String aBaseURL, String aWorkDir );
};

#endif

