
#ifndef _SFXITEMITER_HXX
#define _SFXITEMITER_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif

class SfxPoolItem;
class SfxItemSet;
class SfxItemPool;

class SfxItemIter
{

	const SfxItemSet&	_rSet;
	USHORT				_nStt, _nEnd, _nAkt;

public:
	SfxItemIter( const SfxItemSet& rSet );
	~SfxItemIter();

	const SfxPoolItem* FirstItem()
		   { _nAkt = _nStt;
			 return _rSet._nCount ? *(_rSet._aItems+_nAkt) : 0; }
	const SfxPoolItem* LastItem()
		   { _nAkt = _nEnd;
			 return _rSet._nCount ? *(_rSet._aItems+_nAkt) : 0; }
	const SfxPoolItem* GetCurItem()
		   { return _rSet._nCount ? *(_rSet._aItems+_nAkt) : 0; }
	const SfxPoolItem* NextItem();
	const SfxPoolItem* PrevItem();

	BOOL			   IsAtStart() const { return _nAkt == _nStt; }
	BOOL               IsAtEnd() const   { return _nAkt == _nEnd; }

	USHORT             GetCurPos() const { return _nAkt; }
	USHORT             GetFirstPos() const { return _nStt; }
	USHORT             GetLastPos() const { return _nEnd; }
};

#endif
