
#ifndef _SVT_LISTENER_HXX
#define _SVT_LISTENER_HXX

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

class SvtBroadcaster;
class SfxHint;
class SvtListenerBase;

class SvtListener
{
	friend class SvtListenerBase;
	SvtListenerBase *pBrdCastLst;

	const SvtListener&	operator=(const SvtListener &); 

public:
	TYPEINFO();
				SvtListener();
			SvtListener( const SvtListener &rCopy );
	virtual 			~SvtListener();

	BOOL				StartListening( SvtBroadcaster& rBroadcaster );
	BOOL				EndListening( SvtBroadcaster& rBroadcaster );
	void				EndListeningAll();
	BOOL				IsListening( SvtBroadcaster& rBroadcaster ) const;

	BOOL 				HasBroadcaster() const { return 0 != pBrdCastLst; }

	virtual void		Notify( SvtBroadcaster& rBC, const SfxHint& rHint );
};

#endif

