
#ifndef _SVT_LISTENERITER_HXX
#define _SVT_LISTENERITER_HXX

#ifndef _RTTI_HXX 
#include <tools/rtti.hxx>
#endif

class SvtListener;
class SvtListenerBase;
class SvtBroadcaster;

class SvtListenerIter
{
	friend class SvtListenerBase;

	SvtBroadcaster& rRoot;
	SvtListenerBase *pAkt, *pDelNext;

	static SvtListenerIter *pListenerIters;
	SvtListenerIter *pNxtIter;
	TypeId aSrchId;				

	static void RemoveListener( SvtListenerBase& rDel,
					SvtListenerBase* pNext );

public:
	SvtListenerIter( SvtBroadcaster& );
	~SvtListenerIter();

	const SvtBroadcaster& GetBroadcaster() const	{ return rRoot; }
	SvtBroadcaster& GetBroadcaster() 			{ return rRoot; }

	SvtListener* GoNext();			
	SvtListener* GoPrev();			

	SvtListener* GoStart(); 		
	SvtListener* GoEnd();			

	SvtListener* GoRoot(); 			
	SvtListener* GetCurr() const;	

	int IsChanged() const 		{ return pDelNext != pAkt; }

	SvtListener* First( TypeId nType );
	SvtListener* Next();
};

#endif

