

#ifndef _SVTOOLS_LNGMISC_HXX_
#define _SVTOOLS_LNGMISC_HXX_

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#define SVT_SOFT_HYPHEN	((sal_Unicode) 0x00AD)
#define SVT_HARD_HYPHEN	((sal_Unicode) 0x2011)

namespace linguistic
{

inline BOOL IsHyphen( sal_Unicode cChar )
{
	return cChar == SVT_SOFT_HYPHEN  ||  cChar == SVT_HARD_HYPHEN;
}

inline BOOL IsControlChar( sal_Unicode cChar )
{
	return cChar < (sal_Unicode) ' ';
}

inline BOOL HasHyphens( const rtl::OUString &rTxt )
{
	return	rTxt.indexOf( SVT_SOFT_HYPHEN ) != -1  ||
			rTxt.indexOf( SVT_HARD_HYPHEN ) != -1;
}

BOOL	HasHyphens( const rtl::OUString &rTxt );
INT32	GetNumControlChars( const rtl::OUString &rTxt );
BOOL	RemoveHyphens( rtl::OUString &rTxt );
BOOL	RemoveControlChars( rtl::OUString &rTxt );

} 

#endif
