
#ifndef _SFXLSTNER_HXX
#define _SFXLSTNER_HXX

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif
#include <svtools/svarray.hxx>

class SfxBroadcaster;
class SfxHint;

#ifndef _SFX_LSTNER_CXX
typedef SvPtrarr SfxBroadcasterArr_Impl;
#endif

#if SUPD<=310
#define SFX_NOTIFY( rBC, rBCT, rHint, rHintT ) \
		Notify( rBC, rBCT, rHint, rHintT )
#else
#define SFX_NOTIFY( rBC, rBCT, rHint, rHintT ) \
		Notify( rBC, rHint )
#endif

class SfxListener
{
	SfxBroadcasterArr_Impl aBCs;

private:
	const SfxListener&	operator=(const SfxListener &); 

public:
	TYPEINFO();
				SfxListener();
			SfxListener( const SfxListener &rCopy );
	virtual 			~SfxListener();

	BOOL				StartListening( SfxBroadcaster& rBroadcaster, BOOL bPreventDups = FALSE );
	BOOL				EndListening( SfxBroadcaster& rBroadcaster, BOOL bAllDups = FALSE );
	void				EndListening( USHORT nNo );
	void				EndListeningAll();
	BOOL				IsListening( SfxBroadcaster& rBroadcaster ) const;

	USHORT				GetBroadcasterCount() const
			{ return aBCs.Count(); }
	SfxBroadcaster* 	GetBroadcasterJOE( USHORT nNo ) const
			{ return (SfxBroadcaster*) aBCs.GetObject(nNo); }

	virtual void		Notify( SfxBroadcaster& rBC, const SfxHint& rHint );

#ifndef _NOTIFY_HXX
	void RemoveBroadcaster_Impl( SfxBroadcaster& rBC );
#endif
};

#endif

