
#ifndef INCLUDED_SVTOOLS_MENUOPTIONS_HXX
#define INCLUDED_SVTOOLS_MENUOPTIONS_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

class Link;
class SvtMenuOptions_Impl;

class SvtMenuOptions
{

	public:
	      SvtMenuOptions();
	    ~SvtMenuOptions();
	     void AddListener( const Link& rLink );
	    void RemoveListener( const Link& rLink );

		sal_Bool IsEntryHidingEnabled() const;
		sal_Bool IsFollowMouseEnabled() const;
		sal_Bool IsMenuIconsEnabled() const;

		void SetEntryHidingState( sal_Bool bState );
		void SetFollowMouseState( sal_Bool bState );
		void SetMenuIconsState( sal_Bool bState );

		static ::osl::Mutex& GetOwnStaticMutex();

	private:
	 	static SvtMenuOptions_Impl*	m_pDataContainer	;	
		static sal_Int32			m_nRefCount			;	

};		

#endif	
