
#ifndef INCLUDED_SVTOOLS_MISCOPT_HXX
#define INCLUDED_SVTOOLS_MISCOPT_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

class SvtMiscOptions_Impl;
class Link;

class SvtMiscOptions
{

	public:
	      SvtMiscOptions();
	    ~SvtMiscOptions();
	     void AddListener( const Link& rLink );
	    void RemoveListener( const Link& rLink );
	     sal_Bool UseSystemFileDialog() const;
	    void SetUseSystemFileDialog( sal_Bool bSet );
	     sal_Bool IsPluginsEnabled() const;
		void SetPluginsEnabled( sal_Bool bEnable );
	     sal_Int16 GetSymbolSet() const;
	    void SetSymbolSet( sal_Int16 eSet );
	    sal_Int16 GetToolboxStyle() const;
	    void SetToolboxStyle( sal_Int16 nStyle );

		static ::osl::Mutex& GetInitMutex();

	private:
	 	static SvtMiscOptions_Impl*	m_pDataContainer	;	
		static sal_Int32				m_nRefCount			;	

};		

#endif	
