
#ifndef INCLUDED_SVTOOLS_MODULEOPTIONS_HXX
#define INCLUDED_SVTOOLS_MODULEOPTIONS_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#define FEATUREFLAG_BASICIDE				0x00000020
#define FEATUREFLAG_MATH           			0x00000100
#define FEATUREFLAG_CHART          			0x00000200
#define FEATUREFLAG_CALC           			0x00000800
#define FEATUREFLAG_DRAW           			0x00001000
#define FEATUREFLAG_WRITER     				0x00002000
#define FEATUREFLAG_IMPRESS     			0x00008000

class SvtModuleOptions_Impl;

class SvtModuleOptions
{

	public:
	      SvtModuleOptions();
	    ~SvtModuleOptions();

		sal_Bool IsMath		( sal_Bool bClient = sal_False ) const;
		sal_Bool IsChart	( sal_Bool bClient = sal_False ) const;
		sal_Bool IsCalc		( sal_Bool bClient = sal_False ) const;
		sal_Bool IsDraw		( sal_Bool bClient = sal_False ) const;
		sal_Bool IsWriter	( sal_Bool bClient = sal_False ) const;
		sal_Bool IsImpress	( sal_Bool bClient = sal_False ) const;
		sal_Bool IsBasicIDE	( sal_Bool bClient = sal_False ) const;

		sal_uInt32 GetFeatures( sal_Bool bClient = sal_False ) const;

		static ::osl::Mutex& GetOwnStaticMutex();

	private:
	 	static SvtModuleOptions_Impl*	m_pDataContainer	;	
		static sal_Int32				m_nRefCount			;	

};		

#endif	
