
#ifdef MACOSX

#endif

#ifndef _SFXNRANGES_HXX

#ifndef NUMTYPE

#define NUMTYPE	USHORT
#define SfxNumRanges SfxUShortRanges
#include <svtools/nranges.hxx>

#undef NUMTYPE
#define NUMTYPE	ULONG
#define SfxNumRanges SfxULongRanges
#include <svtools/nranges.hxx>

#define _SFXNRANGES_HXX

#else

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#if SUPD<=383

#if defined MAC || ( defined SOLARIS && defined X86 ) || ( defined SINIX && defined GCC ) || defined SCO
#define NUMTYPE_ARG	int
#else
#define NUMTYPE_ARG	NUMTYPE
#endif

#else

#define NUMTYPE_ARG	int

#endif

class SfxNumRanges
{
	NUMTYPE*                 	_pRanges; 

public:
					SfxNumRanges() : _pRanges( 0 ) {}
					SfxNumRanges( const SfxNumRanges &rOrig );
					SfxNumRanges( NUMTYPE nWhich1, NUMTYPE nWhich2 );
					SfxNumRanges( NUMTYPE_ARG nWh1, NUMTYPE_ARG nWh2, NUMTYPE_ARG nNull, ... );
					SfxNumRanges( const NUMTYPE* nNumTable );
					~SfxNumRanges()
					{ delete _pRanges; }

	BOOL						operator == ( const SfxNumRanges & ) const;
	BOOL						operator != ( const SfxNumRanges & rRanges ) const
					{ return !( *this == rRanges ); }

	SfxNumRanges&				operator = ( const SfxNumRanges & );

	SfxNumRanges&				operator += ( const SfxNumRanges & );
	SfxNumRanges&				operator -= ( const SfxNumRanges & );
	SfxNumRanges&				operator /= ( const SfxNumRanges & );

	NUMTYPE 					Count() const;
	BOOL						IsEmpty() const
					{ return !_pRanges || 0 == *_pRanges; }
	BOOL						Contains( NUMTYPE n ) const;
	BOOL						Intersects( const SfxNumRanges & ) const;
						operator const NUMTYPE* () const
					{ return _pRanges; }
};

#undef NUMTYPE
#undef SfxNumRanges

#endif

#endif
