

#ifndef INCLUDED_SVTOOLS_OPTIONS3D_HXX
#define INCLUDED_SVTOOLS_OPTIONS3D_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

class SvtOptions3D_Impl;

class SvtOptions3D
{

	public:
	      SvtOptions3D();
	    ~SvtOptions3D();

		sal_Bool	IsDithering() const;
		sal_Bool	IsOpenGL() const;
		sal_Bool	IsOpenGL_Faster() const;
		sal_Bool	IsShowFull() const;

		void		SetDithering( sal_Bool bState );
		void		SetOpenGL( sal_Bool bState );
		void		SetOpenGL_Faster( sal_Bool bState );
		void		SetShowFull( sal_Bool bState );

		static ::osl::Mutex& GetOwnStaticMutex();

	private:
	 	static SvtOptions3D_Impl*		m_pDataContainer	;	
		static sal_Int32				m_nRefCount			;	

};		

#endif	
