

#ifndef _OWNLIST_HXX
#define _OWNLIST_HXX

#ifndef _STREAM_HXX 
#include <tools/stream.hxx>
#endif
#ifndef _TOOLS_OWNLIST_HXX 
#include <tools/ownlist.hxx>
#endif

class SvCommand

{
	String	aCommand;
	String	aArgument;
public:
		SvCommand() {}
		SvCommand( const String & rCommand, const String & rArg )
		{
			aCommand = rCommand;
			aArgument = rArg;
		}
	const String & GetCommand() const { return aCommand; }
	const String & GetArgument() const { return aArgument; }

	friend SvStream& operator >> ( SvStream& rStm, SvCommand & rThis )
		{
			rStm.ReadByteString( rThis.aCommand, gsl_getSystemTextEncoding() );
			rStm.ReadByteString( rThis.aArgument, gsl_getSystemTextEncoding() );
			return rStm;
		}
	friend SvStream& operator << ( SvStream& rStm, const SvCommand & rThis )
		{
			rStm.WriteByteString( rThis.aCommand, gsl_getSystemTextEncoding() );
			rStm.WriteByteString( rThis.aArgument, gsl_getSystemTextEncoding() );
			return rStm;
		}
};

class SvCommandList

{
		PRV_SV_DECL_OWNER_LIST(SvCommandList,SvCommand);
	SvCommand &		Append( const String & rCommand, const String & rArg );
	BOOL			AppendCommands( const String & rCmd, USHORT * pEaten );
	String  		GetCommands() const;

	friend SvStream& operator >> ( SvStream& rStm, SvCommandList & );
	friend SvStream& operator << ( SvStream&, const SvCommandList & );
};

#endif 
