

#ifndef _SV_PRNSETUP_HXX_
#define _SV_PRNSETUP_HXX_

#ifndef _VCL_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _VCL_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _VCL_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _VCL_GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef _VCL_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _VCL_TIMER_HXX
#include <vcl/timer.hxx>
#endif
#ifndef _STDCTRL_HXX
#include <svtools/stdctrl.hxx>
#endif

class Printer;
class QueueInfo;

class PrinterSetupDialog : public ModalDialog
{
private:
	FixedLine		maFlPrinter;
	FixedText		maFtName;
	ListBox 		maLbName;
	PushButton		maBtnProperties;
	FixedText		maFtStatus;
	FixedInfo		maFiStatus;
	FixedText		maFtType;
	FixedInfo		maFiType;
	FixedText		maFtLocation;
	FixedInfo		maFiLocation;
	FixedText		maFtComment;
	FixedInfo		maFiComment;
	FixedLine		maFlSepButton;
	OKButton		maBtnOK;
	CancelButton	maBtnCancel;
	HelpButton		maBtnHelp;
	AutoTimer		maStatusTimer;
	Printer*		mpPrinter;
	Printer*		mpTempPrinter;

	void			ImplSetInfo();
			DECL_LINK( ImplPropertiesHdl, void* );
		DECL_LINK( ImplChangePrinterHdl, void* );
		DECL_LINK( ImplStatusHdl, Timer* );

public:
		PrinterSetupDialog( Window* pWindow );
		~PrinterSetupDialog();

	void			SetPrinter( Printer* pNewPrinter ) { mpPrinter = pNewPrinter; }
	Printer*		GetPrinter() const { return mpPrinter; }

	virtual void	DataChanged( const DataChangedEvent& rDCEvt );
	virtual long	Notify( NotifyEvent& rNEvt );

	virtual short	Execute();
};

#define IMPL_PRINTDLG_STATUS_UPDATE 	15000

void ImplFillPrnDlgListBox( const Printer* pPrinter,
				ListBox* pBox, PushButton* pPropBtn );
void ImplFreePrnDlgListBox( ListBox* pBox, BOOL bClear = TRUE );
Printer* ImplPrnDlgListBoxSelect( ListBox* pBox, PushButton* pPropBtn,
					  Printer* pPrinter, Printer* pTempPrinter );
Printer* ImplPrnDlgUpdatePrinter( Printer* pPrinter, Printer* pTempPrinter );
void ImplPrnDlgUpdateQueueInfo( ListBox* pBox, QueueInfo& rInfo );
XubString ImplPrnDlgGetStatusText( const QueueInfo& rInfo );

#endif 
