
#ifndef _SFXRECTITEM_HXX
#define _SFXRECTITEM_HXX

#ifndef _DEBUG_HXX 
#include <tools/debug.hxx>
#endif
#ifndef _GEN_HXX 
#include <tools/gen.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
class SfxArguments;
class SvStream;

DBG_NAMEEX(SfxRectangleItem);

class SfxRectangleItem: public SfxPoolItem
{
	Rectangle				 aVal;

public:
				 TYPEINFO();
				 SfxRectangleItem();
				 SfxRectangleItem( USHORT nWhich, const Rectangle& rVal );
				 SfxRectangleItem( USHORT nWhich, SvStream & );
				 SfxRectangleItem( const SfxRectangleItem& );
				 ~SfxRectangleItem() {
					 DBG_DTOR(SfxRectangleItem, 0); }

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						XubString &rText,
	                                const IntlWrapper * = 0 ) const;

	virtual int 			 operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*     Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	 Create(SvStream &, USHORT nItemVersion) const;
	virtual SvStream&		 Store(SvStream &, USHORT nItemVersion) const;

	const Rectangle&    	 GetValue() const { return aVal; }
			void			 SetValue( const Rectangle& rNewVal ) {
					 DBG_ASSERT( GetRef() == 0, "SetValue() with pooled item" );
					 aVal = rNewVal;
				 }
	virtual	BOOL 			 QueryValue( com::sun::star::uno::Any& rVal,
				 			 BYTE nMemberId = 0 ) const;
	virtual	BOOL 			 PutValue( const com::sun::star::uno::Any& rVal,
			   			   BYTE nMemberId = 0 );
};

#endif

