
#ifdef MACOSX

#endif

#ifndef _SFXRNGITEM_HXX

#ifndef NUMTYPE

#define NUMTYPE	USHORT
#define SfxXRangeItem SfxRangeItem
#define SfxXRangesItem SfxUShortRangesItem
#include <svtools/rngitem.hxx>
#undef NUMTYPE
#undef SfxXRangeItem
#undef SfxXRangesItem

#ifndef _SFXITEMS_HXX
#define NUMTYPE	ULONG
#define SfxXRangeItem SfxULongRangeItem
#define SfxXRangesItem SfxULongRangesItem
#include <svtools/rngitem.hxx>
#undef NUMTYPE
#undef SfxXRangeItem
#undef SfxXRangesItem
#endif

#define _SFXRNGITEM_HXX

#if SUPD<355
DBG_NAMEEX(SfxRangeItem);
#endif

#else

#include <tools/solar.h>
#include <tools/rtti.hxx>
#include <svtools/poolitem.hxx>

class SfxArguments;
class SvStream;

class SfxXRangeItem : public SfxPoolItem
{
private:
	NUMTYPE 					nFrom;
	NUMTYPE 					nTo;
public:
					TYPEINFO();
					SfxXRangeItem();
					SfxXRangeItem( USHORT nWID, NUMTYPE nFrom, NUMTYPE nTo );
					SfxXRangeItem( USHORT nWID, SvStream &rStream );
					SfxXRangeItem( const SfxXRangeItem& rItem );
#if SUPD<355
	virtual 					~SfxXRangeItem() {};
#endif
	virtual int 				operator==( const SfxPoolItem& ) const;
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						XubString &rText,
	                                const IntlWrapper * = 0 ) const;
	virtual SfxPoolItem*    	Clone( SfxItemPool *pPool = 0 ) const;
	inline NUMTYPE&				From() { return nFrom; }
	inline NUMTYPE				From() const { return nFrom; }
	inline NUMTYPE&				To() { return nTo; }
	inline NUMTYPE				To() const { return nTo; }
	inline BOOL					HasRange() const { return nTo>nFrom; }
	virtual SfxPoolItem*		Create( SvStream &, USHORT nVersion ) const;
	virtual SvStream&			Store( SvStream &, USHORT nItemVersion ) const;
};

class SfxXRangesItem : public SfxPoolItem
{
private:
	NUMTYPE*					_pRanges;

public:
					TYPEINFO();
					SfxXRangesItem();
					SfxXRangesItem( USHORT nWID, const NUMTYPE *pRanges );
					SfxXRangesItem( USHORT nWID, SvStream &rStream );
					SfxXRangesItem( const SfxXRangesItem& rItem );
	virtual 					~SfxXRangesItem();
	virtual int 				operator==( const SfxPoolItem& ) const;
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						XubString &rText,
	                                const IntlWrapper * = 0 ) const;
	virtual SfxPoolItem*    	Clone( SfxItemPool *pPool = 0 ) const;
	inline const NUMTYPE*		GetRanges() const { return _pRanges; }
	virtual SfxPoolItem*		Create( SvStream &, USHORT nVersion ) const;
	virtual SvStream&			Store( SvStream &, USHORT nItemVersion ) const;
};

#endif
#endif
