

#ifndef _SBXDEF_HXX
#define _SBXDEF_HXX

#ifndef __RSC
#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _SBX_CLASS_TYPE
#define _SBX_CLASS_TYPE

enum SbxClassType {			
	SbxCLASS_DONTCARE = 1,	
	SbxCLASS_ARRAY,			
	SbxCLASS_VALUE,			
	SbxCLASS_VARIABLE,		
	SbxCLASS_METHOD, 		
	SbxCLASS_PROPERTY,		
	SbxCLASS_OBJECT			
};

#endif

#ifndef _SBX_DATA_TYPE
#define _SBX_DATA_TYPE

enum SbxDataType {
	SbxEMPTY 	  =  0,	
	SbxNULL 	  =  1,	
	SbxINTEGER	  =  2,	
	SbxLONG		  =  3,	
	SbxSINGLE	  =  4,	
	SbxDOUBLE	  =  5,	
	SbxCURRENCY   =  6,	
	SbxDATE		  =  7,	
	SbxSTRING	  =  8,	
	SbxOBJECT     =  9,	
	SbxERROR      = 10,	
	SbxBOOL		  = 11,	
	SbxVARIANT    = 12,	
	SbxDATAOBJECT = 13,	

	SbxCHAR		  = 16,	
	SbxBYTE 	  = 17,	
	SbxUSHORT	  = 18,	
	SbxULONG 	  = 19,	
	SbxLONG64	  = 20,	
	SbxULONG64	  = 21,	
	SbxINT		  = 22,	
	SbxUINT		  = 23,	
	SbxVOID		  = 24,	
	SbxHRESULT	  = 25,	
	SbxPOINTER	  = 26,	
	SbxDIMARRAY	  = 27,	
	SbxCARRAY	  = 28,	
	SbxUSERDEF	  = 29, 
	SbxLPSTR	  = 30,	
	SbxLPWSTR	  = 31,	
	SbxCoreSTRING = 32,	
	SbxWSTRING	  = 33,	
	SbxWCHAR	  = 34,	

	SbxVECTOR = 0x1000,	
	SbxARRAY  = 0x2000,	
	SbxBYREF  = 0x4000,	

	SbxSV1 	  = 128,  	
	SbxMEMORYSTREAM,	
	SbxSTORAGE,			

	SbxUSER1  = 256,  	
	SbxUSERn  = 2047  	
};

#endif

#ifndef _SBX_OPERATOR
#define _SBX_OPERATOR

enum SbxOperator {

	SbxEXP, 			
	SbxMUL, 			
	SbxDIV, 			
	SbxMOD, 			
	SbxPLUS, 			
	SbxMINUS, 			
	SbxNEG,				
	SbxIDIV,			

	SbxAND,				
	SbxOR,				
	SbxXOR,				
	SbxEQV,				
	SbxIMP,				
	SbxNOT,				

	SbxCAT,				

	SbxEQ, 				
	SbxNE, 				
	SbxLT, 				
	SbxGT, 				
	SbxLE, 				
	SbxGE				
};

#endif

#ifndef _SBX_NAME_TYPE
#define _SBX_NAME_TYPE

enum SbxNameType {				
	SbxNAME_NONE,				
	SbxNAME_SHORT,				
	SbxNAME_SHORT_TYPES,		
	SbxNAME_LONG_TYPES			
};

#endif

typedef ULONG SbxError;			

#endif

#define ERRCODE_SBX_OK							ERRCODE_NONE					
#define ERRCODE_SBX_SYNTAX					    (1UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_COMPILER)			
#define ERRCODE_SBX_NOTIMP					    (2UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_NOTSUPPORTED)		
#define ERRCODE_SBX_OVERFLOW					(3UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_SBX)				
#define ERRCODE_SBX_BOUNDS					    (4UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_SBX)				
#define ERRCODE_SBX_ZERODIV					    (5UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_SBX)				
#define ERRCODE_SBX_CONVERSION					(6UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_SBX)				
#define ERRCODE_SBX_BAD_PARAMETER				(7UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define ERRCODE_SBX_PROC_UNDEFINED			    (8UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define ERRCODE_SBX_ERROR					    (9UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_UNKNOWN)			
#define ERRCODE_SBX_NO_OBJECT				    (10UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define ERRCODE_SBX_CANNOT_LOAD				    (11UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_CREATE)			
#define ERRCODE_SBX_BAD_INDEX				    (12UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_SBX)				
#define ERRCODE_SBX_NO_ACTIVE_OBJECT		    (13UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_ACCESS)			
#define ERRCODE_SBX_BAD_PROP_VALUE			    (14UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define ERRCODE_SBX_PROP_READONLY			    (15UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_READ)				
#define ERRCODE_SBX_PROP_WRITEONLY			    (16UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_WRITE)			
#define ERRCODE_SBX_INVALID_OBJECT			    (17UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_ACCESS)			
#define ERRCODE_SBX_NO_METHOD				    (18UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define ERRCODE_SBX_INVALID_USAGE_OBJECT	    (19UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_ACCESS)			
#define ERRCODE_SBX_NO_OLE					    (20UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_ACCESS)			
#define ERRCODE_SBX_BAD_METHOD				    (21UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define ERRCODE_SBX_OLE_ERROR				    (22UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define ERRCODE_SBX_BAD_ACTION				    (23UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_NOTSUPPORTED)		
#define ERRCODE_SBX_NO_NAMED_ARGS			    (24UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define ERRCODE_SBX_BAD_LOCALE				    (25UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_NOTSUPPORTED)		
#define ERRCODE_SBX_NAMED_NOT_FOUND			    (26UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define ERRCODE_SBX_NOT_OPTIONAL			    (27UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define ERRCODE_SBX_WRONG_ARGS				    (28UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_SBX)				
#define ERRCODE_SBX_NOT_A_COLL				    (29UL | ERRCODE_AREA_SBX | \
									ERRCODE_CLASS_RUNTIME)			
#define LAST_SBX_ERROR_ID						29UL

#ifndef __RSC

#define SbxERR_OK								ERRCODE_SBX_OK
#define SbxERR_SYNTAX							ERRCODE_SBX_SYNTAX
#define SbxERR_NOTIMP							ERRCODE_SBX_NOTIMP
#define SbxERR_OVERFLOW							ERRCODE_SBX_OVERFLOW
#define SbxERR_BOUNDS							ERRCODE_SBX_BOUNDS
#define SbxERR_ZERODIV							ERRCODE_SBX_ZERODIV
#define SbxERR_CONVERSION						ERRCODE_SBX_CONVERSION
#define SbxERR_BAD_PARAMETER					ERRCODE_SBX_BAD_PARAMETER
#define SbxERR_PROC_UNDEFINED					ERRCODE_SBX_PROC_UNDEFINED
#define SbxERR_ERROR							ERRCODE_SBX_ERROR
#define SbxERR_NO_OBJECT						ERRCODE_SBX_NO_OBJECT
#define SbxERR_CANNOT_LOAD						ERRCODE_SBX_CANNOT_LOAD
#define SbxERR_BAD_INDEX						ERRCODE_SBX_BAD_INDEX
#define SbxERR_NO_ACTIVE_OBJECT					ERRCODE_SBX_NO_ACTIVE_OBJECT
#define SbxERR_BAD_PROP_VALUE					ERRCODE_SBX_BAD_PROP_VALUE
#define SbxERR_PROP_READONLY					ERRCODE_SBX_PROP_READONLY
#define SbxERR_PROP_WRITEONLY					ERRCODE_SBX_PROP_WRITEONLY
#define SbxERR_INVALID_OBJECT					ERRCODE_SBX_INVALID_OBJECT
#define SbxERR_NO_METHOD						ERRCODE_SBX_NO_METHOD
#define SbxERR_INVALID_USAGE_OBJECT				ERRCODE_SBX_INVALID_USAGE_OBJECT
#define SbxERR_NO_OLE							ERRCODE_SBX_NO_OLE
#define SbxERR_BAD_METHOD						ERRCODE_SBX_BAD_METHOD
#define SbxERR_OLE_ERROR						ERRCODE_SBX_OLE_ERROR
#define SbxERR_BAD_ACTION						ERRCODE_SBX_BAD_ACTION
#define SbxERR_NO_NAMED_ARGS					ERRCODE_SBX_NO_NAMED_ARGS
#define SbxERR_BAD_LOCALE						ERRCODE_SBX_BAD_LOCALE
#define SbxERR_NAMED_NOT_FOUND					ERRCODE_SBX_NAMED_NOT_FOUND
#define SbxERR_NOT_OPTIONAL						ERRCODE_SBX_NOT_OPTIONAL
#define SbxERR_WRONG_ARGS						ERRCODE_SBX_WRONG_ARGS
#define SbxERR_NOT_A_COLL						ERRCODE_SBX_NOT_A_COLL

#define SBX_READ      0x0001    
#define SBX_WRITE     0x0002    
#define SBX_READWRITE 0x0003    
#define	SBX_DONTSTORE 0x0004	
#define	SBX_MODIFIED  0x0008	
#define SBX_FIXED     0x0010    
#define SBX_CONST	  0x0020	
#define	SBX_OPTIONAL  0x0040	
#define SBX_HIDDEN	  0x0080	
#define	SBX_INVISIBLE 0x0100	
#define	SBX_EXTSEARCH 0x0200	
#define	SBX_EXTFOUND  0x0400	
#define	SBX_GBLSEARCH 0x0800	
#define	SBX_RESERVED  0x1000	
#define	SBX_NO_BROADCAST 0x2000	
#define	SBX_REFERENCE 0x4000	
#define	SBX_NO_MODIFY 0x8000	

#define SBX_HINT_DYING			SFX_HINT_DYING
#define	SBX_HINT_DATAWANTED		SFX_HINT_USER00
#define SBX_HINT_DATACHANGED	SFX_HINT_DATACHANGED
#define	SBX_HINT_CONVERTED		SFX_HINT_USER01
#define SBX_HINT_INFOWANTED		SFX_HINT_USER02
#define SBX_HINT_OBJECTCHANGED	SFX_HINT_USER03

#define SBXCR_SBX			0x20584253		

#define	SBXID_VALUE 		0x4E4E	
#define	SBXID_VARIABLE 		0x4156	
#define	SBXID_ARRAY			0x5241	
#define	SBXID_DIMARRAY		0x4944	
#define	SBXID_OBJECT		0x424F	
#define	SBXID_COLLECTION	0x4F43	
#define	SBXID_FIXCOLLECTION	0x4346	
#define	SBXID_METHOD		0x454D	
#define	SBXID_PROPERTY		0x5250	

#define	SbxMAXCHAR			((sal_Unicode)65535)
#define	SbxMINCHAR			(0)
#define	SbxMAXBYTE			( 255)
#define SbxMAXINT			( 32767)
#define SbxMININT			(-32768)
#define	SbxMAXUINT			((UINT16) 65535)
#define SbxMAXLNG			( 2147483647)
#define SbxMINLNG			((INT32)-2147483648)
#define SbxMAXULNG			((UINT32) 4294967295)
#define SbxMAXSNG			( 3.402823e+38)
#define SbxMINSNG			(-3.402823e+38)
#define SbxMAXSNG2			( 1.175494351e-38)
#define SbxMINSNG2			(-1.175494351e-38)
#define SbxMAXCURR			( 922337203685477.5807)
#define SbxMINCURR			(-922337203685477.5808)
#define CURRENCY_FACTOR		10000
#define SbxMAXCURRLNG		(SbxMAXLNG/CURRENCY_FACTOR)
#define SbxMINCURRLNG		(SbxMINLNG/CURRENCY_FACTOR)

#define	SBX_MAXINDEX		0x3FF0

enum SbxBOOL { SbxFALSE = 0, SbxTRUE = -1 };

#endif

#endif
