
#ifndef INCLUDED_SVTOOLS_SECURITYOPTIONS_HXX
#define INCLUDED_SVTOOLS_SECURITYOPTIONS_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

class SvtSecurityOptions_Impl;

enum EBasicSecurityMode
{
	eNEVER_EXECUTE	= 0,
	eFROM_LIST		= 1,
	eALWAYS_EXECUTE = 2
};

class SvtSecurityOptions
{

	public:
	      SvtSecurityOptions();
	    ~SvtSecurityOptions();
	     sal_Bool    IsExecutePlugins() const;
	    void        SetExecutePlugins( sal_Bool bSet );

		::com::sun::star::uno::Sequence< ::rtl::OUString >	GetSecureURLs(																		) const	;
		void												SetSecureURLs( const ::com::sun::star::uno::Sequence< ::rtl::OUString >& seqURLList	)		;

		EBasicSecurityMode	GetBasicMode(							) const	;
		void				SetBasicMode( EBasicSecurityMode eMode	)		;

		sal_Bool IsSecureURL(	const	::rtl::OUString&	sURL		,
					const	::rtl::OUString&	sReferer	) const ;

		static ::osl::Mutex& GetInitMutex();

	private:
	 	static SvtSecurityOptions_Impl*	m_pDataContainer	;	
		static sal_Int32				m_nRefCount			;	

};		

#endif	
