

#ifndef _STDMENU_HXX
#define _STDMENU_HXX

#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif
#ifndef _INTN_HXX
#include <tools/intn.hxx>
#endif
#ifndef _MENU_HXX
#include <vcl/menu.hxx>
#endif

class FontList;
class FontInfo;

class FontNameMenu : public PopupMenu
{
private:
	XubString		maCurName;
	Link			maSelectHdl;
	Link			maHighlightHdl;

public:
		FontNameMenu();
	virtual 		~FontNameMenu();

	virtual void	Select();
	virtual void	Highlight();

	void			Fill( const FontList* pList );

	void			SetCurName( const XubString& rName );
	const XubString& GetCurName() const { return maCurName; }

	void			SetSelectHdl( const Link& rLink ) { maSelectHdl = rLink; }
	const Link& 	GetSelectHdl() const { return maSelectHdl; }
	void			SetHighlightHdl( const Link& rLink ) { maHighlightHdl = rLink; }
	const Link& 	GetHighlightHdl() const { return maHighlightHdl; }
};

#define FONTSTYLEMENU_FIRSTID		62000
#define FONTSTYLEMENU_LASTID		62999

class FontStyleMenu : public PopupMenu
{
private:
	XubString		maCurStyle;
	Link			maSelectHdl;
	Link			maHighlightHdl;

	BOOL			ImplIsAlreadyInserted( const XubString& rStyleName, USHORT nCount );

public:
		FontStyleMenu();
	virtual 		~FontStyleMenu();

	virtual void	Select();
	virtual void	Highlight();

	void			Fill( const XubString& rName, const FontList* pList );
	void			SetCurStyle( const XubString& rStyle );
	const XubString& GetCurStyle() const { return maCurStyle; }

	void			SetSelectHdl( const Link& rLink ) { maSelectHdl = rLink; }
	const Link& 	GetSelectHdl() const { return maSelectHdl; }
	void			SetHighlightHdl( const Link& rLink ) { maHighlightHdl = rLink; }
	const Link& 	GetHighlightHdl() const { return maHighlightHdl; }
};

class FontSizeMenu : public PopupMenu
{
private:
	International	maIntn;
	long*			mpHeightAry;
	long			mnCurHeight;
	Link			maSelectHdl;
	Link			maHighlightHdl;

public:
		FontSizeMenu();
		~FontSizeMenu();

	virtual void	Select();
	virtual void	Highlight();

	void			Fill( const FontInfo& rInfo, const FontList* pList );

	void			SetCurHeight( long nHeight );
	long			GetCurHeight() const { return mnCurHeight; }

	void			SetSelectHdl( const Link& rLink ) { maSelectHdl = rLink; }
	const Link& 	GetSelectHdl() const { return maSelectHdl; }
	void			SetHighlightHdl( const Link& rLink ) { maHighlightHdl = rLink; }
	const Link& 	GetHighlightHdl() const { return maHighlightHdl; }
};

#endif	
