

#ifndef INCLUDED_SVTOOLS_SYSLOCALEOPTIONS_HXX
#define INCLUDED_SVTOOLS_SYSLOCALEOPTIONS_HXX

#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif
#ifndef _LANG_HXX
#include <tools/lang.hxx>
#endif
#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

const ULONG SYSLOCALEOPTIONS_HINT_LOCALE    = 0x00000001;
const ULONG SYSLOCALEOPTIONS_HINT_CURRENCY  = 0x00000002;

class SvtSysLocaleOptions_Impl;
class SvtListener;
namespace osl { class Mutex; }

class SvtSysLocaleOptions
{
	static  SvtSysLocaleOptions_Impl*   pOptions;
	static  sal_Int32                   nRefCount;
	static  Link                        aCurrencyChangeLink;
	 static  ::osl::Mutex&       GetMutex();

public:
	                            SvtSysLocaleOptions();
	                            ~SvtSysLocaleOptions();
	         sal_Bool            IsModified();
	        void                Commit();
	         BOOL                AddListener( SvtListener& );
	        BOOL                RemoveListener( SvtListener& );
	         void                BlockBroadcasts( BOOL bBlock );
	         const ::rtl::OUString&  GetLocaleConfigString() const;
	        void                SetLocaleConfigString( const ::rtl::OUString& rStr );
	         const ::rtl::OUString&  GetCurrencyConfigString() const;
	        void                SetCurrencyConfigString( const ::rtl::OUString& rStr );
	         LanguageType        GetLocaleLanguageType() const;
	 static  void                GetCurrencyAbbrevAndLanguage(
	                                String& rAbbrev,
	                                LanguageType& eLang,
	                                const ::rtl::OUString& rConfigString );
	 static  ::rtl::OUString     CreateCurrencyConfigString(
	                                const String& rAbbrev,
	                                LanguageType eLang );
	         void                GetCurrencyAbbrevAndLanguage(
	                                    String& rAbbrev,
	                                    LanguageType& eLang ) const
	                                {
	                                    GetCurrencyAbbrevAndLanguage( rAbbrev,
	                                        eLang, GetCurrencyConfigString() );
	                                }
	         void                SetCurrencyAbbrevAndLanguage(
	                                    const String& rAbbrev,
	                                    LanguageType eLang )
	                                {
	                                    SetCurrencyConfigString(
	                                        CreateCurrencyConfigString(
	                                        rAbbrev, eLang ) );
	                                }
	 static  void                SetCurrencyChangeLink( const Link& rLink );
	static  const Link&         GetCurrencyChangeLink();

};

#endif  
