
#ifndef SVTOOLS_TESTTOOL_HXX
#define SVTOOLS_TESTTOOL_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _LINK_HXX 
#include <tools/link.hxx>
#endif

class Application;
class SvStream;

class StatementFlow;
class CommunicationManager;
class CommunicationLink;
#ifdef DEBUG
class EditWindow;
#endif
class ImplRC;

class RemoteControl
{
	friend class StatementFlow;

	BOOL         m_bIdleInserted;
#ifdef DEBUG
	EditWindow *m_pDbgWin;
#endif
	ImplRC* pImplRC;

public:
	RemoteControl();
	~RemoteControl();
	BOOL QueCommands( ULONG nServiceId, SvStream *pIn );
	SvStream* GetReturnStream();

	DECL_LINK( IdleHdl,   Application* );
	DECL_LINK( CommandHdl, Application* );

	DECL_LINK( QueCommandsEvent, CommunicationLink* );
	ULONG nStoredServiceId;
	SvStream *pStoredStream;

	void ExecuteURL( String &aURL );

protected:
	CommunicationManager *pServiceMgr;
	SvStream *pRetStream;
};

#endif 
