
#ifndef INCLUDED_SVTOOLS_VIEWOPTIONS_HXX
#define INCLUDED_SVTOOLS_VIEWOPTIONS_HXX

#ifndef _UTL_CONFIGMGR_HXX_
#include <unotools/configmgr.hxx>
#endif

#ifndef _UTL_CONFIGITEM_HXX_
#include <unotools/configitem.hxx>
#endif

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif

class SvtViewDialogOptions_Impl		;
class SvtViewTabDialogOptions_Impl	;
class SvtViewTabPageOptions_Impl	;
class SvtViewWindowOptions_Impl		;

enum EViewType
{
	E_DIALOG	=	0,
	E_TABDIALOG	=	1,
	E_TABPAGE	=	2,
	E_WINDOW	=	3
};

class SvtViewOptions
{

	public:
	      SvtViewOptions( EViewType eType, const ::rtl::OUString& sViewName );
	    ~SvtViewOptions();
	     static void            AcquireOptions();
	    static void            ReleaseOptions();

		sal_Bool Exists() const;

		sal_Bool Delete();

		void GetPosition( sal_Int32& nX, sal_Int32& nY ) const	;
		void SetPosition( sal_Int32  nX, sal_Int32  nY )		;

		void GetSize( sal_Int32& nWidth, sal_Int32& nHeight ) const	;
		void SetSize( sal_Int32  nWidth, sal_Int32  nHeight )		;

		sal_Int32	GetPageID(					) const	;
		void		SetPageID( sal_Int32 nID	)		;

		sal_Bool	IsVisible	(					) const	;
		void		SetVisible	( sal_Bool bState	)		;

		::rtl::OUString	GetUserData(								) const	;
		void			SetUserData( const ::rtl::OUString& sData	)		;

		static ::com::sun::star::uno::Sequence< ::rtl::OUString >	SeperateUserData( const ::rtl::OUString&									sData	, sal_Unicode cSeperator = ';' );
		static ::rtl::OUString										GenerateUserData( const ::com::sun::star::uno::Sequence< ::rtl::OUString >&	seqData	, sal_Unicode cSeperator = ';' );

		static ::osl::Mutex& GetOwnStaticMutex();

	private:

		EViewType			m_eViewType		;
		::rtl::OUString		m_sViewName		;
	 	static SvtViewDialogOptions_Impl*		m_pDataContainer_Dialogs	;	
		static sal_Int32						m_nRefCount_Dialogs			;
		static SvtViewTabDialogOptions_Impl*	m_pDataContainer_TabDialogs	;	
		static sal_Int32						m_nRefCount_TabDialogs		;
		static SvtViewTabPageOptions_Impl*		m_pDataContainer_TabPages	;	
		static sal_Int32						m_nRefCount_TabPages		;
		static SvtViewWindowOptions_Impl*		m_pDataContainer_Windows	;	
		static sal_Int32						m_nRefCount_Windows			;

};		

#endif	
