
#ifndef _ZFORLIST_HXX
#define _ZFORLIST_HXX

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif
#ifndef _TABLE_HXX 
#include <tools/table.hxx>
#endif
#ifndef _LANG_HXX 
#include <tools/lang.hxx>
#endif
#ifndef _TOOLS_INTN_HXX 
#include <tools/intn.hxx>
#endif
#ifndef _SVARRAY_HXX 
#include <svtools/svarray.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif
#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif
#ifndef _COM_SUN_STAR_I18N_NUMBERFORMATCODE_HPP_
#include <com/sun/star/i18n/NumberFormatCode.hpp>
#endif
#ifndef _UNOTOOLS_LOCALEDATAWRAPPER_HXX
#include <unotools/localedatawrapper.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_ONDEMAND_HXX
#include <svtools/ondemand.hxx>
#endif
#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif

class Date;
class SvStream;
class Color;
class SvUShorts;
class CharClass;
class CalendarWrapper;

class ImpSvNumberformatScan;
class ImpSvNumberInputScan;
class SvNumberformat;

namespace com { namespace sun { namespace star {
	namespace lang {
		class XMultiServiceFactory;
	}
}}}

#define SV_COUNTRY_LANGUAGE_OFFSET  5000	
#define SV_MAX_ANZ_STANDARD_FORMATE  100	

#ifndef NUMBERFORMAT_ALL

#define NUMBERFORMAT_ALL			 0x000	
#define NUMBERFORMAT_DEFINED		 0x001	
#define NUMBERFORMAT_DATE			 0x002	
#define NUMBERFORMAT_TIME			 0x004	
#define NUMBERFORMAT_CURRENCY		 0x008	
#define NUMBERFORMAT_NUMBER			 0x010	
#define NUMBERFORMAT_SCIENTIFIC		 0x020	
#define NUMBERFORMAT_FRACTION		 0x040	
#define NUMBERFORMAT_PERCENT		 0x080	
#define NUMBERFORMAT_TEXT			 0x100	
#define NUMBERFORMAT_DATETIME		 0x006	
#define NUMBERFORMAT_LOGICAL		 0x400	
#define NUMBERFORMAT_UNDEFINED		 0x800	
#endif
#define NUMBERFORMAT_ENTRY_NOT_FOUND 0xffffffff	

enum NfIndexTableOffset
{
	NF_NUMERIC_START = 0,

	NF_NUMBER_START = NF_NUMERIC_START,
	NF_NUMBER_STANDARD = NF_NUMBER_START,	
	NF_NUMBER_INT,							
	NF_NUMBER_DEC2,							
	NF_NUMBER_1000INT,						
	NF_NUMBER_1000DEC2,						
	NF_NUMBER_SYSTEM,						
	NF_NUMBER_END = NF_NUMBER_SYSTEM,

	NF_SCIENTIFIC_START,
	NF_SCIENTIFIC_000E000 = NF_SCIENTIFIC_START,	
	NF_SCIENTIFIC_000E00,							
	NF_SCIENTIFIC_END = NF_SCIENTIFIC_000E00,

	NF_PERCENT_START,
	NF_PERCENT_INT = NF_PERCENT_START,		
	NF_PERCENT_DEC2,						
	NF_PERCENT_END = NF_PERCENT_DEC2,

	NF_FRACTION_START,
	NF_FRACTION_1 = NF_FRACTION_START,		
	NF_FRACTION_2,							
	NF_FRACTION_END = NF_FRACTION_2,

	NF_NUMERIC_END = NF_FRACTION_END,

	NF_CURRENCY_START,
	NF_CURRENCY_1000INT = NF_CURRENCY_START,
	NF_CURRENCY_1000DEC2,					
	NF_CURRENCY_1000INT_RED,                
	NF_CURRENCY_1000DEC2_RED,				
	NF_CURRENCY_1000DEC2_CCC,				
	NF_CURRENCY_1000DEC2_DASHED,			
	NF_CURRENCY_END = NF_CURRENCY_1000DEC2_DASHED,

	NF_DATE_START,
	NF_DATE_SYSTEM_SHORT = NF_DATE_START,	
	NF_DATE_SYSTEM_LONG,					
	NF_DATE_SYS_DDMMYY,		   				
	NF_DATE_SYS_DDMMYYYY,	   				
	NF_DATE_SYS_DMMMYY,	   					
	NF_DATE_SYS_DMMMYYYY,	   				
	NF_DATE_DIN_DMMMYYYY,					
	NF_DATE_SYS_DMMMMYYYY,					
	NF_DATE_DIN_DMMMMYYYY,					
	NF_DATE_SYS_NNDMMMYY,		 			
	NF_DATE_DEF_NNDDMMMYY,		 			
	NF_DATE_SYS_NNDMMMMYYYY,	   			
	NF_DATE_SYS_NNNNDMMMMYYYY,	   			
	NF_DATE_DIN_MMDD,		 				
	NF_DATE_DIN_YYMMDD,		 				
	NF_DATE_DIN_YYYYMMDD,	 				
	NF_DATE_SYS_MMYY,		   				
	NF_DATE_SYS_DDMMM,						
	NF_DATE_MMMM,							
	NF_DATE_QQJJ,							
	NF_DATE_WW,								
	NF_DATE_END = NF_DATE_WW,

	NF_TIME_START,
	NF_TIME_HHMM = NF_TIME_START,			
	NF_TIME_HHMMSS,							
	NF_TIME_HHMMAMPM,						
	NF_TIME_HHMMSSAMPM,						
	NF_TIME_HH_MMSS,						
	NF_TIME_MMSS00,							
	NF_TIME_HH_MMSS00,	  					
	NF_TIME_END = NF_TIME_HH_MMSS00,

	NF_DATETIME_START,
	NF_DATETIME_SYSTEM_SHORT_HHMM = NF_DATETIME_START,	
	NF_DATETIME_SYS_DDMMYYYY_HHMMSS,		
	NF_DATETIME_END = NF_DATETIME_SYS_DDMMYYYY_HHMMSS,

	NF_BOOLEAN,								
	NF_TEXT,								
	NF_INDEX_TABLE_ENTRIES
};

enum NfEvalDateFormat
{

	NF_EVALDATEFORMAT_INTL,

	NF_EVALDATEFORMAT_FORMAT,

	NF_EVALDATEFORMAT_INTL_FORMAT,

	NF_EVALDATEFORMAT_FORMAT_INTL
};

#if 0 // _SOLAR__PRIVATE
#define _ZFORLIST_DECLARE_TABLE
#endif
#ifdef _ZFORLIST_DECLARE_TABLE
DECLARE_TABLE (SvNumberFormatTable, SvNumberformat*);
DECLARE_TABLE (SvULONGTable, ULONG*);
#else
typedef Table SvNumberFormatTable;
typedef Table SvULONGTable;
#endif

class NfCurrencyEntry
{
	String   		aSymbol;			
	String			aBankSymbol;		
	LanguageType	eLanguage;			
	USHORT			nPositiveFormat;	
	USHORT			nNegativeFormat;	
	USHORT			nDigits;			
	sal_Unicode		cZeroChar;			
				NfCurrencyEntry( const NfCurrencyEntry& );

	NfCurrencyEntry&	operator=( const NfCurrencyEntry& );

private:

#if 0 // _SOLAR__PRIVATE

	void				Impl_BuildFormatStringNumChars( String&,
				const LocaleDataWrapper&, USHORT nDecimalFormat ) const;
#endif	

public:
				NfCurrencyEntry();
			NfCurrencyEntry( const LocaleDataWrapper& rLocaleData,
				LanguageType eLang );
			NfCurrencyEntry(
				const ::com::sun::star::i18n::Currency & rCurr,
				const LocaleDataWrapper& rLocaleData,
				LanguageType eLang );
	                    ~NfCurrencyEntry() {}

	BOOL				operator==( const NfCurrencyEntry& r ) const;

	void				SetEuro();
	BOOL				IsEuro() const;

	void				ApplyVariableInformation( const NfCurrencyEntry& );

	const String&		GetSymbol() const			{ return aSymbol; }
	const String&		GetBankSymbol() const		{ return aBankSymbol; }
	LanguageType		GetLanguage() const			{ return eLanguage; }
	USHORT				GetPositiveFormat() const	{ return nPositiveFormat; }
	USHORT				GetNegativeFormat() const	{ return nNegativeFormat; }
	USHORT				GetDigits() const			{ return nDigits; }
	sal_Unicode			GetZeroChar() const			{ return cZeroChar; }

	void				BuildSymbolString( String& rStr, BOOL bBank,
				BOOL bWithoutExtension = FALSE ) const;

	void				BuildPositiveFormatString( String& rStr, BOOL bBank,
				const LocaleDataWrapper&, USHORT nDecimalFormat = 1 ) const;
	void				BuildNegativeFormatString( String& rStr, BOOL bBank,
				const LocaleDataWrapper&, USHORT nDecimalFormat = 1 ) const;

	void				CompletePositiveFormatString( String& rStr, BOOL bBank,
				USHORT nPosiFormat ) const;
	void				CompleteNegativeFormatString( String& rStr, BOOL bBank,
				USHORT nNegaFormat ) const;

	static	void		CompletePositiveFormatString( String& rStr,
				const String& rSymStr, USHORT nPosiFormat );
	static	void		CompleteNegativeFormatString( String& rStr,
				const String& rSymStr, USHORT nNegaFormat );

	static	USHORT		GetEffectivePositiveFormat( USHORT nIntlFormat,
				USHORT nCurrFormat, BOOL bBank );
	static	USHORT		GetEffectiveNegativeFormat( USHORT nIntlFormat,
				USHORT nCurrFormat, BOOL bBank );

	static inline sal_Unicode	GetEuroSymbol() { return sal_Unicode(0x20AC); }

	static	sal_Char	GetEuroSymbol( rtl_TextEncoding eTextEncoding );
};

typedef NfCurrencyEntry* NfCurrencyEntryPtr;
SV_DECL_PTRARR_DEL( NfCurrencyTable, NfCurrencyEntryPtr, LANGUAGE_COUNT, 1 );
typedef String* WSStringPtr;
SV_DECL_PTRARR_DEL( NfWSStringsDtor, WSStringPtr, 8, 1 );

class SvNumberFormatterRegistry_Impl;

class SvNumberFormatter
{
public:

	SvNumberFormatter(
		const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& xSMgr,
		LanguageType eLang
		);

	SvNumberFormatter( LanguageType eLang );

	~SvNumberFormatter();
	 void SetColorLink( const Link& rColorTableCallBack )    { aColorLink = rColorTableCallBack; }

	Color* GetUserDefColor(USHORT nIndex);

	void ChangeIntl( LanguageType eLnge );

	void ChangeNullDate(USHORT nDay, USHORT nMonth, USHORT nYear);

	void ChangeStandardPrec(short nPrec);

	void SetNoZero(BOOL bNZ) { bNoZero = bNZ; }
	 LanguageType GetLanguage() const { return IniLnge; }

	BOOL IsCompatible(short eOldType, short eNewType);

	SvNumberFormatTable& GetEntryTable(short eType,
						   ULONG& FIndex,
						   LanguageType eLnge);

	SvNumberFormatTable& ChangeCL(short eType,
					  ULONG& FIndex,
					  LanguageType eLnge);

	SvNumberFormatTable& GetFirstEntryTable(short& eType,
								ULONG& FIndex,
								LanguageType& rLnge);

	void DeleteEntry(ULONG nKey);

	BOOL PutEntry( String& rString, xub_StrLen& nCheckPos, short& nType, ULONG& nKey,
	  LanguageType eLnge = LANGUAGE_DONTKNOW );

	BOOL PutandConvertEntry( String& rString, xub_StrLen& nCheckPos,
				 short& nType, ULONG& nKey,
				 LanguageType eLnge, LanguageType eNewLnge );

	BOOL PutandConvertEntrySystem( String& rString, xub_StrLen& nCheckPos,
				 short& nType, ULONG& nKey,
				 LanguageType eLnge, LanguageType eNewLnge );

	void GenerateFormat( String& sString, ULONG nIndex,
			LanguageType eLnge = LANGUAGE_DONTKNOW,
			BOOL bThousand = FALSE, BOOL IsRed = FALSE,
			USHORT nPrecision = 0, USHORT nAnzLeading = 1 );

	BOOL IsNumberFormat( const String& sString, ULONG& F_Index, double& fOutNumber );

	void GetOutputString( const double& fOutNumber, ULONG nFIndex,
			  String& sOutString, Color** ppColor );

	void GetOutputString( String& sString, ULONG nFIndex,
			  String& sOutString, Color** ppColor );

	void GetInputLineString( const double& fOutNumber,
				ULONG nFIndex, String& sOutString );

	BOOL GetPreviewString( const String& sFormatString, double fPreviewNumber,
			  String& sOutString, Color** ppColor,
			  LanguageType eLnge = LANGUAGE_DONTKNOW );

	BOOL GetPreviewStringGuess( const String& sFormatString, double fPreviewNumber,
			  String& sOutString, Color** ppColor,
			  LanguageType eLnge = LANGUAGE_DONTKNOW );

	ULONG TestNewString( const String& sFormatString,
			LanguageType eLnge = LANGUAGE_DONTKNOW );

	BOOL IsTextFormat(ULONG nFIndex) const;

	BOOL HasTextFormat(ULONG nFIndex) const;

	BOOL Load( SvStream& rStream );

	BOOL Save( SvStream& rStream ) const;

	void PrepareSave();

	void SetFormatUsed(ULONG nFIndex);

	void GetFormatSpecialInfo(ULONG nFormat, BOOL& bThousand, BOOL& IsRed,
				  USHORT& nPrecision, USHORT& nAnzLeading);

	USHORT GetFormatPrecision( ULONG nFormat ) const;

	ULONG GetFormatSpecialInfo( const String&, BOOL& bThousand, BOOL& IsRed,
				  USHORT& nPrecision, USHORT& nAnzLeading,
				  LanguageType eLnge = LANGUAGE_DONTKNOW );

	BOOL IsUserDefined( const String& sStr, LanguageType eLnge = LANGUAGE_DONTKNOW );

	ULONG GetEntryKey( const String& sStr, LanguageType eLnge = LANGUAGE_DONTKNOW );

	const SvNumberformat* GetEntry(ULONG nKey) const
		{ return (SvNumberformat*) aFTable.Get(nKey); }

	ULONG GetStandardIndex(LanguageType eLnge = LANGUAGE_DONTKNOW);

	ULONG GetStandardFormat(short eType, LanguageType eLnge = LANGUAGE_DONTKNOW);

	ULONG GetStandardFormat( ULONG nFIndex, short eType, LanguageType eLnge );

	ULONG GetStandardFormat( double fNumber, ULONG nFIndex, short eType,
				LanguageType eLnge );

	BOOL IsSpecialStandardFormat( ULONG nFIndex, LanguageType eLnge );

	Date* GetNullDate();

	short GetStandardPrec();

	BOOL GetNoZero() { return bNoZero; }

	short GetType(ULONG nFIndex);

	void ClearMergeTable();

	SvULONGTable* MergeFormatter(SvNumberFormatter& rNewTable);

	inline BOOL HasMergeFmtTbl() const;

	inline ULONG GetMergeFmtIndex( ULONG nOldFmt ) const;

	USHORT GetLastInsertKey(ULONG CLOffset);

	ULONG GetFormatForLanguageIfBuiltIn( ULONG nFormat,
						LanguageType eLnge = LANGUAGE_DONTKNOW );

	ULONG GetFormatIndex( NfIndexTableOffset, LanguageType eLnge = LANGUAGE_DONTKNOW );

	NfIndexTableOffset GetIndexTableOffset( ULONG nFormat ) const;

	void SetEvalDateFormat( NfEvalDateFormat eEDF ) { eEvalDateFormat = eEDF; }
	NfEvalDateFormat GetEvalDateFormat() const { return eEvalDateFormat; }

	void	SetYear2000( USHORT nVal );
	USHORT	GetYear2000() const;
	static	USHORT	GetYear2000Default();

	USHORT	ExpandTwoDigitYear( USHORT nYear ) const;
	inline	static	USHORT	ExpandTwoDigitYear( USHORT nYear, USHORT nTwoDigitYearStart );
	 sal_Unicode GetDecSep() const { return GetNumDecimalSep().GetChar(0); }
	 String GetDecimalSep() const { return GetNumDecimalSep(); }

	String GetFormatDecimalSep( ULONG nFormat ) const;
	 static const NfCurrencyTable& GetTheCurrencyTable();
	 static const NfCurrencyEntry*  MatchSystemCurrency();
	 static const NfCurrencyEntry&  GetCurrencyEntry( LanguageType );
	 static const NfCurrencyEntry*  GetCurrencyEntry( const String& rAbbrev,
	            LanguageType eLang );
	 static void SetDefaultSystemCurrency( const String& rAbbrev, LanguageType eLang );

	USHORT	GetCurrencyFormatStrings( NfWSStringsDtor&, const NfCurrencyEntry&,
	BOOL bBank ) const;

	BOOL	GetNewCurrencySymbolString( ULONG nFormat, String& rSymbol,
	const NfCurrencyEntry** ppEntry = NULL, BOOL* pBank = NULL ) const;
	 static const NfCurrencyEntry* GetCurrencyEntry( BOOL & bFoundBank,
	const String& rSymbol, const String& rExtension,
	            LanguageType eFormatLanguage, BOOL bOnlyStringLanguage = FALSE );
	 void GetCompatibilityCurrency( String& rSymbol, String& rAbbrev ) const;

	void	GetUsedLanguages( SvUShorts& rList );

	String GetKeyword( LanguageType eLnge, USHORT nIndex );
	 String GetStandardName( LanguageType eLnge );

	static void SkipNumberFormatterInStream( SvStream& );

	static LanguageType GetProperLanguage( LanguageType eLang );

	static ::com::sun::star::lang::Locale ConvertLanguageToLocale( LanguageType eLang );

private:
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xServiceManager;
	::com::sun::star::lang::Locale aLocale;
	SvNumberFormatTable aFTable;			
	Table aDefaultFormatKeys;				
	SvNumberFormatTable* pFormatTable;		
	SvULONGTable* pMergeTable;				
	CharClass* pCharClass;					
	OnDemandLocaleDataWrapper xLocaleData;  
	OnDemandTransliterationWrapper xTransliteration;    
	OnDemandCalendarWrapper xCalendar;      
	ImpSvNumberInputScan* pStringScanner;	
	ImpSvNumberformatScan* pFormatScanner;	
	Link aColorLink;                        
	ULONG MaxCLOffset;						
	ULONG nDefaultSystemCurrencyFormat;		
	LanguageType IniLnge;                   
	LanguageType ActLnge;                   
	NfEvalDateFormat eEvalDateFormat;		
	BOOL bNoZero;							
	 String aDecimalSep;
	String aThousandSep;
	String aDateSep;

#ifdef _ZFORLIST_CXX				

	static BOOL 			bCurrencyTableInitialized;
	static NfCurrencyTable	theCurrencyTable;
	static USHORT			nSystemCurrencyPosition;
	static SvNumberFormatterRegistry_Impl* pFormatterRegistry;
	 static SvNumberFormatterRegistry_Impl& GetFormatterRegistry();

	void ImpConstruct( LanguageType eLang );

	void ImpChangeSysCL( LanguageType eLnge, BOOL bLoadingSO5 );

	void ImpGenerateFormats( ULONG CLOffset, BOOL bLoadingSO5 );

	void ImpGenerateAdditionalFormats(
	ULONG CLOffset,
	NumberFormatCodeWrapper& rNumberFormatCode,
	BOOL bAfterLoadingSO5 );

	SvNumberformat* ImpInsertFormat(
	const ::com::sun::star::i18n::NumberFormatCode& rCode,
	ULONG nPos,
	BOOL bAfterLoadingSO5 = FALSE,
	sal_Int16 nOrgIndex = 0 );

	SvNumberformat* ImpInsertNewStandardFormat(
	const ::com::sun::star::i18n::NumberFormatCode& rCode,
	ULONG nPos,
	USHORT nVersion,
	BOOL bAfterLoadingSO5 = FALSE,
	sal_Int16 nOrgIndex = 0 );

	ULONG ImpGetCLOffset(LanguageType eLnge) const;

	ULONG ImpIsEntry( const String& rString,
			ULONG CLOffset,
			LanguageType eLnge );

	ULONG ImpGenerateCL( LanguageType eLnge, BOOL bLoadingSO5 = FALSE );
	 void ImpGetNegCurrFormat( String& sNegStr, const String& rCurrSymbol );
	 void ImpGetPosCurrFormat( String& sPosStr, const String& rCurrSymbol );
	 static void ImpInitCurrencyTable();

	ULONG	ImpGetDefaultSystemCurrencyFormat();

	ULONG	ImpGetDefaultCurrencyFormat();

	ULONG	ImpGetDefaultFormat( short nType );

	sal_Int32 ImpGetFormatCodeIndex(
		::com::sun::star::uno::Sequence< ::com::sun::star::i18n::NumberFormatCode >& rSeq,
		const NfIndexTableOffset nTabOff );

#ifdef PRODUCT
	inline
#endif
	    static BOOL SvNumberFormatter::ImpLookupCurrencyEntryLoopBody(
			const NfCurrencyEntry*& pFoundEntry, BOOL& bFoundBank,
	        const NfCurrencyEntry* pData, USHORT nPos, const String& rSymbol );
	 DECL_STATIC_LINK( SvNumberFormatter, CurrencyChangeLink, void* );

#endif 

public:
	 static ::osl::Mutex&        GetMutex();
	 void ResetDefaultSystemCurrency();
	 void ReplaceSystemCL( LanguageType eOldLanguage );

	inline ::com::sun::star::uno::Reference<
		::com::sun::star::lang::XMultiServiceFactory >
		GetServiceManager() const { return xServiceManager; }

	inline const ImpSvNumberformatScan* GetFormatScanner() const { return pFormatScanner; }

	inline const ::com::sun::star::lang::Locale& GetLocale() const { return aLocale; }
	 inline const ::utl::TransliterationWrapper* GetTransliteration() const { return xTransliteration.get(); }

	inline const CharClass* GetCharClass() const { return pCharClass; }
	 inline const LocaleDataWrapper* GetLocaleData() const { return xLocaleData.get(); }
	 inline CalendarWrapper* GetCalendar() const { return xCalendar.get(); }
	 inline const String& GetNumDecimalSep() const { return aDecimalSep; }
	 inline const String& GetNumThousandSep() const { return aThousandSep; }
	 inline const String& GetDateSep() const { return aDateSep; }

};

inline ULONG SvNumberFormatter::GetMergeFmtIndex( ULONG nOldFmt ) const
{
	ULONG* pU = (pMergeTable && pMergeTable->Count()) ? (ULONG*)pMergeTable->Get( nOldFmt ) : 0;
	return pU ? *pU : nOldFmt;
}

inline BOOL SvNumberFormatter::HasMergeFmtTbl() const
{
	return pMergeTable && (0 != pMergeTable->Count());
}

inline USHORT SvNumberFormatter::ExpandTwoDigitYear(
			USHORT nYear, USHORT nTwoDigitYearStart )
{
	if ( nYear < 100 )
	{
		if ( nYear < (nTwoDigitYearStart % 100) )
			return nYear + (((nTwoDigitYearStart / 100) + 1) * 100);
		else
			return nYear + ((nTwoDigitYearStart / 100) * 100);
	}
	return nYear;
}

#endif	
