
#ifndef _SVX_ASIANCFG_HXX
#define _SVX_ASIANCFG_HXX

#ifndef _UTL_CONFIGITEM_HXX_
#include <unotools/configitem.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif

namespace com{namespace sun{namespace star{
namespace lang{
	struct Locale;
}}}}

struct SvxAsianConfig_Impl;
class SvxAsianConfig : public utl::ConfigItem
{
	SvxAsianConfig_Impl* pImpl;

public:
	SvxAsianConfig(sal_Bool bEnableNotify = sal_True);
	virtual ~SvxAsianConfig();

	void 			Load();
	virtual void	Commit();
	virtual void 	Notify( const com::sun::star::uno::Sequence<rtl::OUString>& aPropertyNames);

	sal_Bool 	IsKerningWesternTextOnly() const;
	void 		SetKerningWesternTextOnly(sal_Bool bSet);

	sal_Int16	GetCharDistanceCompression() const;
	void 		SetCharDistanceCompression(sal_Int16 nSet);

	com::sun::star::uno::Sequence<com::sun::star::lang::Locale>
	GetStartEndCharLocales();

	sal_Bool	GetStartEndChars( const com::sun::star::lang::Locale& rLocale,
						rtl::OUString& rStartChars,
						rtl::OUString& rEndChars );
	void		SetStartEndChars( const com::sun::star::lang::Locale& rLocale,
						const rtl::OUString* pStartChars,
						const rtl::OUString* pEndChars );
};

#endif

