
#ifndef _BMPMASK_HXX_
#define _BMPMASK_HXX_

#ifndef _SFXCTRLITEM_HXX
#include <sfx2/ctrlitem.hxx>
#endif
#ifndef _SFXDOCKWIN_HXX
#include <sfx2/dockwin.hxx>
#endif
#ifndef _SV_TOOLBOX_HXX
#ifdef VCL
#include <vcl/toolbox.hxx>
#else
#include <vcl/toolbox.hxx>
#endif
#endif
#ifndef _SV_FIXED_HXX
#ifdef VCL
#include <vcl/fixed.hxx>
#else
#include <vcl/fixed.hxx>
#endif
#endif
#ifndef _SV_GROUP_HXX
#ifdef VCL
#include <vcl/group.hxx>
#else
#include <vcl/group.hxx>
#endif
#endif
#ifndef _SV_GRAPH_HXX
#ifdef VCL
#include <vcl/graph.hxx>
#else
#include <vcl/graph.hxx>
#endif
#endif

#include <svx/dlgctrl.hxx>

class SvxBmpMask;

class SvxBmpMaskSelectItem : public SfxControllerItem
{
private:
	SvxBmpMask  &rBmpMask;

protected:
	virtual void StateChanged( USHORT nSID, SfxItemState eState,
				   const SfxPoolItem* pState );

public:
	SvxBmpMaskSelectItem( USHORT nId, SvxBmpMask& rMask,
			  SfxBindings& rBindings );
};

class SvxBmpMaskChildWindow : public SfxChildWindow
{
 public:
				SvxBmpMaskChildWindow( Window*,
									   USHORT, SfxBindings*,
									   SfxChildWinInfo* );

	SFX_DECL_CHILDWINDOW(SvxBmpMaskChildWindow);
};

class MaskData;
class MaskSet;
class ColorWindow;

class SvxBmpMask : public SfxDockingWindow
{
	friend class MaskData;
	friend class MaskSet;

	Window* 			pParentWin;
	Size				aLastSize;
	ToolBox				aTbxPipette;
	ColorWindow*		pCtlPipette;
	PushButton			aBtnExec;
	FixedLine           aGrpQ;
	MaskSet*			pQSet;
	CheckBox			aCbx1;
	MetricField			aSp1;
	CheckBox			aCbx2;
	MetricField			aSp2;
	CheckBox			aCbx3;
	MetricField			aSp3;
	CheckBox			aCbx4;
	MetricField			aSp4;
	CheckBox			aCbxTrans;
	ColorLB				aLbColor1;
	ColorLB				aLbColor2;
	ColorLB				aLbColor3;
	ColorLB				aLbColor4;
	ColorLB				aLbColorTrans;
	FixedText			aFt1;
	FixedText			aFt2;
	FixedText			aFt3;
	const XColorTable* 	pColTab;
	MaskData*			pData;
	Color				aPipetteColor;
	SvxBmpMaskSelectItem aSelItem;

	virtual BOOL 		Close();

#ifdef BMPMASK_PRIVATE

	USHORT				InitColorArrays( Color* pSrcCols, Color* pDstCols,
							 ULONG* pTols );

	Bitmap 				ImpMask( const Bitmap& rBitmap );
	BitmapEx			ImpMask( const BitmapEx& rBitmapEx );
	GDIMetaFile 		ImpMask( const GDIMetaFile& rMtf );
	Animation 			ImpMask( const Animation& rAnimation );
	BitmapEx			ImpMaskTransparent( const BitmapEx& rBitmapEx,
								const Color& rColor,
								const long nTol );
	BitmapEx			ImpReplaceTransparency( const BitmapEx& rBmpEx,
									const Color& rColor );
	Animation			ImpReplaceTransparency( const Animation& rAnim,
									const Color& rColor );
	GDIMetaFile			ImpReplaceTransparency( const GDIMetaFile& rMtf,
									const Color& rColor );

#endif 

public:
				SvxBmpMask( SfxBindings *pBindinx,
						SfxChildWindow *pCW,
						Window* pParent,
						const ResId& rResId );
			~SvxBmpMask();

	void				SetColor( const Color& rColor );
	void				PipetteClicked();

	BOOL				NeedsColorTable() const;
	void 				SetColorTable( const XColorTable* pColorTable );

	void				SetExecState( BOOL bEnable );

	Graphic 			Mask( const Graphic& rGraphic );

	BOOL				IsEyedropping() const;
};

#define SVXBMPMASK() ( (SvxBmpMask*) ( SfxViewFrame::Current()->GetChildWindow( 	\
		 SvxBmpMaskChildWindow::GetChildWindowId() )-> 	\
		 GetWindow() ) )

#endif 

