
#ifndef _SVX_BORDER_HXX
#define _SVX_BORDER_HXX

#ifndef _CTRLBOX_HXX 
#include <svtools/ctrlbox.hxx>
#endif
#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif
#ifndef _FIELD_HXX 
#include <vcl/field.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _VALUESET_HXX 
#include <svtools/valueset.hxx>
#endif
#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif

class SvxFrameSelector;
class SvxBorderLine;
class XColorTable;
class SvxFrameLine;

#define SW_BORDER_MODE_PARA 	0x01
#define SW_BORDER_MODE_TABLE    0x02
#define SW_BORDER_MODE_FRAME    0x04

class SvxBorderTabPage : public SfxTabPage
{
public:
	static SfxTabPage*	Create( Window* pParent,
					const SfxItemSet& rAttrSet);
	static USHORT*		GetRanges();

	virtual	BOOL		FillItemSet( SfxItemSet& rCoreAttrs );
	virtual	void		Reset( const SfxItemSet& );

	void				HideShadowControls();
	void				SetSWMode(BYTE nSet);

protected:
	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );

private:
	SvxBorderTabPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SvxBorderTabPage();

	FixedLine			aFlBorder;
	ValueSet            aWndPresets;
	Window				aWndFrameSel;
	SvxFrameSelector*	pFrameSel;
	 FixedLine           aFlSep1;
	FixedLine			aFlLine;
	LineListBox			aLbLineStyle;
	ColorListBox		aLbLineColor;
	 FixedLine           aFlSep2;
	FixedLine			aDistanceFL;
	FixedText 			aLeftFT;
	MetricField			aLeftMF;
	FixedText 			aRightFT;
	MetricField			aRightMF;
	FixedText 			aTopFT;
	MetricField			aTopMF;
	FixedText 			aBottomFT;
	MetricField			aBottomMF;
	CheckBox			aSynchronizeCB;

	FixedLine			aFlShadow;
	FixedText			aFtShadowPos;
	ValueSet			aWndShadows;
	FixedText			aFtShadowSize;
	MetricField			aEdShadowSize;
	FixedText			aFtShadowColor;
	ColorListBox		aLbShadowColor;

	long				nMinValue;	
	BYTE				nSWMode;	
	BOOL				bIsTableBorder;

	static BOOL 		bSync;

#ifdef _SVX_BORDER_CXX

	DECL_LINK( SelStyleHdl_Impl, ListBox* pLb );
	DECL_LINK( SelColHdl_Impl, ListBox* pLb );
	DECL_LINK( SelPreHdl_Impl, void* );
	DECL_LINK( SelSdwHdl_Impl, void* );
	DECL_LINK( LinesChanged_Impl, void* );
	DECL_LINK( ModifyDistanceHdl_Impl, MetricField*);
	DECL_LINK( SyncHdl_Impl, CheckBox*);

	void				FillLineListBox_Impl();
	void 				FillValueSets_Impl();

	void				ResetFrameLine_Impl( const SvxBorderLine* pCurLine,
								 SvxFrameLine& rFrameLine );
	void				SetCoreLine_Impl( const SvxFrameLine* pFrameLine,
							  SvxBorderLine*& rpCoreLine );
#endif
};

#endif

