
#ifndef _SVX_BOXOBJ_HXX
#define _SVX_BOXOBJ_HXX

#ifndef _SFX_SHOBJ_HXX 
#include <sfx2/shobj.hxx>
#endif
class SvxBoxItem;
class SvxBoxInfoItem;
class SvxBorderLine;

class SvxBoxObject: public SfxShellSubObject

{
friend class SvxBoxLineObject_Impl;

	SvxBoxItem* 			pBox;
	SvxBoxInfoItem* 		pBoxInfo;

#ifdef _SVX_BOXOBJ_CXX
private:
	const SvxBorderLine*	GetLine_Impl( USHORT nSID ) const;
	BOOL					SetLine_Impl( USHORT nSID, const SvxBorderLine *pLine );
	void					Update_Impl() const;
#endif

protected:

	void					SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
						const SfxHint& rHint, const TypeId& rHintType );
	virtual ULONG			SetProperty( USHORT nSID, SbxVariable &rRet );
	virtual ULONG			GetProperty( USHORT nSID, SbxVariable &rRet );

	virtual SbxError    	GetLineColor( USHORT nSID, Color &rColor ) const;
	virtual SbxError        GetLineStyle( USHORT nSID,
							  USHORT &rOutWidth, USHORT &rDist, USHORT &rInWidth ) const;
	virtual SbxError		GetDistance( USHORT &rDist ) const;

	virtual SbxError		SetLineColor( USHORT nSID, const Color &rColor );
	virtual SbxError		SetLineStyle( USHORT nSID,
							  USHORT nOutWidth, USHORT nDist, USHORT nInWidth );
	virtual SbxError        SetDistance( USHORT nDist );

public:
				TYPEINFO();
				SvxBoxObject( SfxShell *pShell = 0 );
					~SvxBoxObject();

	const SvxBoxItem&		GetBoxItem() const { return *pBox; }
	const SvxBoxInfoItem&	GetBoxInfoItem() const { return *pBoxInfo; }

	virtual String 			GenerateSource( const String &rLinePrefix,
								const SbxObject *pRelativeTo );
};

#endif

