
#ifndef _SVX_CHECKLBX_HXX
#define _SVX_CHECKLBX_HXX

#ifndef _SVTREEBOX_HXX 
#include <svtools/svtreebx.hxx>
#endif

#ifndef _SVLBOXITM_HXX 
#include <svtools/svlbitm.hxx>
#endif

#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif

class SvxCheckListBox : public SvTreeListBox
{
private:
	SvLBoxButtonData* 	pCheckButton;

#ifdef _SVX_CHECKLBX_CXX
	void				Init_Impl();
#endif

public:
	SvxCheckListBox( Window* pParent, WinBits nWinStyle = 0 );
	SvxCheckListBox( Window* pParent, const ResId& rResId );
	~SvxCheckListBox();

	void			InsertEntry			( const String& rStr,
							  USHORT nPos = LISTBOX_APPEND );
	void			RemoveEntry			( USHORT nPos );

	void			SelectEntryPos		( USHORT nPos, BOOL bSelect = TRUE );
	USHORT			GetSelectEntryPos	() const;

	String			GetText				( USHORT nPos ) const;
	USHORT			GetCheckedEntryCount() const;
	void			CheckEntryPos		( USHORT nPos, BOOL bCheck = TRUE );
	BOOL			IsChecked			( USHORT nPos ) const;
	void			ToggleCheckButton	( SvLBoxEntry* pEntry );

	void*			SetEntryData		( USHORT nPos, void* pNewData );
	void*			GetEntryData		( USHORT nPos ) const;

	virtual void 	MouseButtonDown		( const MouseEvent& rMEvt );
	virtual void	KeyInput			( const KeyEvent& rKEvt );
};

class SvxCheckListBoxBitmaps : public Resource
{
private:
	const Bitmap	aUncheckedBmp;
	const Bitmap	aCheckedBmp;
	const Bitmap	aHiCheckedBmp;
	const Bitmap	aHiUncheckedBmp;
	const Bitmap	aTriStateBmp;
	const Bitmap	aHiTriStateBmp;

public:
	SvxCheckListBoxBitmaps();

	const Bitmap&	GetUncheckedBmp	  () const { return aUncheckedBmp; }
	const Bitmap&	GetCheckedBmp	  () const { return aCheckedBmp; }
	const Bitmap&	GetHiCheckedBmp	  () const { return aHiCheckedBmp; }
	const Bitmap&	GetHiUncheckedBmp () const { return aHiUncheckedBmp; }
	const Bitmap&	GetTriStateBmp	  () const { return aTriStateBmp; }
	const Bitmap&	GetHiTriStateBmp  () const { return aHiTriStateBmp; }
};

#endif

