
#ifndef _SVX_CMAPITEM_HXX
#define _SVX_CMAPITEM_HXX

#ifndef _SFXENUMITEM_HXX 
#include <svtools/eitem.hxx>
#endif
#ifndef _SVX_SVXENUM_HXX
#include <svx/svxenum.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

class SvXMLUnitConverter;
#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

class SvxCaseMapItem : public SfxEnumItem
{
public:
	TYPEINFO();

	SvxCaseMapItem( const SvxCaseMap eMap = SVX_CASEMAP_NOT_MAPPED,
		const USHORT nId = ITEMID_CASEMAP );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*    Create(SvStream &, USHORT) const;
	virtual SvStream&		Store(SvStream &, USHORT nItemVersion) const;
	virtual String			GetValueTextByPos( USHORT nPos ) const;
	virtual USHORT          GetValueCount() const;

	void			 		SetValue( USHORT nNewVal )
					{SfxEnumItem::SetValue(nNewVal); }

	inline SvxCaseMapItem& operator=(const SvxCaseMapItem& rMap)
		{
			SetValue( rMap.GetValue() );
			return *this;
		}

	SvxCaseMap 				GetCaseMap() const
					{ return (SvxCaseMap)GetValue(); }
	void 					SetCaseMap( SvxCaseMap eNew )
					{ SetValue( (USHORT)eNew ); }
	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );
};

#endif

