
#ifndef _SVX_COLRITEM_HXX
#define _SVX_COLRITEM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif
#ifndef _SV_COLOR_HXX 
#include <vcl/color.hxx>
#endif

class SvXMLUnitConverter;
#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

#define VERSION_USEAUTOCOLOR	1

class SvxColorItem : public SfxPoolItem
{
private:
	Color					mColor;

public:
	TYPEINFO();

	SvxColorItem( const USHORT nId = ITEMID_COLOR );
	SvxColorItem( const Color& aColor, const USHORT nId = ITEMID_COLOR );
	SvxColorItem( SvStream& rStrm, const USHORT nId = ITEMID_COLOR );
	SvxColorItem( const SvxColorItem& rCopy );
	~SvxColorItem();

	virtual int 			 operator==( const SfxPoolItem& ) const;
	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );
	virtual USHORT			GetVersion( USHORT nFileVersion ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*	 Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	 Create(SvStream &, USHORT) const;
	virtual SvStream&		 Store(SvStream &, USHORT nItemVersion) const;

	inline SvxColorItem& operator=(const SvxColorItem& rColor)
	{
		SetValue( rColor.GetValue() );
		return *this;
	}

	const	Color&			GetValue() const
				{
					return mColor;
				}
			void			SetValue( const Color& rNewCol );

};

#endif

