
#ifndef _SVX_DLGUTIL_HXX
#define _SVX_DLGUTIL_HXX

#ifndef _FIELD_HXX
#include <vcl/field.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif
#ifndef _SFXINTITEM_HXX 
#include <svtools/intitem.hxx>
#endif

#if SUPD<609
#define GET_MODULE_FIELDUNIT( eFieldUnit )									\
{																			\
	SfxApplication* pSfxApp = SFX_APP();									\
	eFieldUnit = pSfxApp->GetOptions().GetMetric();							\
	SfxModule* pModule = pSfxApp->GetActiveModule();						\
																\
	if ( pModule )															\
	{																		\
		const SfxPoolItem* pItem = pModule->GetItem( SID_ATTR_METRIC );		\
																\
		if ( pItem )														\
			eFieldUnit = (FieldUnit)( (SfxUInt16Item*)pItem )->GetValue();	\
	}																		\
}
#endif

typedef long (*FUNC_CONVERT)(long);

String 	GetLanguageString( LanguageType eType );
String 	GetDicInfoStr( const String& rName, const USHORT nLang,
		   const BOOL bNeg );

void SetFieldUnit( MetricField& rCtrl,
	   FieldUnit eUnit, BOOL bAll = FALSE );
void SetFieldUnit( MetricBox& rCtrl,
	   FieldUnit eUnit, BOOL bAll = FALSE );

FieldUnit GetModuleFieldUnit( const SfxItemSet* pSet = NULL );

long 		CalcToUnit( float nIn, SfxMapUnit eUnit );
long 		CalcToPoint( long nIn, SfxMapUnit eUnit, USHORT nFaktor );

long		ItemToControl( long nIn, SfxMapUnit eItem, SfxFieldUnit eCtrl );
long		ControlToItem( long nIn, SfxFieldUnit eCtrl, SfxMapUnit eItem );

FieldUnit	MapToFieldUnit( const SfxMapUnit eUnit );
MapUnit		FieldToMapUnit( const SfxFieldUnit eUnit );

long		ConvertValueToMap( long nVal, SfxMapUnit eUnit );
long		ConvertValueToUnit( long nVal, SfxMapUnit eUnit );

void 		SetMetricValue( MetricField& rField,
				long lCoreValue, SfxMapUnit eUnit );
long 		GetCoreValue( const MetricField& rField, SfxMapUnit eUnit );

long 	CMToTwips( long nIn );
long 	MMToTwips( long nIn );
long 	InchToTwips( long nIn );
long 	PointToTwips( long nIn );
long 	PicaToTwips( long nIn );

long 	TwipsToCM( long nIn );
long 	InchToCM( long nIn );
long 	MMToCM( long nIn );
long 	PointToCM( long nIn );
long	PicaToCM( long nIn );

long 	TwipsToMM( long nIn );
long 	CMToMM( long nIn );
long 	InchToMM( long nIn );
long 	PointToMM( long nIn );
long 	PicaToMM( long nIn );

long 	TwipsToInch(long nIn );
long 	CMToInch(long nIn );
long 	MMToInch(long nIn );
long 	PointToInch(long nIn );
long	PicaToInch(long nIn );

long 	TwipsToPoint(long nIn );
long 	InchToPoint(long nIn );
long 	CMToPoint(long nIn );
long 	MMToPoint(long nIn );
long 	PicaToPoint(long nIn );

long 	TwipsToPica(long nIn );
long 	InchToPica(long nIn );
long 	PointToPica(long nIn );
long 	CMToPica(long nIn );
long	MMToPica(long nIn );

long 	TransformMetric( long nVal, FieldUnit aOld, FieldUnit aNew );

String		ConvertPosSizeToIniString( const Point& rPos, const Size& rSize );
sal_Bool	ConvertIniStringToPosSize(	const String& rIniStr, Point& rPos, Size& rSize );

#endif

