

#ifndef _E3D_DLIGHT3D_HXX
#define _E3D_DLIGHT3D_HXX

#ifndef _E3D_LIGHT3D_HXX
#include <svx/light3d.hxx>
#endif

class E3dDistantLight : public E3dLight
{
 protected:
	Vector3D aDirection;

	virtual void CreateLightObj();

 public:
	TYPEINFO();
	E3dDistantLight(const Vector3D& rPos,
		const Vector3D& rDirection,
		const Color&    rColor,
		double          fLightIntensity = 1.0);

	E3dDistantLight() :
		aDirection(Vector3D(0, 1, 0))
	{
	}

	virtual ~E3dDistantLight();

	virtual UINT16 GetObjIdentifier() const;

	virtual FASTBOOL CalcLighting(Color& rNewColor,
					  const Vector3D& rPnt,
					  const Vector3D& rPntNormal,
					  const Color& rPntColor);

	const Vector3D& GetDirection() const { return aDirection; }
	void SetDirection(const Vector3D& rNewDir);

	virtual void WriteData(SvStream& rOut) const;
	virtual void ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);

	virtual void operator=(const SdrObject&);
};

#endif			
