
#ifndef _SVX_DRAWITEM_HXX
#define _SVX_DRAWITEM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif

#ifdef ITEMID_COLOR_TABLE
class XColorTable;

class SvxColorTableItem: public SfxPoolItem
{
	XColorTable*			pColorTable;

public:
				TYPEINFO();
				SvxColorTableItem();
				SvxColorTableItem( XColorTable* pTable,
						USHORT nWhich = ITEMID_COLOR_TABLE );
				SvxColorTableItem( const SvxColorTableItem& );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual int 			operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;

	XColorTable*			GetColorTable() const { return pColorTable; }
	void			 		SetColorTable( XColorTable* pTable ) {
						pColorTable = pTable; }
};

#endif

#ifdef ITEMID_GRADIENT_LIST
class XGradientList;

class SvxGradientListItem: public SfxPoolItem
{
	XGradientList*				pGradientList;

public:
				TYPEINFO();
				SvxGradientListItem();
				SvxGradientListItem( XGradientList* pList,
						USHORT nWhich = ITEMID_GRADIENT_LIST );
				SvxGradientListItem( const SvxGradientListItem& );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual int 			operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;

	XGradientList*			GetGradientList() const { return pGradientList; }
	void			 		SetGradientList( XGradientList* pList ) {
						pGradientList = pList; }
};

#endif

#ifdef ITEMID_HATCH_LIST
class XHatchList;

class SvxHatchListItem: public SfxPoolItem
{
	XHatchList*				pHatchList;

public:
				TYPEINFO();
				SvxHatchListItem();
				SvxHatchListItem( XHatchList* pList,
						USHORT nWhich = ITEMID_HATCH_LIST );
				SvxHatchListItem( const SvxHatchListItem& );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual int 			operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;

	XHatchList*				GetHatchList() const { return pHatchList; }
	void			 		SetHatchList( XHatchList* pList ) {
						pHatchList = pList; }
};

#endif

#ifdef ITEMID_BITMAP_LIST
class XBitmapList;

class SvxBitmapListItem: public SfxPoolItem
{
	XBitmapList*				pBitmapList;

public:
				TYPEINFO();
				SvxBitmapListItem();
				SvxBitmapListItem( XBitmapList* pBL,
						USHORT nWhich = ITEMID_BITMAP_LIST );
				SvxBitmapListItem( const SvxBitmapListItem& );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual int 			operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;

	XBitmapList*			GetBitmapList() const { return pBitmapList; }
	void			 		SetBitmapList( XBitmapList* pList ) {
						pBitmapList = pList; }
};

#endif

#ifdef ITEMID_DASH_LIST
class XDashList;

class SvxDashListItem: public SfxPoolItem
{
	XDashList*				pDashList;

public:
				TYPEINFO();
				SvxDashListItem();
				SvxDashListItem( XDashList* pList,
						USHORT nWhich = ITEMID_DASH_LIST );
				SvxDashListItem( const SvxDashListItem& );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual int 			operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;

	XDashList*	  			GetDashList() const { return pDashList; }
	void			 		SetDashList( XDashList* pList ) {
						pDashList = pList; }
};

#endif

#ifdef ITEMID_LINEEND_LIST
class XLineEndList;

class SvxLineEndListItem: public SfxPoolItem
{
	XLineEndList*	 		pLineEndList;

public:
				TYPEINFO();
				SvxLineEndListItem();
				SvxLineEndListItem( XLineEndList* pList,
						USHORT nWhich = ITEMID_LINEEND_LIST );
				SvxLineEndListItem( const SvxLineEndListItem& );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual int 			operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;

	XLineEndList*			GetLineEndList() const { return pLineEndList; }
	void			 		SetLineEndList( XLineEndList* pList ) {
						pLineEndList = pList; }
};

#endif

#endif

