
#ifndef _SVX_DSTRIBUT_HXX
#define _SVX_DSTRIBUT_HXX

#ifndef _SVX_DLG_CTRL_HXX
#include <svx/dlgctrl.hxx>
#endif

#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

enum SvxDistributeHorizontal
{
	SvxDistributeHorizontalNone = 0,
	SvxDistributeHorizontalLeft,
	SvxDistributeHorizontalCenter,
	SvxDistributeHorizontalDistance,
	SvxDistributeHorizontalRight
};

enum SvxDistributeVertical
{
	SvxDistributeVerticalNone = 0,
	SvxDistributeVerticalTop,
	SvxDistributeVerticalCenter,
	SvxDistributeVerticalDistance,
	SvxDistributeVerticalBottom
};

class SvxDistributePage : public SvxTabPage
{
	SvxDistributeHorizontal		meDistributeHor;
	SvxDistributeVertical		meDistributeVer;

	FixedLine					maFlHorizontal		;
	RadioButton					maBtnHorNone		;
	RadioButton					maBtnHorLeft		;
	RadioButton					maBtnHorCenter		;
	RadioButton					maBtnHorDistance	;
	RadioButton					maBtnHorRight		;
	FixedImage					maHorLow			;
	FixedImage					maHorCenter			;
	FixedImage					maHorDistance		;
	FixedImage					maHorHigh			;
	FixedLine					maFlVertical		;
	RadioButton					maBtnVerNone		;
	RadioButton					maBtnVerTop			;
	RadioButton					maBtnVerCenter		;
	RadioButton					maBtnVerDistance	;
	RadioButton					maBtnVerBottom		;
	FixedImage					maVerLow			;
	FixedImage					maVerCenter			;
	FixedImage					maVerDistance		;
	FixedImage					maVerHigh			;

public:
	SvxDistributePage(Window* pWindow, const SfxItemSet& rInAttrs,
		SvxDistributeHorizontal eHor = SvxDistributeHorizontalNone,
		SvxDistributeVertical eVer = SvxDistributeVerticalNone);
	~SvxDistributePage();

	static SfxTabPage* Create(Window*, const SfxItemSet&,
		SvxDistributeHorizontal eHor, SvxDistributeVertical eVer);
	static UINT16* GetRanges();
	virtual BOOL FillItemSet(SfxItemSet&);
	virtual void Reset(const SfxItemSet&);
	virtual void PointChanged(Window* pWindow, RECT_POINT eRP);

	SvxDistributeHorizontal GetDistributeHor() const { return meDistributeHor; }
	SvxDistributeVertical GetDistributeVer() const { return meDistributeVer; }
};

class SvxDistributeDialog : public SfxSingleTabDialog
{
	SvxDistributePage*			mpPage;

public:
	SvxDistributeDialog(Window* pParent, const SfxItemSet& rAttr,
		SvxDistributeHorizontal eHor = SvxDistributeHorizontalNone,
		SvxDistributeVertical eVer = SvxDistributeVerticalNone);
	~SvxDistributeDialog();

	SvxDistributeHorizontal GetDistributeHor() const { return mpPage->GetDistributeHor(); }
	SvxDistributeVertical GetDistributeVer() const { return mpPage->GetDistributeVer(); }
};

#endif 

