

#ifndef _SVXE3DITEM_HXX
#define _SVXE3DITEM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
#ifndef _VECTOR3D_HXX
#include <goodies/vector3d.hxx>
#endif

#ifndef _SVXVECT3DITEM_HXX
#define _SVXVECT3DITEM_HXX

class SvStream;

DBG_NAMEEX(SvxVector3DItem);

class SvxVector3DItem: public SfxPoolItem
{
	Vector3D				aVal;

public:
				TYPEINFO();
				SvxVector3DItem();
				SvxVector3DItem( USHORT nWhich, const Vector3D& rVal );
				SvxVector3DItem( USHORT nWhich, SvStream & );
				SvxVector3DItem( const SvxVector3DItem& );
				~SvxVector3DItem() {
					 DBG_DTOR(SvxVector3DItem, 0); }

	virtual int				operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	Create(SvStream &, USHORT nVersion) const;
	virtual SvStream&		Store(SvStream &, USHORT nItemVersion ) const;

	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

	const Vector3D&			GetValue() const { return aVal; }
			void			SetValue( const Vector3D& rNewVal ) {
					 DBG_ASSERT( GetRef() == 0, "SetValue() with pooled item" );
					 aVal = rNewVal;
				 }

	virtual USHORT GetVersion (USHORT nFileFormatVersion) const;
};

#endif

#endif

