

#ifndef _EDITSTAT_HXX
#define _EDITSTAT_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#define EE_CNTRL_USECHARATTRIBS		0x00000001	
#define EE_CNTRL_USEPARAATTRIBS		0x00000002	
#define EE_CNTRL_CRSRLEFTPARA		0x00000004	
#define EE_CNTRL_DOIDLEFORMAT		0x00000008	
#define EE_CNTRL_PASTESPECIAL		0x00000010	
#define EE_CNTRL_AUTOINDENTING		0x00000020	
#define EE_CNTRL_UNDOATTRIBS		0x00000040	
#define EE_CNTRL_ONECHARPERLINE		0x00000080	
#define EE_CNTRL_NOCOLORS			0x00000100	
#define EE_CNTRL_OUTLINER			0x00000200	
#define EE_CNTRL_OUTLINER2			0x00000400	
#define EE_CNTRL_ALLOWBIGOBJS		0x00000800	
#define EE_CNTRL_ONLINESPELLING		0x00001000	
#define EE_CNTRL_STRETCHING			0x00002000	
#define EE_CNTRL_MARKFIELDS			0x00004000	
#define EE_CNTRL_URLSFXEXECUTE		0x00008000	
#define EE_CNTRL_RESTOREFONT		0x00010000	
#define EE_CNTRL_RTFSTYLESHEETS		0x00020000	
#define EE_CNTRL_NOREDLINES			0x00040000	
#define EE_CNTRL_AUTOCORRECT		0x00080000	
#define EE_CNTRL_AUTOCOMPLETE		0x00100000	
#define EE_CNTRL_AUTOPAGESIZEX		0x00200000	
#define EE_CNTRL_AUTOPAGESIZEY		0x00400000	
#define EE_CNTRL_AUTOPAGESIZE		(EE_CNTRL_AUTOPAGESIZEX|EE_CNTRL_AUTOPAGESIZEY)
#define EE_CNTRL_TABINDENTING		0x00800000	
#define EE_CNTRL_FORMAT100			0x01000000	
#define EE_CNTRL_ULSPACESUMMATION	0x02000000	
#define EE_CNTRL_ULSPACEFIRSTPARA	0x04000000	

#define EV_CNTRL_AUTOSCROLL			0x00000001	
#define EV_CNTRL_BIGSCROLL			0x00000002	
#define EV_CNTRL_ENABLEPASTE		0x00000004	
#define EV_CNTRL_SINGLELINEPASTE	0x00000008	
#define EV_CNTRL_OVERWRITE			0x00000010	
#define EV_CNTRL_INVONEMORE			0x00000020	
#define EV_CNTRL_AUTOSIZEX			0x00000040	
#define EV_CNTRL_AUTOSIZEY			0x00000080	
#define EV_CNTRL_AUTOSIZE			(EV_CNTRL_AUTOSIZEX|EV_CNTRL_AUTOSIZEY)

#define EE_STAT_HSCROLL				0x00000001
#define EE_STAT_VSCROLL				0x00000002
#define EE_STAT_CURSOROUT			0x00000004
#define EE_STAT_CRSRMOVEFAIL		0x00000008
#define EE_STAT_CRSRLEFTPARA		0x00000010
#define EE_STAT_TEXTWIDTHCHANGED	0x00000020
#define EE_STAT_TEXTHEIGHTCHANGED	0x00000040
#define EE_STAT_WRONGWORDCHANGED	0x00000080

#define EE_CNTRL_AUTOCENTER		EE_CNTRL_AUTOPAGESIZE
#define EE_STAT_GROWY			EE_STAT_TEXTHEIGHTCHANGED

inline void SetFlags( ULONG& rBits, const ULONG nMask, FASTBOOL bOn )
{
	if ( bOn )
		rBits |= nMask;
	else
		rBits &= ~nMask;
}

class EditStatus
{
protected:
	ULONG	nStatusBits;
	ULONG	nControlBits;
	USHORT	nPrevPara;					

public:
			EditStatus()				{ nStatusBits = 0; nControlBits = 0; nPrevPara = 0xFFFF; }

	void	Clear() 					{ nStatusBits = 0; }
	void	SetControlBits( ULONG nMask, FASTBOOL bOn )
	{ SetFlags( nControlBits, nMask, bOn ); }

	ULONG	GetStatusWord() const		{ return nStatusBits; }
	ULONG&	GetStatusWord() 			{ return nStatusBits; }

	ULONG	GetControlWord() const		{ return nControlBits; }
	ULONG&	GetControlWord() 			{ return nControlBits; }

	USHORT	GetPrevParagraph() const	{ return nPrevPara; }
	USHORT&	GetPrevParagraph() 			{ return nPrevPara; }
};

#define SPELLCMD_IGNOREWORD			0x0001
#define SPELLCMD_STARTSPELLDLG		0x0002
#define SPELLCMD_ADDTODICTIONARY	0x0003

struct SpellCallbackInfo
{
	USHORT		nCommand;
	String		aWord;

	SpellCallbackInfo( USHORT nCMD, const String& rWord )
	: aWord( rWord )
	{
		nCommand = nCMD;
	}
};

#endif 

