
#ifndef _SVX_EMPHITEM_HXX
#define _SVX_EMPTITEM_HXX

#ifndef _VCL_VCLENUM_HXX
#include <vcl/vclenum.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

class SvXMLUnitConverter;
#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

class SvxEmphasisMarkItem : public SfxUInt16Item
{
public:
	TYPEINFO();

	SvxEmphasisMarkItem(  const FontEmphasisMark eVal = EMPHASISMARK_NONE,
			  const USHORT nId = ITEMID_EMPHASISMARK );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						String &rText,
	                                const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	Create(SvStream &, USHORT) const;
	virtual SvStream&		Store(SvStream &, USHORT nItemVersion) const;
	virtual USHORT			GetVersion( USHORT nFileVersion ) const;

	virtual	sal_Bool        QueryValue( com::sun::star::uno::Any& rVal,
								BYTE nMemberId = 0 ) const;
	virtual	sal_Bool		PutValue( const com::sun::star::uno::Any& rVal,
								BYTE nMemberId = 0 );

	inline SvxEmphasisMarkItem& operator=(const SvxEmphasisMarkItem& rItem )
	{
		SetValue( rItem.GetValue() );
		return *this;
	}

	FontEmphasisMark		GetEmphasisMark() const
					{ return (FontEmphasisMark)GetValue(); }
	void					SetEmphasisMark( FontEmphasisMark eNew )
					{ SetValue( (USHORT)eNew ); }
};

#endif 

