
#ifndef _SVX_FNTCTRL_HXX
#define _SVX_FNTCTRL_HXX

#ifndef _WINDOW_HXX 
#include <vcl/window.hxx>
#endif
#ifndef _SVX_SVXFONT_HXX 
#include <svx/svxfont.hxx>
#endif

class FontPrevWin_Impl;

class SvxFontPrevWindow : public Window
{
private:
	SvxFont         	aFont;
	FontPrevWin_Impl*   pImpl;
	Printer*        	pPrinter;
	BOOL            	bDelPrinter;

	void				InitSettings( BOOL bForeground, BOOL bBackground );

public:
	SvxFontPrevWindow( Window* pParent, const ResId& rId );
	~SvxFontPrevWindow();

	virtual void		StateChanged( StateChangedType nStateChange );
	virtual void		DataChanged( const DataChangedEvent& rDCEvt );

	SvxFont& 			GetFont() { return aFont; }
	const SvxFont& 		GetFont() const { return aFont; }
	void  				SetFont( const SvxFont& rFont );
	SvxFont&            GetCJKFont();
	void  				SetColor( const Color& rColor );
	void                SetBackColor( const Color& rColor );
	void                UseResourceText( BOOL bUse = TRUE );
	void  				Paint( const Rectangle& );

	BOOL				IsTwoLines() const;
	void				SetTwoLines(BOOL bSet);

	void				SetBrackets(sal_Unicode cStart, sal_Unicode cEnd);
};

#endif 

