
#ifndef _SVX_FWDTITEM_HXX
#define _SVX_FWDTITEM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
#ifndef   ITEMID_FONTWIDTH
#define   ITEMID_FONTWIDTH 0
#endif

class SvxFontWidthItem : public SfxPoolItem
{
	UINT16	nWidth;			
	USHORT	nProp;			
public:
	TYPEINFO();

	SvxFontWidthItem(	const USHORT nSz = 0,
			const USHORT nPropWidth = 100,
			const USHORT nId = ITEMID_FONTWIDTH );

	virtual int 			 operator==( const SfxPoolItem& ) const;
	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*	 Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*     Create(SvStream &, USHORT) const;
	virtual SvStream&		 Store(SvStream &, USHORT nItemVersion) const;
	virtual int				 ScaleMetrics( long nMult, long nDiv );
	virtual	int				 HasMetrics() const;

	inline SvxFontWidthItem& operator=(const SvxFontWidthItem& rItem )
		{
			SetWidthValue( rItem.GetWidth() );
			SetProp( rItem.GetProp() );
			return *this;
		}

	void SetWidth( UINT16 nNewWidth, const USHORT nNewProp = 100 )
		{
			DBG_ASSERT( GetRef() == 0, "SetValue() with pooled item" );
			nWidth = UINT16(( (UINT32)nNewWidth * nNewProp ) / 100 );
			nProp = nNewProp;
		}

	UINT16 GetWidth() const { return nWidth; }

	void SetWidthValue( UINT16 nNewWidth )
		{
			DBG_ASSERT( GetRef() == 0, "SetValue() with pooled item" );
			nWidth = nNewWidth;
		}

	void SetProp( const USHORT nNewProp )
		{
			DBG_ASSERT( GetRef() == 0, "SetValue() with pooled item" );
			nProp = nNewProp;
		}

	USHORT GetProp() const { return nProp; }
};

#endif

