

#ifndef _SVX_GALBRWS_HXX_
#define _SVX_GALBRWS_HXX_

#ifndef _SFXCTRLITEM_HXX
#include <sfx2/ctrlitem.hxx>
#endif
#ifndef _SFXDOCKWIN_HXX
#include <sfx2/dockwin.hxx>
#endif
#ifndef _SV_GRAPH_HXX
#include <vcl/graph.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#define GALLERYBROWSER() ((GalleryBrowser*)( SfxViewFrame::Current()->GetChildWindow(GalleryChildWindow::GetChildWindowId())->GetWindow()))

class GalleryChildWindow : public SfxChildWindow
{
public:
			GalleryChildWindow( Window*, USHORT, SfxBindings*, SfxChildWinInfo* );
			~GalleryChildWindow();
				SFX_DECL_CHILDWINDOW( GalleryChildWindow );
};

class FmFormModel;

class GalleryBrowser1;
class GalleryBrowser2;
class Splitter;
class Gallery;

class GalleryBrowser : public SfxDockingWindow
{
	friend class GalleryBrowser1;
	friend class GalleryBrowser2;

private:

	Size					maLastSize;
	Splitter*				mpSplitter;
	GalleryBrowser1*		mpBrowser1;
	GalleryBrowser2*		mpBrowser2;
	Gallery*				mpGallery;
	long					mnDummy1;
	long					mnDummy2;
	long					mnDummy3;

	virtual BOOL 			Close();
	virtual void			Resize();
					DECL_LINK( SplitHdl, void* );

protected:

	void					ThemeSelectionHasChanged();

public:						
					GalleryBrowser( SfxBindings* pBindings, SfxChildWindow* pCW,
								Window* pParent, const ResId& rResId );
				~GalleryBrowser();

	INetURLObject			GetURL() const;
	String					GetFilterName() const;
	Graphic					GetGraphic() const;
	BOOL					GetVCDrawModel( FmFormModel& rModel ) const;
	BOOL					IsLinkage() const;
};

#endif 
