
#ifndef _SVX_GRFCROP_HXX
#define _SVX_GRFCROP_HXX

#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif

#define GRFCROP_VERSION_SWDEFAULT		0
#define GRFCROP_VERSION_MOVETOSVX 		1

class SvxGrfCrop : public SfxPoolItem
{
	sal_Int32	nLeft, nRight, nTop, nBottom;
public:

	SvxGrfCrop( USHORT = ITEMID_GRF_CROP );
	SvxGrfCrop( sal_Int32 nLeft,	sal_Int32 nRight,
	sal_Int32 nTop,		sal_Int32 nBottom,
	USHORT = ITEMID_GRF_CROP );
	virtual ~SvxGrfCrop();

	virtual int            		operator==( const SfxPoolItem& ) const;

	virtual SfxPoolItem*		Create(SvStream &, USHORT nVer) const;
	virtual SvStream&			Store(SvStream &, USHORT nIVer) const;
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						String &rText,
	                                const IntlWrapper* pIntl = 0 ) const;
	virtual	BOOL        	 QueryValue( com::sun::star::uno::Any& rVal,
							BYTE nMemberId = 0 ) const;
	virtual	BOOL			 PutValue( const com::sun::star::uno::Any& rVal,
							BYTE nMemberId = 0 );

	void SetLeft( sal_Int32 nVal )		{ nLeft = nVal; }
	void SetRight( sal_Int32 nVal )		{ nRight = nVal; }
	void SetTop( sal_Int32 nVal )		{ nTop = nVal; }
	void SetBottom( sal_Int32 nVal )	{ nBottom = nVal; }

	sal_Int32 GetLeft() const			{ return nLeft; }
	sal_Int32 GetRight() const 			{ return nRight; }
	sal_Int32 GetTop() const			{ return nTop; }
	sal_Int32 GetBottom() const			{ return nBottom; }

	inline SvxGrfCrop& operator=( const SvxGrfCrop& rCrop )
		{
			nLeft = rCrop.GetLeft(); 		nTop = rCrop.GetTop();
			nRight = rCrop.GetRight();		nBottom = rCrop.GetBottom();
			return *this;
		}
};

#endif  
