

#ifndef _SVX_GRFPAGE_HXX
#define _SVX_GRFPAGE_HXX

#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _BUTTON_HXX 
#include <vcl/button.hxx>
#endif
#ifndef _FIELD_HXX 
#include <vcl/field.hxx>
#endif
#ifndef _SV_GRAPH_HXX 
#include <vcl/graph.hxx>
#endif

#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif

class SvxGrfCropPage : public SfxTabPage
{
	class SvxCropExample : public Window
	{
		Size 		aFrameSize;
		Point 		aTopLeft, aBottomRight;
		Graphic		aGrf;

	public:
		SvxCropExample( Window* pPar, const ResId& rResId );

		virtual void Paint( const Rectangle& rRect );

		void SetTopLeft( const Point& rNew )	{ aTopLeft = rNew; }
		void SetTop( long nVal )				{ aTopLeft.X() = nVal; }
		void SetBottom( long nVal )				{ aBottomRight.X() = nVal; }
		void SetLeft( long nVal )				{ aTopLeft.Y() = nVal; }
		void SetRight( long nVal)				{ aBottomRight.Y() = nVal; }
		void SetBottomRight(const Point& rNew )	{ aBottomRight = rNew; }
		void SetFrameSize( const Size& rSz );
		void SetGraphic( const Graphic& rGrf )	{ aGrf = rGrf; }
		const Graphic& GetGraphic() const		{ return aGrf; }
	};
	 FixedLine       aCropFL;
	RadioButton		aZoomConstRB;
	RadioButton		aSizeConstRB;
	FixedText		aLeftFT;
	MetricField    	aLeftMF;
	FixedText		aRightFT;
	MetricField    	aRightMF;
	FixedText		aTopFT;
	MetricField    	aTopMF;
	FixedText		aBottomFT;
	MetricField    	aBottomMF;
	 FixedLine       aZoomFL;
	FixedText		aWidthZoomFT;
	MetricField    	aWidthZoomMF;
	FixedText		aHeightZoomFT;
	MetricField    	aHeightZoomMF;
	 FixedLine       aSizeFL;
	FixedText		aWidthFT;
	MetricField    	aWidthMF;
	FixedText		aHeightFT;
	MetricField    	aHeightMF;
	FixedText		aOrigSizeFT;
	PushButton		aOrigSizePB;

	SvxCropExample	aExampleWN;

	Timer			aTimer;
	String 			aGraphicName;
	Size			aOrigSize;
	Size 			aPageSize;
	const MetricField* 	pLastCropField;
	long			nOldWidth;
	long			nOldHeight;
	BOOL			bReset;
	BOOL			bInitialized;
	BOOL			bSetOrigSize;

	SvxGrfCropPage( Window *pParent, const SfxItemSet &rSet );
	virtual ~SvxGrfCropPage();

	DECL_LINK( ZoomHdl, MetricField * );
	DECL_LINK( SizeHdl, MetricField * );
	DECL_LINK( CropHdl, const MetricField * );
	DECL_LINK( CropLoseFocusHdl, MetricField * );
	DECL_LINK( CropModifyHdl, MetricField * );
	DECL_LINK( OrigSizeHdl, PushButton * );
	DECL_LINK( Timeout, Timer * );

	void 			CalcZoom();
	void			CalcMinMaxBorder();
	void			GraphicHasChanged(BOOL bFound);
	virtual void 	ActivatePage(const SfxItemSet& rSet);

	Size			GetGrfOrigSize( const Graphic& ) const;
public:
	static SfxTabPage *Create( Window *pParent, const SfxItemSet &rSet );

	virtual BOOL FillItemSet( SfxItemSet &rSet );
	virtual void Reset( const SfxItemSet &rSet );
	virtual int DeactivatePage( SfxItemSet *pSet );
};

#endif
