
#ifndef _SVX_HYZNITEM_HXX
#define _SVX_HYZNITEM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

class SvXMLUnitConverter;
#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

class SvxHyphenZoneItem : public SfxPoolItem
{
	BOOL bHyphen:  1;
	BOOL bPageEnd: 1;
	BYTE nMinLead;
	BYTE nMinTrail;
	BYTE nMaxHyphens;

	friend SvStream & operator<<( SvStream & aS, SvxHyphenZoneItem & );

public:
	TYPEINFO();

	SvxHyphenZoneItem( const BOOL bHyph = FALSE,
		   const USHORT nId = ITEMID_HYPHENZONE );

	virtual int 			 operator==( const SfxPoolItem& ) const;
	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*	 Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	 Create(SvStream &, USHORT) const;
	virtual SvStream&		 Store(SvStream &, USHORT nItemVersion ) const;

	inline void SetHyphen( const BOOL bNew ) { bHyphen = bNew; }
	inline BOOL IsHyphen() const { return bHyphen; }

	inline void SetPageEnd( const BOOL bNew ) { bPageEnd = bNew; }
	inline BOOL IsPageEnd() const { return bPageEnd; }

	inline BYTE &GetMinLead() { return nMinLead; }
	inline BYTE GetMinLead() const { return nMinLead; }

	inline BYTE &GetMinTrail() { return nMinTrail; }
	inline BYTE GetMinTrail() const { return nMinTrail; }

	inline BYTE &GetMaxHyphens() { return nMaxHyphens; }
	inline BYTE GetMaxHyphens() const { return nMaxHyphens; }

	inline SvxHyphenZoneItem &operator=( const SvxHyphenZoneItem &rNew )
	{
		bHyphen = rNew.IsHyphen();
		bPageEnd = rNew.IsPageEnd();
		nMinLead = rNew.GetMinLead();
		nMinTrail = rNew.GetMinTrail();
		nMaxHyphens = rNew.GetMaxHyphens();
		return *this;
	}
};

#endif

