
#ifndef _SVX_KEEPITEM_HXX
#define _SVX_KEEPITEM_HXX

#ifndef _SFXENUMITEM_HXX 
#include <svtools/eitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

class SvxFmtKeepItem : public SfxBoolItem
{
public:
	TYPEINFO();

	inline SvxFmtKeepItem( const BOOL bKeep = FALSE,
			   const USHORT nWhich = ITEMID_FMTKEEP );
	inline SvxFmtKeepItem& operator=( const SvxFmtKeepItem& rSplit );

	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	Create( SvStream&, USHORT ) const;
	virtual SvStream&		Store( SvStream& , USHORT nItemVersion ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;
};

inline SvxFmtKeepItem::SvxFmtKeepItem( const BOOL bKeep, const USHORT nWhich ) :
	SfxBoolItem( nWhich, bKeep )
{}

inline SvxFmtKeepItem& SvxFmtKeepItem::operator=( const SvxFmtKeepItem& rKeep )
{
	SetValue( rKeep.GetValue() );
	return *this;
}

#endif

