
#ifndef _SVX_LANGBOX_HXX
#define _SVX_LANGBOX_HXX

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif

#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif

#include <vcl/image.hxx>

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

class SvxLanguageTable;

#define LANG_LIST_EMPTY			0x0000
#define LANG_LIST_ALL			0x0001
#define LANG_LIST_WESTERN		0x0002
#define LANG_LIST_CTL			0x0004
#define LANG_LIST_CJK			0x0008
#define LANG_LIST_FBD_CHARS		0x0010
#define LANG_LIST_SPELL_AVAIL	0x0020
#define LANG_LIST_HYPH_AVAIL	0x0040
#define LANG_LIST_THES_AVAIL	0x0080
#define LANG_LIST_ONLY_KNOWN    0x0100  
#define LANG_LIST_SPELL_USED    0x0200
#define LANG_LIST_HYPH_USED     0x0400
#define LANG_LIST_THES_USED     0x0800

class SvxLanguageBox : public ListBox
{
public:

private:
	Image					m_aNotCheckedImage;
	Image					m_aCheckedImage;
	String					m_aAllString;
#if SUPD >= 637
	com::sun::star::uno::Sequence< INT16 >  *m_pSpellUsedLang;
#endif
	SvxLanguageTable*		m_pLangTable;
	INT16					m_nLangList;
	BOOL                    m_bHasLangNone;
	BOOL					m_bLangNoneIsLangAll;
	BOOL					m_bWithCheckmark;
	 void                    Init();
public:
	SvxLanguageBox( Window* pParent, WinBits nWinStyle, BOOL bCheck = FALSE);
	SvxLanguageBox( Window* pParent, const ResId& rResId, BOOL bCheck = FALSE);
	~SvxLanguageBox();

	void			SetLanguageList( INT16 nLangList,
				BOOL bHasLangNone, BOOL bLangNoneIsLangAll = FALSE,
				BOOL bCheckSpellAvail = FALSE );

	USHORT			InsertLanguage( const LanguageType eLangType, USHORT nPos = LISTBOX_APPEND );
	USHORT          InsertLanguage( const LanguageType eLangType, 
	                        BOOL bCheckEntry, USHORT nPos = LISTBOX_APPEND );
	void			RemoveLanguage( const LanguageType eLangType );
	void			SelectLanguage( const LanguageType eLangType, BOOL bSelect = TRUE );
	LanguageType	GetSelectLanguage() const;
	BOOL			IsLanguageSelected( const LanguageType eLangType ) const;
};

#endif

