
#ifndef _SVX_LANGITEM_HXX
#define _SVX_LANGITEM_HXX

#ifndef _SFXENUMITEM_HXX 
#include <svtools/eitem.hxx>
#endif
#ifndef _LANG_HXX 
#include <tools/lang.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

class SvXMLUnitConverter;
#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

class SvxLanguageItem : public SfxEnumItem
{
public:
	TYPEINFO();

	SvxLanguageItem( const LanguageType eLang = LANGUAGE_GERMAN,
		 const USHORT nId = ITEMID_LANGUAGE );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*    Create(SvStream &, USHORT) const;
	virtual SvStream&		Store(SvStream &, USHORT nItemVersion) const;
	virtual USHORT          GetValueCount() const;

	inline SvxLanguageItem& operator=(const SvxLanguageItem& rLang)
		{
			SetValue( rLang.GetValue() );
			return *this;
		}

	LanguageType 			GetLanguage() const
					{ return (LanguageType)GetValue(); }
	void 					SetLanguage( const LanguageType eLang )
					{ SetValue( (USHORT)eLang ); }
	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );
};

#endif

