

#ifndef _SVX_LBOXCTRL_HXX_
#define _SVX_LBOXCTRL_HXX_

#ifndef _SFXTBXCTRL_HXX
#include <sfx2/tbxctrl.hxx>
#endif

class ToolBox;
class SvxPopupWindowListBox;

class SvxListBoxControl : public SfxToolBoxControl
{
protected:	
	String                  aActionStr;
	SvxPopupWindowListBox *	pPopupWin;
	USHORT					nItemId;
	 void    Impl_SetInfo( USHORT nCount );

	DECL_LINK( PopupModeEndHdl, void * );
	DECL_LINK( SelectHdl, void * );

public:
	SFX_DECL_TOOLBOX_CONTROL();

	SvxListBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
	virtual ~SvxListBoxControl();

	virtual SfxPopupWindowType	GetPopupWindowType() const;
	virtual SfxPopupWindow* 	CreatePopupWindow();
	virtual void				StateChanged( USHORT nSID,
								  SfxItemState eState,
								  const SfxPoolItem* pState );
};

class SvxUndoControl : public SvxListBoxControl
{
public:
	SFX_DECL_TOOLBOX_CONTROL();

	SvxUndoControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
	virtual ~SvxUndoControl();

	virtual SfxPopupWindow* 	CreatePopupWindow();
	virtual SfxPopupWindowType	GetPopupWindowType() const;
	virtual void				StateChanged( USHORT nSID,
								  SfxItemState eState,
								  const SfxPoolItem* pState );
};

class SvxRedoControl : public SvxListBoxControl
{
public:
	SFX_DECL_TOOLBOX_CONTROL();

	SvxRedoControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
	virtual ~SvxRedoControl();

	virtual SfxPopupWindow* 	CreatePopupWindow();
	virtual SfxPopupWindowType	GetPopupWindowType() const;
	virtual void				StateChanged( USHORT nSID,
								  SfxItemState eState,
								  const SfxPoolItem* pState );
};

#endif

