

#ifndef _SVX_LIGHT3D_HXX_
#define _SVX_LIGHT3D_HXX_

#include <svx/dlgctl3d.hxx>

#ifndef _SV_FIXED_HXX 
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_GROUP_HXX 
#include <vcl/group.hxx>
#endif

#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif

#ifndef _BASEDLGS_HXX 
#include <sfx2/basedlgs.hxx>
#endif

#ifndef _FIELD_HXX 
#include <vcl/field.hxx>
#endif

#ifndef _SVX_DLG_CTRL_HXX 
#include <svx/dlgctrl.hxx>
#endif

class Vector3D;

class Svx3DTabDialog : public SfxTabDialog
{
private:
	const SfxItemSet&	rOutAttrs;

public:
			Svx3DTabDialog( Window* pParent, const SfxItemSet* pAttr );
			~Svx3DTabDialog();
};

class Svx3DSingleTabDialog : public SfxSingleTabDialog
{
private:
	const SfxItemSet&	rOutAttrs;

public:
		Svx3DSingleTabDialog( Window* pParent, const SfxItemSet* pAttr );
		~Svx3DSingleTabDialog();
};

class SvxLight3DTabPage : public SfxTabPage
{
private:
	SvxRectCtl3D		aCtlLight;
	FixedText			aFtLightIntensity;
	MetricField			aMtrFldLightIntensity;
	FixedText			aFtLightColor;
	ColorLB  			aLbLightColor;
	GroupBox			aGrpLight;
	FixedText			aFtIntensity;
	MetricField			aMtrFldIntensity;
	FixedText			aFtColor;
	ColorLB  			aLbColor;
	GroupBox			aGrpAmbient;
	const SfxItemSet&	rOutAttrs;

public:
		 SvxLight3DTabPage( Window* pParent, const SfxItemSet& rInAttrs  );

	static SfxTabPage* Create( Window*, const SfxItemSet& );
	static USHORT*	   GetRanges();

	virtual BOOL FillItemSet( SfxItemSet& );
	virtual void Reset( const SfxItemSet & );
};

#endif 

