
#ifndef _SVXLINKMGR_HXX
#define _SVXLINKMGR_HXX

#ifndef _LINKMGR_HXX
#include <so3/linkmgr.hxx>
#endif

class Graphic;
class Size;

enum LinkState
{
	STATE_LOAD_OK,
	STATE_LOAD_ERROR,
	STATE_LOAD_ABORT
};

class SvxLinkManager : public so3::SvLinkManager
{
	SvxLinkManager( const SvxLinkManager& );
	SvxLinkManager& operator=( const SvxLinkManager& );

public:
	SvxLinkManager( SvPersist * pCacheCont );

	BOOL InsertFileLink( so3::SvBaseLink&,
			USHORT nFileType,
			const String& rTxt,
			const String* pFilterNm = 0,
			const String* pRange = 0 );

	BOOL InsertFileLink( so3::SvBaseLink& );

	virtual BOOL GetDisplayNames( const so3::SvBaseLink*,
						String* pType,
						String* pFile = 0,
						String* pLink = 0,
						String* pFilter = 0 ) const;

	virtual so3::SvLinkSourceRef CreateObj( so3::SvBaseLink * );

	void CancelTransfers();

	static void SetTransferPriority( so3::SvBaseLink& rLink, USHORT nPrio );

	static ULONG  RegisterStatusInfoId();

	static BOOL GetGraphicFromAny( const String& rMimeType,
					const ::com::sun::star::uno::Any & rValue,
					Graphic& rGrf );

};

#endif

