
#ifndef _SVX_MULTIPAT_HXX
#define _SVX_MULTIPAT_HXX

#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

#ifndef MAC
#define MAX_PATHLEN		30
#else
#define MAX_PATHLEN		45
#endif

struct MultiPath_Impl;

class SvxMultiPathDialog : public ModalDialog
{
protected:
	ListBox			aPathLB;
	PushButton		aAddBtn;
	PushButton		aDelBtn;
	FixedLine       aPathGB;
	OKButton		aOKBtn;
	CancelButton	aCancelBtn;
	HelpButton		aHelpButton;

	MultiPath_Impl*	pImpl;

	DECL_LINK( AddHdl_Impl, PushButton * );
	DECL_LINK( DelHdl_Impl, PushButton * );
	DECL_LINK( SelectHdl_Impl, ListBox * );

public:
	SvxMultiPathDialog( Window* pParent, BOOL bEmptyAllowed = FALSE );
	~SvxMultiPathDialog();

	String			GetPath() const;
	void			SetPath( const String& rPath );
	void			ShowPathFiles();

	static String	CreateUIName( const String& rPath );
};

#endif 

