
#ifndef _SVX_NUMINF_HXX
#define _SVX_NUMINF_HXX

#ifndef _SFXITEMPOOL_HXX 
#include <svtools/itempool.hxx>
#endif
#ifndef _SVX_NUMFMTSH_HXX 
#include <svx/numfmtsh.hxx>
#endif

#ifdef ITEMID_NUMBERINFO

class SvxNumberInfoItem : public SfxPoolItem
{
public:
	TYPEINFO();

	SvxNumberInfoItem( const USHORT nId = ITEMID_NUMBERINFO );
	SvxNumberInfoItem( SvNumberFormatter* pNumFormatter,
		   const USHORT nId = ITEMID_NUMBERINFO );
	SvxNumberInfoItem( SvNumberFormatter* pNumFormatter, const String& rVal,
		   const USHORT nId = ITEMID_NUMBERINFO );
	SvxNumberInfoItem( SvNumberFormatter* pNumFormatter, const double& rVal,
		   const USHORT nId = ITEMID_NUMBERINFO );

	SvxNumberInfoItem( SvNumberFormatter* pNumFormatter, const double& rVal,
		   const String& rValueStr, const USHORT nId );
	SvxNumberInfoItem( const SvxNumberInfoItem& );
	~SvxNumberInfoItem();

	virtual int              operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*     Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*     Create( SvStream& rStream, USHORT nVer ) const;
	virtual SvStream&		 Store( SvStream& , USHORT nItemVersion ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	SvNumberFormatter*		GetNumberFormatter() const { return pFormatter; }
	void					SetNumberFormatter( SvNumberFormatter* pNumFrmt );
	const String&			GetValueString() const { return aStringVal; }
	void					SetStringValue( const String& rNewVal );
	double					GetValueDouble() const 	{ return nDoubleVal; }
	void					SetDoubleValue( const double& rNewVal );

	const ULONG*			GetDelArray() const { return pDelFormatArr; }
	void					SetDelFormatArray( const ULONG* pData,
								   const ULONG  nCount );

	SvxNumberValueType		GetValueType() const { return eValueType; }
	ULONG					GetDelCount() const  { return nDelCount; }

private:
	SvNumberFormatter*	pFormatter;
	SvxNumberValueType	eValueType;
	String				aStringVal;
	double				nDoubleVal;

	ULONG*				pDelFormatArr;
	ULONG				nDelCount;
};

#endif

#endif

