
#ifndef _SVX_OPENGRF_HXX
#define _SVX_OPENGRF_HXX

#include <memory>		

#ifndef _FILTER_HXX 
#include <svtools/filter.hxx>
#endif

struct  SvxOpenGrf_Impl;

class SvxOpenGraphicDialog
{
public:
	SvxOpenGraphicDialog	( const String& rTitle );
	~SvxOpenGraphicDialog	();

	short					Execute();

	void					SetPath( const String& rPath );
	void					SetPath( const String& rPath, sal_Bool bLinkState );
	String					GetPath() const;

	int 					GetGraphic(Graphic&) const;

	void					EnableLink(sal_Bool);
	void					AsLink(sal_Bool);
	sal_Bool				IsAsLink() const;

	String					GetCurrentFilter() const;
	void					SetCurrentFilter(const String&);

private:

	SvxOpenGraphicDialog	(const SvxOpenGraphicDialog&);
	SvxOpenGraphicDialog& operator = ( const SvxOpenGraphicDialog & );

	const std::auto_ptr< SvxOpenGrf_Impl >	mpImpl;
};

#endif 

