
#ifndef _SVX_OPTGENRL_HXX
#define _SVX_OPTGENRL_HXX

#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _EDIT_HXX 
#include <vcl/edit.hxx>
#endif
#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif

class SvxAddressItem;
struct GeneralTabPage_Impl;

#define SfxGeneralTabPage SvxGeneralTabPage

#define	UNKNOWN_EDIT	((USHORT)0)
#define COMPANY_EDIT	((USHORT)1)
#define FIRSTNAME_EDIT	((USHORT)2)
#define LASTNAME_EDIT	((USHORT)3)
#define STREET_EDIT		((USHORT)4)
#define COUNTRY_EDIT	((USHORT)5)
#define PLZ_EDIT		((USHORT)6)
#define CITY_EDIT		((USHORT)7)
#define STATE_EDIT		((USHORT)8)
#define TITLE_EDIT		((USHORT)9)
#define POSITION_EDIT	((USHORT)10)
#define SHORTNAME_EDIT	((USHORT)11)
#define TELPRIV_EDIT	((USHORT)12)
#define TELCOMPANY_EDIT	((USHORT)13)
#define FAX_EDIT		((USHORT)14)
#define EMAIL_EDIT		((USHORT)15)

class SvxGeneralTabPage : public SfxTabPage
{
private:
	FixedText 			aCompanyLbl;
	Edit 				aCompanyEdit;
	FixedText 			aNameLbl;
	FixedText 			aNameLblRuss;
	Edit				aFatherName;
	Edit 				aFirstName;
	Edit 				aName;
	Edit 				aShortName;
	FixedText 			aStreetLbl;
	FixedText 			aStreetLblRuss;
	Edit 				aStreetEdit;
	Edit 				aApartmentNrEdit;
	FixedText 			aCityLbl;
	Edit 				aPLZEdit;
	Edit 				aCityEdit;
	Edit 				aUsCityEdit;
	Edit 				aUsStateEdit;
	Edit 				aUsZipEdit;
	FixedText			aCountryLbl;
	Edit 				aCountryEdit;
	FixedText 			aTitlePosLbl;
	Edit 				aTitleEdit;
	Edit 				aPositionEdit;
	FixedText 			aPhoneLbl;
	Edit 				aTelPrivEdit;
	Edit 				aTelCompanyEdit;
	FixedText 			aFaxMailLbl;
	Edit 				aFaxEdit;
	Edit 				aEmailEdit;
	FixedLine           aAddrFrm;
	CheckBox			aUseDataCB;

	GeneralTabPage_Impl*	pImpl;

#ifdef _SVX_OPTGENRL_CXX
	DECL_LINK( ModifyHdl_Impl, Edit * );

	String              GetAddress_Impl();
	void				SetAddress_Impl( const SvxAddressItem& rAddress );
#endif

protected:
	virtual int			DeactivatePage( SfxItemSet* pSet );

public:
	SvxGeneralTabPage( Window* pParent, const SfxItemSet& rSet );
	~SvxGeneralTabPage();

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

#endif 

