
#ifndef _SVX_OPTGRID_HXX
#define _SVX_OPTGRID_HXX

#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif
#ifndef _SFXENUMITEM_HXX 
#include <svtools/eitem.hxx>
#endif
#ifndef _SV_GROUP_HXX 
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_FIELD_HXX 
#include <vcl/field.hxx>
#endif

class SvxGridTabPage;

class SvxOptionsGrid
{
protected:
	UINT32	nFldDrawX;
	UINT32 	nFldDivisionX;
	UINT32	nFldDrawY;
	UINT32 	nFldDivisionY;
	UINT32	nFldSnapX;
	UINT32	nFldSnapY;
	BOOL	bUseGridsnap:1;
	BOOL	bSynchronize:1;
	BOOL	bGridVisible:1;
	BOOL	bEqualGrid:	 1;

public:
	SvxOptionsGrid();
	~SvxOptionsGrid();

	void 	SetFldDrawX(	UINT32 nSet){nFldDrawX 		= nSet;}
	void 	SetFldDivisionX(UINT32 nSet){nFldDivisionX  = nSet;}
	void 	SetFldDrawY   (	UINT32 nSet){nFldDrawY      = nSet;}
	void 	SetFldDivisionY(UINT32 nSet){nFldDivisionY  = nSet;}
	void 	SetFldSnapX(	UINT32 nSet){nFldSnapX 		= nSet;}
	void 	SetFldSnapY   (	UINT32 nSet){nFldSnapY      = nSet;}
	void 	SetUseGridSnap( BOOL bSet ) {bUseGridsnap	= bSet;}
	void 	SetSynchronize( BOOL bSet ) {bSynchronize	= bSet;}
	void 	SetGridVisible( BOOL bSet ) {bGridVisible	= bSet;}
	void 	SetEqualGrid( BOOL bSet )	{bEqualGrid		= bSet;}

	UINT32	GetFldDrawX(	) const {  return nFldDrawX;    }
	UINT32 	GetFldDivisionX() const {  return nFldDivisionX;}
	UINT32	GetFldDrawY   (	) const {  return nFldDrawY;    }
	UINT32 	GetFldDivisionY() const {  return nFldDivisionY;}
	UINT32	GetFldSnapX(	) const {  return nFldSnapX;    }
	UINT32	GetFldSnapY   (	) const {  return nFldSnapY;    }
	BOOL	GetUseGridSnap( ) const {  return bUseGridsnap; }
	BOOL	GetSynchronize( ) const {  return bSynchronize; }
	BOOL	GetGridVisible( ) const {  return bGridVisible; }
	BOOL	GetEqualGrid()	  const {  return bEqualGrid;   }
};

class SvxGridItem : public SvxOptionsGrid, public SfxPoolItem
{
	friend SvxGridTabPage;

public:
	SvxGridItem( USHORT nWhich) : SfxPoolItem(nWhich){};
	SvxGridItem( const SvxGridItem& pTestItem );

	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;
	virtual int             operator==( const SfxPoolItem& ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

};

class SvxGridTabPage : public SfxTabPage
{
public:
	SvxGridTabPage( Window* pParent, const SfxItemSet& rSet );

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );

	virtual void 		ActivatePage( const SfxItemSet& rSet );
	virtual int  		DeactivatePage( SfxItemSet* pSet );

private:
	CheckBox			aCbxUseGridsnap;
	CheckBox			aCbxGridVisible;

	FixedText			aFtResolution;
	FixedText			aFtDrawX;
	MetricField			aMtrFldDrawX;
	FixedText			aFtDrawY;
	MetricField			aMtrFldDrawY;
	FixedText			aFtDivision;
	MetricField			aMtrFldDivisionX;
	MetricField			aMtrFldDivisionY;
	CheckBox			aCbxSynchronize;
	FixedLine           aGrpDrawGrid; 

protected:
	 FixedLine       aGrpSnap;
	CheckBox        aCbxSnapHelplines;
	CheckBox		aCbxSnapBorder;
	CheckBox		aCbxSnapFrame;
	CheckBox		aCbxSnapPoints;
	FixedText		aFtSnapArea;
	MetricField 	aMtrFldSnapArea;
	 FixedLine       aSeparatorFL;
	 FixedLine       aGrpOrtho;
	CheckBox        aCbxOrtho;
	CheckBox		aCbxBigOrtho;
	CheckBox		aCbxRotate;
	MetricField 	aMtrFldAngle;
	FixedText		aFtBezAngle;
	MetricField 	aMtrFldBezAngle;

private:
	BOOL                bAttrModified;
	BOOL				bEqualGrid; 

#ifdef _SVX_OPTGRID_CXX
	DECL_LINK( ClickRotateHdl_Impl, void * );
	DECL_LINK( ChangeDrawXHdl_Impl, void * );
	DECL_LINK( ChangeDrawYHdl_Impl, void * );
	DECL_LINK( ChangeSnapXHdl_Impl, void * );
	DECL_LINK( ChangeSnapYHdl_Impl, void * );
	DECL_LINK( ChangeGridsnapHdl_Impl, void * );
	DECL_LINK( ChangeDivisionXHdl_Impl, void * );
	DECL_LINK( ChangeDivisionYHdl_Impl, void * );

#endif
};

#endif

