
#ifndef _SVX_OPTINET_HXX
#define _SVX_OPTINET_HXX

#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
#ifndef _SVARRAY_HXX
#include <svtools/svarray.hxx>
#endif
#ifndef _STDCTRL_HXX 
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SVTABBX_HXX 
#include <svtools/svtabbx.hxx>
#endif
#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif
#ifndef _SVX_SRCHNCFG_HXX
#include <svx/srchcfg.hxx>
#endif

#ifdef _SVX_OPTINET2_CXX
#ifndef _HEADBAR_HXX 
#include <svtools/headbar.hxx>
#endif
#else
class HeaderBar;
#endif

class SfxFilter;

#ifndef SV_NODIALOG
#define PROXY_CONTROLS 	23
#define CACHE_CONTROLS 	20
#define INET_SEARCH 	19

#if defined(OS2) || defined(MAC)
#define TYPE_CONTROLS  20
#else
#define TYPE_CONTROLS  18
#endif

class SvxNoSpaceEdit : public Edit
{
private:
	BOOL			bOnlyNumeric;

public:
	SvxNoSpaceEdit(Window* pParent, ResId rResId, BOOL bNum = FALSE ) :
		Edit( pParent, rResId ), bOnlyNumeric( bNum ) {}

	virtual void	KeyInput( const KeyEvent& rKEvent );
	virtual void	Modify();
};

typedef SfxFilter* SfxFilterPtr;
SV_DECL_PTRARR( SfxFilterPtrArr, SfxFilterPtr, 0, 4 )

class SvxProxyTabPage : public SfxTabPage
{
private:
	FixedLine       aOptionGB;

	FixedText 		aProxyModeFT;
	ListBox			aProxyModeLB;

	FixedText		aHttpProxyFT;
	SvxNoSpaceEdit	aHttpProxyED;
	FixedText		aHttpPortFT;
	SvxNoSpaceEdit 	aHttpPortED;

	FixedText		aFtpProxyFT;
	SvxNoSpaceEdit	aFtpProxyED;
	FixedText		aFtpPortFT;
	SvxNoSpaceEdit 	aFtpPortED;

	FixedText		aSocksProxyFT;
	SvxNoSpaceEdit	aSocksProxyED;
	FixedText		aSocksPortFT;
	SvxNoSpaceEdit 	aSocksPortED;

	FixedText		aNoProxyForFT;
	Edit			aNoProxyForED;
	FixedText		aNoProxyDescFT;
	 FixedLine            aDNSGB;
	RadioButton			aDNSAutoRB;
	RadioButton			aDNSManualRB;
	PatternField		aDNSED;

	FixedText			aSendFT;
	Edit				aSendED;
	 FixedLine            aServerGB;

	String				sMsg255_0;
	String				sMsg255_1;

#ifdef _SVX_OPTINET2_CXX
	DECL_LINK( AutoDNSHdl_Impl, RadioButton* );
	void 			EnableControls_Impl(BOOL bEnable);

	DECL_LINK( ProxyHdl_Impl, ListBox * );
	DECL_LINK( LoseFocusHdl_Impl, Edit * );
#endif

	SvxProxyTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual ~SvxProxyTabPage();

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

class SvxSearchConfig;
class SvxSearchTabPage : public SfxTabPage
{
private:
	FixedLine       aSearchGB;
	ListBox			aSearchLB;
	FixedText		aSearchNameFT;
	SvxNoSpaceEdit	aSearchNameED;

	FixedText		aSearchFT;
	RadioButton		aAndRB;
	RadioButton		aOrRB;
	RadioButton		aExactRB;

	FixedText		aURLFT;
	SvxNoSpaceEdit	aURLED;

	FixedText		aPostFixFT;
	SvxNoSpaceEdit	aPostFixED;
	FixedText		aSeparatorFT;
	SvxNoSpaceEdit	aSeparatorED;
	FixedText		aCaseFT;
	ListBox	 		aCaseED;

	PushButton		aNewPB;
	PushButton		aAddPB;
	PushButton		aChangePB;
	PushButton		aDeletePB;

	String 			sLastSelectedEntry;
	String          sModifyMsg;
	 SvxSearchConfig     aSearchConfig;
	SvxSearchEngineData aCurrentSrchData;

#ifdef _SVX_OPTINET2_CXX
	void 			FillSearchBox_Impl();
	String 			GetSearchString_Impl();

	DECL_LINK( NewSearchHdl_Impl, PushButton * );
	DECL_LINK( AddSearchHdl_Impl, PushButton * );
	DECL_LINK( ChangeSearchHdl_Impl, PushButton * );
	DECL_LINK( DeleteSearchHdl_Impl, PushButton * );
	DECL_LINK( SearchEntryHdl_Impl, ListBox * );
	DECL_LINK( SearchModifyHdl_Impl, SvxNoSpaceEdit * );
	DECL_LINK( SearchPartHdl_Impl, RadioButton * );
#endif
	 virtual void        ActivatePage( const SfxItemSet& rSet );
	virtual int         DeactivatePage( SfxItemSet* pSet = 0 );

	SvxSearchTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual ~SvxSearchTabPage();

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

class SvtJavaOptions;
class SvxScriptingTabPage : public SfxTabPage
{
private:
	 FixedLine           aGrpScriptExec;
	Edit                aEdtScriptExec;
	ListBox				aLbScriptExec;
	PushButton			aBtnScriptExecInsert;
	PushButton			aBtnScriptExecDelete;
	PushButton			aBtnScriptExecDefault;
	 FixedLine           aGrpScriptingStarBasic;
	RadioButton         aRbtExecStarBasicList;
	RadioButton         aRbtExecStarBasicAlways;
	RadioButton         aRbtExecStarBasicNever;
	 FixedInfo           aFiExecStarBasicAlways;
	FixedInfo    		aFiExecStarBasicList;
	FixedInfo    		aFiExecStarBasicNever;
	 FixedLine           aJavaFL;
	CheckBox            aJavaEnableCB;
	CheckBox            aJavaSecurityCB;
	FixedText           aNetAccessFT;
	ListBox             aNetAccessLB;
	FixedText           aClassPathFT;
	Edit                aClassPathED;
	PushButton          aClassPathPB;
	 FixedLine           aSeparatorFL;
	 FixedLine           aExecuteGB;
	CheckBox			aExePlugCB;
	CheckBox            aExecAppletsCB;
	 SvtJavaOptions*     pJavaOptions;
#ifdef _SVX_OPTINET2_CXX
	DECL_LINK( EditHdl_Impl, Edit* );
	DECL_LINK( LBHdl_Impl, ListBox* );
	DECL_LINK( BtnHdl_Impl, PushButton* );
	DECL_LINK( RadioBtnHdl_Impl, RadioButton* );
	DECL_LINK( JavaEnableHdl_Impl, CheckBox* );
	DECL_LINK( ClassPathHdl_Impl, PushButton* );

	void				FillListBox_Impl();
	void                EnableJava_Impl( BOOL bEnable );
#endif
	SvxScriptingTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual 	~SvxScriptingTabPage();

protected:
	virtual void        ActivatePage( const SfxItemSet& rSet );
	virtual int         DeactivatePage( SfxItemSet* pSet = 0 );

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

#endif

#endif 

