

#ifndef _SVX_OPTJSEARCH_HXX_
#define _SVX_OPTJSEARCH_HXX_

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SFXTABDLG_HXX
#include <sfx2/tabdlg.hxx>
#endif

class Window;
class SfxItemSet;

class SvxJSearchOptionsPage : public SfxTabPage
{
private:
	FixedLine	aTreatAsEqual;
	CheckBox	aMatchCase;
	CheckBox	aMatchFullHalfWidth;
	CheckBox	aMatchHiraganaKatakana;
	CheckBox	aMatchContractions;
	CheckBox	aMatchMinusDashChoon;
	CheckBox	aMatchRepeatCharMarks;
	CheckBox	aMatchVariantFormKanji;
	CheckBox	aMatchOldKanaForms;
	CheckBox	aMatchDiziDuzu;
	CheckBox	aMatchBavaHafa;
	CheckBox	aMatchTsithichiDhizi;
	CheckBox	aMatchHyuiyuByuvyu;
	CheckBox	aMatchSesheZeje;
	CheckBox	aMatchIaiya;
	CheckBox	aMatchKiku;
	FixedLine	aIgnore;
	CheckBox	aIgnorePunctuation;
	CheckBox	aIgnoreWhitespace;
	CheckBox	aIgnoreProlongedSoundMark;
	CheckBox	aIgnoreMiddleDot;

	INT32		nTransliterationFlags;
	BOOL		bSaveOptions;

	INT32				GetTransliterationFlags_Impl();

protected:
			SvxJSearchOptionsPage( Window* pParent, const SfxItemSet& rSet );

public:
			~SvxJSearchOptionsPage();

	static SfxTabPage*  Create( Window* pParent, const SfxItemSet& rSet );

	virtual void        Reset( const SfxItemSet& rSet );
	virtual BOOL        FillItemSet( SfxItemSet& rSet );

	BOOL				IsSaveOptions() const			{ return bSaveOptions; }
	void				EnableSaveOptions( BOOL bVal )	{ bSaveOptions = bVal; }

	INT32				GetTransliterationFlags() const	{ return nTransliterationFlags; }
	void				SetTransliterationFlags( INT32 nSettings );
};

#endif

