

#ifndef _E3D_PNTOBJ3D_HXX
#define _E3D_PNTOBJ3D_HXX

#ifndef _E3D_OBJ3D_HXX
#include <svx/obj3d.hxx>
#endif

class E3dPointObj : public E3dObject
{
 protected:
	Vector3D	aPosition;
	Vector3D	aTransPos;

	FASTBOOL	bTransPosValid	: 1;

	virtual void SetTransformChanged();

 public:
	TYPEINFO();
	E3dPointObj(const Vector3D& rPos);
	E3dPointObj();

	virtual UINT16 GetObjIdentifier() const;

	virtual void SetPosition(const Vector3D& rNewPos);
	const Vector3D& GetPosition() const { return aPosition; }
	const Vector3D& GetTransPosition();

	virtual void WriteData(SvStream& rOut) const;
	virtual void ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);

	virtual void operator=(const SdrObject&);
};

#endif			
