

#ifndef _E3D_POLYGON3D_HXX
#define _E3D_POLYGON3D_HXX

#ifndef _E3D_OBJ3D_HXX
#include <svx/obj3d.hxx>
#endif

#ifndef _POLY3D_HXX
#include <svx/poly3d.hxx>
#endif

class E3dPolygonObj : public E3dCompoundObject
{
private:

	PolyPolygon3D	aPolyPoly3D;
	PolyPolygon3D	aPolyNormals3D;
	PolyPolygon3D	aPolyTexture3D;
	BOOL			bLineOnly;

	void CreateDefaultNormals();
	void CreateDefaultTexture();

public:
	void SetPolyPolygon3D(const PolyPolygon3D& rNewPolyPoly3D);
	void SetPolyNormals3D(const PolyPolygon3D& rNewPolyPoly3D);
	void SetPolyTexture3D(const PolyPolygon3D& rNewPolyPoly3D);

	TYPEINFO();

	E3dPolygonObj(E3dDefaultAttributes& rDefault, const PolyPolygon3D& rPoly3D,
		BOOL bLinOnly=FALSE);
	E3dPolygonObj(E3dDefaultAttributes& rDefault, const PolyPolygon3D& rPoly3D,
		const PolyPolygon3D& rVector3D, BOOL bLinOnly=FALSE);
	E3dPolygonObj(E3dDefaultAttributes& rDefault, const PolyPolygon3D& rPoly3D,
		const PolyPolygon3D& rVector3D, const PolyPolygon3D& rNormal3D, BOOL bLinOnly=FALSE);
	E3dPolygonObj(E3dDefaultAttributes& rDefault, const Vector3D& rP1,
		const Vector3D& rP2, BOOL bLinOnly=TRUE);

	E3dPolygonObj();
	virtual ~E3dPolygonObj();

	const PolyPolygon3D& GetPolyPolygon3D() const { return aPolyPoly3D; }
	const PolyPolygon3D& GetPolyNormals3D() const { return aPolyNormals3D; }
	const PolyPolygon3D& GetPolyTexture3D() const { return aPolyTexture3D; }

	virtual UINT16 GetObjIdentifier() const;
	virtual void CreateWireframe(Polygon3D& rWirePoly, const Matrix4D* pTf = NULL,
		E3dDragDetail eDetail = E3DDETAIL_DEFAULT);
	virtual SdrObject* DoConvertToPolyObj(BOOL bBezier) const;

	virtual void operator=(const SdrObject&);
	virtual void WriteData(SvStream& rOut) const;
	virtual void ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);

	virtual void CreateGeometry();

	virtual void GetLineGeometry(PolyPolygon3D& rLinePolyPolygon) const;

	BOOL GetLineOnly() { return bLineOnly; }
	void SetLineOnly(BOOL bNew);
};

#endif			
