

#ifndef _E3D_POLYSC3D_HXX
#define _E3D_POLYSC3D_HXX

#ifndef _SVDPAGE_HXX
#include <svx/svdpage.hxx>
#endif

#ifndef _E3D_SCENE3D_HXX
#include <svx/scene3d.hxx>
#endif

#ifndef _B3D_HMATRIX_HXX
#include <goodies/hmatrix.hxx>
#endif

class E3dPolyScene : public E3dScene
{
public:
	TYPEINFO();
	E3dPolyScene();
	E3dPolyScene(E3dDefaultAttributes& rDefault);

	virtual UINT16 GetObjIdentifier() const;

	virtual FASTBOOL Paint(ExtOutputDevice&, const SdrPaintInfoRec&) const;

	virtual void TakeContour(XPolyPolygon& rPoly) const;
	virtual void TakeContour3D(XPolyPolygon& rPoly);

	virtual void Paint3D(ExtOutputDevice& rOut, Base3D* pBase3D,
		const SdrPaintInfoRec& rInfoRec, UINT16 nDrawFlags=0);

protected:
	void DrawAllShadows(Base3D *pBase3D, ExtOutputDevice& rXOut,
		const Rectangle& rBound, const Volume3D& rVolume,
		const SdrPaintInfoRec& rInfoRec);

	BOOL LocalPaint3D(ExtOutputDevice& rOut, const SdrPaintInfoRec& rInfoRec);

	void DrawPolySceneClip(ExtOutputDevice& rOut, const E3dObject *p3DObj,
		Base3D *pBase3D, const SdrPaintInfoRec& rInfoRec);

	void DrawWireframe(Base3D *pBase3D, ExtOutputDevice& rXOut);
};

#endif          
