
#ifndef _SVX_POSTATTR_HXX
#define _SVX_POSTATTR_HXX

#ifndef _SFXSTRITEM_HXX 
#include <svtools/stritem.hxx>
#endif

#ifdef ITEMID_AUTHOR

class SvxPostItAuthorItem: public SfxStringItem
{
public:
	TYPEINFO();

	SvxPostItAuthorItem( USHORT nWhich = ITEMID_AUTHOR );

	SvxPostItAuthorItem( const String& rAuthor, USHORT nWhich = ITEMID_AUTHOR );
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;

	inline SvxPostItAuthorItem& operator=( const SvxPostItAuthorItem& rAuthor )
	{
		SetValue( rAuthor.GetValue() );
		return *this;
	}
};
#endif

#ifdef ITEMID_DATE

class SvxPostItDateItem: public SfxStringItem
{
public:
	TYPEINFO();

	SvxPostItDateItem( USHORT nWhich = ITEMID_DATE );

	SvxPostItDateItem( const String& rDate, USHORT nWhich = ITEMID_DATE );
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;
	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;

	inline SvxPostItDateItem& operator=( const SvxPostItDateItem& rDate )
	{
		SetValue( rDate.GetValue() );
		return *this;
	}
};
#endif

#ifdef ITEMID_TEXT

class SvxPostItTextItem: public SfxStringItem
{
public:
	TYPEINFO();

	SvxPostItTextItem( USHORT nWhich = ITEMID_TEXT );

	SvxPostItTextItem( const String& rText, USHORT nWhich = ITEMID_TEXT );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;

	inline SvxPostItTextItem& operator=( const SvxPostItTextItem& rText )
	{
		SetValue( rText.GetValue() );
		return *this;
	}
};
#endif

#endif

