
#ifndef _SVX_POSTITEM_HXX
#define _SVX_POSTITEM_HXX

#ifndef _SV_FONTTYPE_HXX 
#include <vcl/fonttype.hxx>
#endif
#ifndef _SFXENUMITEM_HXX 
#include <svtools/eitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

class SvXMLUnitConverter;
#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

class SvxPostureItem : public SfxEnumItem
{
public:
	TYPEINFO();

	SvxPostureItem( const FontItalic ePost = ITALIC_NONE,
		const USHORT nId = ITEMID_POSTURE );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*    Create(SvStream &, USHORT) const;
	virtual SvStream&		Store(SvStream &, USHORT nItemVersion) const;
	virtual String			GetValueTextByPos( USHORT nPos ) const;
	virtual USHORT          GetValueCount() const;

	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

	virtual int 			HasBoolValue() const;
	virtual BOOL			GetBoolValue() const;
	virtual void			SetBoolValue( BOOL bVal );

	inline SvxPostureItem& operator=(const SvxPostureItem& rPost) {
		SetValue( rPost.GetValue() );
		return *this;
	}

	FontItalic				GetPosture() const
					{ return (FontItalic)GetValue(); }
	void					SetPosture( FontItalic eNew )
					{ SetValue( (USHORT)eNew ); }
};

#endif 

