
#ifndef _SVX_PROTITEM_HXX
#define _SVX_PROTITEM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif

class SvXMLUnitConverter;
#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

class SvxProtectItem : public SfxPoolItem
{
	BOOL bCntnt :1;     
	BOOL bSize  :1;     
	BOOL bPos   :1;     

public:
	TYPEINFO();

	inline SvxProtectItem( const USHORT nId = ITEMID_PROTECT );
	inline SvxProtectItem &operator=( const SvxProtectItem &rCpy );

	virtual int 			 operator==( const SfxPoolItem& ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*     Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	 Create(SvStream &, USHORT) const;
	virtual SvStream&		 Store(SvStream &, USHORT nItemVersion ) const;

	BOOL IsCntntProtected() const { return bCntnt; }
	BOOL IsSizeProtected()  const { return bSize;  }
	BOOL IsPosProtected()   const { return bPos;   }
	void SetCntntProtect( BOOL bNew ) { bCntnt = bNew; }
	void SetSizeProtect ( BOOL bNew ) { bSize  = bNew; }
	void SetPosProtect  ( BOOL bNew ) { bPos   = bNew; }

	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );
};

inline SvxProtectItem::SvxProtectItem( const USHORT nId )
	: SfxPoolItem( nId )
{
	bCntnt = bSize = bPos = FALSE;
}

inline SvxProtectItem &SvxProtectItem::operator=( const SvxProtectItem &rCpy )
{
	bCntnt = rCpy.IsCntntProtected();
	bSize  = rCpy.IsSizeProtected();
	bPos   = rCpy.IsPosProtected();
	return *this;
}

#endif

