
#ifndef _SVX_RELFLD_HXX
#define _SVX_RELFLD_HXX

#ifndef _FIELD_HXX 
#include <vcl/field.hxx>
#endif

class SvxRelativeField : public MetricField
{
private:
	USHORT          nRelMin;
	USHORT          nRelMax;
	USHORT          nRelStep;
	BOOL            bRelativeMode;
	BOOL            bRelative;
	BOOL            bNegativeEnabled;

protected:
	void            Modify();

public:
	SvxRelativeField( Window* pParent, WinBits nWinStyle = 0 );
	SvxRelativeField( Window* pParent, const ResId& rResId );

	void            EnableRelativeMode( USHORT nMin = 50, USHORT nMax = 150,
							USHORT nStep = 5 );
	BOOL            IsRelativeMode() const { return bRelativeMode; }
	void            SetRelative( BOOL bRelative = FALSE );
	BOOL            IsRelative() const { return bRelative; }
	void            EnableNegativeMode() {bNegativeEnabled = TRUE;}
};

#endif

