
#ifndef _SVX_SPLDLG_HXX
#define _SVX_SPLDLG_HXX

#ifndef _BASEDLGS_HXX 
#include <sfx2/basedlgs.hxx>
#endif

#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif

#ifndef _EDIT_HXX 
#include <vcl/edit.hxx>
#endif

#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif

#ifndef _STDCTRL_HXX 
#include <svtools/stdctrl.hxx>
#endif

#ifndef _BUTTON_HXX 
#include <vcl/button.hxx>
#endif

#ifndef _MENUBTN_HXX 
#include <vcl/menubtn.hxx>
#endif

#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif

#ifndef _SV_DECOVIEW_HXX 
#include <vcl/decoview.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif

#ifndef _SVX_BOX_HXX 
#include <svx/svxbox.hxx>
#endif
#ifndef _SVX_LANGBOX_HXX
#include <svx/langbox.hxx>
#endif

namespace com{namespace sun{namespace star{
namespace linguistic2{
	class XSpellChecker1;
}}}}

class SvxSpellWrapper;
class Menu;
struct SpellCheckDlg_Impl;
class SvxSpellCheckDialog;

void SvxPrepareAutoCorrect( String &rOldText, String &rNewText );

class SvxClickInfoCtr: public Control
{
private:
	SvxSpellCheckDialog*	pMyParent;
	FixedInfo				aFixedInfo;
	Link					aActivateLink;

public:
	SvxClickInfoCtr( SvxSpellCheckDialog* pParent, const ResId& rResId );
	~SvxClickInfoCtr();

	virtual void		SetText( const XubString& rStr );
	virtual XubString	GetText() const;

	void				SetActivateHdl( const Link& rLink ) { aActivateLink = rLink; }
	const Link&			GetActivateHdl() const { return aActivateLink; }

protected:
	virtual void		MouseButtonDown( const MouseEvent& rMEvt );
	virtual long		PreNotify( NotifyEvent& rNEvt );

};

class SvxSpellCheckDialog : public SfxModalDialog
{
private:
	FixedText       aWordText;
	SvxClickInfoCtr aAktWord;
	FixedText       aNewWord;
	Edit            aNewWordED;
	FixedImage 		aStateImage;
	ImageButton     aTestBtn;
	FixedText		aSuggestionFT;
	ListBox         aNewWordLB;
	FixedText       aLanguageText;
	SvxLanguageBox  aLangLB;
	FixedText       aBookText;
	SvxListBox      aBookDLB;
	PushButton      aAddBtn;
	DecorationView	aDecoView;
	GroupBox        aAuditBox;

	PushButton      aIgnoreBtn;
	PushButton      aIgnoreAllBtn;
	PushButton      aChangeBtn;
	PushButton      aChangeAllBtn;
	PushButton      aAutoCorrBtn;
	PushButton      aThesBtn;
	PushButton      aOptionsBtn;
	CancelButton    aCancelBtn;
	CheckBox		aBackWdBox;
	HelpButton      aHelpBtn;

	FixedInfo       aStatusText;

	short           nActDict;
	String          aTitel;
	Image			aFalseStateIm;
	Image			aTrueStateIm;
	Size			aOldWordEDSize;
	sal_Bool		bModified;
	String			aErrorStr;
	String			aStateStr;

	SpellCheckDlg_Impl* pImpl;
	::com::sun::star::uno::Reference< 
		::com::sun::star::linguistic2::XSpellChecker1 > 	xSpell;
	String				aOldWord;
	LanguageType		nOldLang;

#ifdef _SVX_SPLDLG_CXX
	DECL_LINK( ChgHdl, Button * );
	DECL_LINK( ChgAllHdl, Button * );
	DECL_LINK( IgnAllHdl, Button * );
	DECL_LINK( IgnHdl, Button * );
	DECL_LINK( AddHdl, Button * );
	DECL_LINK( ExtClickHdl, Button * );
	DECL_LINK( CancelHdl, Button * );
	DECL_LINK( WordSelectHdl, ListBox * );
	DECL_LINK( SelectHdl, ListBox * );
	DECL_LINK( DirectionHdl, CheckBox * );
	DECL_LINK( AuditHdl, Button * );
	DECL_LINK(ModifyHdl, Edit *);
	DECL_LINK(ClickHdl, SvxClickInfoCtr *);
	DECL_LINK(ErrorHdl, void* );

	void            Audit_Impl();
	void            StartSpellOptDlg_Impl();
	void            InitUserDicts();
	void            UpdateBoxes_Impl();
	void            Init_Impl();
	void            SpellContinue_Impl();
	void            StartThesaurus_Impl( sal_Bool bInter = sal_False );
	String          AddPreAndPost_Impl( const String& rStr );

	void			SetAddBtnHelp(const String& rString);
	void			SetChangesHelp(const String& rString);
	void			SetIgnoreHelp(const String& rString);

	void			SetSelectedLang_Impl( LanguageType nLang );
	LanguageType	GetSelectedLang_Impl() const;
#endif

protected:

	virtual void	Paint( const Rectangle& rRect );

public:
	SvxSpellCheckDialog( Window* pParent,
			::com::sun::star::uno::Reference< 
	::com::sun::star::linguistic2::XSpellChecker1 >  &xChecker, 
			SvxSpellWrapper* pWrapper );
	~SvxSpellCheckDialog();

	String			GetNewEditWord(){ return aNewWordED.GetText(); }
	void			SetNewEditWord( const String& rNew )
			{ aNewWordED.SetText( rNew ); }
	void			HideAutoCorrect();
	void			SetLanguage( sal_uInt16 nLang );
	virtual sal_Bool	Close();

};

#endif

