

#ifndef _SVDETC_HXX
#define _SVDETC_HXX

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif

#ifndef _GDIOBJ_HXX 
#include <vcl/gdiobj.hxx>
#endif

#ifndef _CONTNR_HXX 
#include <tools/contnr.hxx>
#endif

#ifndef _OUTDEV_HXX 
#include <vcl/outdev.hxx>
#endif

#ifndef _SHL_HXX 
#include <tools/shl.hxx>
#endif

#ifndef _OUTLINER_HXX 
#include <svx/outliner.hxx>
#endif

class SdrOutliner;
class SdrModel;
class CharClass;
class LocaleDataWrapper;

namespace com { namespace sun { namespace star { namespace lang {
	struct Locale;
}}}}

class SdrEngineDefaults
{
friend class SdrAttrObj;
	String     aFontName;
	FontFamily eFontFamily;
	Color      aFontColor;
	ULONG      nFontHeight;
	MapUnit    eMapUnit;
	Fraction   aMapFraction;

private:
	static SdrEngineDefaults& GetDefaults();

public:
	SdrEngineDefaults();

	static void       SetFontName(const String& rFontName) { GetDefaults().aFontName=rFontName; }
	static String     GetFontName()                        { return GetDefaults().aFontName; }

	static void       SetFontFamily(FontFamily eFam)       { GetDefaults().eFontFamily=eFam; }
	static FontFamily GetFontFamily()                      { return GetDefaults().eFontFamily; }

	static void       SetFontColor(const Color& rColor)    { GetDefaults().aFontColor=rColor; }
	static Color      GetFontColor()                       { return GetDefaults().aFontColor; }

	static void       SetFontHeight(ULONG nHeight)         { GetDefaults().nFontHeight=nHeight; }
	static ULONG      GetFontHeight()                      { return GetDefaults().nFontHeight; }

	static void       SetMapUnit(MapUnit eMap)             { GetDefaults().eMapUnit=eMap; }
	static MapUnit    GetMapUnit()                         { return GetDefaults().eMapUnit; }

	static void       SetMapFraction(const Fraction& rMap) { GetDefaults().aMapFraction=rMap; }
	static Fraction   GetMapFraction()                     { return GetDefaults().aMapFraction; }

	static void       LanguageHasChanged();

	friend SdrOutliner* SdrMakeOutliner( USHORT nOutlinerMode, SdrModel* pMod );
};

class SfxItemSet;

FASTBOOL GetDraftFillColor(const SfxItemSet& rSet, Color& rCol);

class UShortCont {
	Container aArr;
public:
	UShortCont(USHORT nBlock, USHORT nInit, USHORT nResize): aArr(nBlock,nInit,nResize) {}
	void   Clear()                                           { aArr.Clear(); }
	void   Insert(USHORT nElem, ULONG nPos=CONTAINER_APPEND) { aArr.Insert((void*)ULONG(nElem),nPos); }
	void   Remove(ULONG nPos)                                { aArr.Remove(nPos); }
	void   Replace(USHORT nElem, ULONG nPos)                 { aArr.Replace((void*)ULONG(nElem),nPos); }
	USHORT GetObject(ULONG nPos)                       const { return USHORT(ULONG(aArr.GetObject(nPos))); }
	ULONG  GetPos(USHORT nElem)                        const { return aArr.GetPos((void*)(ULONG)nElem); }
	ULONG  GetCount()                                  const { return aArr.Count(); }
	void   Sort();
};

class ContainerSorter {
protected:
	Container& rCont;
private:
#if 0 // _SOLAR__PRIVATE
	void ImpSubSort(long nL, long nR) const;
#endif 
public:
	ContainerSorter(Container& rNewCont): rCont(rNewCont) {}
#if SUPD>358
	void DoSort(ULONG a=0, ULONG b=0xFFFFFFFF) const;
#else
	void DoSort();
	void DoSort(ULONG a, ULONG b=0xFFFFFFFF) const;
#endif
#ifdef This_Is_Just_For_A_Comment
	Compare() muss returnieren:
	  -1 falls *pElem1<*pElem2
	0 falls *pElem1=*pElem2
	  +1 falls *pElem1>*pElem2
#endif
	virtual int Compare(const void* pElem1, const void* pElem2) const=NULL;
private: 
virtual
#if SUPD <= 355
		FASTBOOL
#else
		void
#endif
	 Is1stLessThan2nd(const void* pElem1, const void* pElem2) const;

};

#if 0 // _SOLAR__PRIVATE
#define SDRHDC_SAVEPEN                1 
#define SDRHDC_SAVEBRUSH              2 
#define SDRHDC_SAVEFONT               4 
#define SDRHDC_SAVEPENANDBRUSH        3 
#define SDRHDC_SAVEPENANDBRUSHANDFONT 7 
#define SDRHDC_SAVECLIPPING           8 
#define SDRHDC_SAVEALL               15 

class ImpClipMerk;
class ImpColorMerk;
class ImpSdrHdcMerk
{
	ImpColorMerk* pFarbMerk;
	ImpClipMerk*  pClipMerk;
	Color*		  pLineColorMerk;
	USHORT        nMode;
public:
	ImpSdrHdcMerk(const OutputDevice& rOut, USHORT nNewMode=SDRHDC_SAVEALL, FASTBOOL bAutoMerk=TRUE);
	~ImpSdrHdcMerk();
	void Save(const OutputDevice& rOut);
	FASTBOOL IsSaved() const                 { return pFarbMerk!=NULL || pClipMerk!=NULL || pLineColorMerk!=NULL; }
	void Restore(OutputDevice& rOut, USHORT nMask=SDRHDC_SAVEALL) const;
};
#endif 

BOOL SearchOutlinerItems(const SfxItemSet& rSet, BOOL bInklDefaults, BOOL* pbOnlyEE=NULL);

USHORT* RemoveWhichRange(const USHORT* pOldWhichTable, USHORT nRangeBeg, USHORT nRangeEnd);

class Link;

class SvdProgressInfo
{
private:
	ULONG nSumActionCount;	
	ULONG nSumCurAction;	

	ULONG nActionCount;		
	ULONG nCurAction;		

	ULONG nInsertCount;		
	ULONG nCurInsert;		

	ULONG nObjCount;		
	ULONG nCurObj;			

	Link *pLink;

public:
	SvdProgressInfo( Link *_pLink );

	void Init( ULONG _nSumActionCount, ULONG _nObjCount );

	BOOL SetNextObject();

	void SetActionCount( ULONG _nActionCount );
	void SetInsertCount( ULONG _nInsertCount );

	BOOL ReportActions( ULONG nAnzActions );
	BOOL ReportInserts( ULONG nAnzInserts );

	ULONG GetSumActionCount() const { return nSumActionCount; };
	ULONG GetSumCurAction() const { return nSumCurAction; };
	ULONG GetObjCount() const { return nObjCount; };
	ULONG GetCurObj() const { return nCurObj; };

	ULONG GetActionCount() const { return nActionCount; };
	ULONG GetCurAction() const { return nCurAction; };

	ULONG GetInsertCount() const { return nInsertCount; };
	ULONG GetCurInsert() const { return nCurInsert; };

	void ReportError();
	BOOL ReportRescales( ULONG nAnzRescales );
};

class SdrLinkList
{
	Container aList;
protected:
	unsigned FindEntry(const Link& rLink) const;
public:
	SdrLinkList(): aList(1024,4,4)        {}
	~SdrLinkList()                        { Clear(); }
	void Clear();
	unsigned GetLinkCount() const            { return (unsigned)aList.Count(); }
	Link& GetLink(unsigned nNum)             { return *((Link*)(aList.GetObject(nNum))); }
	const Link& GetLink(unsigned nNum) const { return *((Link*)(aList.GetObject(nNum))); }
	void InsertLink(const Link& rLink, unsigned nPos=0xFFFF);
	void RemoveLink(const Link& rLink);
	FASTBOOL HasLink(const Link& rLink) const { return FindEntry(rLink)!=0xFFFF; }
};

SdrLinkList& ImpGetUserMakeObjHdl();
SdrLinkList& ImpGetUserMakeObjUserDataHdl();

class SdrOle2Obj;
class AutoTimer;

class OLEObjCache : public Container
{
	ULONG				nSize;
	AutoTimer*          pTimer;

	BOOL UnloadObj( SdrOle2Obj* pObj );
	DECL_LINK( UnloadCheckHdl, AutoTimer* );

public:
	OLEObjCache();
	~OLEObjCache();

	void SetSize(ULONG nNewSize);
	void InsertObj(SdrOle2Obj* pObj);
	void RemoveObj(SdrOle2Obj* pObj);
};

class SdrGlobalData
{
public:
	SdrLinkList     	aUserMakeObjHdl;
	SdrLinkList     	aUserMakeObjUserDataHdl;
	SdrOutliner*       	pOutliner;
	SdrEngineDefaults* 	pDefaults;
	ResMgr*            	pResMgr;
	String*            	pStrCache;
	ULONG              	nExchangeFormat;
	OLEObjCache			aOLEObjCache;
	::com::sun::star::lang::Locale*	pLocale;
	CharClass*			            pCharClass;
	LocaleDataWrapper*	            pLocaleData;

public:
	SdrGlobalData();
	~SdrGlobalData();

	OLEObjCache& 		GetOLEObjCache() { return aOLEObjCache; }
};

inline SdrGlobalData& GetSdrGlobalData()
{
	void** ppAppData=GetAppData(SHL_SVD);
	if (*ppAppData==NULL) {
		*ppAppData=new SdrGlobalData;
	}
	return *((SdrGlobalData*)*ppAppData);
}

#endif 

