

#ifndef _SVDOBJ_HXX
#define _SVDOBJ_HXX

#ifndef _CPPUHELPER_WEAKREF_HXX_
#include <cppuhelper/weakref.hxx>
#endif

#ifndef _MAPMOD_HXX 
#include <vcl/mapmod.hxx>
#endif

#ifndef _SFXLSTNER_HXX 
#include <svtools/lstner.hxx>
#endif

#ifndef VCL
#ifndef _SV_TIMER_HXX
#include <vcl/timer.hxx>
#endif
#else
#ifndef _SV_TIMER_HXX
#include <vcl/timer.hxx>
#endif
#endif 

#ifndef _SVDSOB_HXX 
#include <svx/svdsob.hxx>
#endif

#ifndef _SVDTYPES_HXX
#include <svx/svdtypes.hxx> 
#endif

#ifndef _SVDGLUE_HXX
#include <svx/svdglue.hxx> 
#endif

#ifndef _SVX_XDASH_HXX
#include <svx/xdash.hxx>
#endif

#ifndef _XPOLY_HXX
#include <svx/xpoly.hxx>
#endif

#ifndef _POLY3D_HXX
#include <svx/poly3d.hxx>
#endif

#ifndef _XENUM_HXX
#include <svx/xenum.hxx>
#endif

class SfxBroadcaster;
class Pointer;
class AutoTimer;
class ExtOutputDevice;
class ImpSdrMtfAnimator;
class OutlinerParaObject;
class SdrOutliner;
class SdrDragStat;
class SdrHdl;
class SdrHdlList;
class SdrItemPool;
class SdrMiscSetItem;
class SdrModel;
class SdrObjIOHeader;
class SdrObjList;
class SdrObject;
class SdrOutlinerSetItem;
class SdrPage;
class SdrPageView;
class SdrShadowSetItem;
class SdrView;
class SfxItemSet;
class SfxSetItem;
class SfxStyleSheet;
class SfxUndoAction;
class XFillAttrSetItem;
class XLineAttrSetItem;
class XPolyPolygon;
class XPolygon;
class XTextAttrSetItem;
class SfxItemPool;
class PolyPolygon;
class SfxPoolItem;

enum SdrObjKind {OBJ_NONE       = 0,  
	 OBJ_GRUP       = 1,  
	 OBJ_LINE       = 2,  
	 OBJ_RECT       = 3,  
	 OBJ_CIRC       = 4,  
	 OBJ_SECT       = 5,  
	 OBJ_CARC       = 6,  
	 OBJ_CCUT       = 7,  
	 OBJ_POLY       = 8,  
	 OBJ_PLIN       = 9,  
	 OBJ_PATHLINE   =10,  
	 OBJ_PATHFILL   =11,  
	 OBJ_FREELINE   =12,  
	 OBJ_FREEFILL   =13,  
	 OBJ_SPLNLINE   =14,  
	 OBJ_SPLNFILL   =15,  
	 OBJ_TEXT       =16,  
	 OBJ_TEXTEXT    =17,  
	 OBJ_wegFITTEXT,      
	 OBJ_wegFITALLTEXT,   
	 OBJ_TITLETEXT  =20,  
	 OBJ_OUTLINETEXT=21,  
	 OBJ_GRAF       =22,  
	 OBJ_OLE2       =23,  
	 OBJ_EDGE       =24,  
	 OBJ_CAPTION    =25,  
	 OBJ_PATHPOLY   =26,  
	 OBJ_PATHPLIN   =27,  
	 OBJ_PAGE       =28,  
	 OBJ_MEASURE    =29,  
	 OBJ_DUMMY      =30,  
	 OBJ_FRAME      =31,  
	 OBJ_UNO        =32,  
	 OBJ_MAXI};

#define SDRPAINTMODE_MASTERPAGE		0x0001 
#define SDRPAINTMODE_TEXTEDIT		0x0002 
#define SDRPAINTMODE_DRAFTTEXT		0x0004 
#define SDRPAINTMODE_DRAFTGRAF		0x0008 
#define SDRPAINTMODE_GLUEPOINTS		0x0010 
#define SDRPAINTMODE_ANILIKEPRN		0x0020 
#define SDRPAINTMODE_HIDEDRAFTGRAF  0x0040 
#define SDRPAINTMODE_DRAFTLINE		0x0080 
#define SDRPAINTMODE_DRAFTFILL		0x0100 

enum SdrUserCallType {SDRUSERCALL_MOVEONLY,       	
		  SDRUSERCALL_RESIZE,         	
		  SDRUSERCALL_CHGATTR,  		
		  SDRUSERCALL_DELETE,   		
		  SDRUSERCALL_COPY,     		
		  SDRUSERCALL_INSERTED, 		
		  SDRUSERCALL_REMOVED,  		
		  SDRUSERCALL_CHILD_MOVEONLY, 	
		  SDRUSERCALL_CHILD_RESIZE,   	
		  SDRUSERCALL_CHILD_CHGATTR,  	
		  SDRUSERCALL_CHILD_DELETE,   	
		  SDRUSERCALL_CHILD_COPY,     	
		  SDRUSERCALL_CHILD_INSERTED, 	
		  SDRUSERCALL_CHILD_REMOVED}; 	

#define nLayerID nLayerId

class SdrObjUserCall
{
public:
	TYPEINFO();
	virtual ~SdrObjUserCall();
	virtual void Changed(const SdrObject& rObj, SdrUserCallType eType, const Rectangle& rOldBoundRect);
};

class SdrObjMacroHitRec
{
public:
	Point						aPos;
	Point						aDownPos;
	OutputDevice*				pOut;
	const SetOfByte*			pVisiLayer;
	const SdrPageView*			pPageView;
	USHORT						nTol;
	FASTBOOL					bDown;

public:
	SdrObjMacroHitRec()
	:	pOut(NULL),
		pVisiLayer(NULL),
		pPageView(NULL),
		nTol(0),
		bDown(FALSE)
	{}
};

class SdrObjUserData
{
protected:
	UINT32						nInventor;
	UINT16						nIdentifier;
	UINT16						nVersion;

private:
	void operator=(const SdrObjUserData& rData);        
	FASTBOOL operator==(const SdrObjUserData& rData) const; 
	FASTBOOL operator!=(const SdrObjUserData& rData) const; 

public:
	TYPEINFO();

	SdrObjUserData(UINT32 nInv, UINT16 nId, UINT16 nVer)
	:	nInventor(nInv),
		nIdentifier(nId),
		nVersion(nVer)
	{}
	SdrObjUserData(const SdrObjUserData& rData)
	:	nInventor(rData.nInventor),
		nIdentifier(rData.nIdentifier),
		nVersion(rData.nVersion)
	{}
	virtual ~SdrObjUserData();

	virtual SdrObjUserData* Clone(SdrObject* pObj1) const = NULL;
	UINT32  GetInventor() const { return nInventor; }
	UINT16  GetId() const { return nIdentifier; }
	virtual void WriteData(SvStream& rOut);
	virtual void ReadData(SvStream& rIn);

	virtual void AfterRead();

	virtual FASTBOOL HasMacro (const SdrObject* pObj) const;
	virtual SdrObject* CheckMacroHit (const SdrObjMacroHitRec& rRec, const SdrObject* pObj) const;
	virtual Pointer GetMacroPointer (const SdrObjMacroHitRec& rRec, const SdrObject* pObj) const;
	virtual void PaintMacro (ExtOutputDevice& rXOut, const Rectangle& rDirtyRect, const SdrObjMacroHitRec& rRec, const SdrObject* pObj) const;
	virtual FASTBOOL DoMacro (const SdrObjMacroHitRec& rRec, SdrObject* pObj);
	virtual XubString GetMacroPopupComment(const SdrObjMacroHitRec& rRec, const SdrObject* pObj) const;
};

class SdrObjUserDataList
{
	Container					aList;

public:
	SdrObjUserDataList()
	:	aList(1024,4,4)
	{}
	~SdrObjUserDataList() { Clear(); }

	void Clear();
	USHORT GetUserDataCount() const { return USHORT(aList.Count()); }
	SdrObjUserData* GetUserData(USHORT nNum) const { return (SdrObjUserData*)aList.GetObject(nNum); }
	void InsertUserData(SdrObjUserData* pData, USHORT nPos=0xFFFF) { aList.Insert(pData,nPos); }
	SdrObjUserData* RemoveUserData(USHORT nNum) { return (SdrObjUserData*)aList.Remove(nNum);}
	void DeleteUserData(USHORT nNum) { delete RemoveUserData(nNum); }
};

class SdrObjGeoData
{
public:
	Rectangle					aBoundRect;
	Point						aAnchor;
	SdrGluePointList*			pGPL;
	BOOL						bMovProt;
	BOOL						bSizProt;
	BOOL						bNoPrint;
	BOOL						bClosedObj;
	UINT16						nLayerId;

public:
	SdrObjGeoData();
	virtual ~SdrObjGeoData();
};

class SdrObjPlusData
{
	friend class				SdrObject;

public:
	SfxBroadcaster*				pBroadcast;    
	SdrObjUserDataList*			pUserDataList; 
	SdrGluePointList*			pGluePoints;   
	ImpSdrMtfAnimator*			pAnimator;     
	AutoTimer*					pAutoTimer;
	XubString					aObjName;      

	XubString					aHTMLName;

public:
	TYPEINFO();
	SdrObjPlusData();
	virtual ~SdrObjPlusData();
	virtual SdrObjPlusData* Clone(SdrObject* pObj1) const;

};

class SdrObjTransformInfoRec
{
public:
	unsigned					bSelectAllowed : 1;     
	unsigned					bMoveAllowed : 1;       
	unsigned					bResizeFreeAllowed : 1; 
	unsigned					bResizePropAllowed : 1; 
	unsigned					bRotateFreeAllowed : 1; 
	unsigned					bRotate90Allowed : 1;   
	unsigned					bMirrorFreeAllowed : 1; 
	unsigned					bMirror45Allowed : 1;   
	unsigned					bMirror90Allowed : 1;   
	unsigned					bTransparenceAllowed : 1; 
	unsigned					bGradientAllowed : 1; 
	unsigned					bShearAllowed : 1;      
	unsigned					bEdgeRadiusAllowed : 1;
	unsigned					bNoOrthoDesired : 1;    
	unsigned					bNoContortion : 1;      
	unsigned					bCanConvToPath : 1;     
	unsigned					bCanConvToPoly : 1;     
	unsigned					bCanConvToContour : 1;     
	unsigned					bCanConvToPathLineToArea : 1; 
	unsigned					bCanConvToPolyLineToArea : 1; 

public:
	SdrObjTransformInfoRec()
	:	bSelectAllowed(TRUE),
		bMoveAllowed(TRUE),
		bResizeFreeAllowed(TRUE),
		bResizePropAllowed(TRUE),
		bRotateFreeAllowed(TRUE),
		bRotate90Allowed(TRUE),
		bMirrorFreeAllowed(TRUE),
		bMirror45Allowed(TRUE),
		bMirror90Allowed(TRUE),
		bTransparenceAllowed(TRUE),
		bGradientAllowed(TRUE),
		bShearAllowed(TRUE),
		bEdgeRadiusAllowed(TRUE),
		bNoOrthoDesired(TRUE),
		bNoContortion(TRUE),
		bCanConvToPath(TRUE),
		bCanConvToPoly(TRUE),
		bCanConvToContour(FALSE),
		bCanConvToPathLineToArea(TRUE),
		bCanConvToPolyLineToArea(TRUE)
	{}
};

class SdrPaintInfoRec
{
public:
	SetOfByte					aPaintLayer;
	Rectangle					aDirtyRect;
	Rectangle					aCheckRect;
	const SdrPageView*			pPV;  
	const Link*					pPaintProc;
	const SdrObjList*			pAktList; 
	USHORT						nBrkEvent;
	USHORT						nPaintMode;
	UINT32						nOriginalDrawMode;

	BOOL						bPrinter;
	BOOL						bNotActive;
	BOOL						bOriginalDrawModeSet;

public:
	SdrPaintInfoRec()
	:	aPaintLayer(TRUE),
		pPV(NULL),
		pPaintProc(NULL),
		pAktList(NULL),
		nBrkEvent(0),
		nPaintMode(0),
		nOriginalDrawMode(0L),
		bPrinter(FALSE),
		bNotActive(TRUE),
		bOriginalDrawModeSet(FALSE)
	{}
};

class LineStyleParameterPack
{
	OutputDevice&				mrOut;
	XDash						aDash;

	XLineJoint					eLineJoint;
	XLineStyle					eLineStyle;

	const XPolygon&				rStartPolygon;
	const XPolygon&				rEndPolygon;

	INT32						nLineWidth;
	INT32						nStartWidth;
	INT32						nEndWidth;

	double*						pDotDashArray;
	double						fFullDashDotLen;
	double						fDegreeStepWidth;

	UINT16						nNumDotDashArray;

	BOOL						bStartCentered;
	BOOL						bEndCentered;
	BOOL						bForceNoArrowsLeft;
	BOOL						bForceNoArrowsRight;

public:
	LineStyleParameterPack(const SfxItemSet& rSet,
		BOOL bForceHair, OutputDevice& rOut);
	~LineStyleParameterPack();

	OutputDevice& GetOutDev() const { return mrOut; }
	INT32 GetLineWidth() const { return nLineWidth; }
	XLineStyle GetLineStyle() const { return eLineStyle; }

	INT32 GetStartWidth() const { return nStartWidth; }
	INT32 GetEndWidth() const { return nEndWidth; }

	const XPolygon& GetStartPolygon() const { return rStartPolygon; }
	const XPolygon& GetEndPolygon() const { return rEndPolygon; }

	double GetDegreeStepWidth() const { return fDegreeStepWidth; }

	XLineJoint GetLineJoint() const { return eLineJoint; }
	double GetLinejointMiterUpperBound() const { return 3.0; }

	XDashStyle GetDashStyle() const { return aDash.GetDashStyle(); }
	UINT16 GetDots() const { return aDash.GetDots(); }
	UINT32 GetDotLen() const { return aDash.GetDotLen(); }
	UINT16 GetDashes() const { return aDash.GetDashes(); }
	UINT32 GetDashLen() const { return aDash.GetDashLen(); }
	UINT32 GetDashDistance() const { return aDash.GetDistance(); }
	double GetFullDashDotLen() const { return fFullDashDotLen; }
	UINT16 GetFirstDashDotIndex(double fPos, double& rfDist) const;
	UINT16 GetNextDashDotIndex(UINT16 nInd, double& rfDist) const;

	BOOL IsStartCentered() const { return bStartCentered; }
	BOOL IsEndCentered() const { return bEndCentered; }

	BOOL IsStartActive() const { return (!bForceNoArrowsLeft && GetStartPolygon().GetPointCount() && GetStartWidth()); }
	BOOL IsEndActive() const { return (!bForceNoArrowsRight && GetEndPolygon().GetPointCount() && GetEndWidth()); }

	void ForceNoArrowsLeft(BOOL bNew) { bForceNoArrowsLeft = bNew; }
	void ForceNoArrowsRight(BOOL bNew) { bForceNoArrowsRight = bNew; }
};

class LineGeometryCreator
{
	const LineStyleParameterPack&		mrLineAttr;
	PolyPolygon3D&						mrPolyPoly3D;
	PolyPolygon3D&						mrPolyLine3D;
	BOOL								mbLineDraft;

	void ImpCreateLineGeometry(const Polygon3D& rSourcePoly);
	double ImpCreateLineStartEnd(Polygon3D& rArrowPoly, const Polygon3D& rSourcePoly, BOOL bFront, double fWantedWidth, BOOL bCentered);
	void ImpCreateSegmentsForLine(const Vector3D* pPrev, const Vector3D* pLeft, const Vector3D* pRight, const Vector3D* pNext, double fPolyPos);
	void ImpCreateLineSegment(const Vector3D* pPrev, const Vector3D* pLeft, const Vector3D* pRight, const Vector3D* pNext);
	double ImpSimpleFindCutPoint(const Vector3D& rEdge1Start, const Vector3D& rEdge1Delta, const Vector3D& rEdge2Start, const Vector3D& rEdge2Delta);

public:
	LineGeometryCreator(const LineStyleParameterPack& rAttr, PolyPolygon3D& rPoPo,
		PolyPolygon3D& rPoLi, BOOL bIsLineDraft = FALSE)
	:	mrLineAttr(rAttr),
		mrPolyPoly3D(rPoPo),
		mrPolyLine3D(rPoLi),
		mbLineDraft(bIsLineDraft)
	{
	}

	void AddPolygon3D(const Polygon3D& rPoly) { ImpCreateLineGeometry(rPoly); }
	const PolyPolygon3D& GetPolyPolygon3D() const { return mrPolyPoly3D; }
	const PolyPolygon3D& GetPolyLines3D() const { return mrPolyLine3D; }
	void Clear() { mrPolyPoly3D.Clear(); mrPolyLine3D.Clear(); }
};

class ImpLineGeometry
{
	PolyPolygon3D				maPolyPoly3D;
	PolyPolygon3D				maLinePoly3D;
	BOOL						mbForceOnePixel;
	BOOL						mbForceTwoPixel;

public:
	ImpLineGeometry(PolyPolygon3D& rPolyPoly, PolyPolygon3D& rLinePoly,
		BOOL bForceOnePixel, BOOL bForceTwoPixel)
	:	maPolyPoly3D(rPolyPoly),
		maLinePoly3D(rLinePoly),
		mbForceOnePixel(bForceOnePixel),
		mbForceTwoPixel(bForceTwoPixel)
	{}

	PolyPolygon3D& GetPolyPoly3D() { return maPolyPoly3D; }
	PolyPolygon3D& GetLinePoly3D() { return maLinePoly3D; }
	BOOL DoForceOnePixel() const { return mbForceOnePixel; }
	BOOL DoForceTwoPixel() const { return mbForceTwoPixel; }
};

class SdrBroadcastItemChange
{
	sal_uInt32					mnCount;
	void*						mpData;

public:
	SdrBroadcastItemChange(const SdrObject& rObj);
	~SdrBroadcastItemChange();

	sal_uInt32 GetRectangleCount() const { return mnCount; }
	const Rectangle& GetRectangle(sal_uInt32 nIndex) const;
};

class SdrObject: public SfxListener
{
	friend class				SdrObjListIter;
	friend class				SdrVirtObj;
	friend class				SdrRectObj;

	static SfxItemSet*			mpEmptyItemSet;

protected:
	Rectangle					aOutRect;     
	Point						aAnchor;      
	SdrObjList*					pObjList;     
	SdrPage*					pPage;
	SdrModel*					pModel;
	SdrObjUserCall*				pUserCall;
	SdrObjPlusData*				pPlusData;    

	UINT32						nOrdNum;      
	UINT16						nLayerId;

	BOOL						bVirtObj : 1;
	BOOL						bBoundRectDirty : 1;
	BOOL						bSnapRectDirty : 1;
	BOOL						bNetLock : 1;   
	BOOL						bInserted : 1;  
	BOOL						bGrouped : 1;   

	BOOL						bMovProt : 1; 
	BOOL						bSizProt : 1; 
	BOOL						bNoPrint : 1; 

	BOOL						bEmptyPresObj : 1;     
	BOOL						bNotPersistent : 1;    
	BOOL						bNeedColorRestore : 1; 

	BOOL						bNotVisibleAsMaster : 1;

	BOOL						bClosedObj : 1;
	BOOL						bWriterFlyFrame : 1;   
	BOOL						bIsEdge : 1;
	BOOL						bIs3DObj : 1;
	BOOL						bMarkProt : 1;  
	BOOL						bIsUnoObj : 1;
	BOOL						bNotMasterCachable : 1;

private:
	static SdrItemPool*			mpGlobalItemPool;
public:
	static SdrItemPool* GetGlobalDrawObjectItemPool();
private:
	static void FreeGlobalDrawObjectItemPool();

protected:
	void ImpDeleteUserData();
	SdrObjUserData* ImpGetMacroUserData() const;
	Rectangle ImpDragCalcRect(const SdrDragStat& rDrag) const;

	void ImpTakeDescriptionStr(USHORT nStrCacheID, String& rStr, USHORT nVal=0) const;

	void ImpForcePlusData() { if (pPlusData==NULL) pPlusData=NewPlusData(); }
	ImpSdrMtfAnimator* ImpGetMtfAnimator() const { return pPlusData!=NULL ? pPlusData->pAnimator : NULL; }
	ImpSdrMtfAnimator* ImpForceMtfAnimator();

	String GetWinkStr(long nWink, FASTBOOL bNoDegChar=FALSE) const;
	String GetMetrStr(long nVal, MapUnit eWantMap=MAP_MM, FASTBOOL bNoUnitChars=FALSE) const;

	virtual void SetRectsDirty(FASTBOOL bNotMyself=FALSE);

	virtual SdrObjPlusData* NewPlusData() const;

	::com::sun::star::uno::WeakReference< ::com::sun::star::uno::XInterface > mxUnoShape;

protected:

	virtual SdrObjGeoData* NewGeoData() const;
	virtual void SaveGeoData(SdrObjGeoData& rGeo) const;
	virtual void RestGeoData(const SdrObjGeoData& rGeo);

public:
	TYPEINFO();
	SdrObject();
	virtual ~SdrObject();

	virtual void SetObjList(SdrObjList* pNewObjList);
	SdrObjList* GetObjList() const { return pObjList; }

	virtual void SetPage(SdrPage* pNewPage);
	SdrPage* GetPage() const { return pPage; }

	virtual void SetModel(SdrModel* pNewModel);
	SdrModel* GetModel() const { return pModel; }
	SdrItemPool* GetItemPool() const;

	void AddListener(SfxListener& rListener);
	void RemoveListener(SfxListener& rListener);
	const SfxBroadcaster* GetBroadcaster() const { return pPlusData!=NULL ? pPlusData->pBroadcast : NULL; }

	virtual void AddReference(SdrVirtObj& rVrtObj);
	virtual void DelReference(SdrVirtObj& rVrtObj);
	virtual UINT32 GetObjInventor() const;
	virtual UINT16 GetObjIdentifier() const;
	virtual void TakeObjInfo(SdrObjTransformInfoRec& rInfo) const;
	virtual SdrLayerID GetLayer() const;

	virtual void   GetLayer(SetOfByte& rSet) const;
	virtual void   NbcSetLayer(SdrLayerID nLayer);
	virtual void   SetLayer(SdrLayerID nLayer);
	void SetUserCall(SdrObjUserCall* pUser) { pUserCall=pUser; }
	SdrObjUserCall* GetUserCall() const { return pUserCall; }
	void SendUserCall(SdrUserCallType eUserCall, const Rectangle& rBoundRect);

	virtual FASTBOOL HasRefPoint() const;
	virtual Point GetRefPoint() const;
	virtual void SetRefPoint(const Point& rPnt);

	virtual FASTBOOL HasSetName() const;
	virtual void SetName(const String& rStr);
	virtual String GetName() const;

	void SetHTMLName(const String& rStr);
	String GetHTMLName() const;

	FASTBOOL IsGroupObject() const { return GetSubList()!=NULL; }
	virtual SdrObjList* GetSubList() const;
	SdrObject* GetUpGroup() const;

	UINT32 GetOrdNum() const;

	UINT32 GetOrdNumDirect() const { return nOrdNum; }

	void SetOrdNum(UINT32 nNum) { nOrdNum=nNum; }

	const AutoTimer* GetAutoTimer() const { return pPlusData!=NULL ? pPlusData->pAutoTimer : NULL; }
	AutoTimer* GetAutoTimer() { return pPlusData!=NULL ? pPlusData->pAutoTimer : NULL; }
	AutoTimer* ForceAutoTimer();

	virtual const Rectangle& GetBoundRect() const;
	virtual void RecalcBoundRect();
	void SendRepaintBroadcast(BOOL bNoPaintNeeded = FALSE) const;
	void SendRepaintBroadcast(const Rectangle& rRect) const;

	virtual void SetChanged();

	virtual FASTBOOL Paint(ExtOutputDevice& rXOut, const SdrPaintInfoRec& rInfoRec) const;
	virtual FASTBOOL PaintGluePoints(ExtOutputDevice& rXOut, const SdrPaintInfoRec& rInfoRec) const;

	ImpLineGeometry* ImpPrepareLineGeometry(ExtOutputDevice& rXOut, const SfxItemSet& rSet, BOOL bIsLineDraft = FALSE) const;
	void ImpDrawLineGeometry(ExtOutputDevice& rXOut, Color& rColor,	sal_uInt16 nTransparence, ImpLineGeometry& rLineGeometry) const;
	void ImpDrawShadowLineGeometry(ExtOutputDevice& rXOut, const SfxItemSet& rSet, ImpLineGeometry& rLineGeometry) const;
	void ImpDrawColorLineGeometry(ExtOutputDevice& rXOut, const SfxItemSet& rSet, ImpLineGeometry& rLineGeometry) const;
	virtual void CreateLinePoly(PolyPolygon3D& rPolyPolygon, PolyPolygon3D& rPolyLine, OutputDevice& rOut,
		BOOL bForceHair = FALSE, BOOL bIsLineDraft = FALSE) const;
	BOOL LineGeometryUsageIsNecessary() const;

	virtual SdrObject* CheckHit(const Point& rPnt, USHORT nTol, const SetOfByte* pVisiLayer) const;
	SdrObject* CheckHit(const Point& rPnt, USHORT nTol) const { return CheckHit(rPnt,nTol,NULL); }
	FASTBOOL IsHit(const Point& rPnt, USHORT nTol, const SetOfByte* pVisiLayer) const { return CheckHit(rPnt,nTol,pVisiLayer)!=NULL; }
	FASTBOOL IsHit(const Point& rPnt, USHORT nTol) const { return CheckHit(rPnt,nTol,NULL)!=NULL; }

	virtual SdrObject* Clone() const;
	virtual SdrObject* Clone(SdrPage* pPage, SdrModel* pModel) const;
	virtual void operator=(const SdrObject& rObj);

	virtual void TakeObjNameSingul(String& rName) const;
	virtual void TakeObjNamePlural(String& rName) const;

	virtual void TakeXorPoly(XPolyPolygon& rPoly, FASTBOOL bDetail) const;

	virtual void TakeContour(XPolyPolygon& rPoly) const;
	virtual void TakeContour(XPolyPolygon& rXPoly, SdrContourType eType) const;

	virtual USHORT GetHdlCount() const;
	virtual SdrHdl* GetHdl(USHORT nHdlNum) const;
	virtual USHORT GetPlusHdlCount(const SdrHdl& rHdl) const;
	virtual SdrHdl* GetPlusHdl(const SdrHdl& rHdl, USHORT nPlNum) const;
	virtual void AddToHdlList(SdrHdlList& rHdlList) const;

	virtual FASTBOOL HasSpecialDrag() const;
	virtual FASTBOOL BegDrag(SdrDragStat& rDrag) const;
	virtual FASTBOOL MovDrag(SdrDragStat& rDrag) const; 
	virtual FASTBOOL EndDrag(SdrDragStat& rDrag);
	virtual void BrkDrag(SdrDragStat& rDrag) const;
	virtual String GetDragComment(const SdrDragStat& rDrag, FASTBOOL bUndoDragComment, FASTBOOL bCreateComment) const;
	virtual void TakeDragPoly(const SdrDragStat& rDrag, XPolyPolygon& rXPP) const;

	virtual FASTBOOL BegCreate(SdrDragStat& rStat);
	virtual FASTBOOL MovCreate(SdrDragStat& rStat); 
	virtual FASTBOOL EndCreate(SdrDragStat& rStat, SdrCreateCmd eCmd);
	virtual FASTBOOL BckCreate(SdrDragStat& rStat);
	virtual void BrkCreate(SdrDragStat& rStat);

	virtual Pointer GetCreatePointer() const;

	virtual void TakeCreatePoly(const SdrDragStat& rDrag, XPolyPolygon& rXPP) const;

	virtual void NbcMove  (const Size& rSiz);
	virtual void NbcResize(const Point& rRef, const Fraction& xFact, const Fraction& yFact);
	virtual void NbcRotate(const Point& rRef, long nWink, double sn, double cs);
	virtual void NbcMirror(const Point& rRef1, const Point& rRef2);
	virtual void NbcShear (const Point& rRef, long nWink, double tn, FASTBOOL bVShear);

	virtual void Move  (const Size& rSiz);
	virtual void Resize(const Point& rRef, const Fraction& xFact, const Fraction& yFact);
	virtual void Rotate(const Point& rRef, long nWink, double sn, double cs);
	virtual void Mirror(const Point& rRef1, const Point& rRef2);
	virtual void Shear (const Point& rRef, long nWink, double tn, FASTBOOL bVShear);

	virtual void NbcSetRelativePos(const Point& rPnt);
	virtual void SetRelativePos(const Point& rPnt);
	virtual Point GetRelativePos() const;
	void ImpSetAnchorPos(const Point& rPnt) { aAnchor=rPnt; }
	virtual void NbcSetAnchorPos(const Point& rPnt);
	virtual void SetAnchorPos(const Point& rPnt);
	virtual const Point& GetAnchorPos() const;

	virtual void RecalcSnapRect();
	virtual const Rectangle& GetSnapRect() const;
	virtual void SetSnapRect(const Rectangle& rRect);
	virtual void NbcSetSnapRect(const Rectangle& rRect);

	virtual const Rectangle& GetLogicRect() const;
	virtual void SetLogicRect(const Rectangle& rRect);
	virtual void NbcSetLogicRect(const Rectangle& rRect);

	virtual long GetRotateAngle() const;
	virtual long GetShearAngle(FASTBOOL bVertical=FALSE) const;

	virtual USHORT GetSnapPointCount() const;
	virtual Point GetSnapPoint(USHORT i) const;

	virtual FASTBOOL IsPolyObj() const;
	virtual USHORT GetPointCount() const;
	virtual const Point& GetPoint(USHORT i) const;
	virtual void SetPoint(const Point& rPnt, USHORT i);
	virtual void NbcSetPoint(const Point& rPnt, USHORT i);

	virtual USHORT InsPoint(const Point& rPos, FASTBOOL bNewObj, FASTBOOL& rInsNextAfter);
	virtual USHORT NbcInsPoint(const Point& rPos, FASTBOOL bNewObj, FASTBOOL bHideHim, FASTBOOL& rInsNextAfter);

	virtual USHORT InsPoint(USHORT i, const Point& rPos, FASTBOOL bInsAfter, FASTBOOL bNewObj);
	virtual USHORT NbcInsPoint(USHORT i, const Point& rPos, FASTBOOL bInsAfter, FASTBOOL bNewObj, FASTBOOL bHideHim);

	virtual FASTBOOL DelPoint(USHORT i);
	virtual FASTBOOL NbcDelPoint(USHORT i);

	virtual SdrObject* RipPoint(USHORT i, USHORT& rNewPt0Index);
	virtual SdrObject* NbcRipPoint(USHORT i, USHORT& rNewPt0Index);

	virtual void Shut();
	virtual void NbcShut();

	virtual SdrObjGeoData* GetGeoData() const;
	virtual void SetGeoData(const SdrObjGeoData& rGeo);

	virtual const SfxItemSet& GetItemSet() const;
	virtual SfxItemSet* CreateNewItemSet(SfxItemPool& rPool);
	virtual void SetItem(const SfxPoolItem& rItem);
	virtual void ClearItem(const sal_uInt16 nWhich = 0);
	virtual void SetItemSet(const SfxItemSet& rSet);
	virtual void BroadcastItemChange(const SdrBroadcastItemChange& rChange);
	virtual void ItemSetChanged(const SfxItemSet& rSet);

	void SetItemAndBroadcast(const SfxPoolItem& rItem);
	void ClearItemAndBroadcast(const sal_uInt16 nWhich = 0);
	void SetItemSetAndBroadcast(const SfxItemSet& rSet);
	const SfxPoolItem& GetItem(const sal_uInt16 nWhich) const;

	virtual BOOL AllowItemChange(const sal_uInt16 nWhich, const SfxPoolItem* pNewItem = 0) const;
	virtual void ItemChange(const sal_uInt16 nWhich, const SfxPoolItem* pNewItem = 0);
	virtual void PostItemChange(const sal_uInt16 nWhich);

	virtual void PreSave();
	virtual void PostSave();

	void TakeNotPersistAttr(SfxItemSet& rAttr, FASTBOOL bMerge) const;
	void ApplyNotPersistAttr(const SfxItemSet& rAttr);
	void NbcApplyNotPersistAttr(const SfxItemSet& rAttr);

	virtual void SetStyleSheet(SfxStyleSheet* pNewStyleSheet, FASTBOOL bDontRemoveHardAttr);
	virtual void NbcSetStyleSheet(SfxStyleSheet* pNewStyleSheet, FASTBOOL bDontRemoveHardAttr);
	virtual SfxStyleSheet* GetStyleSheet() const;

	virtual FASTBOOL HasTextEdit() const;
	virtual SdrObject* CheckTextEditHit(const Point& rPnt, USHORT nTol, const SetOfByte* pVisiLayer) const;
	SdrObject* CheckTextEditHit(const Point& rPnt, USHORT nTol) const { return CheckTextEditHit(rPnt,nTol,NULL); }
	FASTBOOL IsTextEditHit(const Point& rPnt, USHORT nTol, const SetOfByte* pVisiLayer) const { return CheckTextEditHit(rPnt,nTol,pVisiLayer)!=NULL; }
	FASTBOOL IsTextEditHit(const Point& rPnt, USHORT nTol) const { return CheckTextEditHit(rPnt,nTol,NULL)!=NULL; }

	virtual FASTBOOL BegTextEdit(SdrOutliner& rOutl);
	virtual void EndTextEdit(SdrOutliner& rOutl);

	virtual void SetOutlinerParaObject(OutlinerParaObject* pTextObject);
	virtual void NbcSetOutlinerParaObject(OutlinerParaObject* pTextObject);
	virtual OutlinerParaObject* GetOutlinerParaObject() const;
	virtual void NbcReformatText();
	virtual void ReformatText();
	virtual void BurnInStyleSheetAttributes( BOOL bPseudoSheetsOnly=FALSE );

	virtual void RestartAnimation(SdrPageView* pPageView) const;

	virtual FASTBOOL HasMacro() const;
	virtual SdrObject* CheckMacroHit (const SdrObjMacroHitRec& rRec) const;
	virtual Pointer GetMacroPointer (const SdrObjMacroHitRec& rRec) const;
	virtual void PaintMacro (ExtOutputDevice& rXOut, const Rectangle& rDirtyRect, const SdrObjMacroHitRec& rRec) const;
	virtual FASTBOOL DoMacro (const SdrObjMacroHitRec& rRec);
	virtual XubString GetMacroPopupComment(const SdrObjMacroHitRec& rRec) const;
	FASTBOOL IsMacroHit(const SdrObjMacroHitRec& rRec) const { return CheckMacroHit(rRec)!=NULL; }

	virtual FASTBOOL IsNode() const;

	virtual SdrGluePoint GetVertexGluePoint(USHORT nNum) const;

	virtual SdrGluePoint GetCornerGluePoint(USHORT nNum) const;

	virtual const SdrGluePointList* GetGluePointList() const;
	virtual SdrGluePointList* GetGluePointList();

	virtual SdrGluePointList* ForceGluePointList();

	void SetGlueReallyAbsolute(FASTBOOL bOn);
	void NbcRotateGluePoints(const Point& rRef, long nWink, double sn, double cs);
	void NbcMirrorGluePoints(const Point& rRef1, const Point& rRef2);
	void NbcShearGluePoints (const Point& rRef, long nWink, double tn, FASTBOOL bVShear);

	virtual FASTBOOL IsEdge() const;

	virtual void ToggleEdgeXor(const SdrDragStat& rDrag, ExtOutputDevice& rXOut, FASTBOOL bTail1, FASTBOOL bTail2, FASTBOOL bDetail) const;
	virtual void NspToggleEdgeXor(const SdrDragStat& rDrag, ExtOutputDevice& rXOut, FASTBOOL bTail1, FASTBOOL bTail2, FASTBOOL bDetail) const;

	virtual void ConnectToNode(FASTBOOL bTail1, SdrObject* pObj);
	virtual void DisconnectFromNode(FASTBOOL bTail1);
	virtual SdrObject* GetConnectedNode(FASTBOOL bTail1) const;

	virtual SdrObject* DoConvertToPolyObj(BOOL bBezier) const;
	SdrObject* ConvertToPolyObj(BOOL bBezier, BOOL bLineToArea) const;

	SdrObject* ConvertToContourObj(SdrObject* pRet, BOOL bForceLineDash = FALSE) const;
	SdrObject* ImpConvertToContourObj(SdrObject* pRet, BOOL bForceLineDash = FALSE) const;

	virtual void WriteData(SvStream& rOut) const;

	virtual void ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);

	virtual void AfterRead();

	friend SvStream& operator<<(SvStream& rOut, const SdrObject& rObj);
	friend SvStream& operator>>(SvStream& rIn, SdrObject& rObj);

	FASTBOOL IsVirtualObj() const { return bVirtObj; }

	FASTBOOL IsClosedObj() const { return bClosedObj; }
	FASTBOOL IsWriterFlyFrame() const { return bWriterFlyFrame; }
	FASTBOOL IsEdgeObj() const { return bIsEdge; }
	FASTBOOL Is3DObj() const { return bIs3DObj; }
	FASTBOOL IsUnoObj() const { return bIsUnoObj; }
	FASTBOOL IsMasterCachable() const { return !bNotMasterCachable; }
	FASTBOOL ShareLock() { FASTBOOL r=!bNetLock; bNetLock=TRUE; return r; }
	void ShareUnlock() { bNetLock=FALSE; }
	FASTBOOL IsShareLock() const { return bNetLock; }
	void SetMarkProtect(FASTBOOL bProt) { bMarkProt=bProt; }
	FASTBOOL IsMarkProtect() const { return bMarkProt; }
	void SetInserted(FASTBOOL bIns);
	FASTBOOL IsInserted() const { return bInserted; }
	void SetGrouped(FASTBOOL bGrp) { bGrouped=bGrp; }
	FASTBOOL IsGrouped() const { return bGrouped; }
	void SetMoveProtect(FASTBOOL bProt);
	FASTBOOL IsMoveProtect() const { return bMovProt; }
	void SetResizeProtect(FASTBOOL bProt);
	FASTBOOL IsResizeProtect() const { return bSizProt; }
	void SetPrintable(FASTBOOL bPrn);
	FASTBOOL IsPrintable() const { return !bNoPrint; }
	void SetEmptyPresObj(FASTBOOL bEpt) { bEmptyPresObj=bEpt; }
	FASTBOOL IsEmptyPresObj() const { return bEmptyPresObj; }
	FASTBOOL IsNotPersistent() const { return bNotPersistent; }
	FASTBOOL IsNeedColorRestore() const { return bNeedColorRestore; }
	void SetNotVisibleAsMaster(FASTBOOL bFlg) { bNotVisibleAsMaster=bFlg; }
	FASTBOOL IsNotVisibleAsMaster() const { return bNotVisibleAsMaster; }

	USHORT GetUserDataCount() const;
	SdrObjUserData* GetUserData(USHORT nNum) const;

	void InsertUserData(SdrObjUserData* pData, USHORT nPos=0xFFFF);

	void DeleteUserData(USHORT nNum);

	virtual void MigrateItemPool(SfxItemPool* pSrcPool, SfxItemPool* pDestPool);

	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > getUnoShape();

	virtual BOOL TRGetBaseGeometry(Matrix3D& rMat, XPolyPolygon& rPolyPolygon) const;

	virtual void TRSetBaseGeometry(const Matrix3D& rMat, const XPolyPolygon& rPolyPolygon);

	FASTBOOL IsTransparent( BOOL bCheckForAlphaChannel = FALSE ) const;
};

class SdrObjFactory
{
public:
	UINT32						nInventor;
	UINT16						nIdentifier;

	SdrPage*					pPage;
	SdrModel*					pModel;
	SdrObject*					pNewObj;

	SdrObject*					pObj;
	SdrObjUserData*				pNewData;

private:
	SdrObjFactory(UINT32 nInvent, UINT16 nIdent, SdrPage* pNewPage, SdrModel* pNewModel) { nInventor=nInvent; nIdentifier=nIdent; pNewObj=NULL; pPage=pNewPage; pModel=pNewModel; pObj=NULL; pNewData=NULL; }
	SdrObjFactory(UINT32 nInvent, UINT16 nIdent, SdrObject* pObj1) { nInventor=nInvent; nIdentifier=nIdent; pNewObj=NULL; pPage=NULL; pModel=NULL; pObj=pObj1; pNewData=NULL; }

public:
	static SdrObject* MakeNewObject(UINT32 nInvent, UINT16 nIdent, SdrPage* pPage, SdrModel* pModel=NULL);
	static void InsertMakeObjectHdl(const Link& rLink);
	static void RemoveMakeObjectHdl(const Link& rLink);
	static SdrObjUserData* MakeNewObjUserData(UINT32 nInvent, UINT16 nIdent, SdrObject* pObj);
	static void InsertMakeUserDataHdl(const Link& rLink);
	static void RemoveMakeUserDataHdl(const Link& rLink);
};

#endif 

