

#ifndef _SVDOOLE2_HXX
#define _SVDOOLE2_HXX

#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif

#ifndef _SVDORECT_HXX
#include <svx/svdorect.hxx>
#endif
#ifndef _GRAPH_HXX 
#include <vcl/graph.hxx>
#endif
#ifndef _GDIMTF_HXX 
#include <vcl/gdimtf.hxx>
#endif
#ifndef _SOT_STORAGE_HXX
#include <sot/storage.hxx>
#endif

class SvPersist;
class SvInPlaceObjectRef;
class SvEmbeddedInfoObject;

#ifdef SVX_LIGHT

#ifndef _OWNLIST_HXX
#include <svtools/ownlist.hxx>
#endif

namespace com { namespace sun { namespace star {
	namespace awt {
	class XToolkit;
	class XWindowPeer;
	}

	namespace plugin {
	class XPlugin;
	}
}}}

class INetURLObject;

class SvInPlaceObject : public SvRefBase
{
private:
	INetURLObject*	pURL;
	SvCommandList	aCmdList;
	USHORT			nPlugInMode;
	String			aMimeType;
	::com::sun::star::uno::Reference< ::com::sun::star::plugin::XPlugin >		xPlugin;
	Rectangle		aRect;

public:
	SvInPlaceObject();
	~SvInPlaceObject();

	void CreatePlugin( ::com::sun::star::uno::Reference< ::com::sun::star::awt::XToolkit > xToolkit,
		   ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindowPeer > xPeer );	

	static SvInPlaceObject* Load( SotStorageRef xSt );
	void SetSizeAndPos( const Rectangle& rRect );
	void DoDisconnect();											
};

SV_DECL_REF(SvInPlaceObject);
SV_IMPL_REF(SvInPlaceObject);

#endif 

class SvxUnoShapeModifyListener;

class SdrOle2ObjImpl;

class SdrOle2Obj : public SdrRectObj
{
protected:
	SvInPlaceObjectRef*			ppObjRef;    

	String						aName;       

	Graphic*					pGraphic;
	String						aProgName;

	BOOL						bFrame : 1;
	BOOL						bInDestruction : 1;

	SdrOle2ObjImpl*				mpImpl;

	SvxUnoShapeModifyListener*	pModifyListener;

protected:

	void ImpSetVisAreaSize();

	void Init();

public:
	TYPEINFO();

	SdrOle2Obj(FASTBOOL bFrame_=FALSE);
	SdrOle2Obj(const SvInPlaceObjectRef& rNewObjRef, FASTBOOL bFrame_=FALSE);
	SdrOle2Obj(const SvInPlaceObjectRef& rNewObjRef, const String& rNewObjName, FASTBOOL bFrame_=FALSE);
	SdrOle2Obj(const SvInPlaceObjectRef& rNewObjRef, const String& rNewObjName, const Rectangle& rNewRect, FASTBOOL bFrame_=FALSE);
	virtual ~SdrOle2Obj();

	void SetGraphic(const Graphic* pGrf);
	Graphic* GetGraphic() const { return pGraphic; }

	virtual FASTBOOL HasSetName() const;

	virtual void SetName(const String& rStr);
	virtual String GetName() const;

	void SetProgName(const String& rNam) { aProgName=rNam; }
	const String& GetProgName() const { return aProgName; }
	FASTBOOL IsEmpty() const;
	void SetObjRef(const SvInPlaceObjectRef& rNewObjRef);
	const SvInPlaceObjectRef& GetObjRef() const;

	virtual void SetPage(SdrPage* pNewPage);
	virtual void SetModel(SdrModel* pModel);

	virtual void TakeObjInfo(SdrObjTransformInfoRec& rInfo) const;
	virtual UINT16 GetObjIdentifier() const;
	virtual FASTBOOL Paint(ExtOutputDevice& rOut, const SdrPaintInfoRec& rInfoRec) const;
	virtual SdrObject* CheckHit(const Point& rPnt, USHORT nTol, const SetOfByte* pVisiLayer) const;

	virtual void TakeObjNameSingul(String& rName) const;
	virtual void TakeObjNamePlural(String& rName) const;

	virtual void operator=(const SdrObject& rObj);
	virtual FASTBOOL HasSpecialDrag() const;

	virtual void NbcMove(const Size& rSize);
	virtual void NbcResize(const Point& rRef, const Fraction& xFact, const Fraction& yFact);
	virtual void NbcSetSnapRect(const Rectangle& rRect);
	virtual void NbcSetLogicRect(const Rectangle& rRect);
	virtual void SetGeoData(const SdrObjGeoData& rGeo);

	FASTBOOL HasGDIMetaFile() const;
	const GDIMetaFile* GetGDIMetaFile() const;

	virtual void WriteData(SvStream& rOut) const;
	virtual void ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);

	BOOL Unload();

	void Connect();
	void Disconnect();

	::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > getXModel() const;
};

#endif 

