

#ifndef _SVDPOOL_HXX
#define _SVDPOOL_HXX

#ifndef _XPOOL_HXX
#include <svx/xpool.hxx>
#endif

#ifndef _SVDDEF_HXX
#include <svx/svddef.hxx>
#endif

class XLineAttrSetItem;
class XFillAttrSetItem;
class XTextAttrSetItem;
class SdrShadowSetItem;
class SdrOutlinerSetItem;
class SdrMiscSetItem;

class SdrItemPool: public XOutdevItemPool {

private:
	void Ctor(SfxItemPool* pMaster, USHORT nAttrStart, USHORT nAttrEnd);

public:

	SdrItemPool(USHORT nAttrStart=SDRATTR_START, USHORT nAttrEnd=SDRATTR_END,
		FASTBOOL bLoadRefCounts = TRUE);

	SdrItemPool(SfxItemPool* pMaster, USHORT nAttrStart=SDRATTR_START, USHORT nAttrEnd=SDRATTR_END,
		FASTBOOL bLoadRefCounts = TRUE);

	SdrItemPool(const SdrItemPool& rPool);
	virtual ~SdrItemPool();
	virtual SfxItemPool* Clone() const;
	virtual SfxItemPresentation GetPresentation(const SfxPoolItem& rItem,
		SfxItemPresentation ePresentation,
		SfxMapUnit          ePresentationMetric,
		String&             rText,
	    const IntlWrapper * pIntlWrapper
		= 0) const;

	static FASTBOOL TakeItemName(USHORT nWhich, String& rItemName);

	static BOOL TakeWhichName(USHORT nWhich, ByteString& rItemName);
};

#endif 

