

#ifndef _SVDSOB_HXX
#define _SVDSOB_HXX

#ifndef _COM_SUN_STAR_UNO_ANY_HXX_ 
#include <com/sun/star/uno/Any.hxx>
#endif

#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

#ifndef _STRING_H
#include <tools/string.hxx> 
#define _STRING_H
#endif

class SetOfByte {
protected:
	BYTE aData[32];
public:
	SetOfByte(FASTBOOL bInitVal=FALSE)                  { memset(aData,bInitVal ? 0xFF : 0x00,sizeof(aData)); }
	FASTBOOL operator==(const SetOfByte& rCmpSet) const { return (memcmp(aData,rCmpSet.aData,sizeof(aData))==0); }
	FASTBOOL operator!=(const SetOfByte& rCmpSet) const { return (memcmp(aData,rCmpSet.aData,sizeof(aData))!=0); }
	void     Set  (BYTE a)                              { aData[a/8]|=1<<a%8; }
	void     Clear(BYTE a)                              { aData[a/8]&=~(1<<a%8); }
	void     Set  (BYTE a, FASTBOOL b)                  { if (b) Set(a); else Clear(a); }
	FASTBOOL IsSet(BYTE a) const                        { return (aData[a/8]&1<<a%8)!=0; }
	FASTBOOL IsSet(USHORT a) const                      { return (a<=255) && (aData[a/8]&1<<a%8)!=0; }
	void     SetAll()                                   { memset(aData,0xFF,sizeof(aData)); }
	void     ClearAll()                                 { memset(aData,0x00,sizeof(aData)); }
	FASTBOOL IsEmpty() const;
	FASTBOOL IsFull() const;
	USHORT   GetSetCount() const;
	BYTE     GetSetBit(USHORT nNum) const;
	USHORT   GetClearCount() const;
	BYTE     GetClearBit(USHORT nNum) const;
	void     operator&=(const SetOfByte& r2ndSet);
	void     operator|=(const SetOfByte& r2ndSet);
	friend inline SvStream& operator<<(SvStream& rOut, const SetOfByte& rSet);
	friend inline SvStream& operator>>(SvStream& rIn, SetOfByte& rSet);

	void	PutValue( const com::sun::star::uno::Any & rAny );		
	void	QueryValue( com::sun::star::uno::Any & rAny ) const;	
};

inline SvStream& operator<<(SvStream& rOut, const SetOfByte& rSet)
{
	rOut.Write((char*)rSet.aData,32);
	return rOut;
}

inline SvStream& operator>>(SvStream& rIn, SetOfByte& rSet)
{
	rIn.Read((char*)rSet.aData,32);
	return rIn;
}

#endif 

