

#ifndef _SVDXCGV_HXX
#define _SVDXCGV_HXX

#ifndef _SVDHDL_HXX
#include <svx/svdhdl.hxx>
#endif

#include <svx/svdedxv.hxx>

#ifndef _GDIMTF_HXX 
#include <vcl/gdimtf.hxx>
#endif

class SdrExchangeView: public SdrObjEditView
{
	friend class				SdrPageView;

protected:
	void ImpGetPasteObjList(Point& rPos, SdrObjList*& rpLst);
	void ImpPasteObject(SdrObject* pObj, SdrObjList& rLst, const Point& rCenter, const Size& rSiz, const MapMode& rMap, UINT32 nOptions);
	BOOL ImpPaste(ULONG nFormat, BOOL bClp, USHORT nItemNum, const Point& rPos, UINT32 nOptions);
	BOOL ImpGetPasteLayer(const SdrObjList* pObjList, SdrLayerID& rLayer) const;
	void ImpYank(ULONG nFormat, BOOL bClp) const;
	Point GetPastePos(SdrObjList* pLst, OutputDevice* pOut=NULL);

	BOOL ImpLimitToWorkArea(Point& rPt, const SdrPageView* pPV=NULL) const;

public:
	SdrExchangeView(SdrModel* pModel1, OutputDevice* pOut=NULL);
	SdrExchangeView(SdrModel* pModel1, ExtOutputDevice* pXOut);

	virtual void DrawMarkedObj(OutputDevice& rOut, const Point& rOfs) const;

	virtual GDIMetaFile GetMarkedObjMetaFile(BOOL bNoVDevIfOneMtfMarked=FALSE) const;

	virtual Bitmap GetMarkedObjBitmap(BOOL bNoVDevIfOneBmpMarked=FALSE) const;

	virtual SdrModel* GetMarkedObjModel() const;
	void DrawAllMarked(OutputDevice& rOut, const Point& rOfs) const { DrawMarkedObj(rOut,rOfs); }
	GDIMetaFile GetAllMarkedMetaFile(BOOL bNoVDevIfOneMtfMarked=FALSE) const { return GetMarkedObjMetaFile(bNoVDevIfOneMtfMarked); }
	Bitmap GetAllMarkedBitmap(BOOL bNoVDevIfOneBmpMarked=FALSE) const { return GetMarkedObjBitmap(bNoVDevIfOneBmpMarked); }
	SdrModel* GetAllMarkedModel() const { return GetMarkedObjModel(); }

	Point GetViewCenter(const OutputDevice* pOut=NULL) const;

	BOOL Paste(const GDIMetaFile& rMtf, SdrObjList* pLst=NULL, OutputDevice* pOut=NULL, UINT32 nOptions=0) { return Paste(rMtf,GetPastePos(pLst,pOut),pLst,nOptions); }
	BOOL Paste(const GDIMetaFile& rMtf, const Point& rPos, SdrObjList* pLst=NULL, UINT32 nOptions=0);
	BOOL Paste(const Bitmap& rBmp, SdrObjList* pLst=NULL, OutputDevice* pOut=NULL, UINT32 nOptions=0) { return Paste(rBmp,GetPastePos(pLst,pOut),pLst,nOptions); }
	BOOL Paste(const Bitmap& rBmp, const Point& rPos, SdrObjList* pLst=NULL, UINT32 nOptions=0);
	BOOL Paste(const SdrModel& rMod, SdrObjList* pLst=NULL, OutputDevice* pOut=NULL, UINT32 nOptions=0) { return Paste(rMod,GetPastePos(pLst,pOut),pLst,nOptions); }
	virtual BOOL Paste(const SdrModel& rMod, const Point& rPos, SdrObjList* pLst=NULL, UINT32 nOptions=0);
	BOOL Paste(const String& rStr, SdrObjList* pLst=NULL, OutputDevice* pOut=NULL, UINT32 nOptions=0) { return Paste(rStr,GetPastePos(pLst,pOut),pLst,nOptions); }
	BOOL Paste(const String& rStr, const Point& rPos, SdrObjList* pLst=NULL, UINT32 nOptions=0);

	BOOL Paste(SvStream& rInput, USHORT eFormat, SdrObjList* pLst=NULL, OutputDevice* pOut=NULL, UINT32 nOptions=0) { return Paste(rInput,eFormat,GetPastePos(pLst,pOut),pLst,nOptions); }
	BOOL Paste(SvStream& rInput, USHORT eFormat, const Point& rPos, SdrObjList* pLst=NULL, UINT32 nOptions=0);

	void CutMarked(ULONG nFormat=SDR_ANYFORMAT);

	void YankMarked(ULONG nFormat=SDR_ANYFORMAT);

	BOOL PasteClipboard(OutputDevice* pOut=NULL, ULONG nFormat=SDR_ANYFORMAT, UINT32 nOptions=0);

	BOOL PasteDragDrop(const Point& rPos, ULONG nFormat=SDR_ANYFORMAT, USHORT nItemNum=SDR_ANYITEM, UINT32 nOptions=0);

	BOOL IsExchangeFormatSupported(ULONG nFormat) const;

	BOOL IsClipboardFormatSupported(ULONG nFormat=SDR_ANYFORMAT) const;

	BOOL IsDragDropFormatSupported(ULONG nFormat=SDR_ANYFORMAT, USHORT nItemNum=SDR_ANYITEM) const;

	BOOL Cut(ULONG nFormat=SDR_ANYFORMAT);
	BOOL Yank(ULONG nFormat=SDR_ANYFORMAT);
	BOOL Paste(Window* pWin=NULL, ULONG nFormat=SDR_ANYFORMAT);
};

#endif 

