

#ifndef _SVXMSBAS_HXX
#define _SVXMSBAS_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _SVSTOR_HXX
#include <so3/svstor.hxx>
#endif

class SfxObjectShell;

class SvxImportMSVBasic
{
public:
	SvxImportMSVBasic( SfxObjectShell &rDocS, SvStorage &rRoot,
			BOOL bImportCode = TRUE, BOOL bCopyStorage = TRUE )
		:	xRoot(&rRoot), rDocSh(rDocS),
			bImport(bImportCode), bCopy(bCopyStorage)
		{}

	int Import( const String& rStorageName, const String &rSubStorageName,
	BOOL bAsComment=TRUE, BOOL bStripped=TRUE );

	ULONG SaveOrDelMSVBAStorage( BOOL bSaveInto, const String& rStorageName );

	static ULONG GetSaveWarningOfMSVBAStorage( SfxObjectShell &rDocS );

	static String GetMSBasicStorageName();
private:
	SvStorageRef xRoot;
	SfxObjectShell &rDocSh;
	BOOL bImport;
	BOOL bCopy;

	BOOL ImportCode_Impl( const String& rStorageName,
			  const String &rSubStorageName,
			  BOOL bAsComment, BOOL bStripped);
	BOOL CopyStorage_Impl( const String& rStorageName,
			   const String &rSubStorageName);
};

#endif
