
#ifndef _SFXIITM_HXX
#define _SFXIITM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif

#ifndef _FRACT_HXX 
#include <tools/fract.hxx>
#endif

class SdrFractionItem: public SfxPoolItem {
	Fraction nValue;
public:
	TYPEINFO();
	SdrFractionItem(USHORT nId=0): SfxPoolItem(nId) {}
	SdrFractionItem(USHORT nId, const Fraction& rVal): SfxPoolItem(nId), nValue(rVal) {}
	SdrFractionItem(USHORT nId, SvStream& rIn);
	virtual int              operator==(const SfxPoolItem&) const;
	virtual SfxItemPresentation GetPresentation(SfxItemPresentation ePresentation, SfxMapUnit eCoreMetric, SfxMapUnit ePresentationMetric, String &rText, const IntlWrapper * = 0) const;
	virtual SfxPoolItem*     Create(SvStream&, USHORT nVer) const;
#if SUPD <= 345
	virtual SvStream&        Store(SvStream&) const;
#else
	virtual SvStream&        Store(SvStream&, USHORT nItemVers) const;
#endif
	virtual SfxPoolItem*     Clone(SfxItemPool *pPool=NULL) const;
			const Fraction&  GetValue() const { return nValue; }
			void             SetValue(const Fraction& rVal) { nValue = rVal; }
#ifdef SDR_ISPOOLABLE
	virtual int IsPoolable() const;
#endif
};

#endif
