
#ifndef _SVX_TEXTANIM_HXX
#define _SVX_TEXTANIM_HXX

#ifndef VCL
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
#else
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
#endif

#ifndef _SFXTABDLG_HXX
#include <sfx2/tabdlg.hxx>
#endif

#ifndef _SVDATTR_HXX
#include <svx/svdattr.hxx>
#endif

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif

#ifndef _SV_GROUP_HXX 
#include <vcl/group.hxx>
#endif

class SdrView;

class SvxTextAnimationPage : public SfxTabPage
{
private:
	FixedLine			aFlEffect;
	FixedText			aFtEffects;
	ListBox				aLbEffect;

	FixedText			aFtDirection;	
	ImageButton			aBtnUp;
	ImageButton			aBtnLeft;
	ImageButton			aBtnRight;
	ImageButton			aBtnDown;

	FixedLine			aFlProperties;	
	TriStateBox			aTsbStartInside;
	TriStateBox			aTsbStopInside;

	FixedText			aFtCount;
	TriStateBox			aTsbEndless;
	NumericField		aNumFldCount;

	FixedText			aFtAmount;
	TriStateBox			aTsbPixel;
	MetricField			aMtrFldAmount;

	FixedText			aFtDelay;
	TriStateBox			aTsbAuto;
	MetricField			aMtrFldDelay;

	const SfxItemSet&	rOutAttrs;
	SdrTextAniKind		eAniKind;
	FieldUnit			eFUnit;
	SfxMapUnit			eUnit;

#ifdef _SVX_TEXTANIM_CXX
	DECL_LINK( SelectEffectHdl_Impl, void * );
	DECL_LINK( ClickEndlessHdl_Impl, void * );
	DECL_LINK( ClickAutoHdl_Impl, void * );
	DECL_LINK( ClickPixelHdl_Impl, void * );
	DECL_LINK( ClickDirectionHdl_Impl, ImageButton * );

	void				SelectDirection( USHORT nValue );
	USHORT				GetSelectedDirection();
#endif

public:

	SvxTextAnimationPage( Window* pWindow, const SfxItemSet& rInAttrs );
	~SvxTextAnimationPage();

	static SfxTabPage* 	Create( Window*, const SfxItemSet& );
	static  USHORT*	    GetRanges();

	virtual BOOL 		FillItemSet( SfxItemSet& );
	virtual void 		Reset( const SfxItemSet & );

	void 		 Construct();
};

class SvxTextTabDialog : public SfxTabDialog
{
private:
	const SfxItemSet&	rOutAttrs;
	const SdrView*		pView;

	virtual void		PageCreated( USHORT nId, SfxTabPage &rPage );

public:
	SvxTextTabDialog( Window* pParent, const SfxItemSet* pAttr,
					const SdrView* pView );
			~SvxTextTabDialog() {};
};

#endif 

