
#ifndef _SVX_THESDLG_HXX
#define _SVX_THESDLG_HXX

#ifndef _EDIT_HXX 
#include <vcl/edit.hxx>
#endif
#ifndef _BUTTON_HXX 
#include <vcl/button.hxx>
#endif
#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _SVX_STDDLG_HXX 
#include <svx/stddlg.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif

struct ThesDlg_Impl;

class SvxThesaurusLanguageDlg_Impl;

namespace com { namespace sun { namespace star { namespace linguistic2 {
	class XThesaurus;
	class XMeaning;
}}}}

class SvxThesaurusDialog : public SvxStandardDialog
{
public:
	friend class SvxThesaurusLanguageDlg_Impl;

	SvxThesaurusDialog( Window* pParent,
			::com::sun::star::uno::Reference<
				::com::sun::star::linguistic2::XThesaurus >  xThesaurus,
			const String &rWord, sal_Int16 nLanguage );
	~SvxThesaurusDialog();
	 String          GetWord() { return aReplaceEdit.GetText(); }
	 sal_uInt16      GetLanguage() const;

private:
	FixedText		aWordText;
	ListBox 		aWordLB;
	FixedText		aReplaceText;
	Edit  			aReplaceEdit;
	FixedText		aMeanText;
	ListBox			aMeanLB;
	FixedText		aSynonymText;
	ListBox			aSynonymLB;
	FixedLine       aVarFL;

	OKButton		aOkBtn;
	CancelButton	aCancelBtn;
	PushButton		aLookUpBtn;
	PushButton		aLangBtn;
	HelpButton		aHelpBtn;

	String			aErrStr;

	ThesDlg_Impl*	pImpl;		

	virtual void 	Apply();

#ifdef _SVX_THESDLG_CXX
	void 			UpdateSynonymBox_Impl();
	void 			UpdateMeaningBox_Impl(
			::com::sun::star::uno::Sequence<
				::com::sun::star::uno::Reference<
					::com::sun::star::linguistic2::XMeaning >  > *pMeaningSeq = NULL );
	void			Init_Impl(sal_Int16 nLanguage);

	DECL_LINK( SelectHdl_Impl, ListBox * );
	DECL_LINK( SynonymHdl_Impl, ListBox * );
	DECL_LINK( LookUpHdl_Impl, Button * );
	DECL_LINK( LanguageHdl_Impl, Button * );
	DECL_LINK( EntryHdl_Impl, ListBox * );
	DECL_LINK( SpellErrorHdl_Impl, void * );
#endif
};

#endif

