

#ifndef _MyTXTRANGE_HXX
#define _MyTXTRANGE_HXX

#ifndef _TXTRANGE_HXX
#define _SVSTDARR_BOOLS
#define _SVSTDARR_LONGS
#include <svtools/svstdarr.hxx>
#endif

class PolyPolygon;
class XPolyPolygon;
class Range;
class Rectangle;

typedef SvLongs* SvLongsPtr;

class TextRanger
{
	Range *pRangeArr;
	SvLongsPtr *pCache;
	PolyPolygon *pPoly; 
	PolyPolygon *pLine; 
	Rectangle *pBound;	
	USHORT nCacheSize;	
	USHORT nCacheIdx;	
	USHORT nRight;		
	USHORT nLeft;		
	USHORT nUpper;		
	USHORT nLower;		
	USHORT nPointCount; 
	BOOL bSimple : 1;	
	BOOL bInner  : 1;	

	BOOL bVertical :1;	
	BOOL bFlag3 :1;
	BOOL bFlag4 :1;
	BOOL bFlag5 :1;
	BOOL bFlag6 :1;
	BOOL bFlag7 :1;
	TextRanger( const TextRanger& ); 
	const Rectangle& _GetBoundRect();
public:
	TextRanger( const XPolyPolygon& rXPoly, const XPolyPolygon* pXLine,
	USHORT nCacheSize, USHORT nLeft, USHORT nRight,
	BOOL bSimple, BOOL bInner, BOOL bVert = sal_False );
	~TextRanger();
	SvLongsPtr GetTextRanges( const Range& rRange );
	USHORT GetRight() const { return nRight; }
	USHORT GetLeft() const { return nLeft; }
	USHORT GetUpper() const { return nUpper; }
	USHORT GetLower() const { return nLower; }
	USHORT GetPointCount() const { return nPointCount; }
	BOOL IsSimple() const { return bSimple; }
	BOOL IsInner() const { return bInner; }
	BOOL IsVertical() const { return bVertical; }
	BOOL HasBorder() const { return nRight || nLeft; }
	const PolyPolygon& GetPolyPolygon() const { return *pPoly; }
	const PolyPolygon* GetLinePolygon() const { return pLine; }
	const Rectangle& GetBoundRect()
		{ return pBound ? *pBound : _GetBoundRect(); }
	void SetUpper( USHORT nNew ){ nUpper = nNew; }
	void SetLower( USHORT nNew ){ nLower = nNew; }
	void SetVertical( BOOL bNew );
	BOOL IsFlag3() const { return bFlag3; }
	void SetFlag3( BOOL bNew ) { bFlag3 = bNew; }
	BOOL IsFlag4() const { return bFlag4; }
	void SetFlag4( BOOL bNew ) { bFlag4 = bNew; }
	BOOL IsFlag5() const { return bFlag5; }
	void SetFlag5( BOOL bNew ) { bFlag5 = bNew; }
	BOOL IsFlag6() const { return bFlag6; }
	void SetFlag6( BOOL bNew ) { bFlag6 = bNew; }
	BOOL IsFlag7() const { return bFlag7; }
	void SetFlag7( BOOL bNew ) { bFlag7 = bNew; }
};

#endif      
