

#ifndef _SVX_SUBSETMAP_HXX
#define _SVX_SUBSETMAP_HXX

#include <svx/ucsubset.hrc>
#include <vcl/metric.hxx>

class FontCharMap;

class Subset
{
public:
	Subset( sal_Unicode nMin, sal_Unicode nMax, const String& aName )
	: mnRangeMin(nMin), mnRangeMax(nMax), maRangeName(aName)
	{}
	 Subset( sal_Unicode _min, sal_Unicode _max, int resId);
	 sal_Unicode     GetRangeMin() const { return mnRangeMin;}
	sal_Unicode     GetRangeMax() const { return mnRangeMax;}
	const String    GetName()     const { return maRangeName;}

private:
	const sal_Unicode   mnRangeMin;
	const sal_Unicode   mnRangeMax;
	String              maRangeName;
};

class SubsetMap : private Resource
{
public:
	SubsetMap( const FontCharMap* );
	~SubsetMap();
	 int             GetSubsetCount() const;
	const Subset*   GetSubsetByUnicode( sal_Unicode c) const;
	const Subset*   GetSubsetByIndex( int index) const;

private:
	int             mnSubsets;
	const Subset**  maSubsets;
	 void            InitList();
	void            ApplyCharMap( const FontCharMap* );
};

#endif
