
#ifndef _SVX_UDLNITEM_HXX
#define _SVX_UDLNITEM_HXX

#ifndef _SFXENUMITEM_HXX 
#include <svtools/eitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif
#ifndef _SV_FONTTYPE_HXX 
#include <vcl/fonttype.hxx>
#endif
#ifndef _TOOLS_COLOR_HXX
#include <tools/color.hxx>
#endif

class SvXMLUnitConverter;
#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

class SvxUnderlineItem : public SfxEnumItem
{
	Color mColor;
public:
	TYPEINFO();

	SvxUnderlineItem( const FontUnderline eSt = UNDERLINE_NONE,
		  const USHORT nId = ITEMID_UNDERLINE );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
				SfxMapUnit eCoreMetric,
				SfxMapUnit ePresMetric,
	                        String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*    Create(SvStream &, USHORT) const;
	virtual SvStream&		Store(SvStream &, USHORT nItemVersion) const;
	virtual String			GetValueTextByPos( USHORT nPos ) const;
	virtual USHORT          GetValueCount() const;

	virtual	sal_Bool        QueryValue( com::sun::star::uno::Any& rVal,
							BYTE nMemberId = 0 ) const;
	virtual	sal_Bool		PutValue( const com::sun::star::uno::Any& rVal,
							BYTE nMemberId = 0 );

	void			 		SetValue( USHORT nNewVal )
					{SfxEnumItem::SetValue(nNewVal); }
	virtual int 			HasBoolValue() const;
	virtual BOOL			GetBoolValue() const;
	virtual void			SetBoolValue( BOOL bVal );

	virtual int 			 operator==( const SfxPoolItem& ) const;

	inline SvxUnderlineItem& operator=(const SvxUnderlineItem& rUnderline)
		{
			SetValue( rUnderline.GetValue() );
			SetColor( rUnderline.GetColor() );
			return *this;
		}

	FontUnderline 			GetUnderline() const
					{ return (FontUnderline)GetValue(); }
	void 					SetUnderline ( FontUnderline eNew )
					{ SetValue((USHORT) eNew); }

	const Color&			GetColor() const				{ return mColor; }
	void 					SetColor( const Color& rCol )	{ mColor = rCol; }
};

#endif 

