

#ifndef _SVX_UNOEDSRC_HXX
#define _SVX_UNOEDSRC_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif
#ifndef _SV_COLOR_HXX 
#include <vcl/color.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
#ifndef _SFXITEMPOOL_HXX 
#include <svtools/itempool.hxx>
#endif

struct ESelection;
class String;
class SfxItemSet;
class SvUShorts;
class SvxTextForwarder;
class SvxFieldItem;

class SvxEditSource
{
public:
				SvxEditSource();
	virtual					~SvxEditSource();

	virtual SvxEditSource*		Clone() const = 0;
	virtual SvxTextForwarder*	GetTextForwarder() = 0;
	virtual void				UpdateData() = 0;
};

class SvxTextForwarder
{
public:
			SvxTextForwarder();
	virtual				~SvxTextForwarder();

	virtual USHORT		GetParagraphCount() const = 0;
	virtual USHORT		GetTextLen( USHORT nParagraph ) const = 0;
	virtual String		GetText( const ESelection& rSel ) const = 0;
	virtual SfxItemSet	GetAttribs( const ESelection& rSel, BOOL bOnlyHardAttrib = FALSE ) const = 0;
	virtual	SfxItemSet  GetParaAttribs( USHORT nPara ) const = 0;
	virtual void		SetParaAttribs( USHORT nPara, const SfxItemSet& rSet ) = 0;
	virtual void		GetPortions( USHORT nPara, SvUShorts& rList ) const = 0;

	virtual USHORT		GetItemState( const ESelection& rSel, USHORT nWhich ) const = 0;
	virtual USHORT		GetItemState( USHORT nPara, USHORT nWhich ) const = 0;

	virtual void		QuickInsertText( const String& rText, const ESelection& rSel ) = 0;
	virtual void		QuickInsertField( const SvxFieldItem& rFld, const ESelection& rSel ) = 0;
	virtual void		QuickSetAttribs( const SfxItemSet& rSet, const ESelection& rSel ) = 0;
	virtual void		QuickInsertLineBreak( const ESelection& rSel ) = 0;

	virtual XubString    CalcFieldValue( const SvxFieldItem& rField, USHORT nPara, USHORT nPos, Color*& rpTxtColor, Color*& rpFldColor ) = 0;

	virtual SfxItemPool* GetPool() const = 0;

	virtual BOOL		IsValid() const = 0;
};

#endif

