
#ifndef WORIENT_HXX
#define WORIENT_HXX

#ifndef _VALUESET_HXX 
#include <svtools/valueset.hxx>
#endif

#ifndef _SV_FIXED_HXX 
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_BUTTON_HXX 
#include <vcl/imagebtn.hxx>
#endif

#ifndef _SV_GROUP_HXX 
#include <vcl/group.hxx>
#endif

#ifndef _SVX_CTRDIAL_HXX
#include <svx/ctrdial.hxx>
#endif

#ifndef _SVX_NFORIENT_HXX
#include <svx/nforient.hxx>
#endif

#ifndef _SVX_ROTMODIT_HXX
#include <svx/rotmodit.hxx>
#endif

class SvxWinOrientation : Link

{
protected:
	ImageButton			aBtnTxtStacked;
	SvxCtrDial			aCtrDial;
	FixedText			aOrientFieldLabel;
	SvxOrientationField	aOrientField;
	FixedText			aVSLockModeLabel;
	ValueSet			aVSLockMode;
	FixedLine           aFlAlign;
	BOOL				bFlagEnabled;

	DECL_LINK( OrientModifyHdl, void * );
	DECL_LINK( LostActiveHdl, void * );

public:
	SvxWinOrientation( Window * pParent,
		const ResId & rResIdForCtrDial,
		const ResId & rResIdForBtnStackedText,
		const ResId & rResIdForOrientLabel,
		const ResId & rResIdForOrientField,
		const ResId & rResIdForVSLockModeLabel,
		const ResId & rResIdForVSLockMode,
	                const ResId & rResIdForFixedLine);

	void			Enable();
	void			Disable();
	BOOL			IsEnabled();

	BOOL			IsStackedTxt();
	void			SetStackedTxt(BOOL bOnOff);

	void			SetDegrees(short alpha);
	short			GetDegrees();
	ValueSet&		GetVSLockMode();
	BOOL			IsSelRotateMode();
	SvxRotateMode	GetRotateMode();
	void			SetRotateMode(SvxRotateMode);
};

#endif

