

#ifndef _SVX_XBTMPIT_HXX
#define _SVX_XBTMPIT_HXX

#include <svx/xbitmap.hxx>

class SdrModel;

class XFillBitmapItem : public NameOrIndex
{
	XOBitmap aXOBitmap;

public:
			TYPEINFO();
			XFillBitmapItem() : NameOrIndex(XATTR_FILLBITMAP, -1 ) {}
			XFillBitmapItem( long nIndex, const XOBitmap& rTheBitmap );
			XFillBitmapItem( const String& rName, const XOBitmap& rTheBitmap );
			XFillBitmapItem( SfxItemPool* pPool, const XOBitmap& rTheBitmap );
			XFillBitmapItem( SfxItemPool* pPool );
			XFillBitmapItem( const XFillBitmapItem& rItem );
			XFillBitmapItem( SvStream& rIn, USHORT nVer = 0 );

	virtual int             operator==( const SfxPoolItem& rItem ) const;
	virtual SfxPoolItem*    Clone( SfxItemPool* pPool = 0 ) const;
	virtual SfxPoolItem*    Create( SvStream& rIn, USHORT nVer ) const;
	virtual SvStream&       Store( SvStream& rOut, USHORT nItemVersion  ) const;
	virtual USHORT          GetVersion( USHORT nFileFormatVersion ) const;

	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	const XOBitmap& GetValue( const XBitmapTable* pTable = 0 ) const;
	void           SetValue( const XOBitmap& rNew )  { aXOBitmap = rNew; Detach(); }

	static BOOL CompareValueFunc( const NameOrIndex* p1, const NameOrIndex* p2 );
	XFillBitmapItem* checkForUniqueItem( SdrModel* pModel ) const;
};

#endif
