

#ifndef _SVX_XFLFTRIT_HXX
#define _SVX_XFLFTRIT_HXX

#ifndef _SVX_XFLGRIT_HXX 
#include <svx/xflgrit.hxx>
#endif

class XFillFloatTransparenceItem : public XFillGradientItem
{
private:

	long					nDummy1;
	long					nDummy2;
	BOOL					bEnabled;

public:
				TYPEINFO();
					XFillFloatTransparenceItem();
				XFillFloatTransparenceItem( long nIndex, const XGradient& rGradient, BOOL bEnable = TRUE );
				XFillFloatTransparenceItem(const String& rName, const XGradient& rGradient, BOOL bEnable = TRUE );
				XFillFloatTransparenceItem(SfxItemPool* pPool, const XGradient& rTheGradient, BOOL bEnable = TRUE );
				XFillFloatTransparenceItem(SfxItemPool* pPool );
				XFillFloatTransparenceItem( const XFillFloatTransparenceItem& rItem );
				XFillFloatTransparenceItem( SvStream& rIn, USHORT nVer = 0 );

	virtual int             operator==( const SfxPoolItem& rItem ) const;
	virtual SfxPoolItem*    Clone( SfxItemPool* pPool = NULL ) const;
	virtual SfxPoolItem*    Create( SvStream& rIn, USHORT nVer ) const;
	virtual SvStream&       Store( SvStream& rOut, USHORT nItemVersion ) const;
	virtual USHORT          GetVersion( USHORT nFileFormatVersion ) const;
	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres, SfxMapUnit eCoreMetric,
	                                SfxMapUnit ePresMetric, String &rText, const IntlWrapper * pIntlWrapper = 0 ) const;

	BOOL					IsEnabled() const { return bEnabled; }
	void					SetEnabled( BOOL bEnable ) { bEnabled = bEnable; }

	static BOOL CompareValueFunc( const NameOrIndex* p1, const NameOrIndex* p2 );
	XFillFloatTransparenceItem* checkForUniqueItem( SdrModel* pModel ) const;
};

#endif
