

#ifndef _SVX_XHATCH_HXX
#define _SVX_XHATCH_HXX

#include <svx/xenum.hxx>

#ifndef _COLOR_HXX 
#include <vcl/color.hxx>
#endif

class XHatch
{
protected:
	XHatchStyle		eStyle;
	Color			aColor;
	long			nDistance;
	long			nAngle;

public:
		XHatch() {}
		XHatch(const Color& rCol, XHatchStyle eStyle = XHATCH_SINGLE,
			   long nDistance = 20, long nAngle = 0);

	int operator==(const XHatch& rHatch) const;

	void			SetHatchStyle(XHatchStyle eNewStyle) { eStyle = eNewStyle; }
	void			SetColor(const Color& rColor) { aColor = rColor; }
	void			SetDistance(long nNewDistance) { nDistance = nNewDistance; }
	void			SetAngle(long nNewAngle) { nAngle = nNewAngle; }

	XHatchStyle		GetHatchStyle() const { return eStyle; }
	Color			GetColor() const { return aColor; }
	long			GetDistance() const { return nDistance; }
	long			GetAngle() const { return nAngle; }
};

#endif
