

#ifndef _SVX_XLNEDIT_HXX
#define _SVX_XLNEDIT_HXX

#ifndef _XPOLY_HXX 
#include <svx/xpoly.hxx>
#endif
#ifndef _SVX_XIT_HXX 
#include <svx/xit.hxx>
#endif

class SdrModel;

class XLineEndItem : public NameOrIndex
{
	XPolygon    aXPolygon;

public:
			TYPEINFO();
			XLineEndItem(long nIndex = -1);
			XLineEndItem(const String& rName, const XPolygon& rXPolygon);
			XLineEndItem(SfxItemPool* pPool, const XPolygon& rXPolygon);
			XLineEndItem(SfxItemPool* pPool );
			XLineEndItem(const XLineEndItem& rItem);
			XLineEndItem(SvStream& rIn);

	virtual int             operator==(const SfxPoolItem& rItem) const;
	virtual SfxPoolItem*    Clone(SfxItemPool* pPool = 0) const;
	virtual SfxPoolItem*    Create(SvStream& rIn, USHORT nVer) const;
	virtual SvStream&       Store(SvStream& rOut, USHORT nItemVersion ) const;

	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	const XPolygon& GetValue(const XLineEndTable* pTable = 0) const;
	void            SetValue(const XPolygon& rXPolygon) { aXPolygon = rXPolygon; Detach(); }

	XLineEndItem* checkForUniqueItem( SdrModel* pModel ) const;
};

#endif
