

#ifndef _SVX_XMLCNITM_HXX
#define _SVX_XMLCNITM_HXX

#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif

class SvXMLNamespaceMap;
namespace rtl { class OUString; }

class SvXMLAttrContainerData;

class SvXMLAttrContainerItem: public SfxPoolItem
{
	SvXMLAttrContainerData	*pImpl;

public:
	TYPEINFO();

	SvXMLAttrContainerItem( sal_uInt16 nWhich = 0 );
	SvXMLAttrContainerItem( const SvXMLAttrContainerItem& );
	virtual ~SvXMLAttrContainerItem();

	virtual int operator==( const SfxPoolItem& ) const;
	virtual int	Compare( const SfxPoolItem &rWith ) const;

	virtual SfxItemPresentation GetPresentation(
					SfxItemPresentation ePresentation,
					SfxMapUnit eCoreMetric,
					SfxMapUnit ePresentationMetric,
					XubString &rText,
	                            const IntlWrapper *pIntlWrapper = 0 ) const;

	virtual sal_uInt16 GetVersion( sal_uInt16 nFileFormatVersion ) const;

	virtual	BOOL        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	BOOL			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

	virtual SfxPoolItem *Clone( SfxItemPool * = 0) const
	{ return new SvXMLAttrContainerItem( *this ); }

	sal_Bool AddAttr( const ::rtl::OUString& rLName,
	 	  	  const ::rtl::OUString& rValue );
	sal_Bool AddAttr( const ::rtl::OUString& rPrefix,
	 	  	  const ::rtl::OUString& rNamespace,
	 	  	  const ::rtl::OUString& rLName,
	 	  	  const ::rtl::OUString& rValue );

	sal_uInt16 GetAttrCount() const;
	::rtl::OUString GetAttrNamespace( sal_uInt16 i ) const;
	::rtl::OUString GetAttrPrefix( sal_uInt16 i ) const;
	const ::rtl::OUString& GetAttrLName( sal_uInt16 i ) const;
	const ::rtl::OUString& GetAttrValue( sal_uInt16 i ) const;

	sal_uInt16 GetFirstNamespaceIndex() const;
	sal_uInt16 GetNextNamespaceIndex( sal_uInt16 nIdx ) const;
	const ::rtl::OUString& GetNamespace( sal_uInt16 i ) const;
	const ::rtl::OUString& GetPrefix( sal_uInt16 i ) const;
};

#endif 

