

#ifndef _XOUTBMP_HXX
#define _XOUTBMP_HXX

#ifndef _SV_GRAPH_HXX
#include <vcl/graph.hxx>
#endif

#define XOUTBMP_MIRROR_HORZ				0x00000001L
#define XOUTBMP_MIRROR_VERT				0x00000010L

#define XOUTBMP_CONTOUR_HORZ			0x00000001L
#define XOUTBMP_CONTOUR_VERT			0x00000002L
#define XOUTBMP_CONTOUR_EDGEDETECT		0x00000004L

#define XOUTBMP_DONT_EXPAND_FILENAME	0x10000000L
#define XOUTBMP_USE_GIF_IF_POSSIBLE		0x20000000L
#define XOUTBMP_USE_GIF_IF_SENSIBLE		0x40000000L
#define XOUTBMP_USE_NATIVE_IF_POSSIBLE	0x80000000L

class GraphicFilter;
class VirtualDevice;
class INetURLObject;
class Polygon;

class XOutBitmap
{
public:

	static GraphicFilter* pGrfFilter;

	static BitmapEx		CreateQuickDrawBitmapEx( const Graphic& rGraphic, const OutputDevice& rCompDev,
									 const MapMode& rMapMode, const Size& rLogSize,
									 const Point& rPoint, const Size& rSize );
	static Graphic		MirrorGraphic( const Graphic& rGraphic, const ULONG nMirrorFlags );
	static Animation	MirrorAnimation( const Animation& rAnimation, BOOL bHMirr, BOOL bVMirr );
	static USHORT		WriteGraphic( const Graphic& rGraphic, String& rFileName,
						  const String& rFilterName, const ULONG nFlags = 0L,
						  const Size* pMtfSize_100TH_MM = NULL );
	static void			DrawQuickDrawBitmapEx( OutputDevice* pOutDev, const Point& rPt,
								   const Size& rSize, const BitmapEx& rBmpEx );
	static void			DrawTiledBitmapEx( OutputDevice* pOutDev, const Point& rStartPt, const Size& rGrfSize,
							   const Rectangle& rTileRect, const BitmapEx& rBmpEx );

	static USHORT		ExportGraphic( const Graphic& rGraphic, const INetURLObject& rURL,
						   GraphicFilter& rFilter, const USHORT nFormat,
						   BOOL bIgnoreOptions );

	static Bitmap		DetectEdges( const Bitmap& rBmp, const BYTE cThreshold );

	static Polygon		GetCountour( const Bitmap& rBmp, const ULONG nContourFlags,
						 const BYTE cEdgeDetectThreshold = 50,
						 const Rectangle* pWorkRect = NULL );
};

BOOL DitherBitmap( Bitmap& rBitmap );

#endif 
