

#ifndef SW_SWDLL_HXX
#define SW_SWDLL_HXX

class ResMgr;
class SvFactory;
class SotFactory;
class StatusBar;

class SfxMedium;
class SfxFilter;

#ifndef _SFXDEFS_HXX 
#include <sfx2/sfxdefs.hxx>
#endif
#ifndef _SFXMODULE_HXX 
#include <sfx2/module.hxx>
#endif

class SwDLL

{

	static void RegisterFactories();
	static void RegisterInterfaces();
	static void RegisterControls();
public:
			SwDLL();
		~SwDLL();

	static void 	LibInit();	
	static void 	LibExit();	
	static void 	PreExit();	

	static void 	Init(); 	
	static void 	Exit(); 	

	static void		FillStatusBar(StatusBar &rBar);

	static ULONG	DetectFilter( SfxMedium& rMedium, const SfxFilter** ppFilter,
						SfxFilterFlags nMust, SfxFilterFlags nDont );
	static ULONG	GlobDetectFilter( SfxMedium& rMedium, const SfxFilter** ppFilter,
						SfxFilterFlags nMust, SfxFilterFlags nDont );
	 static sal_Bool RegisterFrameLoaders( void* pServiceManager, void* pRegistryKey );
	static void*    CreateFrameLoader( const sal_Char* pImplementationName, void* pServiceManager, void *pRegistryKey );
};

class SwModuleDummy : public SfxModule

{
public:
	virtual ~SwModuleDummy();
	TYPEINFO();

	SotFactory*		pSwDocShellFactory;
	SotFactory*		pSwWebDocShellFactory;
	SotFactory*		pSwGlobalDocShellFactory;
			SwModuleDummy( ResMgr *pResMgr, BOOL bDummy,
	                                SotFactory* pWebFact,
	                                SotFactory* pFact,
						SotFactory* pGlobalFact )
		:	SfxModule(pResMgr, bDummy,
					(SfxObjectFactory*)pFact,
					(SfxObjectFactory*)pWebFact,
					(SfxObjectFactory*)pGlobalFact, 0L),
			pSwDocShellFactory( pFact ),
			pSwWebDocShellFactory( pWebFact ),
			pSwGlobalDocShellFactory( pGlobalFact )
		{}

	virtual SfxModule* Load();

	static SvGlobalName GetID(USHORT nFileFormat);
	static USHORT       HasID(const SvGlobalName& rName);
};

#define SW_DLL() ( *(SwModuleDummy**) GetAppData(SHL_WRITER) )

#endif

