

#ifndef _TOOLKIT_HELPER_PROPERTY_HXX_
#define _TOOLKIT_HELPER_PROPERTY_HXX_

#include <sal/types.h>

namespace com {
namespace sun {
namespace star {
namespace uno {
	class Type;
	class Any;
} } } }

namespace rtl {
	class OUString;
}

#define BASEPROPERTY_NOTFOUND				 0

#define BASEPROPERTY_TEXT					 1	
#define BASEPROPERTY_BACKGROUNDCOLOR		 2	
#define BASEPROPERTY_FILLCOLOR				 3	
#define BASEPROPERTY_TEXTCOLOR			     4	
#define BASEPROPERTY_LINECOLOR				 5	
#define BASEPROPERTY_BORDER				 	 6	
#define BASEPROPERTY_ALIGN					 7	
#define BASEPROPERTY_FONTDESCRIPTOR			 8	
#define BASEPROPERTY_DROPDOWN				 9	
#define BASEPROPERTY_MULTILINE				10	
#define BASEPROPERTY_STRINGITEMLIST			11	
#define BASEPROPERTY_HSCROLL				12	
#define BASEPROPERTY_VSCROLL				13	
#define BASEPROPERTY_TABSTOP				14	
#define BASEPROPERTY_STATE					15	
#define BASEPROPERTY_FONT_TYPE				16	
#define BASEPROPERTY_FONT_SIZE				17	
#define BASEPROPERTY_FONT_ATTRIBS			18	
#define BASEPROPERTY_DEFAULTCONTROL			19	
#define BASEPROPERTY_LABEL					20	
#define BASEPROPERTY_LINECOUNT				21	
#define BASEPROPERTY_EXTDATEFORMAT			22	
#define BASEPROPERTY_DATESHOWCENTURY        23	
#define BASEPROPERTY_EXTTIMEFORMAT			24	
#define BASEPROPERTY_NUMSHOWTHOUSANDSEP		25	
#define BASEPROPERTY_CURRENCYSYMBOL			26	
#define BASEPROPERTY_SPIN					27	
#define BASEPROPERTY_STRICTFORMAT			28	
#define BASEPROPERTY_DECIMALACCURACY		29	
#define BASEPROPERTY_DATE					30	
#define BASEPROPERTY_DATEMIN                31	
#define BASEPROPERTY_DATEMAX                32	
#define BASEPROPERTY_TIME					33	
#define BASEPROPERTY_TIMEMIN                34	
#define BASEPROPERTY_TIMEMAX                35	
#define BASEPROPERTY_VALUE_INT32			36	
#define BASEPROPERTY_VALUEMIN_INT32			37	
#define BASEPROPERTY_VALUEMAX_INT32			38	
#define BASEPROPERTY_VALUESTEP_INT32		39	
#define BASEPROPERTY_EDITMASK				40	
#define BASEPROPERTY_LITERALMASK			41	
#define BASEPROPERTY_IMAGEURL				42	
#define BASEPROPERTY_READONLY				43	
#define BASEPROPERTY_ENABLED				44	
#define BASEPROPERTY_PRINTABLE				45	
#define BASEPROPERTY_ECHOCHAR				46	
#define BASEPROPERTY_MAXTEXTLEN				47	
#define BASEPROPERTY_HARDLINEBREAKS			48	
#define BASEPROPERTY_AUTOCOMPLETE			49	
#define BASEPROPERTY_MULTISELECTION			50	
#define BASEPROPERTY_SELECTEDITEMS			51	
#define BASEPROPERTY_VALUE_DOUBLE			52	
#define BASEPROPERTY_VALUEMIN_DOUBLE		53	
#define BASEPROPERTY_VALUEMAX_DOUBLE		54	
#define BASEPROPERTY_VALUESTEP_DOUBLE		55	
#define BASEPROPERTY_TRISTATE				56	
#define BASEPROPERTY_DEFAULTBUTTON			57	
#define BASEPROPERTY_HELPURL				58	
#define BASEPROPERTY_AUTOTOGGLE				59	
#define BASEPROPERTY_FOCUSSELECTIONHIDE		60	
#define BASEPROPERTY_FORMATKEY				61	
#define BASEPROPERTY_FORMATSSUPPLIER		62	
#define BASEPROPERTY_EFFECTIVE_VALUE		63	
#define BASEPROPERTY_TREATASNUMBER			64	
#define BASEPROPERTY_EFFECTIVE_DEFAULT		65	
#define BASEPROPERTY_EFFECTIVE_MIN			66	
#define BASEPROPERTY_EFFECTIVE_MAX			67	
#define BASEPROPERTY_CURSYM_POSITION		68	
#define BASEPROPERTY_TITLE					69	
#define BASEPROPERTY_MOVEABLE				70	
#define BASEPROPERTY_CLOSEABLE				71	
#define BASEPROPERTY_SIZEABLE				72	
#define BASEPROPERTY_HELPTEXT				73	
#define BASEPROPERTY_PROGRESSVALUE  	    74	
#define BASEPROPERTY_PROGRESSVALUE_MIN 	    75	
#define BASEPROPERTY_PROGRESSVALUE_MAX 	    76	
#define BASEPROPERTY_SCROLLVALUE	 	    77	
#define BASEPROPERTY_SCROLLVALUE_MAX 	    78	
#define BASEPROPERTY_LINEINCREMENT	 	    79	
#define BASEPROPERTY_BLOCKINCREMENT	 	    80	
#define BASEPROPERTY_VISIBLESIZE	 	    81	
#define BASEPROPERTY_ORIENTATION	 	    82	
#define BASEPROPERTY_FONTRELIEF	 	        83	
#define BASEPROPERTY_FONTEMPHASISMARK	 	84	
#define BASEPROPERTY_TEXTLINECOLOR			85	
#define BASEPROPERTY_IMAGEALIGN			    86	

#define BASEPROPERTY_FONTDESCRIPTORPART_START			1000
#define BASEPROPERTY_FONTDESCRIPTORPART_NAME			1000	
#define BASEPROPERTY_FONTDESCRIPTORPART_STYLENAME		1001	
#define BASEPROPERTY_FONTDESCRIPTORPART_FAMILY			1002	
#define BASEPROPERTY_FONTDESCRIPTORPART_CHARSET     	1003	
#define BASEPROPERTY_FONTDESCRIPTORPART_HEIGHT      	1004	
#define BASEPROPERTY_FONTDESCRIPTORPART_WEIGHT      	1005	
#define BASEPROPERTY_FONTDESCRIPTORPART_SLANT       	1006	
#define BASEPROPERTY_FONTDESCRIPTORPART_UNDERLINE   	1007	
#define BASEPROPERTY_FONTDESCRIPTORPART_STRIKEOUT   	1008	
#define BASEPROPERTY_FONTDESCRIPTORPART_WIDTH			1009	
#define BASEPROPERTY_FONTDESCRIPTORPART_PITCH			1010	
#define BASEPROPERTY_FONTDESCRIPTORPART_CHARWIDTH		1011	
#define BASEPROPERTY_FONTDESCRIPTORPART_ORIENTATION		1012	
#define BASEPROPERTY_FONTDESCRIPTORPART_KERNING			1013	
#define BASEPROPERTY_FONTDESCRIPTORPART_WORDLINEMODE	1014	
#define BASEPROPERTY_FONTDESCRIPTORPART_TYPE			1015	
#define BASEPROPERTY_FONTDESCRIPTORPART_END         	1015

#define PROPERTY_ALIGN_LEFT						0
#define PROPERTY_ALIGN_CENTER					1
#define PROPERTY_ALIGN_RIGHT					2

#define PROPERTY_STATE_OFF						0
#define PROPERTY_STATE_ON						1
#define PROPERTY_STATE_DONTCARE					2

sal_uInt16							GetPropertyId( const ::rtl::OUString& rPropertyName ); 
const ::com::sun::star::uno::Type*	GetPropertyType( sal_uInt16 nPropertyId );
const ::rtl::OUString&				GetPropertyName( sal_uInt16 nPropertyId );
sal_Int16 							GetPropertyAttribs( sal_uInt16 nPropertyId );
sal_uInt16							GetPropertyOrderNr( sal_uInt16 nPropertyId );
sal_Bool							DoesDependOnOthers( sal_uInt16 nPropertyId );
sal_Bool							CompareProperties( const ::com::sun::star::uno::Any& r1, const ::com::sun::star::uno::Any& r2 );

#endif 

