

#ifndef _AGAPI_HXX
#define _AGAPI_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

class INetURLObject;
class ChannelList;
class AgentItem;
class String;

class AgentApi
{
protected:
	friend class ChannelList;

	AgentItem*			pChannelAgent;
	virtual BOOL		StartAgent() = 0;

	AgentApi(AgentItem* pAgent) { pChannelAgent = pAgent; }

public:
	virtual ~AgentApi() {}

	virtual void	InitAgent() = 0;
	virtual void	ShutDownAgent() = 0;

	virtual BOOL	NewDataPermission(const String& rChannelName) = 0;
	virtual void 	NewData(const String& rChannelName,
			const INetURLObject& rURL) = 0;
	virtual void	NotifyChannelObjFile(const INetURLObject& rURL,
			const String& rFileName) = 0;
	virtual void	NotifyChannelObjData(const INetURLObject& rURL,
			void* pBuffer, long nOffset, long nLen, long nTotalLen) = 0;

	virtual void	RegisterChannels() = 0;
	virtual void 	RegisterUpdateTransmitter() = 0;
};

#endif 

/* $Log: agapi.hxx,v $
/* Revision 1.1.1.1  2000/09/18 17:03:01  hr
/* initial import
/*
/* Revision 1.4  2000/09/18 10:01:01  willem.vandorp
/* OpenOffice header added.
/*
/* Revision 1.3  2000/08/11 16:13:05  willem.vandorp
/* Header and footer replaced
/*
/* Revision 1.2  1999/02/18 15:12:24  tj
/* chg: Syntax
