

#ifndef _CONTNR_HXX
#define _CONTNR_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

class CBlock;

#define CONTAINER_MAXBLOCKSIZE      ((USHORT)0x3FF0)

#define CONTAINER_APPEND            ((ULONG)0xFFFFFFFF)
#define CONTAINER_ENTRY_NOTFOUND    ((ULONG)0xFFFFFFFF)

class Container
{
private:
	CBlock*     pFirstBlock;
	CBlock*     pCurBlock;
	CBlock*     pLastBlock;
	USHORT      nCurIndex;
	USHORT      nBlockSize;
	USHORT      nInitSize;
	USHORT      nReSize;
	ULONG       nCount;

protected:
#ifdef _IMPCONT_HXX
	void        ImpInsert( void* p, CBlock* pBlock, USHORT nIndex );
	void*       ImpRemove( CBlock* pBlock, USHORT nIndex );
	void*       ImpGetObject( ULONG nIndex ) const;
	void**      ImpGetOnlyNodes() const;
#endif
	void**      GetObjectPtr( ULONG nIndex );

public:
	            Container( USHORT nBlockSize,
	                       USHORT nInitSize,
	                       USHORT nReSize );
	            Container( ULONG nSize );
	            Container( const Container& rContainer );
	            ~Container();
	 void        Insert( void* p );
	void        Insert( void* p, ULONG nIndex );
	void        Insert( void* pNew, void* pOld );
	 void*       Remove();
	void*       Remove( ULONG nIndex );
	void*       Remove( void* p )
	                { return Remove( GetPos( p ) ); }
	 void*       Replace( void* p );
	void*       Replace( void* p, ULONG nIndex );
	void*       Replace( void* pNew, void* pOld )
	                { return Replace( pNew, GetPos( pOld ) ); }
	 void        SetSize( ULONG nNewSize );
	ULONG       GetSize() const { return nCount; }
	 ULONG       Count() const { return nCount; }
	void        Clear();
	 void*       GetCurObject() const;
	ULONG       GetCurPos() const;
	void*       GetObject( ULONG nIndex ) const;
	ULONG       GetPos( const void* p ) const;
	ULONG       GetPos( const void* p, ULONG nStartIndex,
	                    BOOL bForward = TRUE ) const;
	 void*       Seek( ULONG nIndex );
	void*       Seek( void* p ) { return Seek( GetPos( p ) ); }
	 void*       First();
	void*       Last();
	void*       Next();
	void*       Prev();
	 Container&  operator =( const Container& rContainer );
	 BOOL        operator ==( const Container& rContainer ) const;
	BOOL        operator !=( const Container& rContainer ) const
	                { return !(Container::operator==( rContainer )); }
};

#endif 
