

#ifndef _DYNARY_HXX
#define _DYNARY_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _CONTNR_HXX
#include <tools/contnr.hxx>
#endif

#define DYNARRAY_ENTRY_NOTFOUND     CONTAINER_ENTRY_NOTFOUND

class DynArray : private Container
{
public:
	Container::SetSize;
	Container::GetSize;
	Container::Clear;
	             DynArray( ULONG nSize = 16 ) : Container( nSize ) {}
	            DynArray( const DynArray& rAry ) : Container( rAry ) {}
	 void*       Put( ULONG nIndex, void* p )
	                { return Container::Replace( p, nIndex ); }
	void*       Get( ULONG nIndex ) const
	                { return Container::GetObject( nIndex ); }
	 ULONG       GetIndex( const void* p ) const
	                { return Container::GetPos( p ); }
	ULONG       GetIndex( const void* p, ULONG nStartIndex,
	                      BOOL bForward = TRUE ) const
	                { return Container::GetPos( p, nStartIndex, bForward ); }
	 DynArray&   operator =( const DynArray& rAry )
	                { Container::operator =( rAry ); return *this; }
	 BOOL        operator ==( const DynArray& rAry ) const
	                { return Container::operator ==( rAry ); }
	BOOL        operator !=( const DynArray& rAry ) const
	                { return Container::operator !=( rAry ); }
};

#define DECLARE_DYNARRAY( ClassName, Type )                             \
class ClassName : private DynArray                                      \
{                                                                       \
public:                                                                 \
	DynArray::SetSize;										\
	DynArray::GetSize;										\
	DynArray::Clear;										\
	                                                                    \
	            ClassName( ULONG nSize = 16 ) :                         \
	                DynArray( nSize ) {}                                \
	            ClassName( const ClassName& rClassName ) :              \
	                DynArray( rClassName ) {}                           \
	                                                                    \
	Type        Put( ULONG nIndex, Type p )                             \
	                { return (Type)DynArray::Put( nIndex, (void*)p ); } \
	Type        Get( ULONG nIndex ) const                               \
	                { return (Type)DynArray::Get( nIndex ); }           \
	                                                                    \
	ULONG       GetIndex( const Type p ) const                          \
	                { return DynArray::GetIndex( (const void*)p ); }    \
	ULONG       GetIndex( const Type p, ULONG nStartIndex,              \
	                      BOOL bForward = TRUE ) const                  \
	                { return DynArray::GetIndex( (const void*)p,        \
	                                             nStartIndex,           \
	                                             bForward ); }          \
	                                                                    \
	ClassName&  operator =( const ClassName& rClassName )               \
	                { DynArray::operator =( rClassName );               \
	                  return *this; }                                   \
	                                                                    \
	BOOL        operator ==( const ClassName& rAry ) const              \
	                { return DynArray::operator ==( rAry ); }           \
	BOOL        operator !=( const ClassName& rAry ) const              \
	                { return DynArray::operator !=( rAry ); }           \
};

#endif 
