

#ifndef _GLOBNAME_HXX
#define _GLOBNAME_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

struct ImpSvGlobalName
{
	BYTE        szData[ 16 ];
	USHORT      nRefCount;
	             ImpSvGlobalName()
	            {
	                nRefCount = 0;
	            }
	            ImpSvGlobalName( const ImpSvGlobalName & rObj );
	            ImpSvGlobalName( int );
	 BOOL    operator == ( const ImpSvGlobalName & rObj ) const;
};

#ifdef WNT
struct _GUID;
typedef struct _GUID GUID;
#else
struct GUID;
#endif
typedef GUID CLSID;
class SvStream;
class SvGlobalNameList;
class SvGlobalName
{
friend SvGlobalNameList;
	ImpSvGlobalName * pImp;
	void    NewImp();
public:
	        SvGlobalName();
	        SvGlobalName( const SvGlobalName & rObj )
	        {
	            pImp = rObj.pImp;
	            pImp->nRefCount++;
	        }
	        SvGlobalName( ImpSvGlobalName * pImpP )
	        {
	            pImp = pImpP;
	            pImp->nRefCount++;
	        }
	        SvGlobalName( UINT32 n1, USHORT n2, USHORT n3,
	                      BYTE b8, BYTE b9, BYTE b10, BYTE b11,
	                      BYTE b12, BYTE b13, BYTE b14, BYTE b15 );
	SvGlobalName & operator = ( const SvGlobalName & rObj );
	        ~SvGlobalName();
	 friend SvStream & operator >> ( SvStream &, SvGlobalName & );
	friend SvStream & operator << ( SvStream &, const SvGlobalName & );
	 BOOL            operator < ( const SvGlobalName & rObj ) const;
	SvGlobalName &  operator += ( UINT32 );
	SvGlobalName &  operator ++ () { return operator += ( 1 ); }
	 BOOL    operator == ( const SvGlobalName & rObj ) const;
	BOOL    operator != ( const SvGlobalName & rObj ) const
	        { return !(*this == rObj); }
	 void    MakeFromMemory( void * pData );
	BOOL    MakeId( const String & rId );
	String  GetctorName() const;
	String  GetHexName() const;
	String  GetRegDbName() const
			{
	String a = '{';
	a += GetHexName();
	a += '}';
	return a;
			}
	               SvGlobalName( const CLSID & rId );
	const CLSID & GetCLSID() const { return *(CLSID *)pImp->szData; }
};

class SvGlobalNameList
{
	List aList;
public:
	                SvGlobalNameList();
	                ~SvGlobalNameList();
	 void            Append( const SvGlobalName & );
	SvGlobalName    GetObject( ULONG );
	BOOL            IsEntry( const SvGlobalName & rName );
	ULONG           Count() const { return aList.Count(); }
private:
	             SvGlobalNameList( const SvGlobalNameList & );
	SvGlobalNameList & operator = ( const SvGlobalNameList & );
};

#endif 

