

#ifndef _SV_CURSOR_HXX
#define _SV_CURSOR_HXX

#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif

class AutoTimer;
struct ImplCursorData;
class Window;

#define CURSOR_SHADOW					((USHORT)0x0001)

class Cursor
{
private:
	ImplCursorData* mpData; 			
	Window* 		mpWindow;			
	long			mnSlant;			
	long			mnOffsetY;			
	Size			maSize; 			
	Point			maPos;				
	short			mnOrientation;		
	USHORT			mnStyle;			
	BOOL			mbVisible;			
	BOOL			mbDummy;			

#if 0 // _SOLAR__PRIVATE
public:
#ifdef _SV_CURSOR_CXX
	void			ImplDraw();
	void			ImplRestore();
		DECL_LINK( ImplTimerHdl, AutoTimer* );
#endif
	void			ImplShow( BOOL bDrawDirect = TRUE );
	void			ImplHide();
	void			ImplNew();
#endif

public:
		Cursor();
		Cursor( const Cursor& rCursor );
		~Cursor();

	void			SetStyle( USHORT nStyle );
	USHORT			GetStyle() const { return mnStyle; }

	void			Show();
	void			Hide();
	BOOL			IsVisible() const { return mbVisible; }

	void			SetWindow( Window* pWindow );
	Window* 		GetWindow() const { return mpWindow; }

	void			SetPos( const Point& rNewPos );
	const Point&	GetPos() const { return maPos; }
	void			SetOffsetY( long mnOffsetY = 0 );
	long			GetOffsetY() const { return mnOffsetY; }

	void			SetSize( const Size& rNewSize );
	const Size& 	GetSize() const { return maSize; }
	void			SetWidth( long nNewWidth );
	long			GetWidth() const { return maSize.Width(); }
	void			SetHeight( long nNewHeight );
	long			GetHeight() const { return maSize.Height(); }

	void			SetSlant( long nSlant = 0 );
	long			GetSlant() const { return mnSlant; }

	void			SetOrientation( short nOrientation = 0 );
	short			GetOrientation() const { return mnOrientation; }

	Cursor& 		operator=( const Cursor& rCursor );
	BOOL			operator==( const Cursor& rCursor ) const;
	BOOL			operator!=( const Cursor& rCursor ) const
			{ return !(Cursor::operator==( rCursor )); }
};

#endif	
