

#ifndef _SV_DIALOG_HXX
#define _SV_DIALOG_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_SYSWIN_HXX
#include <vcl/syswin.hxx>
#endif

class Dialog : public SystemWindow
{
private:
	Window* 		mpDialogParent;
	long			mnDummy;
	Dialog* 		mpPrevExecuteDlg;
	long*			mpResult;
	long			mnDummy1;
	long			mnDummy2;
	BOOL			mbInExecute;
	BOOL			mbOldSaveBack;
	BOOL			mbInClose;
	BOOL			mbModalMode;

#ifdef _SV_DIALOG_CXX
	void			ImplInitData();
	void			ImplInitSettings();
#endif

#if 0 // _SOLAR__PRIVATE
protected:
	void			ImplInit( Window* pParent, WinBits nStyle );
	void			ImplDialogRes( const ResId& rResId );
	void			ImplCenterDialog();

public:
	BOOL			IsInClose() const { return mbInClose; }
#endif

protected:
		Dialog( WindowType nType );
	virtual void	Draw( OutputDevice* pDev, const Point& rPos, const Size& rSize, ULONG nFlags );

public:
		Dialog( Window* pParent, WinBits nStyle = WB_STDDIALOG );
		Dialog( Window* pParent, const ResId& rResId );

	virtual long	Notify( NotifyEvent& rNEvt );
	virtual void	StateChanged( StateChangedType nStateChange );
	virtual void	DataChanged( const DataChangedEvent& rDCEvt );

	virtual BOOL	Close();

	virtual short	Execute();
	BOOL			IsInExecute() const { return mbInExecute; }
	void			EndDialog( long nResult = 0 );
	static void		EndAllDialogs( Window* pParent=NULL );
	 void            GetDrawWindowBorder( long& rLeftBorder, long& rTopBorder,
	                                     long& rRightBorder, long& rBottomBorder ) const;

	void			SetModalInputMode( BOOL bModal );
	void			SetModalInputMode( BOOL bModal, BOOL bSubModalDialogs );
	BOOL			IsModalInputMode() const { return mbModalMode; }

	void			GrabFocusToFirstControl();
};

class ModelessDialog : public Dialog
{
public:
		ModelessDialog( Window* pParent, WinBits nStyle = WB_STDMODELESS );
		ModelessDialog( Window* pParent, const ResId& rResId );
};

class ModalDialog : public Dialog
{
public:
		ModalDialog( Window* pParent, WinBits nStyle = WB_STDMODAL );
		ModalDialog( Window* pParent, const ResId& rResId );

private:
	void			Show( BOOL bVisible = TRUE );
	void			Hide();
};

#endif	
