

#ifndef _SV_FIXED_HXX
#define _SV_FIXED_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_BITMAP_HXX
#include <vcl/bitmap.hxx>
#endif
#ifndef _SV_IMAGE_HXX
#include <vcl/image.hxx>
#endif
#ifndef _SV_CTRL_HXX
#include <vcl/ctrl.hxx>
#endif

class UserDrawEvent;

class FixedText : public Control
{
#if 0 // _SOLAR__PRIVATE
#ifdef _SV_FIXED_CXX
private:
	void            ImplInit( Window* pParent, WinBits nStyle );
	WinBits         ImplInitStyle( WinBits nStyle );
	void            ImplInitSettings( BOOL bFont, BOOL bForeground, BOOL bBackground );
	void            ImplDraw( OutputDevice* pDev, ULONG nDrawFlags,
	                          const Point& rPos, const Size& rSize );
#endif
public:
	static USHORT   ImplGetTextStyle( WinBits nWinBits );
#endif

public:
	                FixedText( Window* pParent, WinBits nStyle = 0 );
	                FixedText( Window* pParent, const ResId& rResId );
	 virtual void    Paint( const Rectangle& rRect );
	virtual void    Draw( OutputDevice* pDev, const Point& rPos, const Size& rSize, ULONG nFlags );
	virtual void    Resize();
	virtual void    StateChanged( StateChangedType nType );
	virtual void    DataChanged( const DataChangedEvent& rDCEvt );
	 Size            CalcMinimumSize( long nMaxWidth = 0 ) const;
};

class FixedLine : public Control
{
#if 0 // _SOLAR__PRIVATE
#ifdef _SV_FIXED_CXX
private:
	void            ImplInit( Window* pParent, WinBits nStyle );
	WinBits         ImplInitStyle( WinBits nStyle );
	void            ImplInitSettings( BOOL bFont, BOOL bForeground, BOOL bBackground );
#endif
#endif

public:
	                FixedLine( Window* pParent, WinBits nStyle = WB_HORZ );
	                FixedLine( Window* pParent, const ResId& rResId );
	 virtual void    Paint( const Rectangle& rRect );
	virtual void    Draw( OutputDevice* pDev, const Point& rPos, const Size& rSize, ULONG nFlags );
	virtual void    Resize();
	virtual void    StateChanged( StateChangedType nType );
	virtual void    DataChanged( const DataChangedEvent& rDCEvt );
};

class FixedBitmap : public Control
{
private:
	Bitmap          maBitmap;

#if 0 // _SOLAR__PRIVATE
#ifdef _SV_FIXED_CXX
private:
	void            ImplInit( Window* pParent, WinBits nStyle );
	WinBits         ImplInitStyle( WinBits nStyle );
	void            ImplInitSettings();
	void            ImplDraw( OutputDevice* pDev, ULONG nDrawFlags,
	                          const Point& rPos, const Size& rSize );
#endif

protected:
	void            ImplLoadRes( const ResId& rResId );
#endif

public:
	                FixedBitmap( Window* pParent, WinBits nStyle = 0 );
	                FixedBitmap( Window* pParent, const ResId& rResId );
	                ~FixedBitmap();
	 virtual void    Paint( const Rectangle& rRect );
	virtual void    Draw( OutputDevice* pDev, const Point& rPos, const Size& rSize, ULONG nFlags );
	virtual void    Resize();
	virtual void    StateChanged( StateChangedType nType );
	virtual void    DataChanged( const DataChangedEvent& rDCEvt );
	 void            SetBitmap( const Bitmap& rBitmap );
	const Bitmap&   GetBitmap() const { return maBitmap; }
};

class FixedImage : public Control
{
private:
	Image           maImage;
	BOOL            mbInUserDraw;

#if 0 // _SOLAR__PRIVATE
#ifdef _SV_FIXED_CXX
private:
	void            ImplInit( Window* pParent, WinBits nStyle );
	WinBits         ImplInitStyle( WinBits nStyle );
	void            ImplInitSettings();
	void            ImplDraw( OutputDevice* pDev, ULONG nDrawFlags,
	                          const Point& rPos, const Size& rSize );
#endif

protected:
	void            ImplLoadRes( const ResId& rResId );
#endif

public:
	                FixedImage( Window* pParent, WinBits nStyle = 0 );
	                FixedImage( Window* pParent, const ResId& rResId );
	                ~FixedImage();
	 virtual void    Paint( const Rectangle& rRect );
	virtual void    Draw( OutputDevice* pDev, const Point& rPos, const Size& rSize, ULONG nFlags );
	virtual void    Resize();
	virtual void    StateChanged( StateChangedType nType );
	virtual void    DataChanged( const DataChangedEvent& rDCEvt );
	virtual void    UserDraw( const UserDrawEvent& rUDEvt );
	 void            SetImage( const Image& rImage );
	const Image&    GetImage() const { return maImage; }
	 Point           CalcImagePos( const Point& rPos,
	                              const Size& rObjSize, const Size& rWinSize );
};

#endif  
