

#ifndef _SV_FONTCVT_HXX
#define _SV_FONTCVT_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#define FONTTOSUBSFONT_IMPORT                   ((ULONG)0x00000001)
#define FONTTOSUBSFONT_EXPORT                   ((ULONG)0x00000002)
#define FONTTOSUBSFONT_ONLYOLDSOSYMBOLFONTS     ((ULONG)0x00000004)

typedef void* FontToSubsFontConverter;
FontToSubsFontConverter     CreateFontToSubsFontConverter( const String& rFontName, ULONG nFlags );
void                        DestroyFontToSubsFontConverter( FontToSubsFontConverter hConverter );
sal_Unicode                 ConvertFontToSubsFontChar( FontToSubsFontConverter hConverter, sal_Unicode c );
String                      GetFontToSubsFontName( FontToSubsFontConverter hConverter );

#define SUBSFONT_ONLYONE    ((ULONG)0x00000001)
#define SUBSFONT_MS         ((ULONG)0x00000002)
#define SUBSFONT_PS         ((ULONG)0x00000004)
#define SUBSFONT_HTML       ((ULONG)0x00000008)
String GetSubsFontName( const String& rName, ULONG nFlags );

String GetFontToken( const String& rName, xub_StrLen nToken, xub_StrLen& rIndex );
inline String GetFontToken( const String& rName, xub_StrLen nToken )
{
	xub_StrLen nTempIndex = 0;
	return GetFontToken( rName, nToken, nTempIndex );
}

#endif 
