

#ifndef _SV_HATCH_HXX
#define _SV_HATCH_HXX

#include <vcl/color.hxx>
#include <vcl/vclenum.hxx>

class SvStream;

struct ImplHatch
{
	USHORT				mnRefCount;
	Color				maColor;
	HatchStyle			meStyle;
	long				mnDistance;
	long				mnDummy;
	USHORT				mnAngle;
				ImplHatch();
			ImplHatch( const ImplHatch& rImplHatch );
	 friend SvStream&	operator>>( SvStream& rIStm, ImplHatch& rImplHatch );
	friend SvStream&	operator<<( SvStream& rOStm, const ImplHatch& rImplHatch );
};

class Hatch
{
private:	

	ImplHatch*		mpImplHatch;
	void			ImplMakeUnique();

public:
			Hatch();
	                Hatch( const Hatch& rHatch );
	                Hatch( HatchStyle eStyle, const Color& rHatchColor, long nDistance, USHORT nAngle10 = 0 );
	                ~Hatch();

	Hatch&			operator=( const Hatch& rHatch );
	BOOL            operator==( const Hatch& rHatch ) const;
	BOOL            operator!=( const Hatch& rHatch ) const { return !(Hatch::operator==( rHatch ) ); }
	BOOL            IsSameInstance( const Hatch& rHatch ) const { return( mpImplHatch == rHatch.mpImplHatch ); }
	 void            SetStyle( HatchStyle eStyle );
	HatchStyle		GetStyle() const { return mpImplHatch->meStyle; }
	 void            SetColor( const Color& rColor  );
	const Color&	GetColor() const { return mpImplHatch->maColor; }
	 void            SetDistance( long nDistance  );
	long			GetDistance() const { return mpImplHatch->mnDistance; }

	void            SetAngle( USHORT nAngle10 );
	USHORT          GetAngle() const { return mpImplHatch->mnAngle; }
	 friend SvStream& operator>>( SvStream& rIStm, Hatch& rHatch );
	friend SvStream& operator<<( SvStream& rOStm, const Hatch& rHatch );

#ifdef SMART_UNO_GENERATION

	HatchStyle		getStyle() const { return GetStyle(); }
	void 			setStyle( HatchStyle eStyle ) { SetStyle( eStyle ); }

	long 			getColor() const { return GetColor().GetColor(); }
	void 			setColor( long nColor ) { SetColor( Color( nColor ) ); }

	long			getDistance() const { return GetDistance(); }
	void 			setDistance( ULONG nDistance ) { SetDistance( nDistance ); }

	USHORT 			getAngle() const { return GetAngle(); }
	void 			setAngle( USHORT n ) { SetAngle( n ); }

#endif
};

#endif  
