

#ifndef _VCL_I18NHELP_HXX
#define _VCL_I18NHELP_HXX

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif

#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

namespace com {
namespace sun {
namespace star {
namespace lang {
	class XMultiServiceFactory; 
}
}}}

namespace utl {
	class TransliterationWrapper;
}

class LocaleDataWrapper;

class Date;

namespace vcl
{

class I18nHelper
{
private:
	::osl::Mutex	                maMutex;
	::com::sun::star::lang::Locale  maLocale;
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > mxMSF;
	LocaleDataWrapper*              mpLocaleDataWrapper;
	utl::TransliterationWrapper*    mpTransliterationWrapper;
	 sal_Bool                        mbTransliterateIgnoreCase;
	 void                            ImplDestroyWrappers();

protected:
	::osl::Mutex& GetMutex() { return maMutex; }
	 utl::TransliterationWrapper&         ImplGetTransliterationWrapper() const;

public:
	         I18nHelper( ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& rxMSF, const ::com::sun::star::lang::Locale& rLocale );
	        ~I18nHelper();
	 void    setLocale( const ::com::sun::star::lang::Locale& rLocale );
	const ::com::sun::star::lang::Locale& getLocale() const;
	 sal_Bool equals( const String& rStr1, sal_Int32 nPos1, sal_Int32 nCount1, const String& rStr2, sal_Int32 nPos2, sal_Int32 nCount2, sal_Bool bIgnoreCase = FALSE ) const;
	 String  getDate( const Date& rDate, sal_Bool bLongFormat ) const;
};

}	

#endif  

