

#ifndef _IMGCONS_HXX
#define _IMGCONS_HXX

#include <vcl/bitmap.hxx>

class ImageProducer;
class ImplColorMapper;
class BitmapEx;
class Image;

#define IMAGEERROR			1
#define SINGLEFRAMEDONE 	2
#define STATICIMAGEDONE 	3
#define IMAGEABORTED		4

class ImageConsumer
{
private:

	Bitmap				maBitmap;
	Bitmap				maMask;
	Rectangle			maChangedRect;
	Rectangle			maDummyRect;
	Size				maSize;
	ImplColorMapper*	mpMapper;
	Color*				mpPal;
	Link				maChgLink;
	Link				maDoneLink;
	ULONG				mnFormat;
	ULONG				mnStatus;
	BOOL				mbTrans;
	long				mnDummy1;
	long				mnDummy2;
	BOOL				mbDummy1;
	BOOL				mbDummy2;

protected:				

	virtual void		DataChanged();

public:					
				ImageConsumer();
	virtual				~ImageConsumer();

	BOOL				GetData( BitmapEx& rBmpEx ) const;
	BOOL				GetData( Image& rImage ) const;
	const Rectangle&	GetChangedRect() const { return maChangedRect; }
	ULONG				GetStatus() const;

	void				SetDataChangedLink( const Link& rLink ) { maChgLink = rLink; }
	const Link&			GetDataChangedLink() const { return maChgLink; }

	void				SetDoneLink( const Link& rLink ) { maDoneLink = rLink; }
	const Link&			GetDoneLink() const { return maDoneLink; }

public:

	virtual void		Init( ULONG nWidth, ULONG nHeight );

	virtual void		SetColorModel( USHORT nBitCount,
						   ULONG nPalEntries, const ULONG* pRGBAPal, 
						   ULONG nRMask, ULONG nGMask, ULONG nBMask, ULONG nAMask  );

	virtual	void		SetPixelsByBytes( ULONG nConsX, ULONG nConsY, 
							  ULONG nConsWidth, ULONG nConsHeight,
							  const BYTE* pProducerData, ULONG nOffset, ULONG nScanSize );

	virtual	void		SetPixelsByLongs( ULONG nConsX, ULONG nConsY, 
							  ULONG nConsWidth, ULONG nConsHeight,
							  const ULONG* pProducerData, ULONG nOffset, ULONG nScanSize );

	virtual void		Completed( ULONG nStatus );

};

#endif 
