

#ifndef _SV_LINE_HXX
#define _SV_LINE_HXX

#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif

class Link;

class Line
{
private:
	 Point           maStart;
	Point           maEnd;

public:
	                Line() {};
	                Line( const Point& rStartPt, const Point& rEndPt ) : maStart( rStartPt ), maEnd( rEndPt ) {}
	 void            SetStart( const Point& rStartPt ) { maStart = rStartPt; }
	const Point&    GetStart() const  { return maStart; }
	 void            SetEnd( const Point& rEndPt ) { maEnd = rEndPt; }
	const Point&    GetEnd() const { return maEnd; }

	long			Left() const { return ( maStart.X() < maEnd.X() ) ? maStart.X() : maEnd.X(); }
	long			Top() const { return ( maStart.Y() < maEnd.Y() ) ? maStart.Y() : maEnd.Y(); }
	long			Right() const { return ( maStart.X() > maEnd.X() ) ? maStart.X() : maEnd.X(); }
	long			Bottom() const { return ( maStart.Y() > maEnd.Y() ) ? maStart.Y() : maEnd.Y(); }
	 BOOL            Intersection( const Line& rLine, double& rIntersectionX, double& rIntersectionY ) const;
	BOOL            Intersection( const Line& rLine, Point& rIntersection ) const;

	double			GetDistance( const double& rPtX, const double& rPtY ) const;
	double			GetDistance( const Point& rPoint ) const { return( GetDistance( rPoint.X(), rPoint.Y() ) ); }
	 Point           NearestPoint( const Point& rPoint ) const;
	 void            Enum( const Link& rEnumLink );
};

#endif 
