

#ifndef _SV_LINEINFO_HXX
#define _SV_LINEINFO_HXX

#include <tools/gen.hxx>
#include <vcl/vclenum.hxx>

class SvStream;

struct ImplLineInfo
{
	USHORT				mnRefCount;
	LineStyle			meStyle;
	long				mnWidth;
	USHORT				mnDashCount;
	long				mnDashLen;
	USHORT				mnDotCount;
	long				mnDotLen;
	long				mnDistance;
				ImplLineInfo();
			ImplLineInfo( const ImplLineInfo& rImplLineInfo );
	 friend SvStream&	operator>>( SvStream& rIStm, ImplLineInfo& rImplLineInfo );
	friend SvStream&	operator<<( SvStream& rOStm, const ImplLineInfo& rImplLineInfo );
};

class LineInfo
{
private:	

	ImplLineInfo*	mpImplLineInfo;
	long			n1;
	long			n2;
	long			n3;

	void			ImplMakeUnique();

public:
			LineInfo( LineStyle eLineStyle = LINE_SOLID, long nWidth = 0L );
	                LineInfo( const LineInfo& rLineInfo );
	                ~LineInfo();

	LineInfo&		operator=( const LineInfo& rLineInfo );
	BOOL            operator==( const LineInfo& rLineInfo ) const;
	BOOL            operator!=( const LineInfo& rLineInfo ) const { return !(LineInfo::operator==( rLineInfo ) ); }
	BOOL            IsSameInstance( const LineInfo& rLineInfo ) const { return( mpImplLineInfo == rLineInfo.mpImplLineInfo ); }
	 void            SetStyle( LineStyle eStyle );
	LineStyle		GetStyle() const { return mpImplLineInfo->meStyle; }
	 void            SetWidth( long nWidth );
	long			GetWidth() const { return mpImplLineInfo->mnWidth; }

	void			SetDashCount( USHORT nDashCount );
	USHORT			GetDashCount() const { return mpImplLineInfo->mnDashCount; }

	void			SetDashLen( long nDashLen );
	long			GetDashLen() const { return mpImplLineInfo->mnDashLen; }

	void			SetDotCount( USHORT nDotCount );
	USHORT			GetDotCount() const { return mpImplLineInfo->mnDotCount; }

	void			SetDotLen( long nDotLen );
	long			GetDotLen() const { return mpImplLineInfo->mnDotLen; }

	void			SetDistance( long nDistance );
	long			GetDistance() const { return mpImplLineInfo->mnDistance; }

	BOOL			IsDefault() const { return( !mpImplLineInfo->mnWidth && ( LINE_SOLID == mpImplLineInfo->meStyle ) ); }
	 friend SvStream& operator>>( SvStream& rIStm, LineInfo& rLineInfo );
	friend SvStream& operator<<( SvStream& rOStm, const LineInfo& rLineInfo );

#ifdef SMART_UNO_GENERATION

	LineStyle		getStyle() const { return GetStyle(); }
	void 			setStyle( LineStyle eStyle ) { SetStyle( eStyle ); }

	long			getWidth() const { return GetWidth(); }
	void 			setWidth( ULONG nDistance ) { SetWidth( nWidth ); }

	USORT			getDashCount const { return GetDashCount(); }
	void			setDashCount( USHORT nDashCount ) { SetDashCount( nDashCount ); }

	long			getDashLen() const { return GetDashLen(); }
	void			setDashLen( long nDashLen ) { SetDashLen( nDashLen ); }

	USHORT			getDotCount() const { return GetDotCount(); }
	void			setDotCount( USHORT nDotCount ) { SetDotCount( nDotCount ); }

	long			getDotLen() const { GetDotLen(); }
	void			setDotLen( long nDotLen ) { SetDotLen( nDotLen ); }

	long			getDistance() const { return GetDistance(); }
	void			setDistance( long nDistance ) { SetDistance( nDistance ); }

#endif
};

#endif  
