

#ifndef _LONGCURR_HXX
#define _LONGCURR_HXX

#ifndef _BIGINT_HXX
#include <tools/bigint.hxx>
#endif
#ifndef _FIELD_HXX
#include <vcl/field.hxx>
#endif

class LocaleDataWrapper;

class LongCurrencyFormatter : public FormatterBase
{
#if 0 // _SOLAR__PRIVATE
#ifdef VCL_LONGCURR_CXX
	friend BOOL ImplLongCurrencyReformat( const XubString&, BigInt, BigInt, USHORT, const LocaleDataWrapper&, XubString&, LongCurrencyFormatter& );
	void					ImpInit();
#endif
#endif

protected:
	BigInt					mnFieldValue;
	BigInt					mnLastValue;
	BigInt					mnMin;
	BigInt					mnMax;
	BigInt					mnCorrectedValue;
	String                  maCurrencySymbol;
	USHORT					mnType;
	USHORT                  mnDecimalDigits;
	BOOL                    mbThousandSep;
	 ULONG                   mnDummy;
	BOOL                    mbDummy;
					LongCurrencyFormatter();
	void					ImplLoadRes( const ResId& rResId );

public:
				~LongCurrencyFormatter();

	virtual void			Reformat();
	virtual void			ReformatAll();
	 void                    SetUseThousandSep( BOOL b );
	BOOL                    IsUseThousandSep() const { return mbThousandSep; }
	 void                    SetCurrencySymbol( const String& rStr );
	String                  GetCurrencySymbol() const;
	 void					SetMin( BigInt nNewMin );
	BigInt					GetMin() const { return mnMin; }
	void					SetMax( BigInt nNewMax );
	BigInt					GetMax() const { return mnMax; }

	void					SetDecimalDigits( USHORT nDigits );
	USHORT					GetDecimalDigits() const;
	void					SetValue( BigInt nNewValue );
	void					SetUserValue( BigInt nNewValue );
	BigInt					GetValue() const;
	BOOL					IsValueModified() const;

	void					SetEmptyValue();
	BOOL					IsEmptyValue() const { return !GetField()->GetText().Len(); }

	BigInt					GetCorrectedValue() const { return mnCorrectedValue; }

	BigInt					Normalize( BigInt nValue ) const;
	BigInt					Denormalize( BigInt nValue ) const;
};

class LongCurrencyField : public SpinField, public LongCurrencyFormatter
{
#if 0 // _SOLAR__PRIVATE
#ifdef VCL_LONGCURR_CXX
	friend void ImplNewLongCurrencyFieldValue( LongCurrencyField*, BigInt );
#endif
#endif

private:
	BigInt			mnSpinSize;
	BigInt			mnFirst;
	BigInt			mnLast;

protected:
	void			ImplLoadRes( const ResId& rResId );

public:
		LongCurrencyField( Window* pParent, WinBits nWinStyle );
		LongCurrencyField( Window* pParent, const ResId& rResId );
		~LongCurrencyField();

	long			PreNotify( NotifyEvent& rNEvt );
	long			Notify( NotifyEvent& rNEvt );

	void			Modify();
	void			Up();
	void			Down();
	void			First();
	void			Last();

	void			SetFirst( BigInt nNewFirst ) { mnFirst = nNewFirst; }
	BigInt			GetFirst() const { return mnFirst; }
	void			SetLast( BigInt nNewLast ) { mnLast = nNewLast; }
	BigInt			GetLast() const { return mnLast; }
	void			SetSpinSize( BigInt nNewSize ) { mnSpinSize = nNewSize; }
	BigInt			GetSpinSize() const { return mnSpinSize; }
};

class LongCurrencyBox : public ComboBox, public LongCurrencyFormatter
{
public:
		LongCurrencyBox( Window* pParent, WinBits nWinStyle );
		LongCurrencyBox( Window* pParent, const ResId& rResId );
		~LongCurrencyBox();

	long			PreNotify( NotifyEvent& rNEvt );
	long			Notify( NotifyEvent& rNEvt );

	void			Modify();
	void			ReformatAll();

	void			InsertValue( BigInt nValue,
					 USHORT nPos = COMBOBOX_APPEND );
	void			RemoveValue( BigInt nValue );
	BigInt			GetValue() const
			{ return LongCurrencyFormatter::GetValue(); }
	BigInt			GetValue( USHORT nPos ) const;
	USHORT			GetValuePos( BigInt nValue ) const;
};

#endif 
