

#ifndef _SV_MENUBTN_HXX
#define _SV_MENUBTN_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif

class Timer;
class PopupMenu;

#define MENUBUTTON_MENUMODE_TIMED		((USHORT)0x0001)

class MenuButton : public PushButton
{
private:
	Rectangle		maFocusRect;
	void*			mpDummy;
	Timer*			mpMenuTimer;
	PopupMenu*		mpOwnMenu;
	PopupMenu*		mpMenu;
	USHORT			mnCurItemId;
	USHORT			mnMenuMode;
	Link			maActivateHdl;
	Link			maSelectHdl;

#ifdef _SV_MENUBTN_CXX
	void			ImplInitData();
	void			ImplExecuteMenu();
		DECL_LINK( ImplMenuTimeoutHdl, Timer* );
#endif

protected:
	void			ImplInit( Window* pParent, WinBits nStyle );
	void			ImplLoadRes( const ResId& rResId );

public:
		MenuButton( Window* pParent, WinBits nStyle = 0 );
		MenuButton( Window* pParent, const ResId& rResId );
		~MenuButton();

	virtual void	MouseButtonDown( const MouseEvent& rMEvt );
	virtual void	KeyInput( const KeyEvent& rKEvt );

	virtual void	Activate();
	virtual void	Select();

	void			SetMenuMode( USHORT nMode );
	USHORT			GetMenuMode() const { return mnMenuMode; }

	void			SetPopupMenu( PopupMenu* pNewMenu );
	PopupMenu*		GetPopupMenu() const { return mpMenu; }

	USHORT			GetCurItemId() const { return mnCurItemId; }

	void			SetActivateHdl( const Link& rLink ) { maActivateHdl = rLink; }
	const Link& 	GetActivateHdl() const				{ return maActivateHdl; }
	void			SetSelectHdl( const Link& rLink )	{ maSelectHdl = rLink; }
	const Link& 	GetSelectHdl() const				{ return maSelectHdl; }
};

#endif	
