

#ifndef _SV_MOREBTN_HXX
#define _SV_MOREBTN_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_MAPMOD_HXX
#include <vcl/mapmod.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif

class ImplMoreWindowList;

class MoreButton : public PushButton
{
private:
	ImplMoreWindowList* mpItemList;
	ULONG               mnDelta;
	MapUnit             meUnit;
	BOOL                mbState;

protected:
	void                ImplInit( Window* pParent, WinBits nStyle );
	void 				ImplLoadRes( const ResId& rResId );

public:
	                    MoreButton( Window* pParent, WinBits nStyle = 0 );
	                    MoreButton( Window* pParent, const ResId& rResId );
	                    ~MoreButton();
	 void                Click();
	 void                AddWindow( Window* pWindow );
	void                RemoveWindow( Window* pWindow );
	 void                SetDelta( ULONG nNewDelta ) { mnDelta = nNewDelta; }
	ULONG               GetDelta() const { return mnDelta; }
	 void                SetMapUnit( MapUnit eNewUnit = MAP_PIXEL ) { meUnit = eNewUnit; }
	MapUnit             GetMapUnit() const { return meUnit; }
	 void                SetState( BOOL bNewState = TRUE );
	BOOL                GetState() const { return mbState; }
	 void                SetText( const XubString& rNewText );
	XubString            GetText() const;
};

inline void MoreButton::SetState( BOOL bNewState )
{
	if ( mbState != bNewState )
	    Click();
}

#endif  
