

#ifndef _SV_MSGBOX_HXX
#define _SV_MSGBOX_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_BTNDLG_HXX
#include <vcl/btndlg.hxx>
#endif
#ifndef _SV_IMAGE_HXX
#include <vcl/image.hxx>
#endif

class FixedText;
class FixedImage;
class CheckBox;

#define RET_OK				 TRUE
#define RET_CANCEL			 FALSE
#define RET_YES 			 2
#define RET_NO				 3
#define RET_RETRY			 4

#define BUTTONID_OK 		 RET_OK
#define BUTTONID_CANCEL 	 RET_CANCEL
#define BUTTONID_YES		 RET_YES
#define BUTTONID_NO 		 RET_NO
#define BUTTONID_RETRY		 RET_RETRY
#define BUTTONID_HELP		 10

class MessBox : public ButtonDialog
{
protected:
	FixedText*			mpFixedText;
	FixedImage* 		mpFixedImage;
	XubString			maMessText;
	Image				maImage;
	USHORT				mnSoundType;
	BOOL				mbHelpBtn;
	BOOL				mbSound;
	CheckBox*           mpCheckBox;
	XubString           maCheckBoxText;
	BOOL                mbCheck;

#ifdef _SV_MSGBOX_CXX
private:
	void				ImplInitData();
	void				ImplInitButtons();
	void				ImplPosControls();
#endif

protected:
	void				ImplLoadRes( const ResId& rResId );
			MessBox( WindowType nType );

public:
			MessBox( Window* pParent, WinBits nStyle,
					 const XubString& rTitle, const XubString& rMessage );
			MessBox( Window* pParent, const ResId& rResId );
			~MessBox();

	virtual void		StateChanged( StateChangedType nStateChange );

	void				SetMessText( const XubString& rText ) { maMessText = rText; }
	const XubString& 	GetMessText() const { return maMessText; }

	void				SetImage( const Image& rImage ) { maImage = rImage; }
	const Image&		GetImage() const { return maImage; }
	 void                SetDefaultCheckBoxText();
	void                SetCheckBoxText( const XubString& rText ) { maCheckBoxText = rText;} 
	const XubString&    GetCheckBoxText() const { return maCheckBoxText;} 
	void                SetCheckBoxState( BOOL bCheck );
	BOOL                GetCheckBoxState() const;
};

class InfoBox : public MessBox
{
#ifdef _SV_MSGBOX_CXX
private:
	void				ImplInitData();
#endif

public:
			InfoBox( Window* pParent, const XubString& rMessage );
			InfoBox( Window* pParent, const ResId & rResId );

	static Image		GetStandardImage();
};

class WarningBox : public MessBox
{
#ifdef _SV_MSGBOX_CXX
private:
	void				ImplInitData();
#endif

public:
			WarningBox( Window* pParent, WinBits nStyle,
						const XubString& rMessage );
			WarningBox( Window* pParent, const ResId& rResId );

	static Image		GetStandardImage();
};

class ErrorBox : public MessBox
{
#ifdef _SV_MSGBOX_CXX
private:
	void				ImplInitData();
#endif

public:
			ErrorBox( Window* pParent, WinBits nStyle,
					  const XubString& rMessage );
			ErrorBox( Window* pParent, const ResId& rResId );

	static Image		GetStandardImage();
};

class QueryBox : public MessBox
{
#ifdef _SV_MSGBOX_CXX
private:
	void				ImplInitData();
#endif

public:
			QueryBox( Window* pParent, WinBits nStyle,
					  const XubString& rMessage );
			QueryBox( Window* pParent, const ResId& rResId );

	static Image		GetStandardImage();
};

#endif	
