

#ifndef _SV_PRNTYPES_HXX
#define _SV_PRNTYPES_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif

enum Orientation { ORIENTATION_PORTRAIT, ORIENTATION_LANDSCAPE };

typedef USHORT Paper;
#define PAPER_A3					((Paper)0)
#define PAPER_A4					((Paper)1)
#define PAPER_A5					((Paper)2)
#define PAPER_B4					((Paper)3)
#define PAPER_B5					((Paper)4)
#define PAPER_LETTER				((Paper)5)
#define PAPER_LEGAL 				((Paper)6)
#define PAPER_TABLOID				((Paper)7)
#define PAPER_USER					((Paper)8)

#define QUEUE_STATUS_READY				((ULONG)0x00000001)
#define QUEUE_STATUS_PAUSED 			((ULONG)0x00000002)
#define QUEUE_STATUS_PENDING_DELETION	((ULONG)0x00000004)
#define QUEUE_STATUS_BUSY				((ULONG)0x00000008)
#define QUEUE_STATUS_INITIALIZING		((ULONG)0x00000010)
#define QUEUE_STATUS_WAITING			((ULONG)0x00000020)
#define QUEUE_STATUS_WARMING_UP 		((ULONG)0x00000040)
#define QUEUE_STATUS_PROCESSING 		((ULONG)0x00000080)
#define QUEUE_STATUS_PRINTING			((ULONG)0x00000100)
#define QUEUE_STATUS_OFFLINE			((ULONG)0x00000200)
#define QUEUE_STATUS_ERROR				((ULONG)0x00000400)
#define QUEUE_STATUS_SERVER_UNKNOWN 	((ULONG)0x00000800)
#define QUEUE_STATUS_PAPER_JAM			((ULONG)0x00001000)
#define QUEUE_STATUS_PAPER_OUT			((ULONG)0x00002000)
#define QUEUE_STATUS_MANUAL_FEED		((ULONG)0x00004000)
#define QUEUE_STATUS_PAPER_PROBLEM		((ULONG)0x00008000)
#define QUEUE_STATUS_IO_ACTIVE			((ULONG)0x00010000)
#define QUEUE_STATUS_OUTPUT_BIN_FULL	((ULONG)0x00020000)
#define QUEUE_STATUS_TONER_LOW			((ULONG)0x00040000)
#define QUEUE_STATUS_NO_TONER			((ULONG)0x00080000)
#define QUEUE_STATUS_PAGE_PUNT			((ULONG)0x00100000)
#define QUEUE_STATUS_USER_INTERVENTION	((ULONG)0x00200000)
#define QUEUE_STATUS_OUT_OF_MEMORY		((ULONG)0x00400000)
#define QUEUE_STATUS_DOOR_OPEN			((ULONG)0x00800000)
#define QUEUE_STATUS_POWER_SAVE 		((ULONG)0x01000000)

#define QUEUE_JOBS_DONTKNOW 			((ULONG)0xFFFFFFFF)

#define PRINTER_CAPABILITIES_SUPPORTDIALOG		((USHORT)1)
#define PRINTER_CAPABILITIES_COPIES 				((USHORT)2)
#define PRINTER_CAPABILITIES_COLLATECOPIES		((USHORT)3)
#define PRINTER_CAPABILITIES_SETORIENTATION 		((USHORT)4)
#define PRINTER_CAPABILITIES_SETPAPERBIN			((USHORT)5)
#define PRINTER_CAPABILITIES_SETPAPERSIZE		((USHORT)6)
#define PRINTER_CAPABILITIES_SETPAPER			((USHORT)7)
#define PRINTER_CAPABILITIES_FAX					((USHORT)8)

#endif	
