

#ifndef _SV_REGBAND_HXX
#define _SV_REGBAND_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_POLY_HXX
#include <vcl/poly.hxx>
#endif

struct ImplRegionBandSep
{
	ImplRegionBandSep*			mpNextSep;
	long						mnXLeft;
	long						mnXRight;
	BOOL						mbRemoved;
};

enum LineType { LINE_ASCENDING, LINE_DESCENDING, LINE_HORIZONTAL };

struct ImplRegionBandPoint
{
	ImplRegionBandPoint*		mpNextBandPoint;
	long						mnX;
	long						mnLineId;
	BOOL						mbEndPoint;
	LineType					meLineType;
};

class ImplRegionBand
{
public:
	ImplRegionBand* 			mpNextBand; 		
	ImplRegionBand* 			mpPrevBand; 		
	ImplRegionBandSep*			mpFirstSep; 		
	ImplRegionBandPoint*		mpFirstBandPoint;	
	long						mnYTop; 			
	long						mnYBottom;
	BOOL						mbTouched;
						ImplRegionBand( long nYTop, long nYBottom );
						ImplRegionBand( const ImplRegionBand & theSourceBand );
					~ImplRegionBand();

	long						GetXLeftBoundary() const;
	long						GetXRightBoundary() const;

	BOOL						OptimizeBand();

	void						ProcessPoints();

	BOOL						InsertPoint( long nX, long nLineID,
								 BOOL bEndPoint, LineType eLineType );

	void						Union( long nXLeft, long nXRight );
	void						Intersect( long nXLeft, long nXRight );
	void						Exclude( long nXLeft, long nXRight );
	void						XOr( long nXLeft, long nXRight );

	void						MoveX( long nHorzMove );
	void						ScaleX( double fHorzScale );

	BOOL						IsInside( long nX );
	BOOL						IsInside( long nLeft, long nRight );
	BOOL						IsOver( long nLeft, long nRight );

	BOOL						IsEmpty() const { return ((!mpFirstSep) && (!mpFirstBandPoint)); }

	BOOL						operator==( const ImplRegionBand& rRegionBand ) const;
};

#endif	
