

#ifndef _SV_SPIN_HXX
#define _SV_SPIN_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_CTRL_HXX
#include <vcl/ctrl.hxx>
#endif
#ifndef _SV_TIMER_HXX
#include <vcl/timer.hxx>
#endif

class SpinButton : public Control
{
private:
	AutoTimer       maRepeatTimer;
	Rectangle       maUpperRect;
	Rectangle       maLowerRect;
	BOOL            mbRepeat      : 1;
	BOOL            mbUpperIn     : 1;
	BOOL            mbLowerIn     : 1;
	BOOL            mbInitialUp   : 1;
	BOOL            mbInitialDown : 1;
	BOOL            mbHorz        : 1;
	Link            maUpHdlLink;
	Link            maDownHdlLink;

#ifdef _SV_SPIN_CXX
	void            ImplInit( Window* pParent, WinBits nStyle );
	                DECL_LINK( ImplTimeout, Timer* );
#endif

public:
	                SpinButton( Window* pParent, WinBits nStyle = 0 );
	                SpinButton( Window* pParent, const ResId& rResId );
	                ~SpinButton();
	 virtual void    Up();
	virtual void    Down();
	 virtual void    Resize();
	virtual void    Paint( const Rectangle& rRect );
	virtual void    MouseButtonDown( const MouseEvent& rMEvt );
	virtual void    MouseButtonUp( const MouseEvent& rMEvt );
	virtual void    MouseMove( const MouseEvent& rMEvt );
	virtual void    KeyInput( const KeyEvent& rKEvt );
	virtual void    StateChanged( StateChangedType nStateChange );
	 void            SetUpHdl( const Link& rLink ) { maUpHdlLink = rLink; }
	const Link&     GetUpHdl() const   { return maUpHdlLink;   }
	void            SetDownHdl( const Link& rLink ) { maDownHdlLink = rLink; }
	const Link&     GetDownHdl() const { return maDownHdlLink; }
};

#endif  
