

#ifndef _SV_SPLIT_HXX
#define _SV_SPLIT_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_WINDOW_HXX
#include <vcl/window.hxx>
#endif

class Splitter : public Window
{
private:
	Window*             mpRefWin;
	long                mnSplitPos;
	long                mnLastSplitPos;
	long                mnStartSplitPos;
	Point               maDragPos;
	Rectangle           maDragRect;
	BOOL                mbHorzSplit;
	BOOL                mbDragFull;
	Link                maStartSplitHdl;
	Link                maSplitHdl;

#ifdef _SV_SPLIT_CXX
	void 				ImplInitData();
	void 				ImplDrawSplitter();
	void                ImplSplitMousePos( Point& rPos );
#endif

protected:
	void 				ImplInit( Window* pParent, WinBits nWinStyle );

public:
	                    Splitter( Window* pParent, WinBits nStyle = WB_VSCROLL );
	                    Splitter( Window* pParent, const ResId& rResId );
	                    ~Splitter();
	 virtual void        StartSplit();
	virtual void        Split();
	virtual void        Splitting( Point& rSplitPos );
	 virtual void        MouseButtonDown( const MouseEvent& rMEvt );
	virtual void        Tracking( const TrackingEvent& rTEvt );
	 void                StartDrag();
	 void                SetDragRectPixel( const Rectangle& rDragRect,
	                                      Window* pRefWin = NULL );
	const Rectangle&    GetDragRectPixel() const { return maDragRect; }
	Window*             GetDragWindow() const { return mpRefWin; }
	 virtual void        SetSplitPosPixel( long nPos );
	long                GetSplitPosPixel() const { return mnSplitPos; }
	 void                SetLastSplitPosPixel( long nNewPos );
	long                GetLastSplitPosPixel() const { return mnLastSplitPos; }
	 BOOL                IsHorizontal() const { return mbHorzSplit; }
	 void                SetStartSplitHdl( const Link& rLink ) { maStartSplitHdl = rLink; }
	const Link&         GetStartSplitHdl() const { return maStartSplitHdl; }
	void                SetSplitHdl( const Link& rLink ) { maSplitHdl = rLink; }
	const Link&         GetSplitHdl() const { return maSplitHdl; }
};

#endif  
