

#ifndef _SV_SYSWIN_HXX
#define _SV_SYSWIN_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_WINDOW_HXX
#include <vcl/window.hxx>
#endif

class ModalDialog;
class MenuBar;

#define MENUBAR_MODE_NORMAL 		((USHORT)0)
#define MENUBAR_MODE_HIDE			((USHORT)1)

#define TITLE_BUTTON_DOCKING		((USHORT)1)
#define TITLE_BUTTON_HIDE			((USHORT)2)

class SystemWindow : public Window
{
private:
	MenuBar*		mpMenuBar;
	Size			maOrgSize;
	Size			maRollUpOutSize;
	Size			maMinOutSize;
	BOOL			mbPined;
	BOOL			mbRollUp;
	BOOL			mbRollFunc;
	BOOL			mbDockBtn;
	BOOL			mbHideBtn;
	BOOL			mbDummy1;
	BOOL			mbDummy2;
	BOOL			mbDummy3;
	USHORT			mnMenuBarMode;
	USHORT			mnDummy;

protected:
		SystemWindow( WindowType nType );

public:
	virtual long	Notify( NotifyEvent& rNEvt );

	virtual BOOL	Close();
	virtual void	TitleButtonClick( USHORT nButton );
	virtual void	Pin();
	virtual void	Roll();
	virtual void	Resizing( Size& rSize );

	void			SetZLevel( BYTE nLevel );
	BYTE			GetZLevel() const;

	void			EnableSaveBackground( BOOL bSave = TRUE );
	BOOL			IsSaveBackgroundEnabled() const;

	void			ShowTitleButton( USHORT nButton, BOOL bVisible = TRUE );
	BOOL			IsTitleButtonVisible( USHORT nButton ) const;

	void			SetPin( BOOL bPin );
	BOOL			IsPined() const { return mbPined; }

	void			RollUp();
	void			RollDown();
	BOOL			IsRollUp() const { return mbRollUp; }

	void			SetRollUpOutputSizePixel( const Size& rSize ) { maRollUpOutSize = rSize; }
	Size			GetRollUpOutputSizePixel() const { return maRollUpOutSize; }

	void			SetMinOutputSizePixel( const Size& rSize );
	const Size& 	GetMinOutputSizePixel() const { return maMinOutSize; }
	Size			GetResizeOutputSizePixel() const;

	void			SetMenuBar( MenuBar* pMenuBar );
	MenuBar*		GetMenuBar() const { return mpMenuBar; }
	void			SetMenuBarMode( USHORT nMode );
	USHORT			GetMenuBarMode() const { return mnMenuBarMode; }
};

#endif 
