

#include <osl/conditn.h>
#include <osl/thread.h>
#include <tools/link.hxx>

namespace vcl
{
	class ThreadExecutor
	{
		oslThread				m_aThread;
		oslCondition			m_aFinish;
		long					m_nReturn;

		static void SAL_CALL worker( void* );
	public:
		ThreadExecutor();
		~ThreadExecutor();

		virtual long doIt() = 0;
		long execute();
	};

	class SolarThreadExecutor
	{
		oslCondition			m_aFinish;
		long					m_nReturn;

		DECL_LINK( worker, void* );
	public:
		SolarThreadExecutor();
		~SolarThreadExecutor();

		virtual long doIt() = 0;
		long execute();
	};

}
