

#ifndef _SV_TIMER_HXX
#define _SV_TIMER_HXX

#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif

struct ImplTimerData;
struct ImplSVData;

class Timer
{
protected:
	ImplTimerData*  mpTimerData;
	ULONG           mnTimeout;
	BOOL            mbActive;
	BOOL            mbAuto;
	Link            maTimeoutHdl;

public:
	                Timer();
	                Timer( const Timer& rTimer );
	                ~Timer();
	 virtual void    Timeout();
	 void            Start();
	void            Stop();
	 void            SetTimeout( ULONG nTimeout );
	ULONG           GetTimeout() const { return mnTimeout; }
	BOOL            IsActive() const { return mbActive; }
	 void            SetTimeoutHdl( const Link& rLink ) { maTimeoutHdl = rLink; }
	const Link&     GetTimeoutHdl() const { return maTimeoutHdl; }
	 Timer&          operator=( const Timer& rTimer );
};

class AutoTimer : public Timer
{
public:
	                AutoTimer();
	                AutoTimer( const AutoTimer& rTimer );
	 AutoTimer&      operator=( const AutoTimer& rTimer );
};

#endif 
