

#ifndef _VCL_UNOWRAP_HXX
#define _VCL_UNOWRAP_HXX

#include <tools/solar.h>

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif

class XWindowPeer;
class XToolkit; 
class XVclToolkit; 
class EventList; 
class Window;
class OutputDevice; 
class MouseEvent;
class CommandEvent;
class KeyEvent;
class Rectangle;
class XVclComponentPeer; 

namespace com {
namespace sun {
namespace star {
namespace awt {
	class XGraphics;
	class XToolkit;
	class XWindowPeer;
}
namespace lang {
	class XMultiServiceFactory;
}
} } }

class UnoWrapperBase
{
public:	
	virtual void 				Destroy() = 0;

	virtual ::com::sun::star::uno::Reference< ::com::sun::star::awt::XToolkit > GetVCLToolkit() = 0;

	virtual ::com::sun::star::uno::Reference< ::com::sun::star::awt::XGraphics >	CreateGraphics( OutputDevice* pOutDev ) = 0;
	virtual void				ReleaseAllGraphics( OutputDevice* pOutDev ) = 0;

	virtual ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindowPeer> GetWindowInterface( Window* pWindow, sal_Bool bCreate ) = 0;
	virtual void				SetWindowInterface( Window* pWindow, ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindowPeer > xIFace ) = 0;

	virtual void				WindowDestroyed( Window* pWindow ) = 0;

	virtual void 				WindowEvent_Move( Window* pWindow ) = 0;
	virtual void 				WindowEvent_Resize( Window* pWindow ) = 0;
	virtual void 				WindowEvent_Show( Window* pWindow, sal_Bool bShow ) = 0;
	virtual void 				WindowEvent_Activate( Window* pWindow, sal_Bool bActivated ) = 0;
	virtual void 				WindowEvent_MouseButtonUp( Window* pWindow, const MouseEvent& rEvt ) = 0;
	virtual void 				WindowEvent_MouseButtonDown( Window* pWindow, const MouseEvent& rEvt ) = 0;
	virtual void 				WindowEvent_MouseMove( Window* pWindow, const MouseEvent& rEvt ) = 0;
	virtual void 				WindowEvent_Command( Window* pWindow, const CommandEvent& rCEvt ) = 0;
	virtual void 				WindowEvent_KeyInput( Window* pWindow, const KeyEvent& rEvt ) = 0;
	virtual void 				WindowEvent_GetFocus( Window* pWindow ) = 0;
	virtual void 				WindowEvent_LoseFocus( Window* pWindow ) = 0;
	virtual void 				WindowEvent_Paint( Window* pWindow, const Rectangle& rRect ) = 0;
	virtual void 				WindowEvent_KeyUp( Window* pWindow, const KeyEvent& rEvt ) = 0;
	virtual void 				WindowEvent_Minimize( Window* pWindow ) = 0;
	virtual void 				WindowEvent_Normalize( Window* pWindow ) = 0;
	virtual void 				WindowEvent_Close( Window* pWindow ) = 0;
};

#endif	
