

#ifndef _VCL_SALCONFIG_HXX
#define _VCL_SALCONFIG_HXX

#include <vcl/config.hxx>
#include <vcl/ppdparser.hxx>

namespace vcl_sal {

	class XpDefaults : public Config
	{
		static XpDefaults*	pOneInstance;
		static BOOL			s_bWriteable;	
		static BOOL			s_bPrivate; 	

		XpDefaults();
		~XpDefaults();

		void readDefaults( void* pSetup, const ByteString& rGroup, PPDParser* );
	public:
		static const String& getProfileName( BOOL bForceSearch = FALSE );
		static XpDefaults& getXpDefaults();
		static void release();
		static BOOL isWriteable() { return s_bWriteable; }
		static BOOL isPrivate() { return s_bPrivate; }

		void	writeSetupSection( void* pSetup, const ByteString& rGroup );
		void*	readSetupSection( const ByteString& rGroup );
		String	checkEquivPrinter( const String& rName, const String& sKey );
	};

}

#endif
