

#ifndef _SV_VIRDEV_HXX
#define _SV_VIRDEV_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_OUTDEV_HXX
#include <vcl/outdev.hxx>
#endif

class SalVirtualDevice;
class RmVirtualDevice;

class VirtualDevice : public OutputDevice
{
private:

#ifndef REMOTE_APPSERVER
	SalVirtualDevice*	mpVirDev;
#else
	RmVirtualDevice*	mpVirDev;
#endif
	VirtualDevice*		mpPrev;
	VirtualDevice*		mpNext;
	USHORT				mnBitCount;
	BOOL				mbScreenComp;
	BOOL				mbDummyAlign;

#if 0 // _SOLAR__PRIVATE
	friend class Application;
	friend class OutputDevice;
#ifdef _SV_VIRDEV_CXX
	void				ImplInitVirDev( const OutputDevice* pOutDev, long nDX, long nDY, USHORT nBitCount );
#endif
#ifdef REMOTE_APPSERVER
	RmVirtualDevice*	ImplGetRemoteVirDev() const { return mpVirDev; }
#endif
#endif

public:
			VirtualDevice( USHORT nBitCount = 0 );
			VirtualDevice( const OutputDevice& rCompDev,
						   USHORT nBitCount = 0 );
	virtual 			~VirtualDevice();

	BOOL				SetOutputSizePixel( const Size& rNewSize, BOOL bErase = TRUE );
	BOOL				SetOutputSize( const Size& rNewSize, BOOL bErase = TRUE )
				{ return SetOutputSizePixel( LogicToPixel( rNewSize ), bErase ); }
};

#endif 
