

#ifndef _SV_WRKWIN_HXX
#define _SV_WRKWIN_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_SYSWIN_HXX
#include <vcl/syswin.hxx>
#endif

namespace com { namespace sun { namespace star { namespace uno { class Any; }}}}
struct SystemParentData;

#define PRESENTATION_HIDEALLAPPS	((USHORT)0x0001)
#define PRESENTATION_NOFULLSCREEN	((USHORT)0x0002)
#define PRESENTATION_NOAUTOSHOW 	((USHORT)0x0004)
#ifndef NOOLDSV
#define PRESENTATION_NOTFULLSCREEN	PRESENTATION_NOFULLSCREEN
#define PRESENTATION_NOTAUTOSHOW	PRESENTATION_NOAUTOSHOW
#endif

#define ICON_DEFAULT                    0
#define ICON_SO_DEFAULT 				1
#define ICON_TEXT_DOCUMENT				2
#define ICON_TEXT_TEMPLATE				3
#define ICON_SPREADSHEET_DOCUMENT		4
#define ICON_SPREADSHEET_TEMPLATE		5
#define ICON_DRAWING_DOCUMENT			6
#define ICON_DRAWING_TEMPLATE			7
#define ICON_PRESENTATION_DOCUMENT		8
#define ICON_PRESENTATION_TEMPLATE		9
#define ICON_PRESENTATION_COMPRESSED	10
#define ICON_GLOBAL_DOCUMENT			11
#define ICON_HTML_DOCUMENT				12
#define ICON_CHART_DOCUMENT				13
#define ICON_DATABASE_DOCUMENT			14
#define ICON_MATH_DOCUMENT				15
#define ICON_TEMPLATE					16
#define ICON_MACROLIBRARY				17
#define ICON_PLAYER                     100
#define ICON_SETUP						500

class WorkWindow : public SystemWindow
{
private:
	USHORT			mnIcon;
	USHORT			mnPresentationFlags;
	BOOL			mbPresentationMode:1,
		mbPresentationVisible:1,
		mbPresentationFull:1,
		mbFullScreenMode:1,
		mbSysChild:1,
		mbDummy1:1,
		mbDummy2:1,
		mbDummy3:1,
		mbDummy4:1,
		mbDummy5:1,
		mbDummy6:1,
		mbDummy7:1;

#ifdef _SV_WRKWIN_CXX
	void			ImplInitData();
	void			ImplInit( Window* pParent, WinBits nStyle, const ::com::sun::star::uno::Any& aSystemWorkWindowToken );
#endif

protected:
		WorkWindow( WindowType nType );
	void			ImplInit( Window* pParent, WinBits nStyle, SystemParentData* pSystemParentData = NULL );
	void			ImplLoadRes( const ResId& rResId );

public:
		WorkWindow( Window* pParent, const ResId& rResId );
		WorkWindow( Window* pParent, WinBits nStyle = WB_STDWORK );
		WorkWindow( Window* pParent, const ::com::sun::star::uno::Any& aSystemWorkWindowToken, WinBits nStyle = WB_STDWORK );
		WorkWindow( SystemParentData* pParent ); 
		~WorkWindow();

	void			SetIcon( USHORT nIcon );
	USHORT			GetIcon() const { return mnIcon; }

	void			SetWindowState( const ByteString& rStr );
	ByteString		GetWindowState() const;

	void			ShowFullScreenMode( BOOL bFullScreenMode = TRUE );
	void			EndFullScreenMode() { ShowFullScreenMode( FALSE ); }
	BOOL			IsFullScreenMode() const { return mbFullScreenMode; }

	void			StartPresentationMode( BOOL bPresentation = TRUE, USHORT nFlags = 0 );
	void			EndPresentationMode() {  StartPresentationMode( FALSE ); }
	BOOL			IsPresentationMode() const { return mbPresentationMode; }

	BOOL			IsMinimized() const;

#ifndef NOOLDSV
	void			Minimize();
	void			Maximize();
	void			Restore();

	BOOL			IsMaximized() const;

	void			SetOptOutputSizePixel( const Size& ) {}
	Size			GetOptOutputSizePixel() const { return Size(); }
#endif
};

#endif 
