
#ifndef _XMLOFF_SCH_XMLEXPORTHELPER_HXX_
#define _XMLOFF_SCH_XMLEXPORTHELPER_HXX_

#ifndef _UNIVERSALL_REFERENCE_HXX
#include <xmloff/uniref.hxx>
#endif
#ifndef _RTL_USTRBUF_HXX_
#include <rtl/ustrbuf.hxx>
#endif
#ifndef _COM_SUN_STAR_UTIL_XSTRINGMAPPING_HPP_
#include <com/sun/star/util/XStringMapping.hpp>
#endif

#include "queue"

namespace com { namespace sun { namespace star {
	namespace chart {
		class XDiagram;
		class XChartDocument;
		class XChartDataArray;
		struct ChartSeriesAddress;
	}
	namespace drawing {
		class XShape;
	}
	namespace task {
		class XStatusIndicator;
	}
	namespace frame {
		class XModel;
	}
	namespace xml {
		namespace sax {
			class XAttributeList;
}}}}}

class SvXMLAutoStylePoolP;
class XMLChartExportPropertyMapper;
class SvXMLExport;
class XMLPropertyHandlerFactory;
class XMLPropertySetMapper;

class SchXMLExportHelper : public UniRefBase
{
private:
	SvXMLExport& mrExport;
	SvXMLAutoStylePoolP& mrAutoStylePool;
	UniReference< XMLPropertyHandlerFactory > mxPropertyHandlerFactory;
	UniReference< XMLPropertySetMapper > mxPropertySetMapper;
	UniReference< XMLChartExportPropertyMapper > mxExpPropMapper;
	com::sun::star::uno::Reference< com::sun::star::util::XStringMapping > mxTableAddressMapper;

	rtl::OUString msTableName;
	rtl::OUStringBuffer msStringBuffer;
	rtl::OUString msString;
	sal_Int32 mnDomainAxes;
	sal_Int32 mnSeriesCount, mnSeriesLength;
	sal_Bool mbHasSeriesLabels, mbHasCategoryLabels;
	sal_Bool mbRowSourceColumns;

	rtl::OUString msChartAddress;
	rtl::OUString msTableNumberList;

	rtl::OUString msCLSID;
	 ::std::queue< ::rtl::OUString > maAutoStyleNameQueue;
	void CollectAutoStyle( const std::vector< XMLPropertyState >& aStates );
	void AddAutoStyleAttribute( const std::vector< XMLPropertyState >& aStates );

	SvXMLAutoStylePoolP& GetAutoStylePoolP() { return mrAutoStylePool; }

	void parseDocument( com::sun::star::uno::Reference<
				com::sun::star::chart::XChartDocument >& rChartDoc,
			sal_Bool bExportContent,
			sal_Bool bIncludeTable = sal_False );
	void exportTable( com::sun::star::uno::Reference<
		  	com::sun::star::chart::XChartDataArray >& rData );
	void exportPlotArea( com::sun::star::uno::Reference< com::sun::star::chart::XDiagram > xDiagram,
			 sal_Bool bExportContent,
			 sal_Bool bIncludeTable );
	void exportAxes( com::sun::star::uno::Reference< com::sun::star::chart::XDiagram > xDiagram,
		 sal_Bool bExportContent );

	void addPosition( com::sun::star::uno::Reference< com::sun::star::drawing::XShape > xShape );

	void addSize( com::sun::star::uno::Reference< com::sun::star::drawing::XShape > xShape );

	void getCellAddress( sal_Int32 nCol, sal_Int32 nRow );

	void swapDataArray( com::sun::star::uno::Sequence< com::sun::star::uno::Sequence< double > >& rSequence );
	 void exportText( const ::rtl::OUString& rText );

public:
	SchXMLExportHelper( SvXMLExport& rExport,
			SvXMLAutoStylePoolP& rASPool );

	void collectAutoStyles( com::sun::star::uno::Reference<
				com::sun::star::chart::XChartDocument > rChartDoc );

	void exportAutoStyles();

	void setTableAddressMapper( com::sun::star::uno::Reference<
						com::sun::star::util::XStringMapping > xMapper )
		{ mxTableAddressMapper = xMapper; }

	void exportChart( com::sun::star::uno::Reference<
		  	com::sun::star::chart::XChartDocument > rChartDoc,
		  sal_Bool bIncludeTable );

	const rtl::OUString& SchXMLExportHelper::getChartCLSID();

	UniReference< XMLPropertySetMapper > GetPropertySetMapper() const { return mxPropertySetMapper; }
	 void SetChartRangeAddress( const ::rtl::OUString& rAddress )
	    { msChartAddress = rAddress; }
	void SetTableNumberList( const ::rtl::OUString& rList )
	    { msTableNumberList = rList; }
};

#endif	
