

#ifndef _XMLOFF_XMLEVENTSIMPORTCONTEXT_HXX
#define _XMLOFF_XMLEVENTSIMPORTCONTEXT_HXX

#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif

#ifndef _XMLOFF_XMLICTXT_HXX
#include <xmloff/xmlictxt.hxx>
#endif

#ifndef _XMLOFF_XMLEVENT_HXX
#include <xmloff/xmlevent.hxx>
#endif

#include <map>
#include <vector>

namespace com { namespace sun { namespace star {
	namespace xml { namespace sax {	class XAttributeList; } }
	namespace beans { struct PropertyValue;	}
	namespace container { class XNameReplace; }
	namespace document { class XEventsSupplier; }
} } }
namespace rtl {	class OUString; }

typedef ::std::pair<
			::rtl::OUString,
			::com::sun::star::uno::Sequence<
	::com::sun::star::beans::PropertyValue> > EventNameValuesPair;

typedef ::std::vector< EventNameValuesPair > EventsVector;

class XMLEventsImportContext : public SvXMLImportContext
{
protected:

	::com::sun::star::uno::Reference< 
		::com::sun::star::container::XNameReplace> xEvents;

	EventsVector aCollectEvents;

public:

	TYPEINFO();

	XMLEventsImportContext(
		SvXMLImport& rImport, 
		sal_uInt16 nPrfx,
		const ::rtl::OUString& rLocalName);

	XMLEventsImportContext(
		SvXMLImport& rImport, 
		sal_uInt16 nPrfx,
		const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference< 
			::com::sun::star::document::XEventsSupplier> & xEventsSupplier);

	XMLEventsImportContext(
		SvXMLImport& rImport, 
		sal_uInt16 nPrfx,
		const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference< 
			::com::sun::star::container::XNameReplace> & xNameRepl);

	~XMLEventsImportContext();

	void AddEventValues(
		const ::rtl::OUString& rEventName,
		const ::com::sun::star::uno::Sequence< 
			::com::sun::star::beans::PropertyValue> & rValues);

	void SetEvents(
		const ::com::sun::star::uno::Reference< 
			::com::sun::star::document::XEventsSupplier> & xEventsSupplier);

	void SetEvents(
		const ::com::sun::star::uno::Reference< 
			::com::sun::star::container::XNameReplace> & xNameRepl);
	 sal_Bool GetEventSequence(
	    const ::rtl::OUString& rName,
	    ::com::sun::star::uno::Sequence<
	    ::com::sun::star::beans::PropertyValue> & rSequence );

protected:

	virtual void StartElement(
		const ::com::sun::star::uno::Reference< 
			::com::sun::star::xml::sax::XAttributeList> & xAttrList);

	virtual void EndElement();

	virtual SvXMLImportContext *CreateChildContext( 
		sal_uInt16 nPrefix,
		const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference< 
			::com::sun::star::xml::sax::XAttributeList> & xAttrList );
};

#endif
