

#ifndef _XMLOFF_PROPERTYHANDLERFACTORY_HXX
#define _XMLOFF_PROPERTYHANDLERFACTORY_HXX

#ifndef __SGI_STL_MAP
#include <map>
#endif

#ifndef _UNIVERSALL_REFERENCE_HXX
#include <xmloff/uniref.hxx>
#endif

#ifndef _XMLOFF_PROPERTYHANDLERBASE_HXX
#include <xmloff/xmlprhdl.hxx>
#endif

class XMLPropertyHandlerFactory : public UniRefBase
{
public:
	virtual ~XMLPropertyHandlerFactory();

	virtual const XMLPropertyHandler* GetPropertyHandler( sal_Int32 nType ) const;

protected:

	XMLPropertyHandler* GetHdlCache( sal_Int32 nType ) const;

	void PutHdlCache( sal_Int32 nType, const XMLPropertyHandler* pHdl ) const;

private:

	const XMLPropertyHandler* GetBasicHandler( sal_Int32 nType ) const;

	typedef ::std::map< sal_Int32, XMLPropertyHandler* > CacheMap;
	CacheMap maHandlerCache;
};

#endif	
