

#ifndef _XMLOFF_TXTFLDI_HXX
#define _XMLOFF_TXTFLDI_HXX

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_ 
#include <com/sun/star/uno/Reference.h>
#endif

#ifndef _COM_SUN_STAR_TEXT_PAGENUMBERTYPE_HPP_
#include <com/sun/star/text/PageNumberType.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_DATETIME_HPP_
#include <com/sun/star/util/DateTime.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_DATE_HPP_
#include <com/sun/star/util/Date.hpp>
#endif

#ifndef _XMLOFF_XMLICTXT_HXX 
#include <xmloff/xmlictxt.hxx>
#endif

#ifndef _XMLOFF_TEXTIMP_HXX_
#include <xmloff/txtimp.hxx>
#endif

#ifndef _RTL_USTRBUF_HXX_
#include <rtl/ustrbuf.hxx>
#endif

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

namespace com { namespace sun { namespace star { 
	namespace xml { namespace sax { class XAttributeList; } } 
	namespace text { class XTextField; }
	namespace beans { class XPropertySet; struct PropertyValue; }
} } }

namespace rtl 
{
	class OUString;
}

class SvXMLImport;
class XMLTextImportHelper;
class SvXMLTokenMap;

enum XMLTextFieldAttrTokens
{
	XML_TOK_TEXTFIELD_FIXED = 0,
	XML_TOK_TEXTFIELD_DESCRIPTION,
	XML_TOK_TEXTFIELD_PLACEHOLDER_TYPE,
	XML_TOK_TEXTFIELD_TIME_ADJUST,
	XML_TOK_TEXTFIELD_DATE_ADJUST,
	XML_TOK_TEXTFIELD_PAGE_ADJUST,
	XML_TOK_TEXTFIELD_SELECT_PAGE,
	XML_TOK_TEXTFIELD_ACTIVE,

	XML_TOK_TEXTFIELD_NAME,
	XML_TOK_TEXTFIELD_FORMULA,
	XML_TOK_TEXTFIELD_NUM_FORMAT,
	XML_TOK_TEXTFIELD_NUM_LETTER_SYNC,
	XML_TOK_TEXTFIELD_DISPLAY_FORMULA,
	XML_TOK_TEXTFIELD_NUMBERING_LEVEL,
	XML_TOK_TEXTFIELD_NUMBERING_SEPARATOR,
	XML_TOK_TEXTFIELD_DISPLAY,
	XML_TOK_TEXTFIELD_OUTLINE_LEVEL,

	XML_TOK_TEXTFIELD_VALUE_TYPE,
	XML_TOK_TEXTFIELD_VALUE,
	XML_TOK_TEXTFIELD_STRING_VALUE,
	XML_TOK_TEXTFIELD_DATE_VALUE,
	XML_TOK_TEXTFIELD_TIME_VALUE,
	XML_TOK_TEXTFIELD_BOOL_VALUE,
	XML_TOK_TEXTFIELD_CURRENCY,
	XML_TOK_TEXTFIELD_DATA_STYLE_NAME,

	XML_TOK_TEXTFIELD_DATABASE_NAME,
	XML_TOK_TEXTFIELD_TABLE_NAME,
	XML_TOK_TEXTFIELD_COLUMN_NAME,
	XML_TOK_TEXTFIELD_ROW_NUMBER,
	XML_TOK_TEXTFIELD_CONDITION,
	XML_TOK_TEXTFIELD_STRING_VALUE_IF_TRUE,
	XML_TOK_TEXTFIELD_STRING_VALUE_IF_FALSE,
	XML_TOK_TEXTFIELD_REVISION,
	XML_TOK_TEXTFIELD_IS_HIDDEN,
	XML_TOK_TEXTFIELD_CURRENT_VALUE,

	XML_TOK_TEXTFIELD_REFERENCE_FORMAT,
	XML_TOK_TEXTFIELD_REF_NAME,
	XML_TOK_TEXTFIELD_CONNECTION_NAME,

	XML_TOK_TEXTFIELD_HREF,
	XML_TOK_TEXTFIELD_TARGET_FRAME,

	XML_TOK_TEXTFIELD_OFFICE_CREATE_DATE,
	XML_TOK_TEXTFIELD_OFFICE_AUTHOR,
	XML_TOK_TEXTFIELD_ANNOTATION,
	XML_TOK_TEXTFIELD_LANGUAGE,

	XML_TOK_TEXTFIELD_MEASURE_KIND,

	XML_TOK_TEXTFIELD_UNKNOWN
};

class XMLTextFieldImportContext : public SvXMLImportContext
{
	const ::rtl::OUString sServicePrefix;
	const ::rtl::OUString sIsFixed;

	::rtl::OUStringBuffer sContentBuffer;	
	::rtl::OUString sContent;				
	::rtl::OUString sServiceName;			
	XMLTextImportHelper& rTextImportHelper;	

protected:

	sal_Bool bValid;						

public:

	TYPEINFO();

	XMLTextFieldImportContext( 
		SvXMLImport& rImport,					
		XMLTextImportHelper& rHlp,				
		const sal_Char* pService,				
		sal_uInt16 nPrfx,						
		const ::rtl::OUString& rLocalName);		

	virtual ~XMLTextFieldImportContext();

	virtual void Characters( const ::rtl::OUString& sContent );

	virtual void StartElement(
		const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList> & xAttrList);

	virtual void EndElement();

	static XMLTextFieldImportContext* CreateTextFieldImportContext(
		SvXMLImport& rImport, 
		XMLTextImportHelper& rHlp,
		sal_uInt16 nPrefix, 
		const ::rtl::OUString& rName,
		sal_uInt16 nToken);

protected:

	inline XMLTextImportHelper& GetImportHelper() { return rTextImportHelper; }

	inline ::rtl::OUString GetServiceName() { return sServiceName; }
	inline void SetServiceName(::rtl::OUString sStr) { sServiceName = sStr; }

	::rtl::OUString GetContent();

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue ) = 0;

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet) = 0;

	sal_Bool CreateField(::com::sun::star::uno::Reference<
			 ::com::sun::star::beans::XPropertySet> & xField,
			 const ::rtl::OUString& sServiceName);

	void ForceUpdate(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::beans::XPropertySet> & rPropertySet);
};

class XMLSenderFieldImportContext : public XMLTextFieldImportContext
{

	sal_Int16 nSubType;			

	const ::rtl::OUString sEmpty;		
	const ::rtl::OUString sPropertyFixed;
	const ::rtl::OUString sPropertyFieldSubType;
	const ::rtl::OUString sPropertyContent;

protected:

	sal_Bool bFixed;
	sal_uInt16 nElementToken;	

public:

	TYPEINFO();

	XMLSenderFieldImportContext( 
		SvXMLImport& rImport,					
		XMLTextImportHelper& rHlp,				
		sal_uInt16 nPrfx,						
		const ::rtl::OUString& sLocalName,		
		sal_uInt16 nToken);						

protected:

	virtual void StartElement(
		const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList> & xAttrList);

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLAuthorFieldImportContext : public XMLSenderFieldImportContext
{

	sal_Bool bAuthorFullName;
	const ::rtl::OUString sServiceAuthor;
	const ::rtl::OUString sPropertyAuthorFullName;
	const ::rtl::OUString sPropertyFixed;
	const ::rtl::OUString sPropertyContent;

public:

	TYPEINFO();

	XMLAuthorFieldImportContext( 
		SvXMLImport& rImport,					
		XMLTextImportHelper& rHlp,				
		sal_uInt16 nPrfx,						
		const ::rtl::OUString& sLocalName,		
		sal_uInt16 nToken);						

protected:

	virtual void StartElement(
		const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList> & xAttrList);

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLPlaceholderFieldImportContext : public XMLTextFieldImportContext
{

	const ::rtl::OUString sEmpty;		
	const ::rtl::OUString sServiceJumpEdit;
	const ::rtl::OUString sPropertyPlaceholderType;
	const ::rtl::OUString sPropertyPlaceholder;
	const ::rtl::OUString sPropertyHint;

	::rtl::OUString sDescription;

	sal_Int16 nPlaceholderType;

public:

	TYPEINFO();

	XMLPlaceholderFieldImportContext( 
		SvXMLImport& rImport,					
		XMLTextImportHelper& rHlp,				
		sal_uInt16 nPrfx,						
		const ::rtl::OUString& sLocalName);		

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLTimeFieldImportContext : public XMLTextFieldImportContext
{

protected:
	const ::rtl::OUString sPropertyNumberFormat;
	const ::rtl::OUString sPropertyFixed;
	const ::rtl::OUString sPropertyDateTimeValue;
	const ::rtl::OUString sPropertyDateTime;
	const ::rtl::OUString sPropertyAdjust;
	const ::rtl::OUString sPropertyIsDate;

	double fTimeValue;
	::com::sun::star::util::DateTime aDateTimeValue;
	sal_Int32 nAdjust;
	sal_Int32 nFormatKey;
	sal_Bool bTimeOK;
	sal_Bool bFormatOK;
	sal_Bool bFixed;
	sal_Bool bIsDate;			

public:

	TYPEINFO();

	XMLTimeFieldImportContext(
		SvXMLImport& rImport,					
		XMLTextImportHelper& rHlp,				
		sal_uInt16 nPrfx,						
		const ::rtl::OUString& sLocalName);		

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLDateFieldImportContext : public XMLTimeFieldImportContext
{

public:

	TYPEINFO();

	XMLDateFieldImportContext(
		SvXMLImport& rImport,					
		XMLTextImportHelper& rHlp,				
		sal_uInt16 nPrfx,						
		const ::rtl::OUString& sLocalName);		

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );
};

class XMLPageContinuationImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertySubType;
	const ::rtl::OUString sPropertyUserText;
	const ::rtl::OUString sPropertyNumberingType;

	::rtl::OUString sString;			
	com::sun::star::text::PageNumberType eSelectPage;	

	sal_Bool sStringOK;					

public:

	TYPEINFO();

	XMLPageContinuationImportContext(
		SvXMLImport& rImport,					
		XMLTextImportHelper& rHlp,				
		sal_uInt16 nPrfx,						
		const ::rtl::OUString& sLocalName);		

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLPageNumberImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertySubType;
	const ::rtl::OUString sPropertyNumberingType;
	const ::rtl::OUString sPropertyOffset;

	::rtl::OUString sNumberFormat;
	::rtl::OUString sNumberSync;
	sal_Int16 nPageAdjust;
	com::sun::star::text::PageNumberType eSelectPage;	

	sal_Bool sNumberFormatOK;

public:

	TYPEINFO();

	XMLPageNumberImportContext(
		SvXMLImport& rImport,					
		XMLTextImportHelper& rHlp,				
		sal_uInt16 nPrfx,						
		const ::rtl::OUString& sLocalName);		

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLDatabaseFieldImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyDatabaseName;
	const ::rtl::OUString sPropertyTableName;

	::rtl::OUString sDatabaseName;
	::rtl::OUString sTableName;

protected:
	sal_Bool bDatabaseOK;
	sal_Bool bTableOK;

	XMLDatabaseFieldImportContext(SvXMLImport& rImport, 
					  XMLTextImportHelper& rHlp,
					  const sal_Char* pServiceName, 
					  sal_uInt16 nPrfx, 
					  const ::rtl::OUString& sLocalName);

public:

TYPEINFO();

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLDatabaseNameImportContext : public XMLDatabaseFieldImportContext
{
public:

	TYPEINFO();

	XMLDatabaseNameImportContext(SvXMLImport& rImport, 
					 XMLTextImportHelper& rHlp,
					 sal_uInt16 nPrfx, 
					 const ::rtl::OUString& sLocalName);

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );
};

class XMLDatabaseNextImportContext : public XMLDatabaseFieldImportContext
{
	const ::rtl::OUString sPropertyCondition;
	const ::rtl::OUString sTrue;
	::rtl::OUString sCondition;
	sal_Bool bConditionOK;

protected:

	XMLDatabaseNextImportContext(SvXMLImport& rImport, 
					 XMLTextImportHelper& rHlp,
					 const sal_Char* pServiceName,
					 sal_uInt16 nPrfx, 
					 const ::rtl::OUString& sLocalName);

public:

	TYPEINFO();

	XMLDatabaseNextImportContext(SvXMLImport& rImport, 
					 XMLTextImportHelper& rHlp,
					 sal_uInt16 nPrfx, 
					 const ::rtl::OUString& sLocalName);

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLDatabaseSelectImportContext : public XMLDatabaseNextImportContext
{
	const ::rtl::OUString sPropertySetNumber;
	sal_Int32 nNumber;
	sal_Bool bNumberOK;

public:

	TYPEINFO();

	XMLDatabaseSelectImportContext(SvXMLImport& rImport, 
					   XMLTextImportHelper& rHlp,
					   sal_uInt16 nPrfx, 
					   const ::rtl::OUString& sLocalName);

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLDatabaseNumberImportContext : public XMLDatabaseFieldImportContext
{
	const ::rtl::OUString sPropertyNumberingType;
	const ::rtl::OUString sPropertySetNumber;
	::rtl::OUString sNumberFormat;
	::rtl::OUString sNumberSync;
	sal_Int32 nValue;
	sal_Bool bValueOK;

public:

	TYPEINFO();

	XMLDatabaseNumberImportContext(SvXMLImport& rImport, 
					   XMLTextImportHelper& rHlp,
					   sal_uInt16 nPrfx, 
					   const ::rtl::OUString& sLocalName);

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLSimpleDocInfoImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyFixed;
	const ::rtl::OUString sPropertyContent;
	const ::rtl::OUString sPropertyAuthor;
	const ::rtl::OUString sPropertyCurrentPresentation;

protected:
	sal_Bool bFixed;
	sal_Bool bHasAuthor;
	sal_Bool bHasContent;

public:

	TYPEINFO();

	XMLSimpleDocInfoImportContext(SvXMLImport& rImport,
					  XMLTextImportHelper& rHlp,
					  sal_uInt16 nPrfx,
					  const ::rtl::OUString& sLocalName,
					  sal_uInt16 nToken,
					  sal_Bool bContent,
					  sal_Bool bAuthor);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);

	static const sal_Char* MapTokenToServiceName(sal_uInt16 nToken);
};

class XMLDateTimeDocInfoImportContext : public XMLSimpleDocInfoImportContext
{
	const ::rtl::OUString sPropertyNumberFormat;
	const ::rtl::OUString sPropertyIsDate;

	sal_Int32 nFormat;
	sal_Bool bFormatOK;
	sal_Bool bIsDate;
	sal_Bool bHasDateTime;

public:

	TYPEINFO();

	XMLDateTimeDocInfoImportContext(SvXMLImport& rImport,
						XMLTextImportHelper& rHlp,
						sal_uInt16 nPrfx,
						const ::rtl::OUString& sLocalName,
						sal_uInt16 nToken);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLRevisionDocInfoImportContext : public XMLSimpleDocInfoImportContext
{
	const ::rtl::OUString sPropertyRevision;
	sal_Int16 nRevision;
	sal_Bool bRevisionOK;

public:

	TYPEINFO();

	XMLRevisionDocInfoImportContext(SvXMLImport& rImport,
						XMLTextImportHelper& rHlp,
						sal_uInt16 nPrfx,
						const ::rtl::OUString& sLocalName,
						sal_uInt16 nToken);

protected:

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLUserDocInfoImportContext : public XMLSimpleDocInfoImportContext
{
public:

	TYPEINFO();

	XMLUserDocInfoImportContext(SvXMLImport& rImport,
					XMLTextImportHelper& rHlp,
					sal_uInt16 nPrfx,
					const ::rtl::OUString& sLocalName,
					sal_uInt16 nToken);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );
};

class XMLHiddenParagraphImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyCondition;
	const ::rtl::OUString sPropertyIsHidden;

	::rtl::OUString sCondition;
	sal_Bool bIsHidden;

public:

	TYPEINFO();

	XMLHiddenParagraphImportContext(SvXMLImport& rImport,
						XMLTextImportHelper& rHlp,
						sal_uInt16 nPrfx,
						const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLConditionalTextImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyCondition;
	const ::rtl::OUString sPropertyTrueContent;
	const ::rtl::OUString sPropertyFalseContent;
	const ::rtl::OUString sPropertyIsConditionTrue;

	::rtl::OUString sCondition;
	::rtl::OUString sTrueContent;
	::rtl::OUString sFalseContent;

	sal_Bool bConditionOK;
	sal_Bool bTrueOK;
	sal_Bool bFalseOK;
	sal_Bool bCurrentValue;

public:

	TYPEINFO();

	XMLConditionalTextImportContext(SvXMLImport& rImport,
						XMLTextImportHelper& rHlp,
						sal_uInt16 nPrfx,
						const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLHiddenTextImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyCondition;
	const ::rtl::OUString sPropertyContent;
	const ::rtl::OUString sPropertyIsHidden;

	::rtl::OUString sCondition;
	::rtl::OUString sString;

	sal_Bool bConditionOK;
	sal_Bool bStringOK;
	sal_Bool bIsHidden;

public:

	TYPEINFO();

	XMLHiddenTextImportContext(SvXMLImport& rImport,
				   XMLTextImportHelper& rHlp,
				   sal_uInt16 nPrfx,
				   const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLFileNameImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyFixed;
	const ::rtl::OUString sPropertyFileFormat;
	const ::rtl::OUString sPropertyCurrentPresentation;

	sal_Int16 nFormat;
	sal_Bool bFixed;

public:

	TYPEINFO();

	XMLFileNameImportContext(SvXMLImport& rImport,
				 XMLTextImportHelper& rHlp,
				 sal_uInt16 nPrfx,
				 const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLTemplateNameImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyFileFormat;

	sal_Int16 nFormat;

public:

	TYPEINFO();

	XMLTemplateNameImportContext(SvXMLImport& rImport,
					 XMLTextImportHelper& rHlp,
					 sal_uInt16 nPrfx,
					 const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLChapterImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyChapterFormat;
	const ::rtl::OUString sPropertyLevel;

	sal_Int16 nFormat;
	sal_Int8 nLevel;

public:

	TYPEINFO();

	XMLChapterImportContext(SvXMLImport& rImport,
				XMLTextImportHelper& rHlp,
				sal_uInt16 nPrfx,
				const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLCountFieldImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyNumberingType;

	::rtl::OUString sNumberFormat;
	::rtl::OUString sLetterSync;

	sal_Bool bNumberFormatOK;

public:

	TYPEINFO();

	XMLCountFieldImportContext(SvXMLImport& rImport,
				   XMLTextImportHelper& rHlp,
				   sal_uInt16 nPrfx,
				   const ::rtl::OUString& sLocalName,
				   sal_uInt16 nToken);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);

	static const sal_Char* MapTokenToServiceName(sal_uInt16 nToken);
};

class XMLPageVarGetFieldImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyNumberingType;

	::rtl::OUString sNumberFormat;
	::rtl::OUString sLetterSync;

	sal_Bool bNumberFormatOK;

public:

	TYPEINFO();

	XMLPageVarGetFieldImportContext(SvXMLImport& rImport,
						XMLTextImportHelper& rHlp,
						sal_uInt16 nPrfx,
						const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLPageVarSetFieldImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyOn;
	const ::rtl::OUString sPropertyOffset;

	sal_Int16 nAdjust;
	sal_Bool bActive;

public:

	TYPEINFO();

	XMLPageVarSetFieldImportContext(SvXMLImport& rImport,
						XMLTextImportHelper& rHlp,
						sal_uInt16 nPrfx,
						const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLMacroFieldImportContext : public XMLTextFieldImportContext
{

	const ::rtl::OUString sPropertyHint;
	const ::rtl::OUString sPropertyMacroName;
	const ::rtl::OUString sPropertyLibraryName;

	::rtl::OUString sDescription;
	SvXMLImportContextRef xEventContext;

	::rtl::OUString sMacro; 

	sal_Bool bMacroOK;
	sal_Bool bDescriptionOK;

public:

	TYPEINFO();

	XMLMacroFieldImportContext(SvXMLImport& rImport,
				   XMLTextImportHelper& rHlp,
				   sal_uInt16 nPrfx,
				   const ::rtl::OUString& sLocalName);

protected:
	 virtual SvXMLImportContext *CreateChildContext( 
		sal_uInt16 nPrefix,
		const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference< 
		::com::sun::star::xml::sax::XAttributeList> & xAttrList );

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLReferenceFieldImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyReferenceFieldPart;
	const ::rtl::OUString sPropertyReferenceFieldSource;
	const ::rtl::OUString sPropertySourceName;
	const ::rtl::OUString sPropertyCurrentPresentation;

	::rtl::OUString sName;
	sal_uInt16 nElementToken;
	sal_Int16 nSource;
	sal_Int16 nType;
	sal_Int16 nSequenceNumber;

	sal_Bool bNameOK;
	sal_Bool bTypeOK;
	sal_Bool bSeqNumberOK;

public:

	TYPEINFO();

	XMLReferenceFieldImportContext(SvXMLImport& rImport,
					   XMLTextImportHelper& rHlp,
					   sal_uInt16 nToken,
					   sal_uInt16 nPrfx,
					   const ::rtl::OUString& sLocalName);

protected:

	virtual void StartElement(
		const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList> & xAttrList);

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLDdeFieldDeclsImportContext : public SvXMLImportContext
{

	SvXMLTokenMap aTokenMap;

public:

	TYPEINFO();

	XMLDdeFieldDeclsImportContext(SvXMLImport& rImport,
					  sal_uInt16 nPrfx,
					  const ::rtl::OUString& sLocalName);

	virtual SvXMLImportContext *CreateChildContext( 
		sal_uInt16 nPrefix,
		const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference< 
		::com::sun::star::xml::sax::XAttributeList> & xAttrList );

};

class XMLDdeFieldDeclImportContext : public SvXMLImportContext
{
	const ::rtl::OUString sPropertyIsAutomaticUpdate;
	const ::rtl::OUString sPropertyName;
	const ::rtl::OUString sPropertyDDECommandType;
	const ::rtl::OUString sPropertyDDECommandFile;
	const ::rtl::OUString sPropertyDDECommandElement;

	const SvXMLTokenMap& rTokenMap;

public:

	TYPEINFO();

	XMLDdeFieldDeclImportContext(SvXMLImport& rImport,
					 sal_uInt16 nPrfx,
					 const ::rtl::OUString& sLocalName,
					 const SvXMLTokenMap& rMap);

	virtual void StartElement(
		const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList> & xAttrList);
};

class XMLDdeFieldImportContext : public XMLTextFieldImportContext
{
	::rtl::OUString sName;

public:

	TYPEINFO();

	XMLDdeFieldImportContext(SvXMLImport& rImport,
				 XMLTextImportHelper& rHlp,
				 sal_uInt16 nPrfx,
				 const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void EndElement();

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);

};

class XMLSheetNameImportContext : public XMLTextFieldImportContext
{

public:

	TYPEINFO();

	XMLSheetNameImportContext(SvXMLImport& rImport,
				  XMLTextImportHelper& rHlp,
				  sal_uInt16 nPrfx,
				  const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLUrlFieldImportContext : public XMLTextFieldImportContext
{

	const ::rtl::OUString sPropertyURL;
	const ::rtl::OUString sPropertyTargetFrame;
	const ::rtl::OUString sPropertyRepresentation;

	::rtl::OUString sURL;
	::rtl::OUString sFrame;
	sal_Bool bFrameOK;

public:

	TYPEINFO();

	XMLUrlFieldImportContext(SvXMLImport& rImport,
				 XMLTextImportHelper& rHlp,
				 sal_uInt16 nPrfx,
				 const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLBibliographyFieldImportContext : public XMLTextFieldImportContext
{

	const ::rtl::OUString sPropertyFields;

	::std::vector< ::com::sun::star::beans::PropertyValue> aValues;

public:

	TYPEINFO();

	XMLBibliographyFieldImportContext(SvXMLImport& rImport,
						  XMLTextImportHelper& rHlp,
						  sal_uInt16 nPrfx,
						  const ::rtl::OUString& sLocalName);

protected:

	virtual void StartElement(
		const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList> & xAttrList);

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);

	static const sal_Char* MapBibliographyFieldName(::rtl::OUString sName);

};

class XMLAnnotationImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyAuthor;
	const ::rtl::OUString sPropertyContent;
	const ::rtl::OUString sPropertyDate;

	::rtl::OUString sAuthor;
	::rtl::OUStringBuffer aTextBuffer;
	::com::sun::star::util::Date aDate;

	sal_Bool bDateOK;

public:

	TYPEINFO();

	XMLAnnotationImportContext(SvXMLImport& rImport,
				   XMLTextImportHelper& rHlp,
				   sal_uInt16 nPrfx,
				   const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);

	virtual SvXMLImportContext *CreateChildContext(
		USHORT nPrefix,
		const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference<
	::com::sun::star::xml::sax::XAttributeList >& xAttrList );
};

class XMLScriptImportContext : public XMLTextFieldImportContext
{
	const ::rtl::OUString sPropertyScriptType;
	const ::rtl::OUString sPropertyURLContent;
	const ::rtl::OUString sPropertyContent;

	::rtl::OUString sContent;
	::rtl::OUString sScriptType;

	sal_Bool bContentOK;
	sal_Bool bScriptTypeOK;
	sal_Bool bUrlContent;

public:

	TYPEINFO();

	XMLScriptImportContext(SvXMLImport& rImport,
			   XMLTextImportHelper& rHlp,
			   sal_uInt16 nPrfx,
			   const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

class XMLMeasureFieldImportContext : public XMLTextFieldImportContext
{
	sal_Int16 mnKind;
public:

	TYPEINFO();

	XMLMeasureFieldImportContext(SvXMLImport& rImport,
						XMLTextImportHelper& rHlp,
						sal_uInt16 nPrfx,
						const ::rtl::OUString& sLocalName);

protected:

	virtual void ProcessAttribute( sal_uInt16 nAttrToken,
					   const ::rtl::OUString& sAttrValue );

	virtual void PrepareField( 
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xPropertySet);
};

#endif
