

#ifndef _XMLOFF_XMLEVENT_HXX
#define _XMLOFF_XMLEVENT_HXX

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif

namespace com { namespace sun { namespace star {
	namespace xml { namespace sax { class XAttributeList; } }
	namespace beans { struct PropertyValue; }
} } }
namespace rtl { class OUString; }

class SvXMLExport;
class SvXMLImportContext;
class SvXMLImport;
class XMLEventsImportContext;

struct XMLEventNameTranslation
{
	const sal_Char* sAPIName;
	const sal_Char* sXMLName;
};

extern const XMLEventNameTranslation aStandardEventTable[];

class XMLEventExportHandler
{
public:
	virtual void Export( 
		SvXMLExport& rExport,					
		const ::rtl::OUString& rEventName,		
		::com::sun::star::uno::Sequence<		
			::com::sun::star::beans::PropertyValue> & rValues,
	 	sal_Bool bUseWhitespace) = 0;	
};

class XMLEventContextFactory
{
public:
	virtual SvXMLImportContext* CreateContext(
		SvXMLImport& rImport,				
		sal_uInt16 nPrefix,					
		const ::rtl::OUString& rLocalName,	
		const ::com::sun::star::uno::Reference< 	
			::com::sun::star::xml::sax::XAttributeList> & xAttrList,

		XMLEventsImportContext* rEvents, 

		const ::rtl::OUString& rApiEventName,

		const ::rtl::OUString& rLanguage) = 0;	
};

#endif
