

#ifndef _XMLOFF_XMLICTXT_HXX
#define _XMLOFF_XMLICTXT_HXX

#ifndef _COM_SUN_STAR_XML_SAX_XATTRIBUTELIST_HPP_
#include <com/sun/star/xml/sax/XAttributeList.hpp>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _REF_HXX
#include <tools/ref.hxx>
#endif
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

class SvXMLNamespaceMap;
class SvXMLImport;

class SvXMLImportContext : public SvRefBase
{
	friend class SvXMLImport;

	SvXMLImport& rImport;

	USHORT		nPrefix;
	::rtl::OUString aLocalName;

	SvXMLNamespaceMap	*pRewindMap;

	SvXMLNamespaceMap  *GetRewindMap() const { return pRewindMap; }
	void SetRewindMap( SvXMLNamespaceMap *p ) { pRewindMap = p; }

protected:

	SvXMLImport& GetImport() { return rImport; }
	const SvXMLImport& GetImport() const { return rImport; }

public:
	TYPEINFO();

	USHORT GetPrefix() const { return nPrefix; }
	const ::rtl::OUString& GetLocalName() const { return aLocalName; }

	SvXMLImportContext( SvXMLImport& rImport, USHORT nPrfx,
			const ::rtl::OUString& rLName );

	virtual ~SvXMLImportContext();

	virtual SvXMLImportContext *CreateChildContext( USHORT nPrefix,
					   const ::rtl::OUString& rLocalName,
					   const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList >& xAttrList );

	virtual void StartElement( const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList >& xAttrList );

	virtual void EndElement();

	virtual void Characters( const ::rtl::OUString& rChars );
};

SV_DECL_REF( SvXMLImportContext )
SV_IMPL_REF( SvXMLImportContext )

#endif	

