
#ifndef _XMLOFF_XMLIMPPR_HXX
#define _XMLOFF_XMLIMPPR_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _COM_SUN_STAR_XML_SAX_XATTRIBUTELIST_HPP_
#include <com/sun/star/xml/sax/XAttributeList.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XMULTIPROPERTYSET_HPP_
#include <com/sun/star/beans/XMultiPropertySet.hpp>
#endif

#ifndef __SGI_STL_VECTOR
#include <vector>
#endif

#ifndef _UNIVERSALL_REFERENCE_HXX
#include <xmloff/uniref.hxx>
#endif

struct XMLPropertyState;
class XMLPropertySetMapper;

namespace rtl { class OUString; }

class SvXMLUnitConverter;
class SvXMLNamespaceMap;

struct _ContextID_Index_Pair 
{
	sal_Int16 nContextID;
	sal_Int32 nIndex;
};

class SvXMLImportPropertyMapper : public UniRefBase
{
	UniReference< SvXMLImportPropertyMapper> mxNextMapper;

protected:

	UniReference< XMLPropertySetMapper > maPropMapper;

public:

	SvXMLImportPropertyMapper(
			const UniReference< XMLPropertySetMapper >& rMapper );
	virtual ~SvXMLImportPropertyMapper();

	void ChainImportMapper(
		const UniReference< SvXMLImportPropertyMapper>& rMapper );

	void importXML(
			::std::vector< XMLPropertyState >& rProperties,
	  ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList > xAttrList,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap ) const;

	void importXML(
			::std::vector< XMLPropertyState >& rProperties,
	  ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList > xAttrList,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap,
			sal_Int32 nStartIdx, sal_Int32 nEndIdx ) const;

	virtual sal_Bool handleSpecialItem(
			XMLPropertyState& rProperty,
			::std::vector< XMLPropertyState >& rProperties,
			const ::rtl::OUString& rValue,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap ) const;

	virtual void finished(
			::std::vector< XMLPropertyState >& rProperties,
			sal_Int32 nStartIndex, sal_Int32 nEndIndex ) const;

	sal_Bool FillPropertySet(
			const ::std::vector< XMLPropertyState >& aProperties,
			const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet > rPropSet ) const;

	inline const UniReference< XMLPropertySetMapper >&
		getPropertySetMapper() const;

	static sal_Bool _FillPropertySet(
	    const ::std::vector<XMLPropertyState> & rProperties,
	    const ::com::sun::star::uno::Reference<
	        ::com::sun::star::beans::XPropertySet> & rPropSet,
	    const ::com::sun::star::uno::Reference<
	        ::com::sun::star::beans::XPropertySetInfo> & rPropSetInfo,
	    const UniReference<XMLPropertySetMapper> & rPropMapper,
	     struct _ContextID_Index_Pair* pSpecialContextIds = NULL );

	static sal_Bool _FillMultiPropertySet(
	    const ::std::vector<XMLPropertyState> & rProperties,
	    const ::com::sun::star::uno::Reference<
	        ::com::sun::star::beans::XMultiPropertySet> & rMultiPropSet,
	    const ::com::sun::star::uno::Reference<
	        ::com::sun::star::beans::XPropertySetInfo> & rPropSetInfo,
	    const UniReference<XMLPropertySetMapper> & rPropMapper,
	     struct _ContextID_Index_Pair* pSpecialContextIds = NULL );

};

inline const UniReference< XMLPropertySetMapper >&
	SvXMLImportPropertyMapper::getPropertySetMapper() const
{
	return maPropMapper;
}

#endif	
