

#ifndef _XMLOFF_XMLNUME_HXX
#define _XMLOFF_XMLNUME_HXX

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _VCL_MAPUNIT_HXX
#include <vcl/mapunit.hxx>
#endif

#ifndef _XMLOFF_ATTRLIST_HXX
#include <xmloff/attrlist.hxx>
#endif

namespace com { namespace sun { namespace star { 
	namespace style { class XStyle; }
	namespace container { class XIndexReplace; }
	namespace beans { struct PropertyValue; }
} } }

class SvXMLNamespaceMap;
class SvXMLUnitConverter;
class SvXMLExportItemMapper;
class SvXMLExport;
class XMLTextListAutoStylePool;

class SvxXMLNumRuleExport
{
	SvXMLExport& rExport;
	const ::rtl::OUString sCDATA;
	const ::rtl::OUString sWS;
	const ::rtl::OUString sNumberingRules;
	const ::rtl::OUString sIsPhysical;
	const ::rtl::OUString sIsContinuousNumbering;

	void exportLevelStyles(
			const ::com::sun::star::uno::Reference<
	::com::sun::star::container::XIndexReplace > & xNumRule,
			sal_Bool bOutline=sal_False );

	void exportLevelStyle(
			sal_Int32 nLevel,
			const ::com::sun::star::uno::Sequence<
	::com::sun::star::beans::PropertyValue>& rProps,
			sal_Bool bOutline=sal_False );

protected:

	virtual void AddListStyleAttributes();

	sal_Bool exportStyle( const ::com::sun::star::uno::Reference<
				::com::sun::star::style::XStyle >& rStyle );
	void exportOutline();

	SvXMLExport& GetExport() { return rExport; }

 	virtual ::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexReplace >  GetUNONumRule() const;

public:

	SvxXMLNumRuleExport( SvXMLExport& rExport );
	virtual ~SvxXMLNumRuleExport();

	void exportStyles( sal_Bool bUsed,
		   XMLTextListAutoStylePool *pPool,
		   sal_Bool bExportChapterNumbering = sal_True );
	void exportNumberingRule(
			const ::rtl::OUString& rName,
			const ::com::sun::star::uno::Reference<
	::com::sun::star::container::XIndexReplace > & xNumRule );

	void Export( const ::rtl::OUString& rOutline, sal_Bool bContNumbering );
	void ExportOutline();
#if SUPD < 627
	static const sal_Char *GetNumFormatValue( sal_Int16 eNumType );
	static const sal_Char *GetNumLetterSync( sal_Int16 eNumType );
#endif
};

#endif	

