

#ifndef _XMLOFF_XMLNUMFE_HXX
#define _XMLOFF_XMLNUMFE_HXX

#ifndef _COM_SUN_STAR_XML_SAX_XDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XDocumentHandler.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif

#ifndef _RTL_USTRBUF_HXX_
#include <rtl/ustrbuf.hxx>
#endif

#define XML_WRITTENNUMBERSTYLES "WrittenNumberStyles"

class Color;
class LocaleDataWrapper;
class CharClass;
class SvXMLNamespaceMap;
class SvXMLAttributeList;
class SvNumberFormatter;
class SvNumberformat;
class SvXMLNumUsedList_Impl;

class SvXMLNumFmtExport
{
private:
	::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XDocumentHandler >	xHandler;
	SvNumberFormatter*			pFormatter;
	SvXMLAttributeList*			pAttrList;
	::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList >	xAttrList;
	const SvXMLNamespaceMap*	pNamespaceMap;
	::rtl::OUString				sPrefix;
	::rtl::OUString				sCDATA;
	::rtl::OUString				sWS;
	::rtl::OUStringBuffer		sTextContent;
	SvXMLNumUsedList_Impl*		pUsedList;
	CharClass*					pCharClass;
	LocaleDataWrapper*			pLocaleData;

	void	AddCalendarAttr_Impl( const ::rtl::OUString& rCalendar );
	void	AddStyleAttr_Impl( sal_Bool bLong );
	void	AddTextualAttr_Impl( sal_Bool bText );
	void	AddLanguageAttr_Impl( sal_Int32 nLang );

	void	AddToTextElement_Impl( const ::rtl::OUString& rString );
	void	FinishTextElement_Impl();

	void	WriteColorElement_Impl( const Color& rColor );
	void	WriteNumberElement_Impl( sal_Int32 nDecimals, sal_Int32 nInteger,
							const ::rtl::OUString& rDashStr, sal_Bool bGrouping );
	void	WriteScientificElement_Impl( sal_Int32 nDecimals, sal_Int32 nInteger,
							sal_Bool bGrouping, sal_Int32 nExp );
	void	WriteFractionElement_Impl( sal_Int32 nInteger, sal_Bool bGrouping,
							sal_Int32 nNumerator, sal_Int32 nDenominator );
	void	WriteCurrencyElement_Impl( const ::rtl::OUString& rString,
							const ::rtl::OUString& rExt );
	void	WriteBooleanElement_Impl();
	void	WriteTextContentElement_Impl();
	void	WriteDayElement_Impl( const ::rtl::OUString& rCalendar, sal_Bool bLong );
	void	WriteMonthElement_Impl( const ::rtl::OUString& rCalendar, sal_Bool bLong, sal_Bool bText );
	void	WriteYearElement_Impl( const ::rtl::OUString& rCalendar, sal_Bool bLong );
	void	WriteEraElement_Impl( const ::rtl::OUString& rCalendar, sal_Bool bLong );
	void	WriteDayOfWeekElement_Impl( const ::rtl::OUString& rCalendar, sal_Bool bLong );
	void	WriteWeekElement_Impl( const ::rtl::OUString& rCalendar );
	void	WriteQuarterElement_Impl( const ::rtl::OUString& rCalendar, sal_Bool bLong );
	void	WriteHoursElement_Impl( sal_Bool bLong );
	void	WriteMinutesElement_Impl( sal_Bool bLong );
	void	WriteSecondsElement_Impl( sal_Bool bLong, sal_uInt16 nDecimals );
	void	WriteAMPMElement_Impl();
	void	WriteMapElement_Impl( sal_Int32 nOp, double fLimit,
						sal_Int32 nKey, sal_Int32 nPart );

	sal_Bool WriteTextWithCurrency_Impl( const ::rtl::OUString& rString,
				const ::com::sun::star::lang::Locale& rLocale );
	void	ExportPart_Impl( const SvNumberformat& rFormat, sal_uInt32 nKey,
					sal_uInt16 nPart, sal_Bool bDefPart );

	void	ExportFormat_Impl( const SvNumberformat& rFormat, sal_uInt32 nKey );

public:
	SvXMLNumFmtExport( const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XDocumentHandler >& rHdl,
		   const ::com::sun::star::uno::Reference<
			::com::sun::star::util::XNumberFormatsSupplier >& rSupp );
	SvXMLNumFmtExport( const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XDocumentHandler >& rHdl,
		   const ::com::sun::star::uno::Reference<
			::com::sun::star::util::XNumberFormatsSupplier >& rSupp,
		   const rtl::OUString& rPrefix );

	virtual ~SvXMLNumFmtExport();

	void Export( const SvXMLNamespaceMap& rNamespMap, sal_Bool bIsAutoStyle);

	void SetUsed( sal_uInt32 nKey );

	::rtl::OUString GetStyleName( sal_uInt32 nKey );

	void GetWasUsed(com::sun::star::uno::Sequence<sal_Int32>& rWasUsed);
	void SetWasUsed(const com::sun::star::uno::Sequence<sal_Int32>& rWasUsed);
};

#endif

