

#ifndef _XMLOFF_XMLNUMFI_HXX
#define _XMLOFF_XMLNUMFI_HXX

#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif

#ifndef _COM_SUN_STAR_XML_SAX_XATTRIBUTELIST_HPP_
#include <com/sun/star/xml/sax/XAttributeList.hpp>
#endif
#ifndef _XMLOFF_XMLSTYLE_HXX
#include <xmloff/xmlstyle.hxx>
#endif
#ifndef _RTL_USTRBUF_HXX_
#include <rtl/ustrbuf.hxx>
#endif
#ifndef _LANG_HXX
#include <tools/lang.hxx>
#endif
#ifndef __SGI_STL_VECTOR
#include <vector>
#endif
#ifndef _UNOTOOLS_LOCALEDATAWRAPPER_HXX
#include <unotools/localedatawrapper.hxx>
#endif

#define XML_NUMBERSTYLES "NumberStyles"

class Color;
class SvXMLNumImpData;
class SvXMLImport;
class SvXMLStyleContext;
class SvXMLStylesContext;
struct SvXMLNumberInfo;

class SvXMLNumFmtHelper
{
	SvXMLNumImpData* pData;

public:
	SvXMLNumFmtHelper( const ::com::sun::star::uno::Reference<
			::com::sun::star::util::XNumberFormatsSupplier >& rSupp );
	~SvXMLNumFmtHelper();

	SvXMLStyleContext*	CreateChildContext( SvXMLImport& rImport,
	USHORT nPrefix, const rtl::OUString& rLocalName,
	const ::com::sun::star::uno::Reference<
	  	::com::sun::star::xml::sax::XAttributeList>& xAttrList,
		SvXMLStylesContext& rStyles);

};

class SvXMLNumFmtDefaults
{
public:
	static sal_Bool	IsSystemLongDay( const International& rIntn, BOOL bLong );
	static sal_Bool	IsSystemLongMonth( const International& rIntn, BOOL bLong );
	static sal_Bool	IsSystemTextualMonth( const International& rIntn, BOOL bLong );
	static sal_Bool	IsSystemLongYear( const International& rIntn, BOOL bLong );
	static sal_Bool	IsSystemLongEra( const International& rIntn, BOOL bLong );
	static sal_Bool	IsSystemLongDayOfWeek( const International& rIntn, BOOL bLong );
};

struct MyCondition
{
	rtl::OUString	sCondition;
	rtl::OUString	sMapName;
};

class SvXMLNumFormatContext : public SvXMLStyleContext
{
	SvXMLNumImpData*	pData;
	SvXMLStylesContext*				pStyles;
	std::vector <MyCondition>	aMyConditions;
	sal_uInt16			nType;
	sal_Int32			nKey;

	rtl::OUString		sFormatTitle;

	rtl::OUString		sCalendar;
	LanguageType		nFormatLang;
	sal_Bool			bAutoOrder;
	sal_Bool			bFromSystem;
	sal_Bool			bTruncate;
	sal_Bool			bAutoDec;		
	sal_Bool			bAutoInt;		
	sal_Bool			bHasExtraText;
	rtl::OUStringBuffer	aFormatCode;
	rtl::OUStringBuffer	aConditions;
	sal_Bool			bHasLongDoW;
	sal_Bool			bHasEra;
	sal_Bool			bHasDateTime;
	sal_Bool			bHasMap;

public:
	SvXMLNumFormatContext( SvXMLImport& rImport, USHORT nPrfx,
						const rtl::OUString& rLName,
						SvXMLNumImpData* pNewData, sal_uInt16 nNewType,
						const ::com::sun::star::uno::Reference<
							::com::sun::star::xml::sax::XAttributeList>& xAttrList,
						SvXMLStylesContext& rStyles );
	SvXMLNumFormatContext( SvXMLImport& rImport, USHORT nPrfx,
						const rtl::OUString& rLName,
						const ::com::sun::star::uno::Reference<
							::com::sun::star::xml::sax::XAttributeList>& xAttrList,
						const sal_Int32 nKey,
						SvXMLStylesContext& rStyles );
	virtual		~SvXMLNumFormatContext();

	virtual SvXMLImportContext *CreateChildContext( USHORT nPrefix,
						const rtl::OUString& rLocalName,
						const ::com::sun::star::uno::Reference<
						  	::com::sun::star::xml::sax::XAttributeList>& xAttrList );
	virtual void CreateAndInsert(sal_Bool bOverwrite);
	virtual void Finish(sal_Bool bOverwrite);

	SvXMLNumImpData* GetData() const				{ return pData; }
	sal_Int32 GetKey();
	void GetFormat(rtl::OUString& rFormatString, com::sun::star::lang::Locale& rLocale);
	sal_uInt16 GetType() const						{ return nType; }	

	sal_Bool IsFromSystem() const					{ return bFromSystem; }
	sal_Bool HasLongDoW() const						{ return bHasLongDoW; }
	void SetHasLongDoW(sal_Bool bSet)				{ bHasLongDoW = bSet; }
	sal_Bool HasEra() const							{ return bHasEra; }
	void SetHasEra(sal_Bool bSet)					{ bHasEra = bSet; }

	void UpdateCalendar( const rtl::OUString& rNewCalendar );

	const LocaleDataWrapper& GetLocaleData() const;

	void AddToCode( const rtl::OUString& rString );
	void AddNumber( const SvXMLNumberInfo& rInfo );
	void AddCurrency( const rtl::OUString& rContent, LanguageType nLang );

	void AddNfKeyword( sal_uInt16 nIndex );
	sal_Bool ReplaceNfKeyword( sal_uInt16 nOld, sal_uInt16 nNew );
	void AddCondition( const sal_Int32 nIndex );
	void AddCondition( const sal_Int32 nIndex, const rtl::OUString& rFormat, const com::sun::star::lang::Locale& rLocale );
	void AddCondition( const rtl::OUString& rCondition, const rtl::OUString& rApplyName );
	void AddColor( const Color& rColor );
};

#endif

